/* A utility class to represent each Hex data line in a hex file
 * it can parse it to many fields and get each field information
 *
 * @author: Xiangdong Xia
 * @date:   January 26, 2006
 */

import java.util.*;
//import org.apache.commons.lang.*;

public class HexLine {

   String transmissionID;
   String year;
   String month;
   String day;
   String hour;
   String minute;
   String second;
   String lat;
   String lon;
   String goodbad;
   String dummy;
   String sat;
   String loc;
   String fileDate;
   String hexData;//only contains 32 bytes hex data
   
   String hexLine;//the whole original line
   
   public HexLine(){
   }   
   
   public HexLine(String hexLine){
   	  this.hexLine=hexLine;
      parseHexLine(hexLine);   	
   }
   
   private void parseHexLine(String hexLine){
   	 String str;
   	 StringTokenizer st = new StringTokenizer(hexLine);
     while (st.hasMoreTokens()) { 
       transmissionID=st.nextToken().trim();
       year=st.nextToken().trim();
       month=st.nextToken().trim();
       day=st.nextToken().trim();
       hour=st.nextToken().trim();
       minute=st.nextToken().trim();
       second=st.nextToken().trim();
       lat=st.nextToken().trim();
       lon=st.nextToken().trim();
       goodbad=st.nextToken().trim();
       dummy=st.nextToken().trim();
       sat=st.nextToken().trim();
       loc=st.nextToken().trim();
       fileDate=st.nextToken().trim();
       hexData=st.nextToken().trim();       
     }    
   }  	
   
   
   public GregorianCalendar convert2GregorianCalendar(String year,String month,String day,String hour,String minute,String second){
        GregorianCalendar gc=null;
        int Year,Month,Day,Hour,Minute,Second;
           
        Year=Integer.parseInt(year);
        Month=Integer.parseInt(month);
        Day=Integer.parseInt(day);
        Hour=Integer.parseInt(hour);
        Minute=Integer.parseInt(minute);
        Second=Integer.parseInt(second);
        gc=new GregorianCalendar(Year,Month-1,Day,Hour,Minute,Second);
        return gc;    	
    }
   
   public GregorianCalendar convert2GregorianCalendar(){
   	    return convert2GregorianCalendar(year,month,day,hour,minute,second);
   }
   
   public long getTime(String year,String month,String day,String hour,String minute,String second){
   	   GregorianCalendar gc=convert2GregorianCalendar(year,month,day,hour,minute,second);
   	   return gc.getTimeInMillis();
   }
   
   public long getTime(){
   	   return getTime(year,month,day,hour,minute,second);
   }
      
   public boolean isPositionLine(){
   	   double Lat=Double.parseDouble(lat);
   	   double Lon=Double.parseDouble(lon);
   	   if(Math.abs(Lat)>0 || Math.abs(Lon)>0){
   	   	return true;
   	   }else{
   	   	return false;
   	   }
   }	   
   public String getTransmissionID(){return transmissionID;}
   public String getYear()  {return year;}
   public String getMonth() {return month;}
   public String getDay() {return day;}
   public String getHour() {return hour;}
   public String getMinute() {return minute;}
   public String getSecond() {return second;}
   public String getLat() {return lat;}
   public String getLon() {return lon;}
   public String getGoodbad() {return goodbad;}
   public String getSat() {return sat;}
   public String getLoc() {return loc;}
   public String getFileDate() {return fileDate;}
   public String getHexData() {return hexData;}	
   public String getHexLine(){return hexLine;}
   public void   setHexLine(String hexLine){this.hexLine=hexLine;}
}