
/*------------------------------------------------------------------------*/
/* function to compute the fugacity of oxygen in water                    */
/*------------------------------------------------------------------------*/
/**
   From Garcia and Gordon L&O 37(6), 1992, 1307 - 1312 provide better fit
   and better estimation of o2 solubility at end members
*/
#include <stdio.h>
#include <math.h>

double dswiftpoly(double x,const double coeff[],int n);
double OxSol(double t,double s)
{
   double oxsol;
   const double T = log((298.15 - t) / (273.15 + t));
   const double A[]={2.00907,3.22014,4.0501,4.94457,-0.256847,3.88767};
   const double B[]={-0.00624523,-0.00737614,-0.010341,-0.00817083};
   const double C[]={dswiftpoly(T,A,5),dswiftpoly(T,B,3),-0.000000488682};
   
   if ((t < -2.0) || (t > 40.0)) return(-999.9);
   if ((s < 0) || (s > 42)) return(-999.9);

   oxsol = exp(dswiftpoly(s,C,2));

   return oxsol;
}
