
/*
%      VAX 11/750      1983      J.HOLTORFF
%
% p      pressure in dbar
% t      temeprature in deg. C
% s      salinity in psu
%
% translated to c from Schmid's matlab code
% by Xiangdong Xia(Jan 2005)
*/

#include <stdio.h>
#include <math.h>

double atg(double p,double t,double s){

   double ds,h1,h2,h3,h4,h5,out;
   ds=s-35.0;
   h1 = ((-2.1687e-13*t + 1.8676e-11)*t - 4.6206e-10)*p;
   h2 = (2.7759e-10*t - 1.1351e-8)*ds;
   h3 = ((-5.4481e-12*t + 8.733e-10)*t - 6.7795e-8)*t;
   h4 = (-4.2393e-7*t + 1.8932e-5)*ds;
   h5 = ((6.6228e-9*t - 6.836e-7)*t + 8.5258e-5)*t + 3.5803e-4;
   out=(h1 + (h2 + h3 + 1.8741e-6))*p + h4 + h5;
   return out;
}
