/*
 *  This class hold one line of position data string from ARGO cnt file,
 *  can get individual fields and whole string
 *  used to check the differences between current ARGO cnt file position part and that 
 *  from new ARGO cnt file which is generated from argo_manual.sh process.
 *
 *  Author: Xiangdong Xia
 *  Date: July 2003
 */

import java.io.IOException;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.*;
import java.io.*;
import java.text.*;
public class PositionEntry {

 String Lat;
 String Lon;
 String YMD;
 String HMS;
 String Transmits;
 String SatType;
 String LocationClass;

 String wholeLine;
 String key;
 String temp;
  
 public PositionEntry(String wholeLine){ 	    
 	this.setWholeLine(wholeLine);
 	this.getAllFields(); 	
 }
 	
 public void setWholeLine(String wholeLine){
 	this.wholeLine=wholeLine;
 }	
	
 public String getWholeLine(){
    return wholeLine;	
 }
 
 public void setKey(String key){
 	this.key=key;
 } 
 public String getLat(){
    return Lat;
 } 
 
 public String getLon(){
 	return Lon;
 }
 
 public String getYMD(){
 	return YMD;
 }
 
 public String getHMS(){
 	return HMS;
 }
 
 public String getTransmits(){
 	return Transmits;
 }
 
 public String getSatType(){
 	return SatType;
 }
 
 public String getLocationClass(){
 	return LocationClass; 	
 }
 
 public void getAllFields(){
 	StringTokenizer st = new StringTokenizer(wholeLine);
 	Lat=st.nextToken().trim();
 	Lon=st.nextToken().trim();
    YMD=st.nextToken().trim();
    HMS=st.nextToken().trim();
    Transmits=st.nextToken().trim();
    SatType=st.nextToken().trim();
    LocationClass=st.nextToken().trim(); 	
 }
 
  
 public String getKey(){ 	
  return key;
 }
 
 /*  
  * extract the date and time fields and compute julian day from it
  */
/*  
 public long getDateTime(){
   long milliSeconds=0;   
   String str,str1,str2,str3,str4,str5,str6,str7,str8,str9,str10,ymd,hms;
   //get ymd and hms;   
   if(type.equalsIgnoreCase("network")){//network table
     StringTokenizer st = new StringTokenizer(wholeLine,"|");
     str1=st.nextToken().trim();str2=st.nextToken().trim();
     str3=st.nextToken().trim();str4=st.nextToken().trim();
     str5=st.nextToken().trim();str6=st.nextToken().trim();
     str7=st.nextToken().trim();str8=st.nextToken().trim();
     str9=st.nextToken().trim();str10=st.nextToken().trim();
     
     ymd=st.nextToken();hms=st.nextToken();
     //System.out.println("Date="+ymd+"  time="+hms);
     
     SimpleDateFormat ymd_formatter=new SimpleDateFormat("yyyy/mm/dd"); 
     SimpleDateFormat hms_formatter=new SimpleDateFormat("hh:mm");     
     try{
       Date ymd_date=ymd_formatter.parse(ymd);
       Date hms_date=hms_formatter.parse(hms);
       milliSeconds=ymd_date.getTime()+hms_date.getTime();	
       //System.out.println("Milliseconds="+milliSeconds);
     }catch(ParseException e){
     	System.out.println("unparseable using formatter");
     	System.exit(2);
     }
   }//if "n"
   
   if(type.equalsIgnoreCase("station")){//station table
     StringTokenizer st = new StringTokenizer(wholeLine,"|");
     str1=st.nextToken().trim();     
     str2=st.nextToken().trim();     
     //System.out.println("Date="+str2);
     
     SimpleDateFormat ymdhms_formatter=new SimpleDateFormat("yyyy-mm-dd hh:mm:ss"); 
     
     try{
       Date ymdhms_date=ymdhms_formatter.parse(str2);       
       milliSeconds=ymdhms_date.getTime();	
       //System.out.println("Milliseconds="+milliSeconds);
     }catch(ParseException e){
     	System.out.println("unparseable using formatter");
     	System.exit(2);
     }
   }//if "n"
   
   return milliSeconds;
 }
 
*/ 

}
