#include <stdio.h>
#include <math.h>
/*
  Revision Date: 13-May-11 (ER Convert T90 to T68 when calculating ptem and sigma)

  o = ox_units(o,s,t,p);
  o = dissolved oxygen in ml/l
  s = salinity
  t = temperature
  p = pressure in bar

  converts oxygen from ml/l to micromol/kg
  using the potential density of water sample

  from WOCE hydrographic program office web site at SIO
  converted from claudia's matlab to C
*/
double ptem(double p_bar,double t,double s,double pr);
double ieos802(double p_bar,double t,double s);

double ox_units(double o,double s,double t,double p){
   double sigma_st,rho;  
   
   t=ptem(p,t*1.00024,s,0);
//CS: new oxygen manual says use p=0!   sigma_st=ieos802(p/10,t,s);
   sigma_st=ieos802(0,t,s);
   rho=sigma_st+1000;
   o = o*1e3/rho * 44.6596;
   return o;
}   
