/************************************************************************
  Revision Date: 12-May-2014 CS & CA: added #include <stdio.h> to avoid complaints
                             about printf)
                 29-dec-2010 When a profile happens after more than 180
                             days after the previous one, the number of
                             the profile number is still corrected as
                             previous prof nbr + (deltaT/cycle_time)

  correct_profilenumber.c
  ==============================
  compute correct profile number

 ***********************************************************************/

#include <stdio.h>

//round a floating number to its nearest integer
int round1(float x) {
      if (x >= 0) return (int) (x+0.5);
      return (int) (x-0.5);
}


int correct_profilenumber(float jd_firstline_prev_old,float jd_firstline_current_old,int profSeqCounter,
                          int profile_no_prev,float start_of_cycles,float cycle_time,int n_prof,int has_prof0)
{
  int debug=0; 

  int correct_profile_no;
  int adjustment=0;

  if (debug==1) {
    printf( "<< BEGIN correct_profilenumber >>\n" );
    printf( "BEFORE: \n" );
    printf( "       jd_firstline_prev_old=%f\n", jd_firstline_prev_old );
    printf( "       jd_firstline_current_old=%f\n", jd_firstline_current_old );
    printf( "       profile_no_prev=%d\n", profile_no_prev );
    printf( "       n_prof=%d\n", n_prof );
    printf( "       cycle_time=%f\n", cycle_time );
  }
    
//  if( jd_firstline_current_old-jd_firstline_prev_old < 180 ||
//      jd_firstline_current_old-jd_firstline_prev_old > 360 )
  if( jd_firstline_current_old-jd_firstline_prev_old > 0 )
  {
    adjustment=round1((jd_firstline_current_old-jd_firstline_prev_old)/cycle_time);
  }
  else
  {
    adjustment=1;
  }

  correct_profile_no=profile_no_prev+adjustment;

  if (debug==1) {
    printf( "AFTER: \n" );
    printf( "       adjustment=%d\n",adjustment);
    printf( "       correct_profile_no=%d\n", correct_profile_no );
  
  }

//  printf("profSeqCounter=%d,profile_no_prev=%d,adjustment=%d,cycle_time=%f,jd_current_old=%f,jd_prev_old=%f,jd_diff=%f\n",profSeqCounter,profile_no_prev,adjustment,cycle_time,jd_firstline_current_old,jd_firstline_prev_old,jd_firstline_current_old-jd_firstline_prev_old);

    if(n_prof!=correct_profile_no)
    {
    	printf("WARNING, n_prof NOT EQUAL TO correct_profile_no\n");
    	printf("n_prof=%d,correct_profile_no=%d,profSeqCounter=%d,profile_no_prev=%d,adjustment=%d\n",n_prof,correct_profile_no,profSeqCounter,profile_no_prev,adjustment);
    }

  	return correct_profile_no;
}
