/***********************************************************************************
    Revision Date: 12-May-2014 (CS & CA: changed jd-jd_prev<2.0 to jd-jd_prev<1.4 (once) and
                               jd-jd_prev>=2.0 to jd-jd_prev>=1.4(twice)
                               to allow for highly compressed mission schedules
                               replaced
                               if ((abs(jd-jd_prev) >= 1.4) && (j > 0)) {
                               with
                               if ((jd-jd_prev>=1.4) && (j > 0)) {
                               no idea why the abs caused problems ...)
                   14-Apr-2011 (ER: Unnecessary abs function was detecting false 
                                    ghosts
                   06-Dec-2010 (ER: Code improved so that when the program only 
                                    generate the last profile get_raw_data doesn't 
                                    get called repeatedly 
                   22-Nov-2010 (ER: Change the formula to detect ghost transmissions
                   02-Jul-2010 (ER: Changes in layout and variable names; commenting
                                    of code in order to make it more readable.
                   01-Jul-2010 (CS: Method gets to be alone in a file of its own.)

    get_data
    ==================


    Input Parameters
      get_which_profile: all profiles (1) or just the last one (0)
      s: data structure with meta file data
      t: data structure with decoding table data.
      out_dir:  output directory, that is, where the cnt files will be generated.

    Returns and integer with this posible values:
      0: success
      1: no data to store (something might have gone wrong on the call to
         write_to_disk method)
      9: error
      
************************************************************************************/  
#include "hex2cnt_tsall.h"

void split_test_normal(char **, int, char **, int*, char **, int*);
int correct_profilenumber(float, float, int, int, float, float, int, int);

int get_data( int get_which_profile, struct meta_struct *s, struct table_struct *t, char *out_dir)
{
  
  int debug=OFF; 
  int LAST=0;
  int ALL=1;

  struct output_record y;
  struct test_record test;
  char **buff;         // hold raw lines read from hex files for one profile.  
  char **buff_test;    // like buff but for profile 0, 'test' data
  char **buff_normal;  // like buff but for profile 0, profile data
  int j; // index variable for buff 

  int nlines=0;//in test message part, the number of lines which contain profile0 data
  int tlines=0;//in test message part, the number of lines for traditional test messages
  int i;
  int iy,imo,ida,ih,im,is,ndoy;
  int n_prof=0;
  int write_to_disk_error;
  int kk,find=0;//added

  float jd;        // julian date of the line being currently processed.
  float jd_prev=0; // julian date of the previous line
  float jd_firstline_prev_old=0;
  float jd_firstline_current_old=0;
  float jd_firstline_prev_new=0;
  float jd_firstline_current_new=0;

  int profSeqCounter=0; 
  int times=0,has_prof0=0,profile_no_prev=0,profile_no_current=0;
  char* onelinehex;


  // Allocate needed memory for arrays buff, buff_normal, buff_test, onelinehex
  //
  if (((buff_normal = (void *) malloc(max_scans*(sizeof(void *)))) == NULL)||
      ((buff_test   = (void *) malloc(max_scans*(sizeof(void *)))) == NULL)||
      ((buff        = (void *) malloc(max_scans*(sizeof(void *)))) == NULL))
  {
    if (trace_file != NULL)
      fprintf (trace_file," GET_DATA: Error allocating buffer pointers\n");
    if (error_file != NULL)
      fprintf (error_file," GET_DATA: Error allocating buffer pointers\n");
    return 9;
  }
  for (i=0; i<max_scans; i++) {
    if (((buff[i]       = (char *) malloc(buff_size*(sizeof(char)))) == NULL)||
       ((buff_normal[i] = (char *) malloc(buff_size*(sizeof(char)))) == NULL)||
       ((buff_test[i]   = (char *) malloc(buff_size*(sizeof(char)))) == NULL))
    {
      if (trace_file != NULL)
        fprintf (trace_file," GET_DATA: Error allocating data buffer arrays\n");
      if (error_file != NULL)
        fprintf (error_file," GET_DATA: Error allocating data buffer arrays\n");
      return 9;
    }
  }
  if((onelinehex=(char *) malloc(buff_size*(sizeof(char))))==NULL){
    if (trace_file != NULL)
      fprintf (trace_file," GET_DATA: Error allocating data buffer arrays\n");
    if (error_file != NULL)
      fprintf (error_file," GET_DATA: Error allocating data buffer arrays\n");
    return 9;
  }
  if (trace_file != NULL)
    fprintf (trace_file," GET_DATA: Arrays successfully allocated\n");


  // Get the data 
  //
  j=0;
  int tmp = 0;

  if(debug==ON) { 
    printf( "<< BEGIN get data >>\n" );
  }
  printf("Entering get_data.c \n");
  while (fgets(onelinehex,buff_size,input_file) != NULL)
  {

    if(sscanf(onelinehex,"%d %d %d %d %d %d %d",&i,&iy,&imo,&ida,&ih,&im,&is) != 7) 
      continue;

    jd = (float) dfr97(iy,imo,ida,ih,im,0,&ndoy);  // get julian date of this line 

    // lines before launch time are skipped.
    //
    if (get_which_profile==ALL){
      if (jd < s->launch_time-s->up_time) {
        if (trace_file != NULL)
          fprintf (trace_file," GET_DATA: WARNING, data before launch time\n");
        if (error_file != NULL)
          fprintf (error_file," GET_DATA: WARNING, data before launch time\n");
        continue;
      }
    }
    if (s->start_time > jd ) 
      continue;

    times++;
    if(times==1) {
      jd_prev=jd;
      jd_firstline_prev_new=jd;
    }

    if(jd-jd_prev<1.4)
      strcpy(buff[j],onelinehex);

    // skip those lines whose jd difference is less than normal cycle; 
    // they are ghost messages.(XXD)
    // 
    if(jd-jd_prev>=1.4 && (jd-jd_firstline_prev_new)<(1-s->up_time/s->cycle_time-0.1)*s->cycle_time)
    {
      if (debug==ON) { 
        printf( "Ghosting it: %s\n", onelinehex );
        printf( "         up_time: %f\n", s->up_time );
        printf( "         cycle_time: %f\n", s->cycle_time );
        printf( "         jd_firstline_prev_new: %f\n", jd_firstline_prev_new );
        printf( "         jd: %f\n", jd );
        printf( "         (jd-jd_firstline_prev_new): %f\n", (jd-jd_firstline_prev_new) );
        printf( "         ghost threshold: %f\n", (1-s->up_time/s->cycle_time-0.1)*s->cycle_time );

      }
      continue;
    }

    // transition from one profile to another one.
    // 
//    if ((abs(jd-jd_prev) >= 1.4) && (j > 0)) {
    if ((jd-jd_prev>=1.4) && (j > 0)) {

      profSeqCounter++;
      if(debug==ON) {
        printf("profSeqCounter=%d\n",profSeqCounter );
      }
     
      jd_firstline_current_new=jd;

      if (get_which_profile==LAST){

        if ((jd_prev - s->launch_time) < 3){
          split_test_normal(buff,j,buff_test,&tlines,buff_normal,&nlines);
          if (nlines==0) {
             n_prof=-1;
          }
          else {
             n_prof=1;
             y.profile_no=1;
          }
        }
        else {
          n_prof=get_profile_number(buff, j, t); 
          if (n_prof != -1) {
            y.profile_no=n_prof;
          }
        }

        if(profile_no_prev >= 250 && n_prof>=0) 
        {
          if(n_prof<250)
            n_prof = n_prof+256;
        }

        if(n_prof==-1 && profSeqCounter==1)
        {
          if(tmp==0)
          {
            profSeqCounter--;
            tmp++;
          }
          else
          {
            if (trace_file != NULL)
              fprintf (trace_file," Can't decode message without frame 1\n");
            if (error_file != NULL)
              fprintf (error_file," Can't decode message without frame 1\n");
            frame1_problem_count++;
            total_cycles_count++;
            y.profile_no = 1;
          }
        }  

        if(profSeqCounter>1)
        {
          y.profile_no=correct_profilenumber(jd_firstline_prev_old, jd_firstline_current_old, profSeqCounter,
                                       profile_no_prev, s->start_of_cycles, s->cycle_time, n_prof, has_prof0);
          if(n_prof == -1)
            total_cycles_count++;
        }    

        profile_no_current=y.profile_no;
        profile_no_prev=profile_no_current;

      }  // End of LAST profile
      else {
        // Begin of ALL profiles
        if ((jd_prev - s->launch_time) < 3){
          split_test_normal(buff,j,buff_test,&tlines,buff_normal,&nlines);
          n_prof = get_raw_data_test(&test,t,s,buff_test,tlines,0);
          // printf("Done get_raw_data_test in get_data 2  \n n_prof = %d \n",n_prof);
          n_prof = get_raw_data(&y,t,s,buff_normal,nlines,1);
        }
        else
          n_prof = get_raw_data(&y,t,s,buff,j,1);
      

        if(profile_no_prev >= 250 && n_prof>=0) //LL: prof # > 256
        {
          if(n_prof<250)
            n_prof = n_prof+256;
        }

        if(n_prof==-1 && profSeqCounter==1)
        {
             
          if(tmp==0)
          {
            profSeqCounter--;
            tmp++;
          }
          else
          {
            if (trace_file != NULL)
              fprintf (trace_file," Can't decode message without frame 1\n");
            if (error_file != NULL)
              fprintf (error_file," Can't decode message without frame 1\n");
            if (get_which_profile==ALL)
            {
		       //printf("there is no profile 1!");
              if (trace_file != NULL)
                fprintf (trace_file," GET_DATA: WARNING, there is no profile 1!\n");
              if (error_file != NULL)
                fprintf (error_file," GET_DATA: WARNING, there is no profile 1!\n");
            }
            frame1_problem_count++;
            total_cycles_count++;
            y.profile_no = 1;
          }
        }  
  
        if(profSeqCounter>1)
        {
          y.profile_no=correct_profilenumber(jd_firstline_prev_old,jd_firstline_current_old,profSeqCounter,
                                             profile_no_prev,s->start_of_cycles,s->cycle_time,n_prof,has_prof0);
          if(n_prof == -1)
		   {
		     if (get_which_profile==ALL)
		     {
              printf("there is no profile %d!\n",y.profile_no);
              if (trace_file != NULL)
                fprintf (trace_file," GET_DATA: WARNING, there is no profile %d!\n",y.profile_no);
              if (error_file != NULL)
                fprintf (error_file," GET_DATA: WARNING, there is no profile %d!\n",y.profile_no);
            }
            total_cycles_count++;
          }
        }

        profile_no_current=y.profile_no;

        if(n_prof>=0 && get_which_profile==ALL) 
          write_to_disk(out_dir,s,t,&y);
  
        profile_no_prev=profile_no_current;
  
        if (get_which_profile==ALL)
        {
          if(profSeqCounter==1 && n_prof==2)
          {
            printf("there is no profile 0!");
            if (trace_file != NULL)
              fprintf (trace_file," GET_DATA: WARNING, there is no profile 0!\n");
            if (error_file != NULL)
              fprintf (error_file," GET_DATA: WARNING, there is no profile 0!\n");
            n_prof = get_raw_data (&y,t,s,buff_test,tlines,1);
            total_cycles_count--;
            if(n_prof==1)
            {
              write_to_disk_error=write_to_disk(out_dir,s,t,&y);
              profSeqCounter++;
            }
            else
            {
              if (trace_file != NULL)
                fprintf (trace_file," GET_DATA: WARNING, there is no profile 1!\n");
              if (error_file != NULL)
                fprintf (error_file," GET_DATA: WARNING, there is no profile 1!\n");
            }
          }
          else {
            if(profSeqCounter==1 && n_prof==1)
            {
              n_prof = get_raw_data_test(&test,t,s,buff_test,tlines,0);
             // printf("Done get_raw_data_test in get_data 3  \n n_prof = %d \n",n_prof);
              total_cycles_count--;
              if(n_prof>=0) {
                write_to_disk_error=write_to_disk_test(out_dir,s,t,&test);
                if(write_to_disk_error==1) 
                  printf("write profile 0 failed!");
              } 
            }
          }
        }
        else {
          if(profSeqCounter==2 && n_prof==2 && tmp>1)
          {
            n_prof = get_raw_data_test(&test,t,s,buff_test,tlines,0);
            //printf("Done get_raw_data_test in get_data 4  \n n_prof = %d \n",n_prof);
            total_cycles_count--;
            if(n_prof>=0) write_to_disk_error=write_to_disk_test(out_dir,s,t,&test);
            if(write_to_disk_error==1) printf("write profile 0 failed!");
          }
        }

      }

      jd_firstline_prev_old=jd_firstline_prev_new;
      jd_firstline_current_old=jd_firstline_current_new;

      //sprintf (buff[0],"%s",buff[j]); j = 0;
      strcpy(buff[0],onelinehex);
      j=0;
      times=0;
    }

    jd_prev = jd;
    if (++j >= max_scans)
    {
      if (trace_file != NULL)
        fprintf (trace_file," Maximum scans for profile exceeded\n");
      if (error_file != NULL)
        fprintf (error_file," Maximum scans for profile exceeded\n");
      exit (1);
    }
  } // while (fgets(buff[j],buff_size,input_file) != NULL)


  //
  // Last profile in hex file.
  if (get_which_profile==LAST){
    //
    // Is there at least one transmission time after launch time?
    for (kk=0; kk<j; kk++){
      if(sscanf(buff[kk],"%d %d %d %d %d %d %d",&i,&iy,&imo,&ida,&ih,&im,&is) != 7) 
        continue;
      if (dfr97(iy,imo,ida,ih,im,0,&ndoy) < s->launch_time-s->up_time){
        if (trace_file != NULL)
          fprintf (trace_file," GET_DATA: WARNING, data before launch time\n");
        if (error_file != NULL)
          fprintf (error_file," GET_DATA: WARNING, data before launch time\n");
        continue;
      }
      else{
        find=1;//find data whose data is larger than launch time-up time
        break;
      }
    }
    if (find==0) {
      // if all data are before launch time-up time, then set j=0, no data to process
      j=0; 
    }
    else  {
      //if there are some data whose date is larger than launch time-up time,then process data
      //reset buff to begin from kk, skip data before kk since their date are less than launch time-up time
      sprintf (buff[0],"%s",buff[kk]);
      j=j-kk;//reset buff length j
    }
  }

  if (j > 0) 
  {  
    // are there any data lines to save to a file? (j is n_scans in get_raw_data)
    profSeqCounter++;

    if ((jd_prev - (int) s->launch_time) < 3)
    {
      split_test_normal(buff,j,buff_test,&tlines,buff_normal,&nlines);
      n_prof = get_raw_data_test(&test,t,s,buff_test,tlines,0);
     // printf("Done get_raw_data_test in get_data 1  \n n_prof = %d \n",n_prof);
      if(n_prof>=0) write_to_disk_error=write_to_disk_test(out_dir,s,t,&test);
      n_prof = get_raw_data (&y,t,s,buff_normal,nlines,1);
    }
    else
    {
      n_prof = get_raw_data (&y,t,s,buff,j,1);
    }

	if(profile_no_prev >= 250 && n_prof>=0) //LL: prof # > 256
	{
      if(n_prof<250)
        n_prof = n_prof+256;
    }

    if(profSeqCounter>1)
    {
      y.profile_no=correct_profilenumber(jd_firstline_prev_old,jd_firstline_current_old,profSeqCounter,profile_no_prev,s->start_of_cycles,s->cycle_time,n_prof,has_prof0);
      if(n_prof<0)
      {
        printf("there is no profile %d!",y.profile_no);
        if (trace_file != NULL)
          fprintf (trace_file," GET_DATA: WARNING, there is no profile %d!\n",y.profile_no);
        if (error_file != NULL)
          fprintf (error_file," GET_DATA: WARNING, there is no profile %d!\n",y.profile_no);
      }
    }
    profile_no_current=y.profile_no;

    if (y.profile_no >= 0 && n_prof>=0)
    {
      write_to_disk_error=write_to_disk(out_dir,s,t,&y);
    }
    else
    {
      write_to_disk_error=1;
    }

  }
  else{
    write_to_disk_error =1; // no data to store -> something may be wrong
  } 

  free (buff);
  if(trace_file != NULL) fprintf(trace_file," GET_DATA completed successfully\n");

  if(debug==ON) { 
    printf( "<< END get data >>\n" );
    fflush(stdout);
  }

  return (write_to_disk_error);

}

