   /***********************************************************************************
       Revision Date: 04-Dec-2012 (CA: frames_per_message_test is a new variable from hex2cnt_tsall.h
				       which is set to 3, as only maximum of 3 Test Messages are 
				       printed in the .cnt files. This helps to rectify the MOST_LIKELY_FRAME_STATUS
				       problem which is incorrectly displayed.(It is displayed as 1 even though
				       all the messages are found in the hex files and are not built))
		      04-Dec-2012 (CA: Skip Bytes "P" and "SEC2" are added )
		      04-Dec-2012 (CA: t->test_flag represents 1,2 or 3 in decoder. Example table_ts13.txt:TEST_MESSAGE,1,29
                                  Message number does not exist in the hexdata with  t->test_flag=1. Most likely frame and Start of 
				  transmission time has been for such floats)
       		      02-Jul-2010
                      01-Jul-2010 (CS: Method gets to be alone in a file of its own.)

   start_of_transmission.c can not work for cycle 0, because roll-overs are too difficult
   to identify robustely.
   But: worth a try (in start_of_transmission.c):

   ii=1:46; blk_short=blk(ii); tim_short=tim_h(ii); % use only hex data from cycle 0
   ii=find(blk_short); blk_short=blk_short(ii); tim_short=tim_short(ii); % remove position lines
   ii=find(diff(blk_short)<0) % find roll overs
   while length(ii),
    blk_short(ii+1:length(blk_short))=blk_short(ii+1:length(blk_short))+255;
    ii=find(diff(blk_short)<0) % find roll overs
   end
   plot(tim_short,blk_short,'-x')


   Because each message has a BLK, using getFirstBLKTimeTest.c will result in estimates
   that are at least as good as those from start_of_transmission.c if the transmission
   irepetition rate in the meta file is correct.
   
   ROLL OVER(roll_over) for floats with their t->test_flag != 1  is implemented in get_raw_data_test.c itself
   and for t->test_flag == 1 roll over is implemented in start_of_transmission.c --CA

       get_raw_data_test
       ==================
       Input Parameters
          NEED TO ADD STUFF HERE

       Returns and integer with this posible values:
          NEED TO ADD STUFF HERE
         
   ************************************************************************************/  
   #include <stdio.h>
   #include <string.h>
   #include <math.h>
   #include <stdlib.h>
   #include "hex2cnt_tsall.h"


   int get_raw_data_test (struct test_record *y, struct table_struct *t, struct meta_struct *s, char ** buff, int n_scans, int m_type)
   {

     int debug=OFF; 

     struct raw_data_record x;
   //  struct tm *time_str;
     //int i,j,k,most_common[frames_per_message+1]; //frames_per_mesage+1 for test mesage
     int i,j,k,most_common[frames_per_message_test+1]; //frames_per_mesage+1 for test mesage
     int id,iy,imo,ida,ih,im,is,g,ndoy,n_l,jd_old=0,n_pos=0;
     int iy1,imo1,ida1,ih1,im1,is1;

     long int dummy;
     int l, frames;
     char ch;
     char frms[3]="";

     float lat,lon;
     unsigned char hex_data[80],sat,l_c;
     unsigned int z[32],roll_over=0,old_count=0;

     int skip_byte[64];
     int m = 0;
     int n = 0;
     int kk = 0;
     int start = 0;
     int end = 0;
     int flag_test_flag=0; //Flag to process most_likely_frame only once for floats with t->test_flag ==1 

     long blk_time = 0;
     if(s->ARGOS_id > 32767 && t->test_cycle > 29)
     {
   	  if (trace_file != NULL)
      	     fprintf (trace_file," ARGOS id indicates 20-bit\n");
         if (error_file != NULL)
            fprintf (error_file," ARGOS id indicates 20-bit\n");
         return -1;
     }
   else if(s->ARGOS_id < 32768 && t->test_cycle < 30)
   {
   	  if (trace_file != NULL)
      	     fprintf (trace_file," ARGOS id indicates 28-bit\n");
         if (error_file != NULL)
            fprintf (error_file," ARGOS id indicates 28-bit\n");
         return -1;
     }

     total_cycles_count++;

     y->flag_most_likely_frame = 0;

    // Example :TEST_MESSAGE,2,29 -test_flag = 2; test_cycle =29 ;test_length = No of bytes that represent test_cycle
    // 2,P,CURRENT PRESSURE, (COUNTS)               ,p1, (DBAR)
    //  table_struct->test_byte[m] = 2
    //  table_struct->test_count[m] = 5
    //  table_struct->test_name[m] = P
    //  table_struct->test_print[m] = CURRENT PRESSURE
    //	table_struct->test_unit[m] =  (COUNTS)
    

 
 
     int nbr_of_msgs = (int)ceil((double)(t->test_count[t->test_length-1])/(double)(t->test_cycle));
     //printf("number of messages nbr_of_msgs =%d \n",nbr_of_msgs);
    // for (i=1; i<=1; i++)
    // {
      //t-> flag is 1,2,3 for get_raw_data_test
       y->flag_blk_time = start_of_transmission(buff, n_scans, &blk_time, 1,t->test_flag);
    // }

  
     //for (i=0; i<frames_per_message; i++)
     for (i=0; i<frames_per_message_test; i++)
     {
   	    int flag_mlf = 0;
      		y->status[i] = NEVER_RECEIVED;

      		if( t->test_cycle == 29 )
      		{
      			for (j=0; j<29; j++)
       			x.data.data_bytes_29[i][j] = 0;
   		}
   		else if( t->test_cycle == 30 )
      		{
      			for (j=0; j<30; j++)
       			x.data.data_bytes_30[i][j] = 0;
   		}

       	if (m_type == 1)
   	   		break;

   		m = 0;
   		if( i < nbr_of_msgs )
   		{
   			for( n=0; n<t->test_length; n++ )
   			{
   				if( (i+1)*t->test_cycle > t->test_count[t->test_length-1] )
   				{
   					if( i == 0 ) start = 0;
   					else start = end;
   					end = t->test_length;
   					n = t->test_length+1; //spead up
   				}
   				else if( (i+1)*t->test_cycle == t->test_count[n] )
   				{
   					if( i == 0 ) start = 0;
   					else start = end;
   					end = n;
   					n = t->test_length+1; //spead up
   				}
   			}
   			//printf("start:%d end:%d\n",start,end);

   			skip_byte[0] = 0;
   			skip_byte[1] = 1;
   			m = 2;

   			for( n=start; n<end; n++ )
   			{
   				if( (strncmp(t->test_name[n],"BLK",3) == 0 && strlen(t->test_name[n]) == 3) ||
   					(strncmp(t->test_name[n],"ABP",3) == 0 && strlen(t->test_name[n]) == 3) ||
   					(strncmp(t->test_name[n],"BAT",3) == 0 && strlen(t->test_name[n]) == 3) || 
   					(strncmp(t->test_name[n],"P",1) == 0 && strlen(t->test_name[n]) == 1)||
   					(strncmp(t->test_name[n],"SEC2",4) == 0 && strlen(t->test_name[n]) == 4))
	
   				{
   				 	for( kk=0; kk<2*t->test_byte[n]; kk++ )
   					{
   						//printf("i:%d m+kk:%d index:%d\n",i,m+kk,4+kk+2*(t->test_count[n]-t->test_count[start]));
   						skip_byte[m+kk] = 4+kk+2*(t->test_count[n]-t->test_count[start]);
   					}
   					m = m + 2*t->test_byte[n];
   				}

   			}
   		}
   		skip_byte[m] = 100;
		//t->test_flag = 1,2,3 .If 1,  Message number does not exist in the hexdata. If 2 and 3, Message No. exists. 
      		if ((j = most_likely_frame (buff, n_scans, i, 1, skip_byte, &flag_mlf,t->test_flag)) >= 0) //find most likely - good CRC only
       		most_common[i] = j;
      		else if ((j = most_likely_frame (buff, n_scans, i, 0, skip_byte, &flag_mlf,t->test_flag)) >= 0) //find most likely - any CRC
       		most_common[i] = j;
      		else
       		most_common[i] = -1;

       	if( flag_mlf > 0 )
       	{
   			y->flag_most_likely_frame = 1;
         	                //printf("FLAG_MLF =%d I am greater than 0 for cycle number = %d\n",flag_mlf,total_cycles_count);
   	}

     }

     //printf("flag_most_likely_frame in raw test: %d\n",y->flag_most_likely_frame);

     for (j=1; j<max_positions; j++)
      	x.jd[j] = -1.0;

     for (i=0; i<5; i++)
     {
     	strcpy(y->hex_test_print[i],"");
     	strcpy(y->hex_test_time[i],"");
     }

     for (i=0; i<n_scans; i++)
     {
        if (sscanf(buff[i],"%d %d %d %d %d %d %d %f %f %d %d %c %c %ld %s",
          &id,&iy,&imo,&ida,&ih,&im,&is,&lat,&lon,&g,&n_l,&sat,&l_c,&dummy,hex_data) != 15)
        continue;

   //first read each line
        x.latitude[n_pos] = lat;
        x.longitude[n_pos] = lon;
        x.jd[n_pos] = dfr97(iy,imo,ida,ih,im,is,&ndoy);

        sprintf(x.date_time[n_pos], "%4d/%02d/%02d%3d:%02d:%02d\0",iy,imo,ida,ih,im,is);
        x.loc_class[n_pos] = l_c;
        x.sat_name[n_pos] = sat;
        x.n_xmits[n_pos] = (int) floor((n_l-1)/8);

        if(n_pos==0)
        {//reset to first 99.999 999.999 line
          x.latitude[n_pos] = (float) 99.999;
          x.longitude[n_pos] = (float) 999.999;
          x.n_xmits[n_pos] = 0;
          n_pos++;
        }

        if((lat != (float) 0.0) || (lon != (float) 0.0))
        {
       	x.latitude[n_pos] = lat;
       	x.longitude[n_pos] = lon;
       	x.jd[n_pos] = dfr97(iy,imo,ida,ih,im,is,&ndoy);

       	sprintf(x.date_time[n_pos], "%4d/%02d/%02d%3d:%02d:%02d\0",iy,imo,ida,ih,im,is);
       	x.loc_class[n_pos] = l_c;
       	x.sat_name[n_pos] = sat;
       	x.n_xmits[n_pos] = (int) floor((n_l-1)/8);
       	n_pos = (n_pos < (max_positions-1)) ? n_pos + 1 : n_pos;
       	continue;
        }


   //16920 2000 12 13 06 21 50 +00.000 +000.000 0  25 L 0 126882763 497101C401595248000F8F5A0C1000F0014E20230C18F8450957FFFFFF072800
        for (j=0; j<32; j++)
       	sscanf( (const char *) &hex_data[2*j],"%2x",&z[j]);


        if ((z[1] - min_frame_no) < 1)
   			{
            continue;
   			}
	//If its a Test Message and has a good CRC
        if ((m_type == 0) && (g == 0))
        {
          /* printf("i =%d , most_common[z[1]-1] = %d , z[1] = %d \n", i,most_common[z[1]],z[1]);
                    Added by CA
   		 		if (i != (most_common[z[1] - 1]))
   		 		{
                  printf("I am skipping %s in get_raw_data_test \n",hex_data); 
            	  continue;
   		 		}*/

   				if(t->test_flag > 1)
   				{
   		 			if (i != (most_common[z[1] - 1]))
   		 			{
                 				 //printf("I am skipping %s in get_raw_data_test \n",hex_data); 
            	  				continue;
   		 			}
   					if (z[2] < old_count) roll_over++;
   					old_count = z[2];
   	    				y->msg_blk_no = z[2]-1 + roll_over*256; //count starts at 1
				//	printf("HEX DATA in GRDT continued =%s \n",hex_data);
   				}
   				else
   				{
   					//changed to the following instead
          				z[1] = 1; //Z[1] now has frame number = 1 for test msg
   		 			if (i != (most_common[z[1] - 1]))
   		 			{
            	  				continue;
   		 			}

					if(flag_test_flag ==0)// Let the program process only once for the floats with t->test_flag = 1 as there will be no message number for this kind of floats
					{
          				 sscanf( (const char *) &hex_data[2],"%2x",&y->msg_blk_id);
				//	 printf("IN GRDT 1 y->msg_blk_id = %d ,old_count= %d ,roll_over = %d \n",y->msg_blk_id,old_count,roll_over);
   					/* if (y->msg_blk_id < old_count) roll_over++;
   					 old_count = y->msg_blk_id;
   	    				 y->msg_blk_no = y->msg_blk_id-1 + roll_over*256; //count starts at 1*/
        				  y->msg_blk_no = y->msg_blk_id -1;
					 //printf("IN GRDT 2 y->msg_blk_id = %d ,old_count= %d ,roll_over = %d \n",y->msg_blk_id,old_count,roll_over);
					 flag_test_flag =1;
					 //printf("HEX DATA in GRDT =%s \n",hex_data);
					}
   				}

         if(t->test_cycle == 29)
         {
    	       for (k=0; k<29; k++)
          	    x.data.data_bytes_29[z[1]-1][k] = (unsigned char) z[k+2];
   	     }
   	     else if( t->test_cycle == 30 )
   	     {
   	        for (k=0; k<30; k++)
   		        x.data.data_bytes_30[z[1]-1][k] = (unsigned char) z[k+2];
   	     }

   //   }
   //Speed up - move time calculations outside loop
        if (z[1] == 1)
        {
    	   	is1 = is;
    	   	im1 = im;
    	   	ih1 = ih;
    	   	ida1 = ida;
    	   	imo1 = imo;
    	   	iy1 = iy;
        }

        	if (z[1] < 3 )  //at most three test messages
        	{
   					sprintf(y->hex_test_print[z[1]-1], "%02d/%02d/%02d %02d:%02d:%02d  %d  %s", iy,imo,ida,ih,im,is,g,hex_data );
   					sprintf(y->hex_test_time[z[1]-1], "%04d %02d %02d %02d %02d %02d", iy,imo,ida,ih,im,is );
   	 				}
      		}//end of if(m_type == 0 and g == 0)
   }//end of for n_scans loop


      //add the last 999.999 line
     x.latitude[n_pos] = (float) 99.999;
     x.longitude[n_pos] = (float) 999.999;
     x.n_xmits[n_pos] = 0;
     //printf("y->flag_blk_time =%d \n",y->flag_blk_time);
     //DELETE THE BELOW CODE
     //y->flag_blk_time = 0;
     //printf("blk_time = %d \n",blk_time);
     if( y->flag_blk_time == 0 )
     {
   	  y->first_blk_time = ((ymd2julday(iy1,imo1,ida1)*24+ih1)*60+im1)*60+is1;
	 // printf(" IN GRDT :  y->first_blk_time =%d \n", y->first_blk_time );
     }
     else
     {
   	  y->first_blk_time = blk_time;
     }

     x.jday = (int) floor(x.jd[0]);

     if ((trace_file != NULL) && (m_type == 1))
     {
       fprintf (trace_file,"T/P Float: profile number %d status = ",y->profile_no);
       //for (j=(frames_per_message-1); j>0; j--)
       for (j=(frames_per_message_test-1); j>0; j--)
       fprintf (trace_file,"%1d",y->status[j]);
       fprintf (trace_file," (0=NOT RCVD,1=OK,4=BAD)\n");
     }

     y->float_id = id;
     y->jd = x.jday;

     if (m_type == 0)   //Test message
     {
      	y->profile_no = 0;

      	y->reference_time[0] = iy1;
      	y->reference_time[1] = imo1;
      	y->reference_time[2] = ida1;
      	y->reference_time[3] = ih1;
      	y->reference_time[4] = im1;
      	y->reference_time[5] = is1;

      	for(n=0;n<t->test_length;n++)
      	{
   		if( strncmp(t->test_name[n],"MON",3) == 0 || strncmp(t->test_name[n],"DAY",3) == 0 || strncmp(t->test_name[n],"YR",2) == 0)
   			 y->test_message[t->test_count[n]] = (x.data.t_fmt.test_message[t->test_count[n]]/16)*10 + x.data.t_fmt.test_message[t->test_count[n]]%16;
     		else
     		{
      			if(t->test_byte[n] == 2)
   				y->test_message[t->test_count[n]] = 256*x.data.t_fmt.test_message[t->test_count[n]] + x.data.t_fmt.test_message[t->test_count[n]+1];
   			else if(t->test_byte[n] == 4)
   				y->test_message[t->test_count[n]] = 256*256*256*x.data.t_fmt.test_message[t->test_count[n]+3] + 256*256*x.data.t_fmt.test_message[t->test_count[n]+2]
   													+ 256*x.data.t_fmt.test_message[t->test_count[n]+1] + x.data.t_fmt.test_message[t->test_count[n]];
   			else
   				y->test_message[t->test_count[n]] = x.data.t_fmt.test_message[t->test_count[n]];
   		}
   		//printf("%d:%d \n",t->test_count[n],x.data.t_fmt.test_message[t->test_count[n]] );
      	}//end of for(n=0;n<t->test_length;n++)

     }// end of   if (m_type == 0)   //Test message

     for (j=0; j<max_positions; j++)
     {
      	y->latitude[j] = x.latitude[j];
      	y->longitude[j] = x.longitude[j];
      	y->position_jd[j] = x.jd[j];
      	y->n_xmits[j] = x.n_xmits[j];
      	y->sat_name[j] = x.sat_name[j];
      	y->loc_class[j] = x.loc_class[j];
      	strncpy(y->date_time[j],x.date_time[j],24);
     }

     if (trace_file != NULL)
     	fprintf(trace_file," GET_RAW_DATA: finished (profile number = %d,number of meas = %d)\n", y->profile_no,k);

     printf("Exiting get_raw_data_test.c\n");
     return(0);
   }
