/***********************************************************************************
    Revision Date: 04-Dec-2012 (CA: SOT FROM GFBT is added to the cnts file if the
                                    if the Start of Transmission time is from
                                    getFirstBLKTimeTest)
   		   02-Jul-2010
                   01-Jul-2010 (CS: Method gets to be alone in a file of its own.)

    write_to_disk_test
    ==================
    Input Parameters
       NEED TO ADD STUFF HERE

    Returns and integer with this posible values:
       NEED TO ADD STUFF HERE
      
************************************************************************************/ 
#include "hex2cnt_tsall.h"


int write_to_disk_test (char *dir_name, struct meta_struct *s, struct table_struct *t, struct test_record *x)
{
/*  Writes output data to disk for T/P floats.  Profile 0 is
 transmitted when float is first turned on.  It has no
 temperature or pressure data. */

 int debug=0; //1 debug,0 no debug

 int  i,j=0,id;
 char *ptr_cnt_filename;
// printf("IN WRDT Entered write_to_disk_test \n and flag_most_likely_frame is %d \n",x->flag_most_likely_frame);
 id = x->float_id;
 if (((x->status[0]) == NEVER_RECEIVED) && (x->profile_no > 0))   //Must have received first scan
 {
  if (trace_file != NULL)
     fprintf (trace_file," First scan not received from float %05d - no data written\n",x->float_id);
  if (error_file != NULL)
     fprintf (error_file," First scan not received from float %05d - no data written\n",x->float_id);
  return(1);
 }
 sprintf(buffer,"%s%04d_%05d_%03d.cnt",dir_name,s->AOML_number,s->ARGOS_id,x->profile_no);

 if (trace_file != NULL){
    fprintf (trace_file,"Opening output file %s...\n",buffer);
    }
 if ((out_file = fopen(buffer,"w+")) == NULL) // used to be fopen(buffer,"a+")
 {
  if (trace_file != NULL){
   fprintf (trace_file," WRITE_TO_DISK: ERROR opening output file %s\n",buffer);
   }
  if (error_file != NULL)
   fprintf (error_file," WRITE_TO_DISK: ERROR opening output file %s\n",buffer);
  return 1;
 }
 if (trace_file != NULL){
  fprintf (trace_file," WRITE_TO_DISK: output file %s successfully opened\n",buffer);
  }
// Write Output Profile Count File Name to List File
// -------------------------------------------------
 if ( (ptr_cnt_filename = strrchr(buffer, '/')) == NULL)
 {
  	if (trace_file != NULL){
   	fprintf (trace_file,"%s : Can't get cnt file basename %s\n", PRGNAME, buffer);
    printf("%s : Can't get cnt file basename %s\n", PRGNAME, buffer);
   	}
   	if (error_file != NULL)
    	fprintf (error_file,
             "%s: Can't get cnt file basename %s\n", PRGNAME, buffer);
   	return 1;
 } // endif: ptr_cnt_filename
 ptr_cnt_filename++;
 fprintf (list_file,"%s\n", ptr_cnt_filename);
 printf("%s\n", ptr_cnt_filename);

 sprintf (buffer,
     "INTERNAL ID NUMBER                      %04d\n"
     "WMO ID NUMBER                           %-5d\n"
     "TRANSMISSION ID NUMBER                  %-5d\n",
      s->AOML_number,abs(s->WMO_id),s->ARGOS_id);
 fwrite (strupr(buffer),1,strlen(buffer),out_file);

 sprintf (buffer,
     "WMO INSTRUMENT TYPE (TABLE 1770)        %d\n"
     "WMO RECORDER TYPE (TABLE 4770)          %d\n"
     "ARGOS PROGRAM NUMBER                    %d\n",
		s->wmo_instrument,s->wmo_recorder,s->exp_no);
 fwrite (strupr(buffer),1,strlen(buffer),out_file);

 sprintf (buffer,
     "INSTRUMENT TYPE                         %s\n"
     "PI                                      %s\n",
		s->float_type,s->PI);
 fwrite (strupr(buffer),1,strlen(buffer),out_file);

//pure test message header goes here
 sprintf (buffer,
     "PROFILE NUMBER                          %d\n",
     x->profile_no);
 fwrite (strupr(buffer),1,strlen(buffer),out_file);

 int m =0;
// printf("In WTD : flag_blk_time = %d \n",x->flag_blk_time);
 if( x->flag_blk_time == 0 )
 {
 	getFirstBLKTimeTest(s,x); // XXX - CHECK if this is only done if start_of_transmission can not derive the time of first transmission---YES
				 
 }

 sprintf (buffer,
 	 "START OF TRANSMISSION                   %s",
          julday2ymd((long)((float)x->first_blk_time/24./3600.)));
 fwrite (strupr(buffer),1,strlen(buffer),out_file);
 sprintf(buffer, " %s\n", timefrac2hms((double)(x->first_blk_time/24./3600.)));
 fwrite (strupr(buffer),1,strlen(buffer),out_file);

 if( x->flag_blk_time == 0 ){
 sprintf (buffer, 
	 "SOT FROM GFBT                           YES\n");
 fwrite (strupr(buffer),1,strlen(buffer),out_file);
 }
else
{
 sprintf (buffer, 
	 "SOT FROM GFBT                           NO\n");
 fwrite (strupr(buffer),1,strlen(buffer),out_file);

}

 int flag_m = 0;

  for(m=0;m<t->test_length;m++)
  {
	if(strncmp(t->test_name[m],"TOD",3) == 0)
	{
		continue;
	}
	if( strncmp(t->test_name[m],"NOTP",4) == 0)
	{
	  	continue;
	}
	else if( m == 0 && strncmp(t->test_name[m],"SN",2) == 0)
	{
		sprintf (buffer,"MESSAGE BLOCK ID                        %d\n",x->msg_blk_id);
  		fwrite (strupr(buffer),1,strlen(buffer),out_file);

		if( strlen( x->hex_test_time[0]) > 0 )
		{
			sprintf (buffer,"REFERENCE FOR MESSAGE BLOCK ID          %s\n",x->hex_test_time[0]);
		  	fwrite (strupr(buffer),1,strlen(buffer),out_file);
  		}

  		sprintf (buffer,"%s%s%d\n",t->test_print[m],t->test_unit[m],x->test_message[t->test_count[m]]);
  		fwrite (strupr(buffer),1,strlen(buffer),out_file);
	}
	else if(strncmp(t->test_name[m],"BLK",3) == 0)
	{
		sprintf (buffer,"%s%s%d\n",t->test_print[m],t->test_unit[m],x->test_message[t->test_count[m]]);
  		fwrite (strupr(buffer),1,strlen(buffer),out_file);

		if( strlen( x->hex_test_time[flag_m]) > 0 )
		{
			if( flag_m > 0 )
			{
				sprintf (buffer,"REFERENCE FOR MESSAGE BLOCK ID %d        %s\n",flag_m+1,x->hex_test_time[flag_m]);
		  		fwrite (strupr(buffer),1,strlen(buffer),out_file);
			}
			else
			{
				sprintf (buffer,"REFERENCE FOR MESSAGE BLOCK ID          %s\n",x->hex_test_time[flag_m]);
		  		fwrite (strupr(buffer),1,strlen(buffer),out_file);
			}
			
  		}
  		flag_m++;
	}
 	else if( strncmp(t->test_name[m],"MON",3) == 0 && strncmp(t->test_name[m+1],"DAY",3) == 0 && strncmp(t->test_name[m+2],"YR",2) == 0)
 	{
   		sprintf (buffer,"%s%s%02d/%02d/%02d\n",
      		t->test_print[m+2],t->test_unit[m+2],x->test_message[t->test_count[m]],x->test_message[t->test_count[m+1]],x->test_message[t->test_count[m+2]]);
   		fwrite (strupr(buffer),1,strlen(buffer),out_file);
   		m=m+2;
 	}
 	else if( strncmp(t->test_name[m],"STATUS",6)==0 )
 	{
 		sprintf (buffer,"%s%s%02X\n",
 		    t->test_print[m],t->test_unit[m],x->test_message[t->test_count[m]]);
  		fwrite (strupr(buffer),1,strlen(buffer),out_file);
 	}
 	else if( strncmp(t->test_name[m],"SEC",3)==0 )
 	{
		if( strncmp(t->test_name[m],"SEC2",4)==0 )
		{
			sprintf (buffer,"%s%s%d\n",
					     	 	t->test_print[m],t->test_unit[m],2*x->test_message[t->test_count[m]]);
  			fwrite (strupr(buffer),1,strlen(buffer),out_file);
		}
		else
		{
			sprintf (buffer,"%s%s%d\n",
		     	 	t->test_print[m],t->test_unit[m],x->test_message[t->test_count[m]]);
  			fwrite (strupr(buffer),1,strlen(buffer),out_file);
		}

		sprintf (buffer,
			 "REFERENCE FOR TIME SINCE START          %04d %02d %02d %02d %02d %02d\n",
		      	x->reference_time[0],x->reference_time[1],x->reference_time[2],x->reference_time[3],x->reference_time[4],x->reference_time[5]);
   		fwrite (strupr(buffer),1,strlen(buffer),out_file);
	}
    else if( strncmp(t->test_name[m],"PAV",3)==0 )
    {
		if(x->test_message[t->test_count[m]] < 255)
		{
  			sprintf (buffer,"%s%s%d\n",t->test_print[m],t->test_unit[m],x->test_message[t->test_count[m]]*2);
  		}
  		else if(x->test_message[t->test_count[m]]==255)
  		{
  			sprintf (buffer,"%s%s%d\n",t->test_print[m],t->test_unit[m],x->test_message[t->test_count[m]]);
  		}
  		fwrite (strupr(buffer),1,strlen(buffer),out_file);
	}
	else if( strncmp(t->test_name[m],"EPOCH",5)==0 )
	{
		 struct tm *gt;
		 x->gmttime = x->test_message[t->test_count[m]];
		 gt = gmtime (&x->gmttime);
		 char gmt_time[30];
		 strftime (gmt_time, 256,"%Y %m %d %H %M %S",gt);
		 sprintf (buffer,"%s%s%s\n",t->test_print[m],t->test_unit[m],gmt_time);
		 fwrite (strupr(buffer),1,strlen(buffer),out_file);

		 if( strncmp(t->test_name[m+1],"TINIT",5)==0 )
		 {
			m = m+1;
			sprintf (buffer,"%s%s%-5d\n",t->test_print[m],t->test_unit[m],x->test_message[t->test_count[m]]);
	   		fwrite (strupr(buffer),1,strlen(buffer),out_file);

			struct tm *gtr;
			x->gmttime += x->test_message[t->test_count[m]]*60;
			gtr = gmtime (&x->gmttime);
			char gmt_time_r[30];
			strftime (gmt_time_r, 256,"%Y %m %d %H %M %S",gtr);
			sprintf (buffer,"REFERENCE TIME FROM EPOCH               %s\n",gmt_time_r);
		 	fwrite (strupr(buffer),1,strlen(buffer),out_file);
		}
	}
 	else
 	{
		sprintf (buffer,"%s%s%d\n",
     	 	t->test_print[m],t->test_unit[m],x->test_message[t->test_count[m]]);
  		fwrite (strupr(buffer),1,strlen(buffer),out_file);
 	}
  }

  sprintf (buffer,
    	"MOST LIKELY FRAME STATUS                %d\n",x->flag_most_likely_frame);
  fwrite (strupr(buffer),1,strlen(buffer),out_file);

  sprintf (buffer,
	"++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
  fwrite (strupr(buffer),1,strlen(buffer),out_file);
  sprintf (buffer,"YEAR/MO/DY HR:MN:SC CRC DATA\n");
  fwrite (strupr(buffer),1,strlen(buffer),out_file);

  int tmp = 0;
  for(tmp=0;tmp<3;tmp++)
  {
	  if( strlen( x->hex_test_print[tmp]) > 0 )
	  {
	  	sprintf (buffer,"%s\n",x->hex_test_print[tmp]);
  	  	fwrite (strupr(buffer),1,strlen(buffer),out_file);
	  }
  }

  sprintf (buffer,
	"==========================================================\n");
  fwrite (strupr(buffer),1,strlen(buffer),out_file);


  i = 0;
  sprintf (buffer,"   LATITUDE  LONGITUDE YEAR/MO/DY HR:MN:SC XMITS SAT CLASS\n");

  fwrite (strupr(buffer),1,strlen(buffer),out_file);
  while (x->position_jd[i] > 0.0)
  {
 	//added new checking to make sure the position line's julian day is larger than the launch time's. by xia
  	int iy,imo,ida,ih,im,is,ndoy;
  	float pos_jday,launchtime_jday;
  	sscanf(x->date_time[i],"%4d/%02d/%02d%3d:%02d:%02d",&iy,&imo,&ida,&ih,&im,&is);
  	pos_jday=(float) dfr97(iy,imo,ida,ih,im,is,&ndoy);

  	if( s->launch_time-s->start_time < s->up_time && s->launch_time>s->start_time)
  		launchtime_jday=s->launch_time-s->up_time;
  	else
    	launchtime_jday=s->launch_time;
  	if(pos_jday>launchtime_jday)
  	{

//                  "----LLL.LLL---LLLL.LLL-YYYY/MM/DD-HH:MM:SS---XXX---S-----C"
  		sprintf (buffer,"    %+7.3f   %+8.3f %-19s   %03d   %1c     %1c\n",
    	x->latitude[i],x->longitude[i],x->date_time[i],x->n_xmits[i],x->sat_name[i],
    	x->loc_class[i]);
  	fwrite (strupr(buffer),1,strlen(buffer),out_file);
  	}

  	i++;
  }

  fprintf (out_file,"==========================================================\n");

   if (out_file != NULL)
    fclose (out_file);   /* Close output file */

  return 0;
}

