#!/bin/sh
###########################################################################
# Revision Date: 09-Mar-06 (RS - streamline email text. Skip profile tests
#                                in email when a problem)
#                16-Jul-03 (RS - remove comments)
#                15-May-03 (RS - improve mail subject)
#                14-May-03 (RS - add to mail subject)
#                20-Jun-00 (RS)
#
# send_email.sh
# ================
# Send SUMMARY_REPORT to OPERATOR list. 
#
###########################################################################
# ----------------------------------------------------------------------
#                         FUTURE EMAIL WORK
# Only one EMAIL_MESSAGE for all hex files process by "argos_process.sh"
# ----------------------------------------------------------------------
this_script=`basename $0`
up_script_name=$1
NPRV_FAILURES=$2

now=`date +'%h %d, %Y %T %p'`
echo "<-------------------- Start $this_script: $now -------------------->"

echo "Entering Script: $this_script"
echo "Number of PRV2HEX Failures: $NPRV_FAILURES"
echo "Calling Script:  $up_script_name"
echo "Email Location: $EMAIL_MESSAGE"
echo "Email Recepient(s): $EMAIL_OPERATOR"

if [ -f $EMAIL_MESSAGE ]
then
  if [ -s $EMAIL_MESSAGE ]
  then                                                  # Email file exists
    if [ $NPRV_FAILURES -eq 0 ]
    then
      subj="$up_script_name - Process Finished"
    else
      subj="$up_script_name - PRV File(s) Not Processed Successfully"
    fi
    echo "[Email Begin]"
    echo "  TO: $EMAIL_OPERATOR"
    echo "  Subj: $subj"
    echo "  Text: "
    awk '{print "  " $0}' $EMAIL_MESSAGE  
    printf "   Sending Email ... "
    mailx -s "$subj" $EMAIL_OPERATOR < $EMAIL_MESSAGE
    status=$?
    if [ $status -eq 0 ]
    then                                     # EMAIL sent
      echo "OK"
      rm -f $EMAIL_MESSAGE
    else
      echo " FAILURE" 
    fi
    echo "[Email End]"
  else                                                  # Email file empty
     echo ">>> $this_script:  Email File is Empty <<<"
  fi
else                                                    # No Email file
  echo ">>> $this_script:  No Email File <<<"
fi

now=`date +'%h %d, %Y %T %p'`
echo "<-------------------- Finish $this_script: $now ------------------->"

exit 0 
