c-------------------------------------------------------------------
      subroutine julday(iyr,imon,iday,ihour,rtime)
      jref=2439126    ! 12/31/65
      call juldat(iday,imon,iyr,j)
      jday=j-jref
      ih=ihour/100
      imin=ihour-ih*100
      rmin=ih*60+imin
      rtime=float(jday)+rmin/(24.0*60.0)
      return
      end
c-------------------------------------------------------------------
C     JULDAT.FOR
C     JULDAT... CONVERTS GREGORIAN CALENDAR DATES TO CORRESPONDING
C               JULIAN DAY NUMBERS.
C     PROGRAMMER... J. MALTAIS
C     DATE      ... NOVEMBER 6,1967
C*
C     Y... MAY BE EXPRESSED AS CENTURY PLUS YEAR WITHIN CENTURY
C          OR MAY BE EXPRESSED AS TWO PLACE INTEGER ('73') FOR THE
C          TWENTIETH CENTURY
C
      SUBROUTINE JULDAT(DP,MP,YP,J)
      DIMENSION IARR(3)
      INTEGER D,Y,C,MO,YR,DP,MP,YP
      D=DP
      M=MP
      Y=YP
    1 IF(Y.LT.100)Y=Y+1900
      YR=Y
      IF(M.GT.2)GO TO 5
      MO=M+9
      YR=Y-1
      GO TO 10
    5 MO=M-3
   10 C=YR/100
      YR=YR-100*C
      J=(146097*C)/4+(1461*YR)/4+(153*MO+2)/5+D+1721119
      RETURN
      ENTRY JULARR(IARR,J)
C     DIMENSION IARR(3)
      Y=IARR(1)
      M=IARR(2)
      D=IARR(3)
      GO TO 1
      END
c-------------------------------------------------------------------
      subroutine j2arr3(julian,ldate)
c
c Input:  julian - an absolute Julain day (not day_of_year )
c                  ( use j2toi3 subroutine for day_of_year )
c Output: ldate - array of year,month,day
      implicit NONE
      integer*4 julian,ldate(3)
c..   pl1900 entry,  adds ipaddt to 1900,1,1,0,0,0,0.
c     entry pl1900(ldate,ipaddt)
c     ldate(1)= year    iaddt(1)=days
c     ldate(2)= month   iaddt(2)=hours
c     ldate(3)= day     iaddt(3)=minutes
c
      integer m(12),l(3),l2,i
      equivalence (l(2),l2)
      data m /31,28,31,30,31,30,31,31,30,31,30,31/
c
      l(1)=1900
      l(2)=1
c      l(3)=julian-2415020	! Subtract 12/31/1899
      l(3)=julian+1	        ! Dave Behringer's analysis time 
  120 if(l(2).ne.2)goto 110
      m(2)=28
      if(mod(l(1),4).ne.0)goto 110
      if(mod(l(1),100).ne.0)goto 170
      if(mod(l(1),400).ne.0)goto 110
  170 m(2)=29
  110 if(l(3).le.m(l2))go to 999
      l(3)=l(3)-m(l2)
      if(l(2).lt.12)go to 150
      l(2)=l(2)-12
      l(1)=l(1)+1
  150 l(2)=l(2)+1
      goto 120
c
  999 do 99 i=1,3
         ldate(i)=l(i)
 99   end do
      return
      end
c----------------------------------------------------------------
      double precision function juldays1950(JDATEP)

      implicit none
c
c     Float reference date : 1950,01-01 00:00 --- 2433283
c     jref=2433283    ! 01/01/1950
C..   Finds elapsed time in minutes from Jan. 1, 1950
C     Mike Minton, AOML, 30-Apr-1991
C
C     JDATEP AND JDATE (1)= YEAR
C     JDATEP AND JDATE (2)= MONTH
C     JDATEP AND JDATE (3)= DAY
C     JDATEP AND JDATE (4)= HOUR
C     JDATEP AND JDATE (5)= MIN
C     JDATEP AND JDATE (6)= SEC
C
c     inputs: integer  --- year,month,day,hour,min,sec
c     output: double precision  --- juldays1950
c
c  check value 2001,7,25,19,14,0   ->   18833.801388919353
c
      integer JDATE(6),JDATEP(6)
      integer i
C
      DO 12 i=1,6
        JDATE(i)=JDATEP(i)
c        print *,'JDATE(i) ',i,JDATE(i)
   12 continue
      CALL JULDAT(JDATE(3),JDATE(2),JDATE(1),i)
C ! 2433283 = JULDAT for Jan.1,1950, 1440 = min/day, 60 = min/hr
      juldays1950=float(jdate(4))/24.+float(jdate(5))/1440.+
     *          float(jdate(6))/86400.
       juldays1950=juldays1950+(i-2433283)
c        print *,'juldays1950 ',i,juldays1950
      return
      end
