c
c*    pres2dep.f
c     =========
c     Pressure to depth conversion using 
c     Saunders&Fofonoff's method (deep sea res., 1976,23,109-111)
c     formula refitted for alpha(p,t,s)
c     units:
c           depth      z      meter
c           pressure   p      dbar
c           latitude   phi    deg
c
      subroutine pres2dep(p,phi,z)
      implicit none
      real p,p1,phi,gr,x,z

      p1=p/10.                         ! dbar->bar
      x=sin(phi/57.29578)
      x=x*x
      gr=9.780318*(1.0+(5.2788E-3+2.36E-5*x)*x)+1.092E-5*p1
      z=(((-1.82E-11*p1+2.279E-7)*p1-2.2512E-3)*p1+97.2659)*p1
      z=z/gr     
      return
      end

