c Revision Date: 31-Oct-12 VMH  - new compiler if(j>1 .and. stufff(j-1) test 
c                                 now fails - both conditions tested
c                01-Jan-10 (ER  - 'max_gts' should be 790 not 815.) 
c                16-Jan-09 (YHD - 'max_gts' should be 815 not 829.)
c                28-Feb-07 (YHD - Added 'PSAL_ADJUST' case.)
c                20-Sep-06 (YHD - A bad profile, 1728_5048_005.qc' case:
c                                 Changed fill value to be -999.99 instead of 99.99 and do not add fill value to sum for same depth case.)
c                11-Apr-06 (YHD - Add 'date long lat line for Reyna' for a 
c                                 normal exit (i.e. status=0) case.
c                01-Feb-06 (YHD - status=5 means exceeding dimension error;
c                                 status=9 means all i/o error)
c                01-Feb-06 (YHD - A warning statement shows when nlev gt lmax
c                                 =2000)
c                12-Jan-06 (YHD - lmax is changed from 1000 to 2000);
c                                 Since the "BATHY" format has a limit of 829 
c                                 data pairs(=15000 bytes), we will use sub-
c                                 sampling method when a profile has more than
c                                 829 data pairs.  Keep all points from 0.0 m
c                                 to 300 m and start subsample below that.)
c                                 
c                14-Sep-05 (YHD - A bad depth got written into the gts file?
c                                 When P is bad; make T & S bad as well.)
c                22-Mar-05 (YHD - A bug found in line 502)
c                07-Mar-05 (YHD - Do not send temp data to GTS when grey_list
c                                 ='y'&'TEMP' with flag of 3; do not send sal
c                                 data to GTS when grey_list='y'& PSAL with
c                                 flag of 3)
c                27-Jan-05 (YHD - 'qc' & 'gts' use same 'rd_phy_qc.f' but
c                                 'netcdf' uses a slightly different 
c                                 'rd_phy_qc.f')
c                27-Jan-05 (YHD - 'rd_float_meta.f' is all same from qc,
c                                 netcdf and gts run.)
c                18-Nov-04 (YHD - 'grey_list' added in META files.)
c                02-Nov-04 (YHD - when 'p' is bad delete that data line &
c                                 meta file is now one of input to this run)
c                20-Oct_04 (YHD - GTS transmission rules & Grey list
c                                 interpretation rules applied. Refer to
c                                 tables).  rd_phy_qc.f & rd_float_meta.f
c                                 introduced.
c                04-Jun-04 (YHD - Don't send the data to GTS when 
c                                 p-good; t-bad; s-bad case)
c                27-Apr-04 (YHD - Forgot to make nlev=jcnt & add status=4
c                                 for no position case & status=5 for all i/o
c                                 error)
c                26-Apr-04 (YHD - 'icnt' was used 2 occasions ---> Mistake)
c                          (icnt: # of positions; icnt1: # of same depth)
c                25-Mar-04 (YHD - No repeated depths allowed in GTS.)
c                25-Feb-04 (YHD - added error trap for any reading statement)
c                01-Dec-03 (YHD - prg name changed from phy2gts_format.f
c                                 to qc2gts_format.f
c                                 Do not use reserved word max. 
c                02_Jun-03 (YHD - TESAC max. length is now 15,000 bytes.)
c                30-May-03 (YHD - change float_id and argos_id to char*16)
c                07-May-03 (RS - correct warning)
c                30-Jan-03 (YHD - write "KKYY" created in trace file when
c                                 it actually create the GTS file)
c                23-Jan-02 (YHD - add GTS_DISTRIBUTION_SITE)
c                09-Jan-02 (YHD - 1 or less data point; Don't send GTS)
c                20-Apr-01 (YHD - Exit status)
c                17-Apr-01 (YHD - add NO WMO profile case)
c                17-Aug-00 (RS - implement return status from pala2kkyy_ts.f)
c                13-Aug-00 (RS - add call exit & and change 't ' to 't')
c
c qc2gts_format.f
c ================
c Creates a 'gts' file using 'kkyy' format when the profile is a good.
c     7  1         2         3         4         5         6         7 2
c* Input units:
c    unit 24: Palace phy file (profile to qc)
c* Output units:status
c    unit 50: error log file (qc2gts.yyyy.mm.dd_hh.mm_error)
c    unit 51: trace log file (qc2gts.yyyy.mm.dd_hh.mm_trace)
c    unit 52: 'kkyy' file (to_gtsgateway.yyyy.mm.dd.hh_mm)
c    unit 53: input '####_#####_###.phy' file
c    unit 66: debug file (qc2gts.yyyy.mm.dd_hh.mm_debug)
c* Exit Status value:
c    0 - OK to send it to GTS
c    1 - Data older than 30 days; Do not send it to GTS
c    2 - Temp. value error/ data <=1 point./unknown GTS_DIST_SITE,grey_list
c    3 - No WMO ID case
c    4 - No position case
c    5 - All I/O error
c
c    program qc2gts_format.f
c    YHD 08-01-2000
c
      implicit none

      integer, parameter :: lmax = 2200 ! max. nbr of levels in one profile
      integer, parameter :: max_byte = 15000
      integer, parameter :: np = 500
      integer, parameter :: max_gts = 790 

      logical :: DEBUG_ON = .false.
      integer, parameter :: DEBUG = 66

      integer iunit,int_num,wmo_num,wmo_inst,wmo_reco,prof_num

      integer nlev,n,nlev_out,igts,nlev_gts,
     *        iyr,imo,ida,ihr,imin,ios,status,
     *        iend_argo_id,
     *        jcnt,j,pres_check,icnt1,icnt2,last2,iunit_m,ireverse,
     *        argos_prg_num,itype,land,num_col,num_cal,icnt,
     *        iover_t,it_frzn,
     *        it_anlz(lmax),it_clim(lmax),
     *        it_gros(lmax),it_spik(lmax),it_vert(lmax),
     *        it_cntv(lmax),it_regi(lmax),it_jump(lmax),
     *        it_vis(lmax),ideep_flag(lmax),ipres(lmax),
     *        ip_vis(lmax),ispd,cksm(lmax),
     *        iover_s,is_frzn,
     *        is_anlz(lmax),is_clim(lmax),
     *        is_gros(lmax),is_spik(lmax),is_dens(lmax),
     *        is_cntv(lmax),is_regi(lmax),is_jump(lmax),
     *        is_vis(lmax),is_salg(lmax)
      
      real    bot_tem,bot_prs,sur_prs,bat_vot,
     *        int_vac,hr,rlat,rlon,fv

      real p(lmax),t(lmax),s(lmax),c(lmax),o(lmax),
     *     pres(lmax),tem(lmax),sal(lmax),pres_out(lmax),
     *     pres_f(lmax),tem_f(lmax),sal_f(lmax),dep_f(lmax),
     *     sum_pres,sum_temp,sum_sal,
     *     pres_gts(lmax),tem_gts(lmax),sal_gts(lmax)
      real dlay_down_hours,sur_prs,deep,sigma_clim,sigma_anal,
     *     alat_hist(np),alon_hist(np)

      character fm*9,ufm*11
      character itime*14
      character clmon*2,debug_arg,min_cnt*2,onoff*3,
     *          float_id*16,argos_id*16,profname*20
      character pathname_gts*128,pathname_qc*128,
     *          pathname_trace*128,pathname_error*128,
     *          pathname_debug*128,qcfile*128,gtsfile*128,
     *          pathname_meta*128,dist_site*5

      character fsnum*4,trans_sys*16,pos_sys*8,inst_ref*64,st_time*64,
     *          laun_time*64,proj_name*64,inst_type*16,whoi_c_date*14,
     *          juld_qc*1,pi*64,st_trans_time*19,whoi_pos_qc*1,
     *          t_param(lmax)*32,t_value(lmax)*32,column(lmax)*256,
     *          calib(lmax)*256,itime_hist(np)*14,itime_first*14,
     *          iclass_hist(lmax)*2

      character send_gts*1,grey_list*3,grey_date_st(5)*11,
     *          grey_date_en(5)*11,grey_parm(5)*10,grey_flag(5)*3,
     *          grey_reason(5)*80,bad_t*5,bad_s*5

      integer*4 lnblnk,index,lchar_occur,last,lastnb,lenstr,last1,
     *          len_float_id,i,n_grey

      integer   max_visp
      integer nx
      parameter (nx=50)
      integer n_drift,nparam
      real    drift_p(nx),drift_t(nx),drift_s(nx),drift_o(nx),
     *        drift_c(nx)

      double precision adate
      double precision down_days,up_hours,cyc_days,des_hours,
     *                 neu_days,asc_hours,
     *                 surf_hours,laun_pos_la,laun_pos_lo

      character PRGMAIN*13,slash*1
      data      PRGMAIN /'qc2gts_format'/

      data fm,ufm/'formatted','unformatted'/
      data iunit,iunit_m /53,54/
      data slash /'/'/
      data bad_t,bad_s/'     ','     '/
      data fv /-999.99/
c
c--- For PSAL_ADJUSTED
c
      integer aamin,aamax,camin,camax,gamin,gamax,ramin,ramax
      real    sal_adj(lmax)
      character sal_adj_line*128,psal_adj_exist*1
      integer is_regia(lmax),
     *        is_anlza(lmax),is_clima(lmax),is_grosa(lmax)
c
c --- Initialize character strings.
c
      do i=1,128
        pathname_gts(i:i)=' '
        pathname_qc(i:i)=' '
        pathname_trace(i:i)=' '
        pathname_error(i:i)=' '
        pathname_debug(i:i)=' '
        pathname_meta(i:i)=' '
        qcfile(i:i)=' '
        gtsfile(i:i)=' '
      end do
      do i=1,20
       profname(i:i)=' '
      end do
      do i=1,16
        float_id(i:i)=' '
        argos_id(i:i)=' '
      end do

      write(6, '(A, ": Entering Program Execution", A)') PRGMAIN 

      !
      ! Get environmental variable
      !
      call GETENV('GTSDEBUG', debug_arg)
      call GETENV('trace_outfile', pathname_trace)
      call GETENV('error_outfile', pathname_error)
      call GETENV('debug_outfile', pathname_debug)
      call GETENV('GTS_DISTRIBUTION_SITE',dist_site)

      if (debug_arg=='y' .or. debug_arg=='Y') then
        DEBUG_ON =.true.
        onoff = 'ON'
      else
        DEBUG_ON = .false.
        onoff = 'OFF'
      endif

      write(6, '(A, ": Debug Option is ", A)') PRGMAIN, onoff 
      write(6, '(A, ": GTS_DISTRIBUTION_SITE is ", A)') PRGMAIN,
     *  dist_site 

      !     
      ! Get command arguments:
      !
      call GETARG(1,pathname_qc)
      call GETARG(2,pathname_gts)
      call GETARG(3,pathname_meta)
      call GETARG(4,min_cnt)

      last1 = lchar_occur(pathname_qc,'/')
      lenstr = lnblnk(pathname_qc)

      profname(1:lenstr-last1+1) = pathname_qc(last1+1:lenstr)

      last = index(pathname_qc, '.')
      len_float_id=last-last1-1

      float_id(1:len_float_id) = profname(1:len_float_id)

      write(6, '(A, ": Profile File Name = ",A)') 
     *          PRGMAIN, float_id(1:len_float_id)
      lastnb = lnblnk(pathname_error)
      write(6, '(A, ": Opening Error file - ", A)') 
     *          PRGMAIN, pathname_error(1:lastnb)
      open(50,file=pathname_error,form='formatted',position='append',
     * iostat=ios)
      if (ios.ne.0) then
        status=9
        write(6, 
     *     '(A, ": Error opening ERROR file unit 50. ios= ", A)') 
     *       PRGMAIN, ios
        write(6,'("      File =", A)') pathname_error(1:lastnb)
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

        write(50,*) PRGMAIN, 
     *              ': Error opening ERROR file unit 50. ios=',ios
        write(50,*)'file =', pathname_error(1:lastnb)
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '9'
      end if

      lastnb = lnblnk(pathname_trace)
      write(6, '(A,": Opening Trace file - ", A)') 
     *          PRGMAIN, pathname_trace(1:lastnb)
      open(51,file=pathname_trace,form='formatted',position='append',
     * iostat=ios)
      if (ios.ne.0) then
        status=9
        write(6, 
     *     '(A, ": Error opening TRACE file unit 51. ios= ", A)') 
     *       PRGMAIN, ios
        write(6,'("      File =", A)') pathname_trace(1:lastnb)
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

        write(50,*) PRGMAIN, 
     *              ': Error opening TRACE file unit 51. ios=',ios
        write(50,*)'file =', pathname_trace(1:lastnb)
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '9'
      end if

      lastnb = lnblnk(pathname_gts)
      write(6, '(A,": Opening gts file - ", A)') 
     *          PRGMAIN, pathname_gts(1:lastnb)
      open(52,file=pathname_gts,form='formatted',position='append',
     *recl=max_byte,iostat=ios)
      if (ios.ne.0) then
        status=9
        write(6, 
     *     '(A, ": Error opening GTS file unit 52. ios= ", A)') 
     *       PRGMAIN, ios
        write(6,'("      File =", A)') pathname_gts(1:lastnb)
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

        write(50,*) PRGMAIN, 
     *              ': Error opening GTS file unit 52. ios=',ios
        write(50,*)'file =', pathname_gts(1:lastnb)
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '9'
      end if

      lastnb = lnblnk(pathname_qc)
      write(6, '(A,": Opening qc file - ", A)') 
     *          PRGMAIN, pathname_qc(1:lastnb)
      open(53,file=pathname_qc,form='formatted',status='old',
     * iostat=ios)
      if (ios.ne.0) then
        status=9
        write(6, 
     *     '(A, ": Error opening QC file unit 53. ios= ", A)') 
     *       PRGMAIN, ios
        write(6,'("      File =", A)') pathname_qc(1:lastnb)
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

        write(50,*) PRGMAIN, 
     *              ': Error opening QC file unit 53. ios=',ios
        write(50,*)'file =', pathname_qc(1:lastnb)
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '9'
      end if

      lastnb = lnblnk(pathname_debug)
      write(6, '(A, ": Opening Debug file - ", A)') 
     *          PRGMAIN, pathname_debug(1:lastnb)
      open(66,file=pathname_debug,form='formatted',position='append',
     * iostat=ios)
      if (ios.ne.0) then
        status=9
        write(6, 
     *     '(A, ": Error opening DEBUG file unit 66. ios= ", A)') 
     *       PRGMAIN, ios
        write(6,'("      File =", A)') pathname_debug(1:lastnb)
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

        write(50,*) PRGMAIN, 
     *              ': Error opening DEBUG file unit 66. ios=',ios
        write(50,*)'file =',pathname_debug(1:lastnb) 
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '9'
      end if
c
c* Open a meta file.
c
      lastnb=lnblnk(pathname_meta)
      write(6, '(A, ": Meta File Name = ",A)') 
     *          PRGMAIN, pathname_meta(1:lastnb)
      write(6, '(A, ": Opening Meta file - ", A)') 
     *          PRGMAIN, pathname_meta(1:lastnb)
      open(iunit_m,file=pathname_meta,form='formatted',status='old',
     * iostat=ios)
      if (ios.ne.0) then
        status=9
        write(6, 
     *     '(A, ": Error opening META file unit 54. ios= ", A)') 
     *       PRGMAIN, ios
        write(6,'("      File =", A)') pathname_meta(1:lastnb)
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

        write(50,*) PRGMAIN, 
     *              ': Error opening META file unit 54. ios=',ios
        write(50,*)'file =', pathname_meta(1:lastnb)
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '9'
      end if

      call rd_float_meta(iunit_m,int_num,wmo_num,argos_id,
     *  proj_name,
     *  inst_ref,st_time,laun_time,dlay_down_hours,down_days,up_hours,
     *  cyc_days,des_hours,neu_days,asc_hours,surf_hours,laun_pos_la,
     *  laun_pos_lo,fsnum,trans_sys,pos_sys,deep,send_gts,grey_list,
     *  grey_date_st,grey_date_en,grey_flag,grey_parm,grey_reason)

      if (DEBUG_ON) write(DEBUG,*)'<<<<< DEBUG from QC2GTS_FORMAT >>>>>'
      if (send_gts.eq.'n') then
          status=2
          write(6, '(A, ": send_gts NO case; do not send it to gts: ")') 
     *    PRGMAIN 
          write(6,'("      File =", A)') pathname_meta
          write(50,*) PRGMAIN, 
     *     '(A, ": send_gts NO case; do not send it to gts: ")'
          write(50,'("      File =", A)') pathname_meta
          write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
          call exit (status)  
          stop '2'
      end if
      if (grey_date_en(1)(1:11).eq.' 9999-99-99') then
        n_grey=1
      else
        n_grey=2     ! need to think about some more
      end if   
      
      if (grey_parm(1)(1:4).eq.'PSAL'.or.grey_parm(1)(6:9).eq.'PSAL') 
     * bad_s='nogts'
      if (grey_parm(1)(1:4).eq.'TEMP'.and.grey_flag(1)(1:1).eq.'3')
     * bad_t='nogts'      
      if (grey_parm(1)(1:4).eq.'PSAL'.and.grey_flag(1)(1:1).eq.'3')
     * bad_s='nogts'      
      if (grey_parm(1)(6:9).eq.'PSAL'.and.grey_flag(1)(3:3).eq.'3')
     * bad_s='nogts'      

      if (bad_t.eq.'nogts'.and.bad_s.eq.'nogts') then
          status=2
          write(6,'(A,": grey_list bad case; do not send it to gts: ")') 
     *    PRGMAIN 
          write(6,'("      File =", A)') pathname_meta
          write(50,*) PRGMAIN, 
     *     '(A, ": grey_list bad case; do not send it to gts: ")'
          write(50,'("      File =", A)') pathname_meta
          write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
          call exit (status)  
          stop '2'
      end if

c      decode(4,11,float_id(1:4)) int_num
      read(float_id(1:4),11,err=9999) int_num
 11   format(i4.4)
      iend_argo_id=index(float_id(6:len_float_id-1),'_')
c      read(float_id(6:iend_argo_id-1),12) argos_id
 12   format(i5)
      argos_id=float_id(6:4+iend_argo_id)
c      read(float_id(iend_argo_id+6:16),14) prof_num
 13   format(i3)
c      write(6,*)iend_argo_id,len_float_id
      read(float_id(iend_argo_id+6:len_float_id),13,err=9999) prof_num
 14   format(i4)
      lastnb = lnblnk(argos_id)
      if (prof_num.gt.1000) then 
        write(6,'(A, ": float_id =", A, " int_num = ", I4.4, 
     *              " argos_id = ", a, " prof_num = ", I4.4)') 
     *           PRGMAIN,float_id,int_num,argos_id(1:lastnb),prof_num 
      else
        write(6,'(A, ": float_id =", A, " int_num = ", I4.4, 
     *              " argos_id = ", a, " prof_num = ", I3.3)') 
     *           PRGMAIN,float_id,int_num,argos_id(1:lastnb),prof_num 
      end if
      
      qcfile=pathname_qc
      lastnb = lnblnk(qcfile)
      write(*, '(A, ": Opening File to qc2gts_format ", A)') 
     *          PRGMAIN, qcfile(1:lastnb)

      open(iunit,status='old',file=qcfile,form='formatted',iostat=ios)
      if (ios.ne.0) then
        status=9
        write(6, 
     *     '(A, ": Error opening QC file unit 53. ios= ", A)') 
     *       PRGMAIN, ios
        write(6,'("      File =", A)') pathname_qc(1:lastnb)
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

        write(50,*) PRGMAIN, 
     *              ': Error opening QC file unit 53. ios=',ios
        write(50,*)'file =', qcfile
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '9'
      end if

      nlev = 0          ! number of pres/tem/sal pairs before check_pts
      nlev_out = 0      ! number of pres/tem/sal pairs after  check_pts
      icnt = 0          ! number of positions

       call rd_phy_qc(iunit,int_num,wmo_num,argos_id,
     *  prof_num,inst_type,ireverse,whoi_c_date,juld_qc,
     *  wmo_inst,wmo_reco,argos_prg_num,pi,itype,land,
     *  sur_prs,st_trans_time,whoi_pos_qc,
     *  sigma_clim,sigma_anal,adate,
     *  n_drift,drift_t,drift_p,drift_s,drift_o,drift_c,
     *  nparam,t_param,t_value,
     *  num_col,column,num_cal,calib,
     *  iover_t,it_anlz,it_clim,it_gros,it_vert,it_spik,it_vis,it_cntv,
     *  it_jump,it_frzn,it_regi,ideep_flag,
     *  iover_s,is_anlz,is_clim,is_gros,is_dens,is_spik,is_vis,is_cntv,
     *  is_salg,is_jump,is_frzn,is_regi,
     *  ipres,ip_vis,ispd,cksm,
     *  icnt,alat_hist,alon_hist,itime_hist,iclass_hist,itime_first,
     *  nlev,p,t,s,c,o,
     *  psal_adj_exist,sal_adj,is_grosa,is_regia)
c
c--- nlev > lmax(=2200) case.
c
      if (nlev.gt.lmax) then
        status=5
        write(6, 
     *     '(A, ": Warning NLEV gt lmax(=2200) case ")') PRGMAIN
        write(6,*) PRGMAIN, ': nlev=',nlev
        write(6,'("      File =", A)') pathname_qc
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
        write(50,*) PRGMAIN, ': Warning NLEV gt lmax(=2200) case.'
        write(50,*) PRGMAIN, ': nlev=',nlev
        write(50,*) PRGMAIN, ': file =', qcfile
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '5'
      end if
c
c*    Check for bad points/fill value (-999.99) case in the data
c*    remove them before sending to GTS.
c
      max_visp=0
      do i=1,nlev
        if (ip_vis(i).gt.max_visp) max_visp=ip_vis(i)
      end do
      nlev_out=nlev
      if (iover_t.eq.4.or.iover_s.eq.4.or.max_visp.eq.4)then
c        call check_pts(it_spik,is_spik,it_gros,is_gros,
c     *       ipres,it_vert,is_dens,
c     *       it_vis,is_vis,ip_vis,
c     *       nlev,t,s,p,
c     *       nlev_out,tem,sal,pres,igts)
        call check_pts(it_gros,it_vert,it_spik,it_vis,it_cntv,
     *                 it_jump,it_frzn,it_regi,ideep_flag,
     *                 is_gros,is_dens,is_spik,is_vis,is_cntv,
     *                 is_salg,is_jump,is_frzn,is_regi,
     *                 ipres,ip_vis,
     *                 nlev,t,s,p,
     *                 psal_adj_exist,sal_adj,is_grosa,is_regia,
     *                 nlev_out,tem,sal,pres,igts)

        if (igts.eq.0) then
          status=2
          write(6, '(A, ": Bad data case; do not send it to gts: ")') 
     *    PRGMAIN 
          write(6,'("      File =", A)') pathname_qc
          write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
          write(50,*) PRGMAIN, 
     *     '(A, ": Bad data case; do not send it to gts: ")'
          write(50,'("      File =", A)') pathname_qc
          write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
          call exit (status)  
          stop '2'
        end if
      else
        do n=1,nlev
          pres(n)=p(n)
          tem(n)=t(n)
          sal(n)=s(n)
          if (psal_adj_exist.eq.'y') sal(n)=sal_adj(n)
        end do
      end if                   !if (iover_t.eq.4.or.iover_s.eq.4)then 
c
c* Check for same depths case (GTS is not allowed).
c
      do j=1,nlev_out
        pres_out(j)=pres(j)
      end do

      jcnt=0                               ! a new counter for pres/tem/sal
      do j=1,nlev_out            
        pres_check=int(pres_out(j))
        if (pres_out(j).eq.fv) go to 90  
        icnt1=0         ! for t
        icnt2=0         ! for s
        sum_pres=0.0
        sum_temp=0.0
        sum_sal=0.0
        ! BAD IN NEW COMPILER if (j.gt.1.and.pres_check.eq.int(pres(j-1))) go to 90
        if(j.gt.1) then
          if(pres_check.eq.int(pres(j-1))) go to 90
        endif
        do i=1,nlev_out        ! bug found  this line was do i=1,nlev
          if (pres_check.eq.int(pres(i))) then
             if (tem(i).eq.fv) then
               sum_temp=0.0
             else
               icnt1=icnt1+1
               sum_temp=sum_temp+tem(i) 
               pres_out(i)=fv
             end if
             if (sal(i).eq.fv) then
               sum_sal=0.0
             else
               icnt2=icnt2+1
               sum_sal=sum_sal+sal(i)
               pres_out(i)=fv
             end if
          end if
 80     end do
        jcnt=jcnt+1
        pres_f(jcnt)=pres(j)
        if (icnt1.eq.0) tem_f(jcnt)=tem(j)
        if (icnt1.gt.0) tem_f(jcnt)=sum_temp/icnt1
        if (icnt2.eq.0) sal_f(jcnt)=sal(j)
        if (icnt2.gt.0) sal_f(jcnt)=sum_sal/icnt2
        if (icnt1.gt.1.or.icnt2.gt.1) then
          pres_out(i)=-999.99
          if (DEBUG_ON)  write(DEBUG,*)'pres -999.99 case: ', jcnt,
     *    pres_check,pres_f(jcnt),tem_f(jcnt),sal_f(jcnt)
          end if
 90   end do
      nlev_out=jcnt
      if (DEBUG_ON) then
        write(DEBUG,*) 'All the levels that fit to print'
        do j=1,jcnt
          write(DEBUG,*)j,pres_f(j),tem_f(j),sal_f(j)
        end do
      end if

c
c*    The maximum p/t/s pairs is max_gts for now (=15000 bytes). If nlev
c     is more than max_gts, it will use subsampling method.
c     Keep all the data points from a surface to 300 m and subsample every
c     other point if a total is less than max_gts, if not then subsample every
c     3rd point so on. (12-Jan-06 decision)
c
      if (DEBUG_ON) then
        write(DEBUG,*) 'NUMBER OF LEVELS IS', nlev_out
      end if

      if (nlev_out>max_gts) then
        write(6,'(A," ",i4," Exceed max p/t/s sets (",i4,") ")')
     *    PRGMAIN, nlev, max_gts
        write(6,'(A, ": Calling subsample4gts routine to reduce data pts
     *")') PRGMAIN
        call subsample4gts(nlev_out,pres_f,tem_f,sal_f,
     *                     nlev_gts,pres_gts,tem_gts,sal_gts)
        nlev_out=nlev_gts
        do i=1,nlev_gts
          pres_f(i)=pres_gts(i)
          tem_f(i)=tem_gts(i)
          sal_f(i)=sal_gts(i)
        end do
      end if
c
c*   No WMO ID float, exit with status=3.
c
      if (wmo_num.eq.0) then
        status=3
        write(6, 
     *     '(A, ": Error No WMO id case ")') PRGMAIN
        write(6,'("      File =", A)') pathname_qc
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
        write(50,*) PRGMAIN, ': Error No WMO id case.'
        write(50,*) PRGMAIN, ': file =', qcfile
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '3'
      end if
c
c--- No position case.
c
      if (icnt.le.0) then
        status=4
        write(6, 
     *     '(A, ": Error No position case ")') PRGMAIN
        write(6,'("      File =", A)') pathname_qc
        write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
        write(50,*) PRGMAIN, ': Error No position case.'
        write(50,*) PRGMAIN, ': file =', qcfile
        write(50,*) PRGMAIN, ': STOP -> STATUS = ', status
        call exit (status)  
        stop '4'
      end if

      if (itime_first.eq.'              ') then
        read(itime_hist(1)(1:4),11,err=9999) iyr
        read(itime_hist(1)(5:6),12,err=9999) imo
        read(itime_hist(1)(7:8),12,err=9999) ida
        read(itime_hist(1)(9:10),12,err=9999) ihr
        read(itime_hist(1)(11:12),12,err=9999) imin
        itime=itime_hist(1)
      else
        read(itime_first(1:4),11,err=9999) iyr
        read(itime_first(5:6),12,err=9999) imo
        read(itime_first(7:8),12,err=9999) ida
        read(itime_first(9:10),12,err=9999) ihr
        read(itime_first(11:12),12,err=9999) imin
        itime=itime_first
      end if
      hr = ihr + 1.0*(imin)/60.0
      rlat = alat_hist(1)
      rlon = alon_hist(1)
c      itime = itime_hist(1)
      gtsfile=pathname_gts
c
c* Create 'kkyy' format file to put on GTS; only a profile that passed all 
c* qc tests.
c
c --- 1 or No data point case; Do not send it to GTS and exit with status=2.
c
      if (nlev_out.le.1) then
        write(50,'(A,": <<< 1 or no data point case >>>")')
     *PRGMAIN
        write(50,'(A, ": Number of data=", I5)') PRGMAIN, nlev_out
        write(6,'(A,": <<< 1 or no data point case >>>")') 
     *PRGMAIN
        write(6,'(A, ": Number of data=", I5)') PRGMAIN, nlev_out
        status = 2                                      
        write(50,'(A, ": STOP -> STATUS=", I2)') PRGMAIN, status
        write(6,'(A, ": STOP -> STATUS=", I2)') PRGMAIN, status
        call exit (status)
        stop '2'
      end if

      if (DEBUG_ON) write(DEBUG,85,err=9999) float_id,iyr,imo,ida,rlat,
     *                rlon,nlev_out
      write(51,85,err=9999) float_id,iyr,imo,ida,rlat,rlon,nlev_out

      if (bad_t.eq.'nogts') then
        do i=1,nlev_out
          tem_f(i)=fv
        end do
      end if
      if (bad_s.eq.'nogts') then
        do i=1,nlev_out
          sal_f(i)=fv
        end do
      end if

      call pala2kkyy(int_num,wmo_num,argos_id,prof_num,
     *  rlat,rlon,itime,wmo_inst,wmo_reco,nlev_out,tem_f,sal_f,pres_f,
     *  dep_f,gtsfile,min_cnt,dist_site,itype,status)

 85   format(1x,'qc2gts_format: ',a,' year/mon/day=',i4,'-',i2.2,'-',
     *i2.2,' lat=',f8.3,' lon=',f9.3,' nlev=',i5)
      
      close(50)                             ! qc2gts error file
      close(51)                             ! qc2gts trace file
      close(52)                             ! qc2gts gts file

      if (status .eq. 0) then
        write(6,'(A, ": Ran successfully - STATUS=", I2)') 
     *        PRGMAIN, status
        write(6,88) PRGMAIN,iyr,imo,ida,ihr,imin,rlat,rlon
 88     format(A,': ',i4.4,'/',i2.2,'/',i2.2,2x,i2.2,':',i2.2,2x,
     *f8.3,f9.3)
      else if (status .eq. 1) then
        write(6,'(A, ": Too Old for GTS Submission - STATUS=", I2)')
     *        PRGMAIN, status
      end if

      if (DEBUG_ON) close(66)             ! qc2gts debug file

      call exit (status)
c
c --- Reading/writing error trap
c
 9999 continue
      status=9
      if (DEBUG_ON) then
        write(DEBUG,'(A, ": Reading/Writing Error - STATUS=", I2)') 
     *        PRGMAIN, status
        write(6,'(A, ": Reading/Writing Error - STATUS=", I2)') 
     *        PRGMAIN, status
      end if
      if (DEBUG_ON) close(66)             ! qc2gts debug file
      call exit (status)
     
      end
c----------------------------------------------------------------------
c     subroutine check_pts
c     This routine checks any spikes or fill value cases.
c     inputs:
c       n - number of data points
c       ispike - overall flag of spike test
c       ispik_flag - array of spike test
c       t - temperature array
c       s - salinity array
c       p - pressure array
c     outputs:
c       igts - 0: do not send it to gts
c       no - number of data points without spike nor fill value
c       to - temperature array
c       so - salinity array
c       po - pressure array
c
c     yhd, 02-Dec-03
c----------------------------------------------------------------------
    
      subroutine check_pts(it_gros,it_vert,it_spik,it_vis,it_cntv,
     *                 it_jump,it_frzn,it_regi,ideep_flag,
     *                 is_gros,is_dens,is_spik,is_vis,is_cntv,
     *                 is_salg,is_jump,is_frzn,is_regi,
     *                 ipres,ip_vis,
     *                 n,t,s,p,
     *                 psal_exist,s_adj,is_grosa,is_regia,
     *                 no,to,so,po,igts)
c
c     it_spik: spike test T flags
c     is_spik: spike test S flags
c     it_gros: gross test T flags
c     is_gros: gross test S flags
c     it_vert: vertical gradient test T flags
c     is_dens: density gradient test S flags
c     is_salg: salinity gradient test S flags
c     it_jump: sensor drift test T flags
c     is_jump: sensor drift test S flags
c     it_regi: regional test T flags
c     is_regi: regional test S flags
c     it_cntv: constant value test T flags
c     is_cntv: constant value test S flags
c     it_frzn: frozen test T flags
c     is_frzn: frozen test S flags
c     ideep_flag: deepest pressure check flags
c     ipres: pressure flags
c     it_vis:  visual T flags
c     is_vis:  visual S flags
c     ip_vis:  visual P flags
c     n: number of data points
c     t:  temperature array
c     s:  salinity array
c     p:  pressure array
c
c          return values
c     igts: indicator to send this data to GTS or not
c     no: number of data points without bad data points
c     to: temperature array without bad data points
c     so: salinity array without bad data points
c     po: pressure array without bad data points

      implicit none
      integer n,no,i,icn,igts,max_flag,max_flag_t,max_flag_s
      integer it_gros(*),it_vert(*),it_spik(*),it_vis(*),it_cntv(*),
     *        it_jump(*),it_frzn,it_regi(*),ideep_flag(*),
     *        is_gros(*),is_dens(*),is_spik(*),is_vis(*),
     *        is_cntv(*),is_salg(*),is_jump(*),is_frzn,
     *        is_regi(*),ipres(*),ip_vis(*)
      real t(*),s(*),p(*),to(*),so(*),po(*),fv
      data fv/-999.99/

      logical :: DEBUG_ON = .false.
      integer, parameter :: DEBUG = 66
c
c--- For PSAL_ADJUSTED
c
      real    s_adj(*)
      character psal_exist*1
      integer is_regia(*),is_grosa(*)

      if (DEBUG_ON) write(DEBUG,*)'<<<<< DEBUG from CHECK_PTS >>>>>'
      igts=1
      no=n
      icn=0        ! a new counter without bad values
      if (DEBUG_ON) write(DEBUG,*)'Number of points coming in=',n
c
c* Visual flags always overrule any other flags.
c
      do i = 1, n
        if (DEBUG_ON) write(DEBUG,*)it_vis(i),is_vis(i),ip_vis(i)
        if (it_vis(i).eq.1.and.is_vis(i).eq.1.and.ip_vis(i).eq.1) then
c--- Visual done & good points:
          icn=icn+1
          to(icn)=t(i)
          so(icn)=s(i)
          po(icn)=p(i)
          if (psal_exist.eq.'y') so(icn)=s_adj(i)
        else if(it_vis(i).eq.4.or.is_vis(i).eq.4.or.ip_vis(i).eq.4) then
c--- Visual done & bad points:
          icn=icn+1
          to(icn)=t(i)
          so(icn)=s(i)
          po(icn)=p(i)
          if (it_vis(i).eq.4) to(icn)=fv
          if (is_vis(i).eq.4) so(icn)=fv
          if (ip_vis(i).eq.4) po(icn)=fv
c          if (it_vis(i).eq.4.and.is_vis(i).eq.4) then
          if ((it_vis(i).eq.4.and.is_vis(i).eq.4).or.
     *         ip_vis(i).eq.4) then
            po(icn)=fv 
            to(icn)=fv
            so(icn)=fv
            icn=icn-1                       ! drop this point
          end if
        else if(it_vis(i).eq.0.or.is_vis(i).eq.0.or.ip_vis(i).eq.0) then
c--- Visual not done:
          icn=icn+1
          to(icn)=t(i)
          so(icn)=s(i)
          po(icn)=p(i)
          if (psal_exist.eq.'y') so(icn)=s_adj(i)
          if (to(icn).eq.0.0.and.so(icn).eq.0.0.and.po(icn).eq.0.0)
     *    then
            icn=icn-1
            go to 90
          end if                             ! drop this point
          max_flag=max(it_gros(i),is_gros(i),it_spik(i),is_spik(i),
     *                 ipres(i),it_vert(i),is_dens(i),is_salg(i),
     *                 it_cntv(i),is_cntv(i),it_jump(i),is_jump(i),
     *                 it_regi(i),is_regi(i),it_frzn,is_frzn,
     *                 ideep_flag(i),is_grosa(i),is_regia(i))
          max_flag_t=max(it_gros(i),it_spik(i),it_vert(i),it_cntv(i),
     *                   it_regi(i),it_frzn,it_jump(i),ideep_flag(i))
          max_flag_s=max(is_gros(i),is_spik(i),is_dens(i),is_cntv(i),
     *                   is_regi(i),is_frzn,is_jump(i),ideep_flag(i),
     *                   is_salg(i),is_grosa(i),is_regia(i))
          if (DEBUG_ON) then
            write(DEBUG,*)'max_flag=',max_flag,' max_flag_t=',
     *                    max_flag_t,' max_flag_s=',max_flag_s
          end if
          if (max_flag.eq.4) then
            if (max_flag_t.eq.4) to(icn)=fv
            if (max_flag_s.eq.4) so(icn)=fv
            if (ipres(i).eq.4) po(icn)=fv
            if (to(icn).eq.fv.and.so(icn).eq.fv) icn=icn-1   ! drop this point
          end if                            ! if (max_flag.eq.4) then
        end if                              ! if (it_vis(i)...
 90     continue
      end do

      if (DEBUG_ON) then
        write(DEBUG,*)'icn=',icn
        do i=1,icn
           write(DEBUG,*)i,po(i),to(i),so(i)
        end do
      end if
      if (icn.eq.0) then
        igts=0
        return
      end if
      no=icn
      return
      end       
c----------------------------------------------------------------------
c     subroutine subsample4gts
c     This routine subsample data points when there are too many data points.
c     Keep first 0.0 - 300.0 m data points and subsample every 2 points or 3
c     points if necessary.
c     inputs:
c       n - number of data points 
c       p - pressure array
c       t - temperature array
c       s - salinity array
c     outputs:
c       n_gts - number of data points to gts (has to be less than max_gts points)
c       p_gts - pressure array
c       t_gts - temperature array
c       s_gts - salinity array
c
c     yhd, 12-Jan-06
c----------------------------------------------------------------------
      subroutine subsample4gts(n,p,t,s,n_gts,p_gts,t_gts,s_gts)
      implicit none

      integer n,n_gts,i,j,isample,n_more,i_300,
     *        status

      integer, parameter :: max_gts = 810
      character(len=13), parameter :: PRGMAIN = 'subsample4gts'
      logical :: DEBUG_ON = .false.
      integer, parameter :: DEBUG = 66
     
      real p(*),t(*),s(*),p_gts(*),t_gts(*),s_gts(*)
      data isample /2/   ! subsample start with 2
      
c
c--- Keep all data points from a surface to 300 m.
c
      if (DEBUG_ON) then
        write(DEBUG,*)'<<<<< DEBUG from subsample4gts >>>>>'
      end if

      do i=1,n
        if (p(i)>=0.0 .and. p(i)<=300.0) then
          n_gts=n_gts+1
          p_gts(n_gts)=p(i)
          t_gts(n_gts)=t(i)
          s_gts(n_gts)=s(i)
          if (DEBUG_ON) then
            write(DEBUG,*) n_gts,p_gts(n_gts),t_gts(n_gts),s_gts(n_gts)
          end if
          i_300=i
        end if
      end do     ! do i=1,n
c
c--- If there are more than max_gts points up to 300 m. Stop this case.
c
      if (n_gts>max_gts) then
         status=5
         write(6,'(A, ": # of points up to 300 m (",i4, ") > ",i5)')
     *     PRGMAIN, max_gts, n_gts
         write(6,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
         write(50,'(A, ": # of points up to 300 m (",i4, ") > ",i5)')
     *     PRGMAIN, max_gts, n_gts
         write(50,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
         call exit (status)  
         stop '5'
      end if      ! if (n_gts.gt.max_gts) then
c
c--- Count how many points to pick from 300.0 m to the last point
c    using every isample points.
c
 10   continue
      n_more=(n-n_gts)/isample+1
      if (DEBUG_ON) then
         write(DEBUG,33) n,n_gts
         write(DEBUG,34) n_more,isample
 33      format(1x,'Total data points=',i5,' No. of data points upto 300
     *m=',i5)
 34      format(1x,'No. of data points from 300.0 to last =',i5,
     *' sample by every ',i2,' point.')
      end if         ! if (DEBUG_ON) then
      if (n_more+n_gts.le.max_gts) then
         do i=i_300+1,n,isample
           n_gts=n_gts+1
           p_gts(n_gts)=p(i)
           t_gts(n_gts)=t(i)
           s_gts(n_gts)=s(i)
           if (DEBUG_ON) write(DEBUG,*) n_gts,p_gts(n_gts),
     *     t_gts(n_gts),s_gts(n_gts)
         end do
      else
        isample=isample+1
        go to 10
      end if          ! if (n_more+n_gts.le.max_gts) then

      return
      end

   
