/***************************************************************************** 
 Revision date:	 13-Jun-2012 VMH: more debug changes
                 21-May-2012 VMH: VMH debugs.
                 14-Mar-2012 VMH: Initial release
  
  Msg2Phy_Ir_TS8.java
  ===================
  Decode a msg file from an Iridium float type NAVISIR_TS8 message file and 
  create a correspondent new phy file

   NAVISIR_TS8 float type's rom version is exactly 
   the same as APEXIR_TS5

*****************************************************************************/

public class Msg2Phy_Ir_TS8 extends Msg2Phy_Ir_TS5
{


   public Msg2Phy_Ir_TS8( String msgPathname, String phyPathname,String stsPathname,
                          String metaPathname, String technicalFilePathname,
                          String configTableFilePathname, 
                          String logJavaFilePathname, String errorFilePathname, 
                          String debug )
   {
     super( msgPathname, phyPathname,stsPathname, metaPathname,
            technicalFilePathname, configTableFilePathname,
            logJavaFilePathname, errorFilePathname, debug );
   }

  public static void main ( String args[] )
  {
    if(debugOn) System.out.println( "TS8 D beg");  
    if ( args.length != 9 ) {
      System.out.println( Utils2.dateFormatMessage( "Msg2Phy_Ir_TS8", null, "Usage:java Msg2File msgPathname phyPathname metaPathname technicalTableFilePathname configTableFilePathname logJavaFilePathname errorFilePathname debug") ); 
      System.exit(ERR_WRONG_NBR_PARAM);
    }

    Msg2Phy_Ir_TS8  msg2Phy = new Msg2Phy_Ir_TS8(args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7],args[8] );
    msg2Phy.process(); 
    if(debugOn) System.out.println( "TS8 D end");
   }

}
