/************************************************************************************* 
  Revision date: 10-Feb-2010 ER: Initial version 
  
  LowResTableReader_all.java
  ===================
  Reads the Low Res table for each float type to determine the flow of equations
  it has to process 

**************************************************************************************/
import java.io.*;
import java.util.*;
import java.text.*;

public class LowResTableReader_all extends Msg2Phy_Ir_TSOALL 
{

    private FileReader fileReader;
    private BufferedReader buffReader;
    boolean error; 
    public String filePathname ;
    List headerNames ;
    LinkedHashMap<String,List> lhm ;
    List<String> equations = new ArrayList<String>();
    List<String> lineGen = new ArrayList<String>();
    int ofreqPos=0;

  public LowResTableReader_all(String filePathname ) {
     
  try {
       this.filePathname=filePathname;
       fileReader = new FileReader( filePathname );
       buffReader = new BufferedReader( fileReader );
       lowResHeaders();
     }
     catch ( IOException e ) {
       setError( true );
       return;
     }


  }
  public void setError( boolean error ) {
    this.error = error;
  }

  public boolean hasError() {
    return this.error;
  }

 private void lowResHeaders() throws IOException,NoSuchElementException{
       
      	String line = buffReader.readLine();
        StringTokenizer st1 ;
       	int sep1Count = 0;
       	int sep2Count = 0;
        String sep1String,sep2String;
	String name = "";
	int keyCount=0;
        lhm =  new LinkedHashMap <String,List>();
        List<String> values = new ArrayList<String>();
	boolean lineGen_bool = false;

       try{
	       while(line != null)
	       {
			 st1= new StringTokenizer(line,"<>");
			 //System.out.println("line"+line);
			while(st1.hasMoreElements())
			{
		
				if(sep1Count == 0)
				{
				 sep1String = st1.nextElement().toString();
				 //System.out.println("sep1String in If"+sep1String);
				 if(sep1String.equals("gen"))
				 lineGen_bool = true;
				 else
				 lineGen_bool = false;
				 sep1Count++;
				 continue;
				}
				sep1String = st1.nextElement().toString();
				//System.out.println("sep1String 2nd time = "+sep1String);
				StringTokenizer st2 = new StringTokenizer(sep1String,",");
				while(st2.hasMoreElements())
				{
				   
				    if(sep2Count == 0)
				    {
				  
					name =st2.nextElement().toString();
					if(name.startsWith("equation"))
					this.equations.add(name);

					if(lineGen_bool){
					 this.lineGen.add(name);
					}
					
					//System.out.println("name in If :::  "+name);
					sep2Count++;
				    }
				    sep2String =st2.nextElement().toString();
				    //System.out.println("sep2String = "+sep2String);
				    values.add(sep2String);
				
				}
//				   //System.out.println("St1 next Element"+st1.nextElement());
				   sep2Count =0;
				   lhm.put(name,values);
				   values = new ArrayList();
				   if(name.startsWith("ofreq")){
				     ofreqPos = lhm.size();
				   }
				   //System.out.println(" Gen Names = "+lineGen);
				   //System.out.println(" No of Values in the Hash map = "+lhm.size());
				   //System.out.println(" values from the Hash map = "+lhm.get(name));
				   setHeaders(lhm);
					

			}
		
		line = buffReader.readLine();
		sep1Count =0;
		}

				   //System.out.println(" values from the Hash map Map= "+lhm);
   	}
   
   	catch(NoSuchElementException n){

		  System.exit(Constants.ERR_ELEMENT_NOT_FOUND);
	}

  }


 
private void setHeaders(LinkedHashMap lhmKeyValues){

	this.headerNames = new ArrayList(lhmKeyValues.keySet());
	//System.out.println("headerNames == "+headerNames);

}
public int getHeadersSize(){

	int headerSize = this.headerNames.size(); 
	//System.out.println("headerNames Size LowRes == "+headerSize);
	return headerSize;
}

public LinkedHashMap getMap(){
        return lhm;
}
public List getHeaders(){
	return this.headerNames;
}

public int getEquationSize(){
	return this.equations.size();
}

public String getFirstValue(String str){
       /* System.out.println("First Value String in low res= "+str);
	System.out.println("First Value"+ (lhm.get(str).get(0).toString()));*/
	return lhm.get(str).get(0).toString();
}

public List getEquations(){
        //System.out.println("Equations in Low Res = "+this.equations);
	return this.equations;
}
public List getEquationParameters(String str){

	List forParameters = new ArrayList();
	List parameters = new ArrayList();
	LinkedHashMap<String,List> lhm_temp = new LinkedHashMap<String,List>();

         //System.out.println("str == "+str);

	lhm_temp = getMap();
	parameters = lhm_temp.get(str);
	
         //System.out.println("parameters::" +parameters.size());
	
	//parameters = lhm_temp.get(str)
	for(int jj=2;jj<parameters.size();jj++){
	
	   forParameters.add(parameters.get(jj));


	}
  //       System.out.println("forParameters in low res class" +forParameters);
	return forParameters;
}


public List getLinegen(){
	return this.lineGen;
}


public int getOfreqPositionLowRes(){
        //System.out.println("Ofreq positon= "+ofreqPos);
	return ofreqPos;
}

public  Integer getNaNCount(){
        
	Integer nanCount = 0;
        if(lhm.containsKey("ALL_NAN_IN_MSG"))
        nanCount = lhm.get("ALL_NAN_IN_MSG").size();
       // System.out.println(nanCount);
	return nanCount;

}

public List getNaNPositions(){

	List nanPositions  = new ArrayList<String>();
	if(lhm.containsKey("ALL_NAN_IN_MSG"))
	nanPositions = lhm.get("ALL_NAN_IN_MSG");
	//System.out.println("nanPositions = "+nanPositions);
	
	return nanPositions;
}

}
