/************************************************************************
 Revision date:  04-Dec-2013 CA fillValueOFreq is modified from 99999 to -999
                 21-Mar-2013 CA Addition of NOM_AIR_P,NOM_AIR_MIX,uM
 	 	 11-Sep-2012 CA Initial Version

*************************************************************************/

public final class Constants{

   // Constants for exit codes
   static public final int OK = 0;
   static public final int ERR_OPEN_MSG_FILE  = 111;
   static public final int ERR_OPEN_META_FILE = 115;
   static public final int ERR_OPEN_TECH_PARAM_FILE = 117;
   static public final int ERR_OPEN_CONFIG_PARAM_FILE = 118;
   static public final int ERR_WRONG_NBR_PARAM = 131;
   static public final int ERR_CREATE_LOG_FILE = 132;
   static public final int ERR_CREATE_PHY_FILE = 133;
   static public final int ERR_WRONG_META_INFO = 134;
   static public final int WRN_MSG_FILE_INCOMPLETE = 135;
   static public final int ERR_OPEN_ERROR_FILE = 136;
   static public final int WRN_CONF_PARAM_NOTFOUND = 137;
   static public final int ERR_COEFF_NOTFOUND = 138;
   static public final int ERR_COEFF_VAL_NOTFOUND = 139;
   static public final int ERR_OPEN_LOWRES_TABLE = 140;
   static public final int ERR_OPEN_HIGHRES_TABLE = 141;
   static public final int ERR_ELEMENT_NOT_FOUND = 142;
   static public final int ERR_FOIL_MATRIX_NOT_FOUND = 143;
   static public final int ERR_LOWRES_TABLE = 144;
   static public final int ERR_ROWSCOLS_MISSING = 145;
   static public final int ERR_ROWSCOLS_VALUES_INCORRECT = 146;
   static public final int ERR_VAR_NOTFOUND = 148;
   static public final int ERR_IO = 998;
   static public final int ERR_EXECUTION = 999;


   // Constants used various Funcitons 
   static public final double NOM_AIR_P = 1013.25;
   static public final double NOM_AIR_MIX = 0.20946;
   static public final double uM = 44.659;
   
   // fill value constants
   static final double fillValuePress = -999.0;
   static final String fillValuePress_char = "-999.0";
   static final double fillValueTemp  = -999.0;
   static final String fillValueTemp_char  = "-999.0";
   static final double fillValuePSal  = -999.0;
   static final String fillValuePSal_char  = "-999.0";
   static final int    fillValueOFreq = -999;
   static final double fillValueBPhase = -999.0;
   static final double fillValueRPhase = -999.0;
   static final double fillValueO2    = -999.0;
   static final double fillValueNO3   = -999.0;
   static final double fillValuePH    = -999.0;


   final static int MAX_NBR_PARAMS = 150;
   // var used for the config parameter lines
   static final int MAX_NBR_CONFIG_LINES = 100;
   // var used for the technical parameter lines
   static final int MAX_NBR_TECH_LINES = 100;
     
 
  // const and vars that indicate in which phase of 
  // the reading of the input file the program is
  
  static final byte NOT_STARTED = 0;
  static final byte MISSION_CONFIG = 1;
  static final byte PARK = 2;
  static final byte LOW_RESOLUTION = 3;
  static final byte HIGH_RESOLUTION = 4;
  static final byte GPS = 5;
  static final byte TECHNICAL = 6;

   //vars used for profiles 1 and 2
   static final int MAX_NBR_DRIFT_LINES = 500;
   static final int MAX_NBR_LOW_RESOL_LINES = 1000;
   static final int MAX_NBR_HIGH_RESOLUTION_LINES = 3000;
   static final int MAX_NBR_PROFILE_1_LINES = 3000;
   static final int MAX_NBR_PROFILE_2_LINES = 1000;
   static final int HEADERS = 20;
}
