import java.io.*;
import java.text.*;
import java.util.*;
import java.lang.*;
public class DecodeSTSData
{
	private String filePathname;
	int eot = -2 ,count = 0,columnCount=7;
        double [][] stsData= new double[2000][8] ; //create a constant value for 2000
        double [][] stsDataTmp= new double[2000][8] ; //create a constant value for 2000
        DecimalFormat dec6Format = new DecimalFormat("0.000000");
	int lineCount=0;
	
	public DecodeSTSData( String filePathname,boolean stsData ) 
	{
		FileReader fileReader;
		BufferedReader buffReader;
		this.filePathname = filePathname;
		int lineLength=0;
		try  {
			fileReader = new FileReader( this.filePathname );
			buffReader = new BufferedReader( fileReader );
			String line = buffReader.readLine();
			while (line!=null) {
			        lineLength = line.length();
                                //detect <EOT>
				if(lineLength == 5 && line.equals("<EOT>")){
				    eot = 0;
				    count = 0;
				    line = buffReader.readLine();
				    continue;
				}
				//detect empty lines
				 if(line.equals("")){
				    count = 0;
				    line = buffReader.readLine();
				    continue;

				 }

				 if(lineLength == 22 || lineLength == 13){
			            for(int i=0;i<8;i++){
                                      if(i == 3) {
				        this.stsData[this.lineCount][i]= getSalinity(this.stsData[this.lineCount][0],this.stsData[this.lineCount][1],this.stsData[this.lineCount][2]);
				      }
				      else if(i == 7){
				        this.stsData[this.lineCount][i]= getSalinity(this.stsData[this.lineCount][0],this.stsData[this.lineCount][5],this.stsData[this.lineCount][6]);
				      }
				      else if(i == 4){
				        this.stsData[this.lineCount][i]= this.stsData[this.lineCount][0];
				      }
				      else{
				        this.stsData[this.lineCount][i]= getValues(line,lineLength,i);
				      }
				        
				     }
				        this.lineCount++;

				 }


				line = buffReader.readLine();
			}
		}

		catch(Exception e){
			System.out.println("Exception"+e );
		}

	}

        public double getValues(String line,int lineLength,int callCount){
             Integer result=0;
	     double resultd=0.0;
	     if(callCount == 0){
	         result = getDecimalSubString(line,0,4);
		 if (result != -9999)
	             resultd = (double)result/10;

	     }
	     if(lineLength == 22){
	      //Main Temparature 
		if(callCount ==  1){
	         result = getDecimalSubString(line,13,4);
		 if (result != -9999)
	             resultd = (double)result/1000;
		 }
	      //Main Conductivity 
		else if (callCount ==  2){
	         result = getDecimalSubString(line,17,5);
		 if (result != -9999)
	             resultd = (double)result/100000;
	       }
	      //STS Temperature
		else if (callCount ==  5){
	         result = getDecimalSubString(line,4,4);
		 if (result != -9999)
	             resultd = (double)result/1000;
	       }
	      //STS Conductivity 
		else if (callCount ==  6){
	         result = getDecimalSubString(line,8,5);
		 if (result != -9999)
	             resultd = (double)result/100000;
	       }


	     }
	     if(lineLength == 13){
	      //STS Temperature
		if(callCount ==  1){
	         result = getDecimalSubString(line,4,4);
		 if (result != -9999)
	             resultd = (double)result/1000;
		 }
	      //STS Conductivity 
		 if (callCount ==  2){
	         result = getDecimalSubString(line,8,5);
		 if (result != -9999)
	             resultd = (double)result/100000;
	       }
	      //Main Temparature 
		else if (callCount ==  5){
	         result = getDecimalSubString(line,17,5);
		 if (result != -9999 )
	             resultd = (double)result/100000;
                 else
	             resultd = -999.0;
                 
	       }
	      //Main Conductivity 
		else if (callCount ==  6){
	         result = getDecimalSubString(line,13,4);
		 if (result != -9999)
	             resultd = (double)result/1000;
                 else
	             resultd = -999.0;
	       }


	     }

	     return resultd;


	 }

       public Integer getDecimalSubString(String line,int pos,int size){


	    Integer result = -9999,end = 0;
            
	    int l = line.length();
	    end = pos + size;

	    if(l >= end)
	    {
	        result = Integer.parseInt(line.substring(pos,end),16);
                if(Double.isNaN((double)result ))
                  result = -9999;
                

	    }// end if

	    return result;
       }

      double getSalinity(double P,double T90,double C)
      {
		int i =0;
		double [] A = {0,.00002070,-.0000000006370,.000000000000003989};
		double [] B = {0,.03426,.0004464,.4215,-.003107};
		double [] a = {.008,-.1692,25.3851,14.0941,-7.0261,2.7081};
		double [] b = {.0005,-.0056,-.0066,-.0375,.0636,-0.0144};
		double [] c = {0.6766097,.0200564,.0001104259,-.00000069698,.0000000010031};
		double rt=0.0,Rt=0.0,Rp=0.0,Rx=0.0,R=0.0,T68=0.0,S=0.0,k=.0162,temp=0.0;

		T68 = 1.00024 * T90;
		R = C / 4.2914;
		Rp = 1 + ( A[1] * P + A[2] * P * P +A[3] * P * P * P )/( 1 + B[1] * T68 + B[2] * T68 * T68 + B[3] * R + B[4] * T68 * R);

		for (  i = 0 ; i <= 4 ; i++ )
		{
		   rt += c[i] * Math.pow( T68, i );
		 
		}//end for
		Rt = R / (rt * Rp);

		for (  i = 0 ; i <= 5 ; i++ )
		{
		   Rx += b[i] * Math.pow( Rt,((double)i)/2.0);
		   temp += a[i] * Math.pow( Rt,((double)i)/2.0);
		}//end for
		S = temp + ( ( T68 - 15 )/( 1 + k*(T68  - 15) ) )* Rx;
		if ( Double.isNaN(S) )
		{
		   S = -999.0;
		}//end if
		return S;

      }// end


       public int getLineCount() {
             return this.lineCount;
       }
       public double[][] getSTSData(){
             this.stsDataTmp = reverseSTSData(this.stsData);
             return this.stsDataTmp ;
       }
       public double[][] reverseSTSData(double[][] stsData){
             double[][] stsDataTmp = new double[2000][8];
	     for(int j = 0;j<this.lineCount;j++){
	        for(int i=4;i<8;i++)
		{
	            stsDataTmp[j][i-4]=stsData[j][i];
	        }
	        for(int i=0;i<4;i++)
		{
	            stsDataTmp[j][i+4]=stsData[j][i];
	        }
	     }
            return stsDataTmp; 

       }


/*	public static void main ( String args[] )
	{
		DecodeSTSData decodeSTSData = new DecodeSTSData(args[0]);

	}
*/

}
