/*************************************************************************************************
        24-Jan-2013  CA:Initial release

        InterpolateGpsFixes.java
        =========================
        Interpolate missing GPS Fixes for those profiles under ice


**************************************************************************************************/
import java.io.*;
import java.lang.*;
import java.util.*;
import java.text.*;
import java.util.TreeSet;
import java.util.StringTokenizer;
import java.util.Date;

public class InterpolateGpsFixes
{

 boolean error = true;
 final static int NBR_LAT_LON = 2;
 String[] latitude  = new String[NBR_LAT_LON];
 String[] longitude = new String[NBR_LAT_LON];
 String[] interpolatedValues = new String[NBR_LAT_LON];
 String[] date = new String[NBR_LAT_LON];
 String[] time = new String[NBR_LAT_LON];
 Date dateProf;
 String floatId;

 public InterpolateGpsFixes(String pathName,String floatId,int profileNumber,String beforeProfLine1) {

     /*System.out.println("pathName"+pathName);
     System.out.println("floatId "+floatId );*/
     FileReader fileReader,fileReader2;
     BufferedReader buffReader,buffReader2;
     String lstPath = pathName + "msg2phy/tmp/"+ floatId +"_pos.gpslst";
     //System.out.println("lstPath "+lstPath );
     boolean flag_prev = false;
     boolean flag_later = false;
     Integer prevProfNum = 0;
     Integer afterProfNum = 0;
     Integer msgno = 0;
     this.floatId = floatId;
     /*System.out.println("lstPath "+lstPath );
     System.out.println("pathName in Interpolate ="+lstPath);*/


     try {
         fileReader = new FileReader( lstPath );
         fileReader2 = new FileReader( lstPath );
         buffReader = new BufferedReader( fileReader );
         buffReader2 = new BufferedReader( fileReader2 );
        }
       catch ( IOException e ) {
        setError( true );
        return;
      }

     try {
          int i = 0;
          String line = buffReader.readLine();
          TreeSet<Integer> msgnoTS = new TreeSet<Integer>();
          StringTokenizer st = null;
          int count =0;
          while(line!=null){
                st = new StringTokenizer(line,".");
                while(st.hasMoreTokens())
                {
                        count ++;
                        if(count == 2)
                        {
                                msgno = Integer.parseInt(st.nextToken());
                                msgnoTS.add(msgno);
                        }
                st.nextToken();
         }//while
        count = 0;
        line = buffReader.readLine();

       }//while

        afterProfNum = msgnoTS.ceiling(profileNumber);
        prevProfNum = msgnoTS.floor(profileNumber);
        /*System.out.println(floatId+" Prev and Later Profile Numbers = " +prevProfNum +","+afterProfNum +","+msgnoTS.size());
        System.out.println(floatId+" Profile Number = "+profileNumber);*/

        if(afterProfNum == null || prevProfNum == null){
        return ;
        }

        //System.out.println("I am in Nulllll222");

       String prevProfNumS = "";
       String afterProfNumS = "";
       count = 0;
       boolean prev = false;
       boolean after = false;

       if(prevProfNum<100)
        prevProfNumS = Utils2.padZeroLeft(prevProfNum.toString(),3,'0');
       else
       prevProfNumS = prevProfNum.toString();

       if(afterProfNum<100)
        afterProfNumS = Utils2.padZeroLeft(afterProfNum.toString(),3,'0');
       else
        afterProfNumS = afterProfNum.toString();

       line = buffReader2.readLine();
       while (line!=null)
       {
        if(line.contains("."+prevProfNumS+".") && line.contains("Tail")&& prev==false)
        {
          st = new StringTokenizer(line);
          while(st.hasMoreTokens()){
          if(count==2)
          setLon(st.nextToken(),0);
          if(count==3)
          setLat(st.nextToken(),0);
          if(count==4)
          setDate(st.nextToken(),0);
          if(count==5)
          setTime(st.nextToken(),0);
          if(count<2)
          st.nextToken();
          if(count>5)
          break;
          count++;
          }//while
         count = 0;
         prev = true;

        }//if


        if(line.contains("."+afterProfNumS+".") && line.contains("Head")&& after==false)
        {
          st = new StringTokenizer(line);
          while(st.hasMoreTokens()){
          if(count==2)
          setLon(st.nextToken(),1);
          if(count==3)
          setLat(st.nextToken(),1);
          if(count==4)
          setDate(st.nextToken(),1);
          if(count==5)
          setTime(st.nextToken(),1);
          if(count<2)
          st.nextToken();
          if(count>5)
          break;
          count++;
          }//while
          count = 0;
          after = true;
         }//if

         line = buffReader2.readLine();

        }//while

     /*System.out.println(floatId +"Prev Lat and Lan ="+ getLat(0)+","+getLon(0));
     System.out.println(floatId +"Latr Lat and Lan ="+ getLat(1)+","+getLon(1));*/


      interpolatedValues(profileNumber,beforeProfLine1);
     }//try
     catch ( Exception e ) {
       setError( true );
       System.out.println( "Error processing technical file: " + e.getMessage() );
      }
  }


  void setLat( String latitude, int index ) {
    this.latitude[ index ] = latitude ;
  }
  String getLat( int index ) {
    return latitude[ index ] ;
  }
  void setLon( String latitude, int index ) {
    this.longitude[ index ] = latitude ;
  }
  String getLon( int index ) {
    return longitude[ index ] ;
  }
  void setDate( String date, int index ) {
    this.date[ index ] = date ;
  }
  void setTime( String time, int index ) {
    this.time[ index ] = time ;
  }

  String getDate( int index ) {
    return this.date[index] ;
  }
  String getTime( int index ) {
    return this.time[index] ;
  }

  void interpolatedValues(int profileNumber,String beforeProfLine1)throws java.text.ParseException  {

  Double interpolatedLat, interpolatedLon;
  String prevDateTime,latrDateTime;
  prevDateTime = getDate(0)+" "+getTime(0);
  latrDateTime = getDate(1)+" "+getTime(1);
  SimpleDateFormat formatter = new SimpleDateFormat("MM/dd/yy HHmmss") ;
  SimpleDateFormat formatter2 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss") ;
  SimpleDateFormat tmp_formatter = new SimpleDateFormat("yyyy MM dd HH mm ss") ;
  Date datePrev = (Date)formatter.parse(prevDateTime);
  Date dateLatr = (Date)formatter.parse(latrDateTime);
  String dateOfProf = "";
  String timeOfProf = "";
  String dateTimeOfProf ="";
  int count = 0;

  StringTokenizer st = new StringTokenizer(beforeProfLine1);
  while(st.hasMoreTokens()){
  count ++;
  if(count < 3)
  st.nextToken();
  if(count==3)
  dateOfProf = st.nextToken();
  if(count==4)
  timeOfProf = st.nextToken();
  if (count == 5)
  break;
  }
  dateTimeOfProf = dateOfProf +" "+ timeOfProf;

  dateProf = (Date)formatter2.parse(dateTimeOfProf);
  setDateProf(dateProf);


  interpolatedLat = (Double)(Double.parseDouble(getLat(0)) +  ( ( (Double.parseDouble(getLat(0)) - Double.parseDouble(getLat(1)) ) / (datePrev.getTime()- dateLatr.getTime()) ) * (dateProf.getTime() - datePrev.getTime()) ) );
  interpolatedLon = (Double)(Double.parseDouble(getLon(0)) +  ( ( (Double.parseDouble(getLon(0)) - Double.parseDouble(getLon(1)) ) / (datePrev.getTime()- dateLatr.getTime()) ) * (dateProf.getTime() - datePrev.getTime()) ) );

  /*System.out.println(this.floatId+" interpolatedLat and interpolatedLon = "+ interpolatedLat +","+interpolatedLon);
  System.out.println(this.floatId+" Date Prev ="+ datePrev); 
  System.out.println(this.floatId+" Date Latr ="+ dateLatr); 
  System.out.println(this.floatId+" Date Prof ="+ dateProf); 
  System.out.println(this.floatId+" Diff of Lats="+ (Double.parseDouble(getLat(0)) - Double.parseDouble(getLat(1)) )); 
  System.out.println(this.floatId+" Diff of Times Prev and Latr ="+ (datePrev.getTime()- dateLatr.getTime()) ); 
  System.out.println(this.floatId+" Diff of Times Prof and Prev="+ (dateProf.getTime() - datePrev.getTime())); 
  System.out.println(this.floatId+" Lat Offset ="+ ( ( (Double.parseDouble(getLat(0)) - Double.parseDouble(getLat(1)) ) / (datePrev.getTime()- dateLatr.getTime()) ) * (dateProf.getTime() - datePrev.getTime()) ));
  System.out.println(this.floatId+" Lon Offset="+ ( ( (Double.parseDouble(getLon(0)) - Double.parseDouble(getLon(1)) ) / (datePrev.getTime()- dateLatr.getTime()) ) * (dateProf.getTime() - datePrev.getTime()) ));
*/
  setInterpolatedValues(interpolatedLat.toString(),interpolatedLon.toString());

  }

  void setInterpolatedValues(String interpolatedLat,String interpolatedLon ) {
  this.interpolatedValues[0] = interpolatedLat.toString();
  this.interpolatedValues[1] = interpolatedLon.toString();
  }
  void setDateProf(Date dateProf){
  this.dateProf = dateProf;
  }
  Date getDateProf(){
  return this.dateProf;
  }

  String getInterpolatedValues(int index ) {
    return this.interpolatedValues[index] ;
  }

  public void setError( boolean error ) {
    this.error = error;
  }

}
