/***************************************************************************** 
  Revision date:24-Jan-2013 CA: padZeroLeft is added
                 10-Feb-2010 ER: Initial version
 
  Utils2.java
  ===========
  Set of methods (functions) to be used by the rest of the Java classes

*****************************************************************************/

import java.io.*;
import java.util.*;
import java.text.*;

public class Utils2 { 

  /****************************************************************
   Given a string(s) and a number(n) it will add length_string - n 
   spaces to the right of the string so its new length = n.
   Example:
   If s = "miami" and n = 8, this function will return "miami   "
  *****************************************************************/ 
  public static String padRight(String s, int n) {
    StringBuffer newString = new StringBuffer(s);
    for (int i=n-s.length(); i>0; i--) 
      newString.append(' ');
    return newString.toString(); 
    // return String.format("%1$-" + n + "s", s);  
  }

  /****************************************************************
   Given a string(s) and a number(n) it will add length_string - n 
   spaces to the left of the string so its new length = n.
   Example:
   If s = "miami" and n = 8, this function will return "   miami"
  *****************************************************************/ 
  public static String padLeft(String s, int n) {
    StringBuffer newString = new StringBuffer(s);
    for (int i=n-s.length(); i>0; i--) 
      newString.insert(0,' ');
    return newString.toString(); 
    // return String.format("%1$#" + n + "s", s);  
  }

  public static String padZeroLeft(String s, int n,char c) {
    StringBuffer newString = new StringBuffer(s);
    for (int i=n-s.length(); i>0; i--) 
      newString.insert(0,c);
    return newString.toString(); 
    // return String.format("%1$#" + n + "s", s);  
  }
  public static String dateFormatMessage( String callingProgram, String phyFilename, String s ) {
     SimpleDateFormat formatter = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss") ;
     Date now = new Date();
     if (phyFilename == null) {
       return ( padRight( callingProgram, 15 ) + " " + formatter.format(now) + ": " + s );
     }
     else {
       return ( padRight( callingProgram, 15 ) + " " + formatter.format(now) + ": " + phyFilename + " " + s );
     }
  }

  public static double linearInterpolation( double x1, double x2, double x3, double y1, double y3 )
  {
     return  (x2-x1)*(y3-y1)/(x3-x1)+y1; 
  }
   

         

}
