c------------------------------------------------------------------- 
c     Revised date: 19-Feb-13  VMH - Read psal by columns if input has > 4 decimal 
c                                    places, write out 3 decimal places
c                   19-May-09 (YHD - dissolved oxygen column case)
c                   17-Jan-07 (YHD - Read 'phy' file and add adjusted salinity
c                                    column)
c     add_adjsal2phy.f
c     ===============
c     Reads an existing 'phy' file, adds an adjusted salinity colum, and
c     writes out a new 'phy' file.
c
c     YHD, 17-Jan-07
c
      subroutine add_adjsal2phy(iunit,ounit,saloff,sal_adj_line)
c     
c     infile:    existing phy file
c     outfile:   a new phy file with adjusted salinity column added
c     saloff:    salinity offset value

      implicit none

      integer nmax,nlev,iunit,ounit,iline,num_col,isal_col,status,
     *        i,lastnb,idbug,lnblnk,ll,lchar_occur,ichk_col,iret,
     *        index,jj,ioxy_col,ip,lastnb1
      integer ic
      parameter (nmax=2500)

      real    saloff,adj_sal,s,ss,adj_sal_ss,rsaloff
      real    coldata(12)
      character sal_adj_line*(*)
      character cline*256,prg_sub*10
      data     idbug/0/                ! make it 1 to get a listing

      data     prg_sub/'ADJSAL2PHY'/
      data     iline/0/
      data     isal_col,ichk_col,nlev/3*0/
c
c---Open input/output files.
c
      if (idbug.gt.0) write(66,*)'<<<<< DEBUG from ADD_ADJSAL2PHY >>>>>'

      if (idbug.gt.0) write(6, '(A, ":saloff=",f10.7)') prg_sub,saloff 

      iret=0

 1    continue
      read(iunit,25,end=5,err=993) cline

      if (idbug.gt.0) write(66,*) cline

      if (cline(1:17).eq.'NUMBER OF COLUMNS') then 
        read(cline(41:51),*,err=998) num_col
        if (num_col+1.lt.10) write(ounit,60) num_col+1
        if (num_col+1.ge.10) write(ounit,61) num_col+1
        do i=1,num_col
          read(iunit,25,end=100,err=993) cline     ! reading column lines
          if (idbug.gt.0) write(66,*) 'read col ',i,' ',cline
          if (cline(41:54).eq.'SALINITY (PSU)') isal_col=i
          if (cline(41:54).eq.'CHECKSUM FLAG ') ichk_col=i
          if (cline(41:56).eq.'DISSOLVED OXYGEN') ioxy_col=i
          lastnb = lnblnk(cline)
          write(ounit,25) cline(1:lastnb)
        end do
        if (num_col+1.lt.10) write(ounit,70) num_col+1
        if (num_col+1.ge.10) write(ounit,71) num_col+1
      else if (cline(1:10).eq.'==========') then
        iline=iline+1
        lastnb = lnblnk(sal_adj_line)
        if (iline.eq.1) write(ounit,25) sal_adj_line(1:lastnb)
        lastnb = lnblnk(cline)
        write(ounit,25) cline(1:lastnb)
        if (iline.eq.2) go to 5
      else
        lastnb = lnblnk(cline)
        write(ounit,25) cline(1:lastnb)
      end if
      go to 1
c
c --- Read pres/tem/sal information.
c
 5    continue
      nlev=nlev+1
      read(iunit,25,end=100,err=999) cline

      lastnb=lnblnk(cline)                ! total length
      if (ioxy_col.gt.0) then
        do i=1,lastnb
          if (cline(i:i).eq.'.') then
            ip=ip+1
            if (ip.eq.isal_col) ll=i      ! salinity point
          end if                          ! if (cline(i:i).eq.'.') then
        end do                            ! do i=1,lastnb 
        if (idbug.gt.0) write(66,*)'salinity point=',ll      
        jj=lchar_occur(cline(1:lastnb),'.')
        if (idbug.gt.0) write(66,*)'oxygen point=',jj
        lastnb1=index(cline(ll:jj),' ')+ll-2
        if (idbug.gt.0) write(66,*)'length after decimal=',lastnb1,ll
      else
        ll=lchar_occur(cline(1:lastnb),'.')
      end if                              ! if (ioxy_col.gt.0) then

      if (idbug.gt.0) write(66,*) cline
      if (idbug.gt.0.) then
        if (ioxy_col.gt.0) write(66,*)'lastnb,lastnb1,ll=',lastnb,
     *lastnb1,ll
        if (ioxy_col.eq.0) write(66,*)'lastnb,ll=',lastnb,ll
      end if

      ! This whole section to read the salinity should be re-written, it
      ! is a totally confusing mess - but the salinity adjustmetn will
      ! soon be incorporated into the new, unified qc program.  Just not yet

      if (isal_col.gt.0) then
        s=-1 ! SIGNAL IF YOU YOU HAVE NOT READ THE SALINITY
        if (ioxy_col.gt.0) then
          if (lastnb1-ll.eq.4) read(cline(ll-2:ll+4),'(f7.4)') s 
          if (lastnb1-ll.eq.3) read(cline(ll-2:ll+3),'(f6.3)') s
        else
          if (ichk_col.gt.0) then
            if (lastnb-ll.eq.8) read(cline(ll-2:ll+4),'(f7.4)') s 
            if (lastnb-ll.eq.7) read(cline(ll-2:ll+3),'(f6.3)') s
          else
            if (lastnb-ll.eq.4) read(cline(ll-2:ll+4),'(f7.4)') s 
            if (lastnb-ll.eq.3) read(cline(ll-2:ll+3),'(f6.3)') s
          end if
        end if      ! if (ioxy_col.gt.0) then 
        if (iret.eq.0) then
          call check_saloff_decimal(ichk_col,sal_adj_line,cline,saloff)
          iret=iret+1
        end if
        if(s < 0.0) then ! salinity vlue HAS NOT BEEN READ
           read(cline,*)(coldata(ic),ic=1,num_col)
           s = coldata(isal_col)
        endif
      end if
      if(s < 0.0) then
        status=9
        write(50,*) prg_sub,': ERROR reading salinity value'
        write(50,*) prg_sub,': indicated by negaive salinity'
        write(50,*) prg_sub,': STOP-> STATUS=',status
        write(6,*) prg_sub,': ERROR reading salinity value'
        write(6,*) prg_sub,': indicated by negaive salinity'
        write(6,*) prg_sub,': STOP-> STATUS=',status
        call exit(status)
        stop '9'
      endif
      adj_sal=s+saloff

      if (idbug.gt.0) then
        if (mod(lastnb-ll,2).eq.0) write(6,112) prg_sub,s,adj_sal,saloff
        if (mod(lastnb-ll,2).eq.1) write(6,111) prg_sub,s,adj_sal,saloff
      end if
 111  format(A,':s=',f6.3,' s_adj=',f6.3,' saloff=',f6.3)
 112  format(A,':s=',f7.4,' s_adj=',f7.4,' saloff=',f7.4)

      if (ichk_col.gt.0) then
        if (ioxy_col.gt.0) then
          if (lastnb1-ll.eq.4) write(ounit,27) cline(1:lastnb),adj_sal 
          if (lastnb1-ll.eq.3) write(ounit,26) cline(1:lastnb),adj_sal
        else
          if (lastnb-ll.eq.6) write(ounit,27) cline(1:lastnb),adj_sal 
          if (lastnb-ll.eq.7) write(ounit,26) cline(1:lastnb),adj_sal
        end if
      else
        if (ioxy_col.gt.0) then
          if (lastnb1-ll.eq.4) write(ounit,27) cline(1:lastnb),adj_sal 
          if (lastnb1-ll.eq.3) write(ounit,26) cline(1:lastnb),adj_sal
        else
          if (lastnb-ll.eq.3) write(ounit,26) cline(1:lastnb),adj_sal 
          if (lastnb-ll.eq.4) write(ounit,27) cline(1:lastnb),adj_sal
        end if
      end if
      if (nlev.gt.nmax) then
        status=9
        write(50,*) prg_sub,': Data points are more than ',nmax
        write(50,*) prg_sub,': Increase a value nmax.'
        write(50,*) prg_sub,': STOP-> STATUS=',status
        call exit(status)
        stop '9'
      end if                    !  if (nlev.gt.nmax) then
      go to 5

 25   format(a)
 26   format(a,2x,f6.3)
 27   format(a,2x,f6.3) ! feb 2013 keep 3 decimal places 7.4)
 60   format('NUMBER OF COLUMNS',23x,i1)
 61   format('NUMBER OF COLUMNS',23x,i2)
 70   format(i1,'. COLUMN',31x,'PSAL_ADJUSTED (PSU)')
 71   format(i2,'. COLUMN',30x,'PSAL_ADJUSTED (PSU)')

 998  write(6,*)'Reading add_adjsal2phy.f(read num_col) error=998'
      write(50,*)'Reading add_adjsal2phy.f(read num_col) error=998'
      status=9
c      call exit(status)
 993  write(6,*)'Reading add_adjsal2phy.f(read cline) error=993'
      write(50,*)'Reading add_adjsal2phy.f(read cline) error=993'
      status=9
c      call exit(status)
999   write(6,*)'Reading add_adjsal2phy.f(read dummy) error=999'
      write(50,*)'Reading add_adjsal2phy.f(read dummy) error=999'
      status=9
c      call exit(status)
 100  continue
      close (iunit)
      close (ounit)

      return
      end 

      subroutine check_saloff_decimal(ichk,sal_adj_line,cline,saloff)
c
c     Checks to see how many decimal places do I need to check.
c     yhd, 08-Mar-07
c
c     inputs:
c     ichk : 0 - checksum is not written; 1 - checksum is written
c     sal_adj_line: psal adjust line
c     cline : data line to see how many decimals were in S value
c
c     output:
c     saloff: new salinity offset to use
     
      implicit none
      integer ichk,lastnb_c,lastnb_s,lc,ls,ns,idbug,lnblnk,
     *        inum,iround,index,lchar_occur
      character sal_adj_line*(*),cline*(*),prg_sub*10
      real saloff
      data idbug /0/
      data prg_sub/'ADJSAL2PHY'/

      lastnb_c=lnblnk(cline)
      lastnb_s=lnblnk(sal_adj_line)
      lc=lchar_occur(cline,'.')
      ls=index(sal_adj_line,'.')      
      ns=index(sal_adj_line(ls:lastnb_s),' ')+ls

      if (idbug.gt.0) then
        write(6, '(A, ":data line(lastnb,lc)=  ",i4,i4)') prg_sub,
     *        lastnb_c,lc  
        write(6, '(A, ":adj line(lastnb,ls,ns)=  ",i4,i4,i4)') prg_sub,
     *        lastnb_s,ls,ns  
        write(6, '(A, ":lchk,lastnb_c-lc :  ",i4,i4)') prg_sub,
     *       ichk,lastnb_c-lc
        write(6, '(A, ":adj line(decimal part)=  ",A)') prg_sub,
     *       sal_adj_line(ls+1:ns-2) 
      end if

      if (ichk.gt.0) then
        if (lastnb_c-lc.eq.8) then  ! 4 decimal case
          if (idbug.gt.0) then
            write(6,'(A, ":checksum flag exists; 4 decimal case ",
     *A)') prg_sub
            write(6, '(A, ":adj_line(ls+5:ls+5)=  ",A)') prg_sub,
     *      sal_adj_line(ls+5:ls+5)
            write(6, '(A, ":adj_line(ls+1:ls+4)=  ",A)') prg_sub,
     *      sal_adj_line(ls+1:ls+4)
          end if
          read(sal_adj_line(ls+5:ls+5),'(i1)') iround
          read(sal_adj_line(ls+1:ls+4),'(i4)') inum
          if (idbug.gt.0) write(6,'(A," iround,inum=",i4,i4)')
     *                    prg_sub,iround,inum
          if (iround.ge.5) inum=inum+1
          write(sal_adj_line(ls+1:ls+4),'(i4.4)') inum
          read(sal_adj_line(ls-2:ls+4),'(f7.4)') saloff
          if (idbug.gt.0) write(6,'(A,":round off saloff=",f7.4)')
     *                    prg_sub,saloff
        end if                      ! if (lastnb_c-lc.eq.8) then

        if (lastnb_c-lc.eq.7) then  ! 3 decimal case
          if (idbug.gt.0) then
            write(6,'(A, ":checksum flag exists; 3 decimal case ",
     *A)') prg_sub
           write(6, '(A, ":adj_line(ls+4:ls+4)=  ",A)') prg_sub,
     *      sal_adj_line(ls+4:ls+4)
            write(6, '(A, ":adj_line(ls+1:ls+3)=  ",A)') prg_sub,
     *      sal_adj_line(ls+1:ls+3)
          end if
          read(sal_adj_line(ls+4:ls+4),'(i1)') iround
          read(sal_adj_line(ls+1:ls+3),'(i3)') inum
          if (idbug.gt.0) write(6,'(A,":iround,inum=",i4,i4)')
     *                    prg_sub,iround,inum
          if (iround.ge.5) inum=inum+1
          write(sal_adj_line(ls+1:ls+3),'(i3.3)') inum
          read(sal_adj_line(ls-2:ls+3),'(f6.3)') saloff
          if (idbug.gt.0) write(6,'(A,":round off saloff=",f6.3)')
     *                    prg_sub,saloff
        end if
      else                          ! no checksum written case
        if (lastnb_c-lc.eq.4) then    ! 4 deciaml case
          if (idbug.gt.0) then
            write(6,'(A, ":No checksum flag exists; 4 decimal case ",
     *A)') prg_sub
            write(6, '(A, ":adj_line(ls+5:ls+5)=  ",A)') prg_sub,
     *      sal_adj_line(ls+5:ls+5)
            write(6, '(A, ":adj_line(ls+1:ls+4)=  ",A)') prg_sub,
     *      sal_adj_line(ls+1:ls+4)
          end if
          read(sal_adj_line(ls+5:ls+5),'(i1)') iround
          read(sal_adj_line(ls+1:ls+4),'(i4)') inum
          if (idbug.gt.0) write(6,'(A,":iround,inum=",i4,i4)')
     *                    prg_sub,iround,inum
          if (iround.ge.5) inum=inum+1
          write(sal_adj_line(ls+1:ls+4),'(i4.4)') inum
          read(sal_adj_line(ls-2:ls+4),'(f7.4)') saloff
        end if

        if (lastnb_c-lc.eq.3) then    ! 3 decimal case
          if (idbug.gt.0) then
            write(6,'(A, ":No checksum flag exists; 3 decimal case ",
     *A)') prg_sub
            write(6, '(A, ":adj_line(ls+4:ls+4)=  ",A)') prg_sub,
     *      sal_adj_line(ls+4:ls+4)
            write(6, '(A, ":adj_line(ls+1:ls+3)=  ",A)') prg_sub,
     *      sal_adj_line(ls+1:ls+3)
          end if
          read(sal_adj_line(ls+4:ls+4),'(i1)') iround
          read(sal_adj_line(ls+1:ls+3),'(i3)') inum
          if (idbug.gt.0) write(6,'(A,":iround,inum=",i4,i4)')
     *                    prg_sub,iround,inum
          if (iround.ge.5) inum=inum+1
          write(sal_adj_line(ls+1:ls+3),'(i3.3)') inum
          read(sal_adj_line(ls-2:ls+3),'(f6.3)') saloff
        end if
      end if                      ! if (ichk.gt.0) then

      return
      end
   
