!  Revision date: 14-Aug-12 VMH - wrapper to parse char time variable and
!                                 use date_check to check for impossible dates
!
!    cdate_check.f
!    ============
!    Parses a date character string and checks validity
!
!    output: io=0  good; io=1 bad
!
      subroutine cdate_check(cdate,io)

      implicit none

      character*19 cdate
      integer iyr,imo,idy,ihr,imn,ndays,io
      character(len=11), parameter :: sub_prog = 'cdate_check'
     
      character(len=1)   :: testchar

      ! First, parse the input character-date
      testchar = cdate(5:5) 
      if(testchar .eq. ' ') then       ! format: yyyy mm dd hh mm ss
          read(cdate(1:4),'(i4)') iyr
          read(cdate(6:7),'(i2)') imo
          read(cdate(9:10),'(i2)') idy
          read(cdate(12:13),'(i2)') ihr
          read(cdate(15:16),'(i2)') imn
      else                             ! format: yyyymmddhhmmss 
          read(cdate(1:4),'(i4)') iyr
          read(cdate(5:6),'(i2)') imo
          read(cdate(7:8),'(i2)') idy
          read(cdate(9:10),'(i2)') ihr
          read(cdate(11:12),'(i2)') imn
      end if

      call date_check(iyr,imo,idy,ihr,imn,io)
      return

      end subroutine cdate_check

