c    Revision date: 04-Jun-03 (YHD - no or patial salinity value case)
c                   11-Dec-01 (YHD - no data point case)
c    Constv_check.f
c    ==============
c    Checks if the profile is constant from top to bottom.
c    yhd, 20-Nov-01
c
c    input:
c      np    ---- number of points
c      value ---- either temp. or salinity array
c    output:
c      icnsv_flag --- 1: No, profile is not constant.
c                     4: Yes, profile has constant value from top to bottom.
c
      subroutine constv_check(np,value,icnsv_flag)

      implicit none

      integer i,icnsv_flag,np,status,idbug
      real    vmin,vmax,value(*),fv
      character sub_prog*12
      data sub_prog/'Constv_check'/
      data fv /-999.0/              ! fill value
      data idbug/0/                 ! make it 1 to get a list
c
c --- No data point case
c
      if (np.eq.0) then
        icnsv_flag=0
        return
      end if

      vmin=1000.0                   ! initial fake value
      vmax=-1000.0                  ! initial fake value
      do 10 i=1,np
        vmin=MIN(vmin,value(i))
        vmax=MAX(vmax,value(i))
 10   end do
      if (idbug.gt.0) then
        write(66,*)'<<<<< DEBUG from CONSTV_CHECK >>>>>'
        write(66,*) 'vmin,vmax:',vmin,vmax
      end if

      if (vmin.eq.vmax) then
        icnsv_flag=4
        if (vmin.eq.fv.and.vmax.eq.fv) icnsv_flag=0
      else
        icnsv_flag=1
      end if

      if (icnsv_flag.ne.0.and.icnsv_flag.ne.1.and.icnsv_flag.ne.4) then
        status=9
        write(6, '(A,": Constant_value_check error - icnsv_flag=",i1)') 
     *          sub_prog, icnsv_flag
        write(6, '(A,": Flag should be either 1 (not constant) or 4
     * (constant).")') sub_prog
        write(50, '(A,": Constant_value_check error - icnsv_flag=",i1)') 
     *          sub_prog, icnsv_flag
        write(50,'(A,": Flag should be either 1 (not constant) or 4
     * (constant).")') sub_prog

        write(6,'(A,": STOP -> STATUS = ", i4)') sub_prog,status
        write(50,'(A,": STOP -> STATUS = ", i4)') sub_prog,status
        call exit (status)
        stop '9'
      end if

      return
      end


