c    land_or_water.f
c    ===============
c    This subroutine will examine the position (X) with all 8 surrounding 
c    (lat,lon) positions from ETOPO 5 grids and decide the float is on land 
c    or water. If more positions are on water than land then the X (float)
c    is on water.
c    
c    1     2     3
c    4     X     6
c    7     8     9
c
c    (where X is a position to check)
c
c    YHD, 12-Jan-2007

      subroutine land_or_water(depth, alat, alon)

      implicit none
      integer rdtbase,depth,iland,iwater,i,idbug,drt
      external rdtbase
      real rlat,rlon,alat,alon,xadd,yadd,delta,rlat1,rlon1
      data idbug/0/

      depth=rdtbase(alat,alon)
      if (depth.lt.0) then
         write(6,*)'The float is in WATER!!!'
         if (idbug.gt.0) write(66,*)'The float is in WATER!!!'
        return
      end if

      delta=0.0833    
      iland=0
      iwater=0
      xadd=0.0
      yadd=0.0
      rlat=0.0
      rlon=0.0
      drt=0

      do i=1,9
        if (i.eq.1) then
          xadd=-1.0
          yadd=-1.0
        else if (i.eq.2) then
          xadd=0.0
          yadd=-1.0
        else if (i.eq.3) then
          xadd=+1.0
          yadd=-1.0
        else if (i.eq.4) then
          xadd=-1.0
          yadd=0.0
        else if (i.eq.5) then
          xadd=0.0
          yadd=0.0
        else if (i.eq.6) then
          xadd=1.0
          yadd=0.0
        else if (i.eq.7) then
          xadd=-1.0
          yadd=1.0
        else if (i.eq.8) then
          xadd=0.0
          yadd=1.0
        else if (i.eq.9) then
          xadd=1.0
          yadd=1.0
        end if
        rlat1=alat+(xadd*delta)
        rlon1=alon+(yadd*delta)

        drt=rdtbase(rlat1,rlon1)

        if (drt.gt.0) then
          iland=iland+1
        else
          iwater=iwater+1
        end if
      end do

      if (iwater.gt.iland) then
         if (depth.gt.0) depth=-1*depth
         write(6,*)'The float is in WATER!!!'
         if (idbug.gt.0) write(66,*)'The float is in WATER!!!'
      else
        if (depth.lt.0) depth=-1*depth
        write(6,*)'The float is on LAND !!!'
        if (idbug.gt.0) write(66,*)'The float is on LAND !!!'
      end if

      return
      end

