!==================================================================
! Revision date: 23-Dec-13 CS   - Fixed problem with previous hasPsal, ... overwritting current
!                                 hasPsal, ...)
!                18-Dec-13 CS,RS - Fixed problem related to 'i1' or 'i2' being out of range
!                                 disable old versus new density gradient test)
!                22-May-13 RS   - replace QCFILES_DIR with QCFILES_AOMLID_DIR
!                                 in GETENV('QCFILES_DIR', pathname_qc)
!                06-May-13 VMH  - Account for number of good levels for density gradiet test
!                                 (ndg) to be 0 or 1. also messaging to debug file
!                25-Apr-13 VMH  - Skip call to jump_check if nlev=0
!                02-Apr-13 VMH  - Adapted from the old qc_s,f. use communication
!                                 for LUNS, array sizes, parameters, messaging,
!                                 call to NEW dengrad_check, retain dengrad_check_old
!                                 for DEBUG_LEV=3
!                14-Aug-12 VMH  - Read st_trans_time_qc & ascent_end_time_qc 
!                                 in rd_phy & rd_qc, do impossible date test;
!                                 move reading most_likely_frame_status from
!                                 rd_float_meta, mv to rd_phy.
!                16-May-11 (ER  - Variable itype replaced by hasTemp, 
!                                 hasPsal, hasCond, hasO2
!                          (ER  - Changes to deal with new gross pressure
!                                 check
!                               - Vertical temp and density salinity flag
!                                 arrays not sharing the same spot when
!                                 calling flags2qcfile
!                               - Changes in calling to gross_check_salinity
!                               - Changes in variable names to make it more
!                                 readable
!                16-Jul-10 (ER  - Changes dealing with surface 
!                                 pressure = null
!                05-Nov-09 (ER  - Grey List treatment rewrote) 
!                22-Oct-09 (ER  - If date test fails, return status=6
!                13-Oct-09 (ER  - Add Most Likely Frame Variable) 
!                04-Mar-09 (YHD - 'type_ts32' is introduced.)
!                23-Jun-08 (YHD - A 'ibad_pos' is introduced)
!                19-Feb-08 (YHD - A trap for ill phy files from Breck Owens
!                                 iridium floats case, exit with a status=11)
!                07-Feb-08 (YHD - Fixed exit status=8 should be same as qc_t
!                                 exit status)
!                15-Jan-08 (YHD - 'iol'- returns from location check;
!                                 'io'- returns from date check)
!                10-Dec-07 (YHD, No position with data case correction.)
!                27-Nov-07 (YHD - speed check failed status=7;
!                                 speed check passed & (0.0,0.0) status=6)
!                26-Nov-07 (YHD - speed flag is 4 when (0.0, 0.0) case.)
!                15-Nov-07 (YHD - 5 frozen test failed consecutively will  
!                                 write in as a grey list in meta file.
!                                 Reversing ZengHong's finding.)
!                09-Nov-07 (YHD - When the frozen test fails, it should marked
!                                 as a bad profile. Thanks to ZengHong Liu).
!                24-Oct-07 (YHD - A new speed check modification)
!                17-Sep-07 (YHD - More correction on spd_table)
!                11-Sep-07 (YHD - A speed check failed position gets '-' in
!                                 front of class, climatology/analysis/etopo
!                                 will use a good position.)
!                07-Sep-07 (YHD - spd(np) dimension increased to 1000)
!                12-Jun-07 (YHD - Write statement changed for when there is
!                                 no previous qc file exist case).
!                07-May-07 (YHD - For bounce float, jump_check test modified)
!                03-Apr-07 (YHD - Sensor jump check is now activated)
!                02-Apr-07 (YHD - Deepest pressure check in deepest pressure
!                                 *10)
!                29-Mar-07 (YHD - grey_list correction; GREY LIST FLAG FOR P
!                                 line is now added to qc file.)
!                07-Feb-07 (Added 'PSAL_ADJUSTED' case)
!                27-Jul-06 (YHD - Traced an empty fort.24 file from 'QC_S' run
!                                 not to create it)
!                18-May-06 (YHD - group1=1 and group2=2-->make a good profile)
!                15-Dec-05 (YHD - Now, (lmax=1100) for iridium float).
!                17-Oct-05 (YHD - "land" problem fixed)
!                14-Jun-05 (YHD - A bounce float is introduced.)
!                13-May-05 (YHD - A bug fixed on line 1398. A profile '000'
!                                 with positions but no data line should exit
!                                 with a status equals 3.)
!                05-May-05 (YHD - Exit with status=5 when no position/no
!                                 data case)
!                03-May-05 (YHD - 1) Add 'grey list flag for T/s' line in qc,
!                                 2) Flag it when pres equals 0.0 case, 
!                                 3) exit status=3 when no position & no data)
!                28-Mar-05 (YHD - nx is increased to 50 for drift p,t,s lists)
!                08-Mar-05 (YHD - Write flags in following order for QC:
!                                 c/d/g/j/p/s/v/r/d --- constant,deep,gross,
!                                 jump,pressure increasing,spike,vertical,
!                                 regional,density)
!                17-Dec-04 (YHD - Tests 15,16,17 & 18 added)
!                02-Dec-04 (YHD - one data line with all 0.0 and no position
!                                 case occurred. 0362_02785_064.phy)
!                26-May-04 (YHD - Exits with status=9 when no ncep file case)
!                02-May-04 (YHD - 'isped_flag' equals 2 is a still good prof.)
!                29-Apr-04 (YHD - I hope today's change will fix the 'qc-s'
!                                 problems.  ETOPO is called only once in
!                                 the 'qc_t' and if the profile is on land
!                                 then the result will get write on the qc 
!                                 file.  qc_s is just reading this indicator
!                                 in qc file and don't need to call ETOPO
!                                 from qc_s run.)
!                28-Apr-04 (YHD - debug statement added for each test)
!                22-Mar-04 (YHD - Got rid of 'write(55,...' lines)
!                15-Mar-04 (YHD - Do not need to call speed_check anymore.
!                                 Speed_check called only in qc_t run.)
!                19_feb-04 (YHD - 'j_qc' correction)
!                11-Feb-04 (YHD - debug on line 1637 error; subscript number
!                                 2 has value 0 in array 'cl_an1')
!                22-Dec-03 (YHD - pres,tem and sal are initialized as 0.0)
!                03-Nov-03 (YHD - 2 lines of data case: densgrad & spik can 
!                                 not applied.)
!                14-Oct-03 (YHD - status=3 when no data lines with positions)
!                07-Oct-03 (YHD - Now 'iover_pres' also determins the status
!                                 ORBCOMM floats are complete.)
!                02-Oct-03 (YHD - add more print statments for debug &
!                                 intrinsic functions)
!                30-Sep-03 (YHD - array boundary check & null character check)
!                25-Sep-03 (YHD - write line added before 'itime_hist' in 535
!                                  is_clim,is_dens,igros_flag... set to 
!                                  max=1000.
!                11-Sep-03 (YHD - '000' profile with data ---> status=5;
!                                  '000' profile with no data ---> status=3
!                03-Sep-03 (YHD - Constant value check=0 (i.e. temp/sal=fill
!                                 value case) & spike check=0 case
!                01-Jul-03 (YHD - "JULD_QC" line added in qc file.)
!                04-Jun-03 (YHD - 1)All salinity is fillvalue, max.cont=0 -->
!                                 ioverall=0 --> exit with 2;
!                                 2) Partial salinity is fillvalue, max.cont=1
!                                 ioverall=1 or 4 depends on other tests -->
!                                 exit with 2.)
!                03-Jun-03 (YHD - WHOI float: pres increasing, t & s -999.0,
!                                 flags should be 0; otherwise t & s are not
!                                 -999.0, apply qc tests.)
!                22-May-03 (YHD - When a status=7, don't do clim. & analysis 
!                                 tests.)
!                15-May-03 (YHD - Meta file is needed)
!                01-May-03 (YHD - Statement number 114 changed.)
!                30-Apr-03 (YHD - ORBCOMM float descending profile case (i.e.
!                                 profile number gt 1000))
!                29-Apr-03 (YHD - "ANALYSIS VERSION USED" and "CLIMATOLOGY
!                                 VERSION USED" lines are added in qc
!                                  file.)
!                28-Apr-03 (YHD - As of 29-Apr-03, the Levitus 2001 
!                                 climatology, WOA01 is replaced the Levitus
!                                 WOA98 climatology.)
!                03-Apr-03 (YHD - no_pos=1 when'000' profile  with no position
!                02-Apr-03 (YHD - WHOI floats 0242_001 0245_007 cases)
!                11-Feb-03 (YHD - WHOI float with -999.0 data line)
!                29-Jan-03 (YHD - argos_id=trans_id as char*16)
!                28-Jan-03 (YHD - profile_id to handle for "ORBCOMM" float
!                21-Jan-03 (YHD - treat pres_flags as vert_flag)
!                02-Oct-02 (YHD - status=6 and status=7 added)
!                24-Sep-02 (YHD - density graf flag is 1 when no data case ??
!                25-Jul-02 (YHD - No data point case again)
!                24-Jul-02 (YHD - QC files created except status=9)
!                11-Jun-02 (YHD - no data point case)
!                07-Jun-02 (YHD - Gradient test=0.0 Do not set overall_flag
!                               to be 0; let the rest of flags result decide
!                22-Apr-02 (YHD - s/r sintp -99.0 changed to -98.0)
!                22-Apr-02 (YHD - maximum density gradient_s flag corrected)
!                19-Apr-02 (CS & YHD - eliminate the execution of 'vintp'
!                02-Apr-02 (CS - force sd0 and sd to be at least 5.e-3
!                22-Jan-02 (YHD - sd .eq. 0.0 case)
!                12-Dec-01 (YHD - profile with no data case)
!                26-Nov-01 (YHD - analysis time check from qc_t and qc_s run
!                20-Nov-01 (YHD - constant value check added)
!                11-Oct-01 (YHD - date_check/location_check added)
!                19-Sep-01 (YHD - global variable "TOPO" introduced to
!                          access ETOPO5 (water/land) data)
!                23-Jul-01 (RS - changes ANALYSIS global variable)
!                19-Jul-01 (YHD - argos id back to 5 digits)
!                10-Jul-01 (RS - argos id expansion)
!                20-Jun-01 (YHD - Read 2 "phy" files for speed check
!                31-May-01 (YHD - Analysis read from NetCDF file)
!                02-May-01 (YHD - stops when float type is 't')
!                10-Apr-01 (YHD - spike check added)
!                01-Mar-01 (YHD - grid1 for clim; grid2 for anal)
!                02-Aug-00 (RS - updates for automatization)
!
!   qc_s.f
!   ======
! Differences from the last qc code include:
! (i)  A new parameter ianal must be set to 1 if the previous week's
!      analysis is to be used.
!      Also set the file name and the type of read for
!      the previous weeks analysis (unit 22)
! (ii) The mask must be read in (unit 23).
!
!     7  1         2         3         4         5         6         7 2
!* This does a quality control on tropical Pacific XBT temperature
!* profiles as a test of methods as well as on Atlantic XBT.
!* Each depth for each cast is assigned a flag as follows, for values
!* both inside and outside of the tropical Pacific (OTP):
!     0...the value is accepted       1...the value is rejected
!     2...the value is missing (rej)  9...the location is OTP.
!
! Quality control test and order of execution are:
!    Gross:
!    CheckSum:
!    Constant Value:
!    Speed:
!    Density Gradient:
!    Spike:
!    Bottom/Top Spike:
!    Climatology: 
!    Analysis:
!
! Set parameters: 
!    max.....maximum number of levels in a cast,
!    stdev_clim......the absolute clim difference level check (s.d.),
!    stdev_anal......the absolute analysis difference level check (s.d.),
!    dfm.....estimate of the number of degrees of freedom/month
!    vgmx....the (-) maximum allowable vertical salinity gradiend ?
!    vgmi....the maximum allowable size of a vertical salinity inversion ?
!    ianal...switch for use of the previous weeks analysis (1=use).
!
! Input units:
!    unit 21: WOA98 Climatology and Standard Deviations on grid1.
!    unit 22: Previous weeks analysis (not avaiable yet) on grid2
!    unit 23: Mask
!    unit 24: Palace phy file (profile to qc)

!* Output units:
!    unit 52: QC-S file with added meta header and observation flags 
!    unit 48: trace of flag tests (trace_qc.yyyy_mm_dd)
!    unit 49: pass/fail table file (table_qc.yyyy_mm_dd)
!    unit 50: error log file (error_qc.yyyy_mm_dd)
!    unit 66: Debug file
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
!    There is no analysis standard deviation available and dummy values
!    are temporary used.  The codes surrounded by &&&&&&& are needed to
!    change later on.
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 
!    program qc_s.f
!    written by Tom Smith/modified by YHD 03-29-2000/10-04-2000
! ===================================================================

use communication                       ! module

implicit none

character(len=6), parameter :: PRGMAIN = 'qc_s: '
character(len=10), parameter :: PRGD = 'qc_s    D '
character(len=4), parameter :: PRG = 'qc_s'

integer, parameter :: nx = 50
integer, parameter :: im1=360,jm1=180,km1=33
integer, parameter :: im2=360,jm2=200,km2=40
integer, parameter :: ianal=1,np=500,nnp=3000
real, parameter :: dfm=3.0,vgmx=1.0,vgmi=0.2
real :: w1,w2
integer :: i1,j1,i2,j2

!     new var defs from qc_s =========================================
integer, parameter :: jwndo = 5 ! jwindow - range of dengrad test
!     old var defs below =============================================
integer :: date_global_test = 0 ! Impossible date test
integer :: date_check_result = 0
integer :: location_check_result = 0
integer :: land_test = 0  ! 0 if float in water, 1 if float in land

integer ii,j,n,nn,nlev,iunit,int_num,wmo_num,prof_num, &
    wmo_inst,wmo_reco,icnt, &
    iyr(np),imo(np),ida(np),ihr(np),imin(np),isec(np), &
    ios,status, &
    jyr,jmo,jda,k,m1,m2,mr,icomplet,prof_num_p, &
    prof_num_prev,icnt_p,nlev_p,no_pos,ireverse, &
    land_qc
logical :: hasTemp, hasPsal, hasCond, hasO2
logical :: hasTemp_prev, hasPsal_prev, hasCond_prev, hasO2_prev

integer mask(im2,jm2),amin,amax,cmin,cmax,gmin,gmax, &
    smin,smax,vmin,vmax,pmin,pmax, &
    is_gros(lmax),  &
    gross_pres_flag(lmax), gross_temp_flag(lmax), &
    gross_pres_adj_flag(lmax), &
    is_clim(lmax),density_grad_flag(lmax),is_anlz(lmax), &
    ipres_flag(lmax),is_pres(lmax), &
    icksm_flag(lmax),is_spik(lmax),isped_flag,iover_all, &
    iover_cksm,iover_clim,iover_dens,iover_anlz,iover_gros, &
    iover_sped,iover_spik,iover_cnsv,iover_pres

real, parameter :: PRES_FILLVAL = -999.0
real, parameter :: SAL_FILLVAL = -999.0
real, parameter :: FILLVAL = -999.0

real dgpres(lmax),dgtemp(lmax),dgpsal(lmax) ! filtered arrays for dengrad_check
integer ndg,iloc(lmax)
integer test_density_grad_flag(lmax)
integer i,lchar_occur
integer depth
integer group1,group2,group3,group4,group5

real    alon_hist(np),alat_hist(np),rdfm,hr, &
    an,sd,cl0,sd0,ta,tt,rlat,rlon,alon,spd(nnp), &
    sd_clim,sd_anal,alon_prev,alat_prev,alon_hist_p(np), &
    alat_hist_p(np),fv

real clma(im1,jm1,km1),sdma(im1,jm1,km1)
real pres(lmax),tem(lmax),sal(lmax),dep(lmax), &
    pres_p(lmax),tem_p(lmax),sal_p(lmax)
real clmb(im1,jm1,km1),sdmb(im1,jm1,km1)
real cl1(im1,jm1,km1),sd1(im1,jm1,km1)
real an2(im2,jm2,km2),sd2(im2,jm2,km2),an2_t(im2,jm2,km2)
real xt1(im1),yt1(jm1),df1(km1),cj1(jm1)
real xt2(im2),yt2(jm2),df2(km2),cj2(jm2)

double precision atime,rtime,adate


character itime_hist(np)*14,itime*14,cksm_flag*1,clim_flag*1, &
    anlz_flag*1,gros_flag*1,dens_flag*1,pres_flag*1, &
    over_all*1
character itime_prev*14,itime_hist_p(np)*14
character sped_flag*1,spik_flag*1,cnsv_flag*1,profile_id*20

character cmon(12)*3,dmon(12)*2
character profname*20,argos_id*16,ana_version*50

character pathname_infile*128,pathname_outfile*128, &
    pathname_infile_prev*128,pathname_meta*128, &
    pathname_clima_s*128,clima_s*128, &
    pathname_mask_t*128, &
    stddev_factor_clima*128,stddev_factor_analysis*128, &
    pathname_analysis_s*128,analysis_s*128, &
    pathname_trace*128, pathname_error*128,  &
    pathname_table*128, pathname_debug*128,phyfile*128

integer  lnblnk,last,lastnb,lenstr,lastdir,lasb,lase, &
    ilen
intrinsic index,len
logical   phy_exist, qc_exist, ncep_exist, for24_exist


!
! For deepest pressure tests
!
integer,dimension(lmax) :: &
    deepest_pres_flag,      & ! Deepest pressure flag vector
    deepest_pres_adj_flag   ! Deepest pressure adjusted flag vector
integer :: dmin=1000,      & ! Min value of deepest pres flag vector
    dmax=0,         & ! Max value of deepest pres flag vector
    d_adjmin=1000,  & ! Min value of deepest pres adj flag vector
    d_adjmax=0      ! Max value of deepest pres adj flag vector

integer ifrzn_flag, nlev_qc, iover_jump, iover_salg, iover_frzn,  &
    icnt_qc, iover_s, is_frzn, iover_deep, iover_deep_adj

integer, dimension(lmax) :: it_clim, it_vert, it_anlz, it_spik,  &
    it_vis,  ip_vis,  it_cntv, it_jump, it_frzn, is_anlz,  is_clim, &
    it_gros, is_gros, is_spik, vert_grad_sal_flag, is_cntv, &
    is_cntv, is_salg, is_jump, isalg_flag, is_vis, icksm_flag_p, &
    dummy_vector_flag


character deep_flag*1,dummy_flag*1
data dummy_flag/'N'/                 ! dummy density gradient flag
!
integer iunit_meta
real dlay_down_hours
double precision down_days,up_hours,cycle_days, &
    descent_hours,neutral_depth_days,ascent_hours,surface_hours, &
    laun_pos_lat,laun_pos_lon

character trans_id_meta*16,inst_ref*64,st_time*64,laun_time*64, &
    float_snum*4,trans_sys*16,pos_sys*8,trans_id*16

integer n_drift,nparam
real, dimension(nx) :: drift_p, drift_t, drift_s, drift_o, &
    drift_c

real, dimension(lmax) :: cond, oxy, oxy2
real, dimension(lmax) :: pres_qc, tem_qc, sal_qc, cond_qc, &
    oxy_qc, oxy2_qc
real :: sigma_clim, sigma_anal

real :: surface_pressure
real :: surf_pres_aux
real    alon_hist_qc(np),alat_hist_qc(np)
real    deep

integer num_col,num_cal
character iclass_hist(lmax)*2

integer it_anlz_qc(lmax),it_clim_qc(lmax), &
    it_gros_qc(lmax),it_spik_qc(lmax),it_vert_qc(lmax), &
    ipres_qc(lmax),it_vis_qc(lmax),ip_vis_qc(lmax), &
    it_cntv_qc(lmax),it_jump_qc(lmax), &
    iover_t,iover_t_qc,it_frzn_qc, &
    is_anlz_qc(lmax),is_clim_qc(lmax), &
    is_gros_qc(lmax),is_spik_qc(lmax),is_dens_qc(lmax), &
    is_cntv_qc(lmax),is_salg_qc(lmax),is_jump_qc(lmax), &
    is_vis_qc(lmax),iover_s_qc,is_frzn_qc,is_cntv_qc(lmax), &
    isped_flag_qc


integer jmin,jmax,kmin,kmax,argos_prg_num,lastdir_qc
character jump_flag*1,trans_id*16,frzn_flag*1,qcfile*128, &
    pathname_qc*128,cprof_num_prev*3,salg_flag*1, &
    inst_type*16,whoi_c_date*14, &
    pi*64,juld_qc*1, &
    st_trans_time*19,st_trans_time_qc*1, &
    ascent_end_time*19,ascent_end_time_qc*1, &
    prev_st_trans_time*19,prev_st_trans_time_qc*1, &
    prev_ascent_end_time*19,prev_ascent_end_time_qc*1, &
    whoi_pos_qc*1, &
    column(lmax)*256,calib(lmax)*256, &
    t_param(lmax)*32,t_value(lmax)*32,itime_hist_qc(np)*14
!
!--- For Regional Check
!
integer iover_regi,ireds_region,imeds_region, &
    ireds_t(lmax),ireds_s(lmax), &
    imeds_t(lmax),imeds_s(lmax),is_regi(lmax),it_regi(lmax), &
    rmin,rmax,iregion
character regi_flag*1


!
! For grey list
!
character(len=1) :: send_gts  ! Send to GTS
character(len=3) :: grey_list ! Add to grey list?
integer :: num_grey  ! Number of parameters in grey list
character(len=11), dimension(5) :: &
    grey_date_st, & ! First date for which the grey list is operative
    grey_date_en  ! Last date for which the grey list is operative
character(len=15), dimension(5) :: &
    grey_parm     ! Parameters in grey list
character(len=5), dimension(5)  :: &
    grey_flag     ! Flag the parameter should get
character(len=80), dimension(5) :: &
    grey_reason   ! Why the parameter was added to the grey list
character(len=64) :: proj_name
! Used to compare profile date against grey list date range
character(len=8) :: aux_profile_date, aux_grey_date_st, &
    aux_grey_date_en
logical :: pres_in_gl   ! Pressure in the grey list?
logical :: temp_in_gl   ! Temperature in the grey list?
logical :: psal_in_gl   ! Salinity in the grey list?
integer :: pres_gl_flag ! Grey list flag for pressure
integer :: temp_gl_flag ! Grey list flag for temperature
integer :: psal_gl_flag ! Grey list flag for salinity
integer :: max_gl_flag  ! Maximum value of grey list flags


!
!--- For bounce float
!
character bounce_ts*1
data      bounce_ts /'n'/
integer   file_num,file_num_prev

!
! Salinity Adjusted related variables
!
logical :: psal_adj_exist ! Salinity adjusted exist in phy file?
real, dimension(lmax) :: sal_adj   ! values of salinity adjusted
                                   ! taken from phy file
  
integer sal_adj_dd,sal_adj_mm,sal_adj_yyyy,sal_adj_pnum, &
    aamin,aamax,camin,camax,gamin,gamax,ramin,ramax
real sal_offset,sal_std, &
    tt_adj,ta_adj
character sal_adj_line*256,grosa_flag*1, &
    regia_flag*1
integer iover_grosa,iover_regia,is_regia(lmax), &
    is_anlza(lmax),is_clima(lmax),is_grosa(lmax), &
    is_anlza_qc(lmax)
data    aamin,camin,gamin,ramin /4*1000/
data    aamax,camax,gamax,ramax /4*0/

! 
! Pressure Ajusted related variables
logical :: pres_adj_exist ! Pressure adjusted exist in phy file?
real, dimension(lmax) :: pres_adj  ! values of pressure adjusted
                                   ! taken from phy file

integer :: most_likely_frame_status

!
!--- For speed check flag.
!
integer bad_row(100),ivalid_pos,ibad_row_cnt,igood_row_cnt
character spd_table*1,spd_table_qc*1
data    ibad_row_cnt,igood_row_cnt /2*0/
data      spd_table,spd_table_qc /2*'P'/
!
!--- Bad phy file case
!
integer ibad_phy, ibad_phy_qc
data    ibad_phy,ibad_phy_qc/2*0/
!
!--- Bad position  case
!
integer ibad_pos, ibad_pos_qc
data    ibad_pos,ibad_pos_qc/2*0/

! 
! For optode float (APEXIR_TSO3)
real, dimension(lmax) :: pres_doxy2
integer, dimension(lmax) :: pres_doxy2_qc

!
!--- Pressure2(sea surface pressure) and Temperature2.
!
integer ipres2(lmax),itemp2(lmax),ipres2_qc(lmax),itemp2_qc(lmax), &
    ipres2_flag(lmax),itemp2_flag(lmax),ideep2_flag(lmax), &
    gross_pres2_flag(lmax), it_gros2(lmax), &
    iover_gros2,it_spik2(lmax)
real pres2(lmax),temp2(lmax),pres2_qc(lmax),temp2_qc(lmax)
character type_ts32*1,gros2_flag*1

data cmon/'jan','feb','mar','apr','may','jun','jul','aug', &
    'sep','oct','nov','dec'/
data dmon/'01','02','03','04','05','06','07','08','09','10', &
    '11','12'/
data iunit/24/
data no_pos/0/
data fv /-999.0/
data profile_id/'                    '/
data profname/'                    '/
data argos_id/'                '/
data amin,cmin,gmin,jmin,kmin,pmin,smin,vmin/8*1000/
data amax,cmax,gmax,jmax,kmax,pmax,smax,vmax/8*0/
data iover_anlz, iover_clim, iover_gros, iover_sped, &
    iover_dens, iover_spik, iover_cnsv, isped_flag,  &
    iover_pres, iover_jump, iover_salg, iover_deep, &
    iover_deep_adj, iover_regi/14*0/
data anlz_flag,cksm_flag,clim_flag,gros_flag,sped_flag, &
    spik_flag,dens_flag,cnsv_flag,pres_flag,jump_flag, &
    regi_flag,frzn_flag,salg_flag,over_all/14*'N'/

integer beg_datetime(8),tmp_datetime(8),end_datetime(8)
character (len=10) big_ben(3)

write(msg,*)'Entering Program Execution'; msgout=TimeStampMsg(msg)
call LogIt(PRG,msgout)

!
! Initialize flags, variables, & characters.
!
do i = 1, lmax
  is_anlz(i)=0
  icksm_flag(i)=0
  is_clim(i)=0
  gross_pres_flag(i)=0
  gross_pres_adj_flag(i)=0
  gross_temp_flag(i)=0
  is_gros(i)=0
  density_grad_flag(i)=0
  test_density_grad_flag(i)=0
  is_spik(i)=0
  ipres_flag(i)=0
  is_jump(i)=0
  vert_grad_sal_flag(i)=0
  deepest_pres_flag(i)=0
  deepest_pres_adj_flag(i)=0
  it_regi(i)=0
  is_regi(i)=0
  ireds_t(i)=0
  ireds_s(i)=0
  imeds_t(i)=0
  imeds_s(i)=0
  pres(i)=0.0
  dep(i)=0.0
  tem(i)=0.0
  sal(i)=0.0
enddo
do i=1,14
  itime(i:i)=' '
  itime_prev(i:i)=' '
enddo
do j=1,np
  do i=1,14
    itime_hist(j)(i:i)=' '
  enddo
enddo
do i=1,50
  ana_version(i:i)=' '
enddo
do i=1, 128
  pathname_infile(i:i)=' '
  pathname_outfile(i:i)=' '
  pathname_infile_prev(i:i)=' '
  pathname_meta(i:i)=' '
  pathname_clima_s(i:i)=' '
  clima_s(i:i)=' '        
  pathname_mask_t(i:i)=' '
  stddev_factor_clima(i:i)=' '
  stddev_factor_analysis(i:i)=' '
  pathname_analysis_s(i:i)=' '
  analysis_s(i:i)=' '
  pathname_trace(i:i)=' '
  pathname_error(i:i)=' '
  pathname_debug(i:i)=' '
  pathname_table(i:i)=' '
  phyfile(i:i)=' '
enddo
do i=1,im1
  do j=1,jm1
    do k=1,km1
      cl1(i,j,k)=0.0
      sd1(i,j,k)=0.0
      clma(i,j,k)=0.0
      sdma(i,j,k)=0.0
      clmb(i,j,k)=0.0
      sdmb(i,j,k)=0.0
    enddo
  enddo
enddo
do i=1,im2
  do j=1,jm2
    do k=1,km2
      an2(i,j,k)=0.0
      sd2(i,j,k)=0.0
      an2_t(i,j,k)=0.0
    enddo
  enddo
enddo
do i=1,np
  spd(i)=0.0
  alon_hist(i)=0.0
  alat_hist(i)=0.0
  alon_hist_p(i)=0.0
  alat_hist_p(i)=0.0
  iyr(i)=0
  imo(i)=0
  ida(i)=0
  ihr(i)=0
  imin(i)=0
  isec(i)=0
enddo
!
! Get environmental variable
!
call GETENV('CLIMATOLOGY_S', pathname_clima_s) 
call GETENV('MASK_T', pathname_mask_t) 
call GETENV('ANALYSIS_FILE', pathname_analysis_s) 
call GETENV('QCFILES_AOMLID_DIR', pathname_qc) 
call GETENV('STDDEV_FACTOR_CLIMA',stddev_factor_clima)
call GETENV('STDDEV_FACTOR_ANALYSIS',stddev_factor_analysis)

call GETENV('results_outfile', pathname_table)
call GETENV('trace_outfile', pathname_trace)
call GETENV('error_outfile', pathname_error)
call GETENV('debug_outfile', pathname_debug)

!     
!* Get command arguments:
!    1) PHY input file path-name 
!    2) QC output file path-name 
!
call GETARG(1, pathname_infile)
call GETARG(2, pathname_meta)
call GETARG(3, pathname_outfile)

print *,'pathname_infile=',pathname_infile
print *,'pathname_meta=',pathname_meta
print *,'pathname_outfile=',pathname_outfile

lastdir = lchar_occur(pathname_infile,'/')
lastdir_qc = lnblnk(pathname_qc)
lenstr = len(pathname_infile) 

profname = pathname_infile(lastdir+1:lenstr)
last = index(pathname_infile, '.')
lasb = lchar_occur(profname(1:last-lastdir),'_')
lase = index(profname,'.')
if(lasb.gt.lase) then
  status=9
  write(LOG, '(A,": Profname error - ", A)')  PRGMAIN, profname
  write(ERR, '(A,": Profname error - ", A)')  PRGMAIN, profname
  write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
  write(LOG,'("call exit at s01")'); call exit(status)
endif
profile_id = profname(1:lase-1)

read(profile_id(lasb+1:lase-1),*) prof_num

write(LOG, '(A, ": Profile File Name = ", A)')  PRGMAIN, pathname_infile

lastnb = lnblnk(pathname_trace)
write(LOG, '(A,": Opening Trace file - ", A)')  PRGMAIN, pathname_trace(1:lastnb)
open(48,file=pathname_trace,form='formatted',position='append', &
    recl=1000,iostat=ios)
if(ios.ne.0) then
  status=9
  write(LOG, '(A,": Opening trace file error - ", A," ios=",i4)')  PRGMAIN, pathname_trace(1:lastnb),ios
  write(ERR, '(A,": Opening trace file error - ", A," ios=",i4)')  PRGMAIN, pathname_trace(1:lastnb),ios
  write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
  write(LOG,'("call exit at s02")'); call exit (status)!stop '9'
endif

lastnb = lnblnk(pathname_error)
write(LOG, '(A, ": Opening Error file - ", A)')  PRGMAIN, pathname_error(1:lastnb)
if(open_file(ERR,pathname_error,'ERROR','QC_T',6,0)==9) then
  status = 9
  write(LOG,'("call exit at t02")'); call exit(status)
endif
!
!*    Readin Standard Deviation values for Clim and Analysis.
!
read(stddev_factor_clima,*) sd_clim
read(stddev_factor_analysis,*) sd_anal

lastnb = lnblnk(pathname_table)
write(LOG, '(A,": Opening Table file - ", A)')  PRGMAIN, pathname_table(1:lastnb)
open(49,file=pathname_table,form='formatted',position='append', &
    recl=1000,iostat=ios)
if(ios.ne.0) then
  status=9
  write(LOG, '(A,": Opening table file error - ", A," ios=",i4)')  PRGMAIN, pathname_table(1:lastnb),ios
  write(ERR, '(A,": Opening table file error - ", A," ios=",i4)')  PRGMAIN, pathname_table(1:lastnb),ios
  write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
  write(LOG,'("call exit at s04")'); call exit (status)!stop '9'
endif

lastnb = lnblnk(pathname_debug)
write(LOG,'(A, "Opening ", A)') PRGMAIN, pathname_debug(1:lastnb)
if(open_file(DBG,pathname_debug,'debug','QC_S',6,50)==9) then
  status=9
  write(LOG, '(A,"Opening debug file error - ", A)') PRGMAIN,pathname_debug
  write(LOG,'("call exit at s05")'); call exit (status)!stop '9'
endif
if(DEBUG) write(msg,*)'DEBUG is ON'; call LogDBG(PRG,msg)
! 
!* Get the lats, lons, depths for the grid1 and grid2.

call fill1(xt1,im1,yt1,jm1,df1,km1)          ! grid 1
call fill2(xt2,im2,yt2,jm2,df2,km2)          ! grid 2
do j=1,jm1
 cj1(j)=cos(0.017453293*yt1(j))
enddo
do j=1,jm2
 cj2(j)=cos(0.017453293*yt2(j))
enddo

!* Read in the grid 2 mask.

lastnb = lnblnk(pathname_mask_t)
write(*, '(A, ": Opening MASK_T file - ", A)')  PRGMAIN, pathname_mask_t(1:lastnb)
open(23,status='old',form='unformatted',file=pathname_mask_t,  &
    iostat=ios)
if(ios.ne.0) then
  status=9
  write(LOG, '(A, ":Error opening mask file unit 23. ios= ", A)')  PRGMAIN, ios 
  write(LOG, '(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
  write(ERR,*) PRGMAIN, ': Error opening mask file unit 23. ios=',ios
  write(ERR,*) PRGMAIN, ': STOP -> STATUS=', status 
  write(LOG,'("call exit at s06")'); call exit (status)!stop '9'
endif
read(23) mask
close(23)
write(LOG,'(A, ": MASK_T file read successfully")') PRGMAIN
!
!* Open meta file.
!
open(iunit_meta,status='old',file=pathname_meta, &
    form='formatted',iostat=ios)
if(ios.ne.0) then
  status=9
  write(LOG,  &
    '(A, ": Error opening META file unit 25. ios= ", i4)')  PRGMAIN, ios
  write(LOG,'("      File =", A)') pathname_meta
  write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
  write(ERR,*) PRGMAIN,  &
    ': Error opening META file unit 25. ios=',ios
  write(ERR,*)'file =', pathname_meta
  write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
  write(LOG,'("call exit at s07")'); call exit (status)!stop '9'
endif
write(LOG,'(A, ": Reading  META file - ", A)') PRGMAIN,  &
    pathname_meta
call rd_float_meta(iunit_meta,int_num,prof_num,wmo_num, &
    trans_id_meta,proj_name, &
    inst_ref,st_time,laun_time,dlay_down_hours,down_days, &
    up_hours, &
    cycle_days,descent_hours,neutral_depth_days,ascent_hours, &
    surface_hours,laun_pos_lat,laun_pos_lon,float_snum, &
    trans_sys,pos_sys,deep, &
    send_gts,grey_list,grey_date_st,grey_date_en,grey_flag, &
    grey_parm,grey_reason, &
    sal_adj_dd,sal_adj_mm,sal_adj_yyyy,sal_adj_pnum,sal_offset, &
    sal_std,sal_adj_line)

!
!* Loop through the data to check.  Depths are in meters; values are
!* temperatures in degrees C.
!
!* BEGINNING OF QC LOOP

phyfile=pathname_infile
lastnb = lnblnk(phyfile)

write(*, '(A, ": Opening File to QC_S - ", A)')  PRGMAIN, phyfile

inquire(file=phyfile,exist=phy_exist)
if(phy_exist) then    
  open(iunit,status='old',file=phyfile,form='formatted', &
    iostat=ios)
  if(ios.ne.0) then
    status=9
    write(LOG,  &
    '(A, ": Error opening PHY file unit 24. ios= ", i4)')  PRGMAIN, ios
    write(LOG,'("      File =", A)') phyfile
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

    write(ERR,*) PRGMAIN,  &
    ': Error opening PHY file unit 24. ios=',ios
    write(ERR,*)'file =', phyfile
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at s08")'); call exit (status)!stop '9'
  endif       ! if(ios.ne.0) then

  nlev = 0       ! initialize pressure/sal pair to be zero.
  icnt = 0       ! initialize surface positions to be zero.

  ! Read the phy file for the current profile
  call rd_phy(iunit,int_num,wmo_num,trans_id, &
    prof_num,file_num,inst_type,ireverse,whoi_c_date, &
    juld_qc, &
    wmo_inst,wmo_reco,argos_prg_num,pi, &
    hasTemp,hasPsal,hasCond,hasO2,land_test, &
    surface_pressure, &
    st_trans_time, st_trans_time_qc, &
    ascent_end_time, ascent_end_time_qc, &
    whoi_pos_qc, &
    sigma_clim,sigma_anal,rtime, &
    n_drift,drift_t,drift_p,drift_s,drift_o,drift_c, &
    nparam,t_param,t_value, &
    num_col,column,num_cal,calib, &
    is_pres,ip_vis,isped_flag,icksm_flag, &
    icnt,alat_hist,alon_hist,itime_hist,iclass_hist, &
    nlev,pres,tem,sal,cond,oxy,oxy2,ibad_phy,ibad_pos, &
    type_ts32,pres2,temp2,ipres2,itemp2, &
    pres_doxy2, &
    pres_doxy2_qc, &
    psal_adj_exist,sal_adj, &
    pres_adj_exist,pres_adj, &
    spd_table,most_likely_frame_status)
if(nlev.le.0.and.icnt.eq.0.and.ibad_phy.eq.1) then ! bad phy file case
  status=11
  over_all='F'
  go to 78
endif

if(prof_num.ne.7.and.mod(file_num,2).eq.1.and.inst_type.eq. &
    'APEX_TSB1') then 
  bounce_ts='y'
  prof_num=file_num
endif

  if(icnt.gt.np) then
    status=9
    write(LOG,  &
    '(A, ": Error dimension check icnt gt np:")')  PRGMAIN
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

    write(ERR,  &
    '(A, ": Error dimension check icnt gt np:")')  PRGMAIN
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at s09")'); call exit (status)!stop '9'
  endif         ! if(icnt.gt.np) then
  if(nlev.gt.lmax) then
    status=9
    write(LOG,'(A, ": Error dimension check nlev gt lmax: nlev lmax"),i5,i5') PRGMAIN,nlev,lmax
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

    write(ERR,  &
    '(A, ": Error dimension check nlev gt lmax: nlev lmax"),i5,i5') PRGMAIN,nlev,lmax
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at s10")'); call exit (status)!stop '9'
  endif          ! if(nlev.gt.lmax) then

  ! Gotta have salinity data
  if( (.not. hasPsal) .and. (nlev>0) ) then         
    status=9
    write(LOG,  &
    '(A, ": Error running QC_S on temperaure type float.")')  PRGMAIN
    write(LOG,'("      Phyfile =", A)') phyfile
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

    write(ERR,  &
    '(A, ": Error running QC_S on temperaure type float.")')  PRGMAIN
    write(ERR,'("      Phyfile =", A)') phyfile
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at s11")'); call exit (status)!stop '9'
  endif           
endif             

if(nlev.lt.0) nlev=0
!
!--- For JUMP check S test.
!
!
!--- Is there a previous QC profile?
!
last = index(pathname_infile, '.')

if(prof_num.gt.1000) then   ! ORBCOMM descending profiles?
  prof_num=prof_num-1000
endif           
if(prof_num.ge.1) then      ! get a previous qc profile
  prof_num_prev=prof_num-1
  if(bounce_ts.eq.'y') prof_num_prev=prof_num-2
  write(cprof_num_prev,'(i3.3)') prof_num_prev
  pathname_infile_prev=pathname_qc(1:lastdir_qc)//'/'// &
    pathname_infile(lastdir+1:last-4)// &
    cprof_num_prev//'.qc'
  qcfile=pathname_infile_prev
else
  prof_num_prev=prof_num
  write(cprof_num_prev,'(i3.3)') prof_num_prev
endif

 10   continue
inquire(file=qcfile,exist=qc_exist)
if(qc_exist) then
  open(iunit,status='old',file=qcfile,form='formatted', &
    iostat=ios)
  if(ios.ne.0) then
    status=9
    write(LOG,  &
    '(A, ": Error opening Previous QC file unit 24. ios= ", i4)')  PRGMAIN, ios
    write(LOG,'("      File =", A)') qcfile
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
    write(ERR,*) PRGMAIN,  &
    ': Error opening Previous QC file unit 24. ios=',ios
    write(ERR,*)'file =', qcfile
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at s12")'); call exit (status)!stop '9'
  endif       ! if(ios.ne.0) then
  write(LOG, '(A, ": Opening Previous QC file - ", A)') PRGMAIN,  &
    qcfile
  write(LOG, '(A, ": Reading Previous QC file - ", A)') PRGMAIN,  &
    qcfile

  icnt_qc=0
  call rd_qc(iunit,int_num,wmo_num,trans_id, &
    prof_num_prev,file_num_prev,inst_type,ireverse,whoi_c_date, &
    juld_qc, &
    wmo_inst,wmo_reco,argos_prg_num,pi, &
    hasTemp_prev,hasPsal_prev,hasCond_prev,hasO2_prev,land_qc, &
    surf_pres_aux, &
    prev_st_trans_time,prev_st_trans_time_qc, &
    prev_ascent_end_time, prev_ascent_end_time_qc, &
    whoi_pos_qc, &
    sigma_clim,sigma_anal,adate, &
    n_drift, drift_t, drift_p, drift_s, drift_o, drift_c, &
    nparam,t_param,t_value, &
    num_col, column, num_cal, calib, &
    iover_t_qc,it_anlz_qc,it_clim_qc,it_gros_qc,it_vert_qc, &
    it_spik_qc,it_vis_qc,it_cntv_qc, &
    it_jump_qc,it_frzn_qc,it_regi, &
    iover_s_qc,is_anlz_qc,is_clim_qc,is_gros_qc,is_dens_qc, &
    is_spik_qc,is_vis_qc,is_cntv_qc, &
    is_salg_qc, is_jump_qc, is_frzn_qc, is_regi, &
    ipres_qc, ip_vis_qc, isped_flag_qc, icksm_flag_p, &
    icnt_qc,alat_hist_qc,alon_hist_qc,itime_hist_qc,iclass_hist, &
    nlev_qc, pres_qc, tem_qc, sal_qc, cond_qc, oxy_qc, oxy2_qc, &
    ibad_phy_qc, ibad_pos_qc, &
    type_ts32, pres2_qc, temp2_qc, ipres2_qc, itemp2_qc, &
    spd_table)
 else
   write(LOG,*)PRGMAIN,': Previous QC file NOT exist. unit 24'
   write(LOG,*)PRGMAIN,': TEST force exit after one failure'
  if(prof_num_prev.ge.1000) then ! TEST 1) then
    lastnb = lnblnk(qcfile)
    write(LOG,'(A,": File =", A," not exist!")') PRGMAIN, &
    qcfile(1:lastnb)
    write(ERR,  &
    '(A, ": Previous QC file NOT exist. unit 24")')  PRGMAIN
   write(ERR,'(A,": File =", A)') PRGMAIN,qcfile
   prof_num_prev=prof_num_prev-1 ! qc file one before.
   if(bounce_ts.eq.'y') prof_num_prev=prof_num_prev-1
   write(cprof_num_prev,'(i3.3)') prof_num_prev
   pathname_infile_prev=pathname_qc(1:lastdir_qc)//'/'// &
    pathname_infile(lastdir+1:last-4)//cprof_num_prev//'.qc'
   qcfile=pathname_infile_prev
   go to 10
  else
  endif       ! if(prof_num_prev.ge.1) then 
endif         ! if(qc_exist) then
!
!--- Test 18: Deepest Pressure test (deepest pressure + 10%) for now.
!             No final decision is made yet. 12-30-2004
!             deepest pressure + 10%         04-02-2007
!     
if(isped_flag.eq.4) then
  status=7    ! speed check really failed  10-25-07
!        write(LOG,*)'rlon=',alon_hist(1),' rlat=',alat_hist(1)
!        if(alon_hist(1).eq.0.0.and.alat_hist(1).eq.0.0) status=7 ! 11-26-07
  spd_table='F'
  sped_flag='F'
endif

!
! Deepest Pressure Test
!
iover_deep=1
do n=1,nlev
  deepest_pres_flag(n)=1
  if(pres(n)>(deep*1.10)) then     ! + 10%
    write(LOG,'(A, ": Error DEEPEST PRESSURE case: ")')  PRGMAIN
    write(LOG,*) 'deep pres=',(deep*1.10),' pres=',pres(n)
    write(ERR,'(A, ": Error DEEPEST PRESSURE case: ")')  PRGMAIN
    write(ERR,*) 'deep pres=',(deep*1.10),' pres=',pres(n)
    deepest_pres_flag(n)=4
    iover_deep=4
  endif
  !
  ! Minimum, Maximum
  !
  if(deepest_pres_flag(n)<dmin) dmin=deepest_pres_flag(n)
  if(deepest_pres_flag(n)>dmax) dmax=deepest_pres_flag(n)
enddo

!
! Deepest Pressure Adjusted Test
!
if(pres_adj_exist) then
  iover_deep_adj=1
  do n=1, nlev
    deepest_pres_adj_flag(n)=1
    if(pres_adj(n)>(deep*1.10)) then     ! + 10%
      write(LOG,'(A, ": Error DEEPEST PRESSURE ADJ case: ")')  PRGMAIN
      write(LOG,*) 'deep pres=',(deep*1.10),' pres_adj=',pres_adj(n)
      write(ERR,'(A, ": Error DEEPEST PRESSURE ADJ case: ")')  PRGMAIN
      write(ERR,*) 'deep pres=',(deep*1.10),' pres=',pres_adj(n)
      deepest_pres_adj_flag(n)=4
      iover_deep_adj=4
    endif
    !
    ! Minimum, Maximum
    !
    if(deepest_pres_adj_flag(n)<d_adjmin) then 
      d_adjmin=deepest_pres_adj_flag(n)
    endif
    if(deepest_pres_adj_flag(n)>d_adjmax) then
      d_adjmax=deepest_pres_adj_flag(n)
    endif
  enddo
endif

if(icnt.eq.0) then
  if(nlev.eq.0) status=5     ! no position and no data
  if(nlev.ge.1) status=8     ! no position with data
  if(ibad_pos.eq.1) status=6 ! bad position with data
  if(ibad_pos.eq.0) no_pos=1 ! no position indicator
  spd_table='N'
  go to 55
endif

rlat = alat_hist(1)
rlon = alon_hist(1)
alon = rlon
ivalid_pos=1

!      if(icnt.ge.1.and.rlat.gt.-0.0001.and.rlat.lt.0.00001.and.
!     *rlon.gt.-0.0001.and.rlon.lt.0.00001) then
if(icnt.ge.1.and.ibad_pos.eq.1) then
  status=6
  go to 55
endif
!
! --- Status=8 (NO S SURFACE POSITION CASE)
!     1) profile num>=1; 2) profile num = 0
!
if(icnt.le.0) then            !
  if(nlev.eq.0) then
    status=5                   ! no position & no data
    go to 78
  endif
  if(prof_num.ne.0) then
    status=8                   ! 02-07-2001
    write(LOG,'(A, ": Error NO SURFACE locations case: ")')  PRGMAIN
    write(LOG,'("      PROFILE ID =", A)') profile_id
    write(LOG,'(A, ": CONTINUE -> STATUS = ", I3)') PRGMAIN, status
    write(ERR,'(A, ": Error NO SURFACE locations case: ")')  PRGMAIN
    write(ERR,'("      PROFILE ID =", A)') profile_id
    write(ERR,*)'file =', phyfile
    write(ERR,*) PRGMAIN, ': CONTINUE -> STATUS = ', status
    no_pos=1
    go to 55
  else
    status=8                   ! 02-07-2001
    write(LOG,'(A, ": Error NO SURFACE locations case: ")')  PRGMAIN
    write(LOG,'("      PROFILE ID =", A)') profile_id
    write(LOG,'(A, ": CONTINUE -> STATUS = ", I3)') PRGMAIN, status
    write(ERR,'(A, ": Error NO SURFACE locations case: ")')  PRGMAIN
    write(ERR,'("      PROFILE ID =", A)') profile_id
    no_pos=1
    go to 55
  endif
endif

!
! Impossible Location test.
!
call location_check(rlon,rlat,location_check_result)

!
! Convert Pressure to depth.
!
do i=1,nlev
  call pres2dep(pres(i),rlat,dep(i))
enddo

! 
! Data is on Water or Land test. Joaquin Trinanes's ETOPO5 database. 
!
depth=-1                     ! Profile is in water.
if(land_test==1) depth=1    ! Profile is in land.
write(LOG,*) 'ETOPO: depth=',depth,' rlat,rlon,icnt=',rlat,rlon,icnt 
if(DEBUG) write(DBG,*)'<<<<< DEBUG from QC_S >>>>>'
if(DEBUG) write(DBG,*)'ETOPO: depth=',depth
if(depth.gt.0) then         ! + depth:land; - depth:water
  status=7
  write(LOG,'(A, ": Error data is on Land case: ")')  PRGMAIN
  write(ERR,'(A, ": Error data is on Land case: ")')  PRGMAIN
  write(LOG,'("      PROFILE ID =", A)') profile_id
  write(ERR,'("      PROFILE ID =", A)') profile_id
  write(LOG,'(A, ": CONTINUE -> STATUS=", I3)') PRGMAIN, status
  write(ERR,'(A, ": CONTINUE -> STATUS=", I3)') PRGMAIN, status
  write(ERR,*)'file =', phyfile
  land_test=1
endif

do n=1,icnt
  read(itime_hist(n)(1:4),'(i4)') iyr(n)
  read(itime_hist(n)(5:6),'(i2)') imo(n)
  read(itime_hist(n)(7:8),'(i2)') ida(n)
  read(itime_hist(n)(9:10),'(i2)') ihr(n)
  read(itime_hist(n)(11:12),'(i2)') imin(n)
  read(itime_hist(n)(13:14),'(i2)') isec(n)
enddo
jyr = iyr(ivalid_pos)
jmo = imo(ivalid_pos)
jda = ida(ivalid_pos)
hr = ihr(ivalid_pos) + 1.0*(imin(1))/60.0
itime = itime_hist(ivalid_pos)

!
! Impossible Date test.
!
call date_check(jyr,jmo,jda,ihr(ivalid_pos),imin(ivalid_pos), &
    date_check_result)
if(date_check_result==0) date_global_test=1  ! Date OK
if(date_check_result==1) date_global_test=4  ! Impossible date

! 
!* 0) Profile, '000' case.
!
if(prof_num.eq.0) then            ! profile = '000' case

  if(isped_flag.eq.4) then
    write(LOG,*) 'SPEED CHECK TEST      failed.'
    write(TRC,*)'SPEED CHECK TEST      failed.'
    sped_flag='F'
    iover_sped=4
    over_all='F'
    iover_all=4
    status=7     ! 10-25-07
  else if(isped_flag.eq.0) then
    write(LOG,*) 'SPEED CHECK TEST     can not be applied.'
    write(TRC,*)'SPEED CHECK TEST     can not be applied.'
    sped_flag='N'
    iover_sped=0
    over_all='N'
    iover_all=0
   else
    sped_flag='P'
    iover_sped=1
    if(isped_flag.eq.2) iover_sped=2
    over_all='P'
    iover_all=1
    write(LOG,*) 'SPEED CHECK TEST       passed.'
    write(TRC,*)'SPEED CHECK TEST       passed.'
  endif
  if(nlev.eq.0) status=5                  ! profile 0 with no data line
  if(nlev.ge.1.and.status.ne.7) status=1  ! profile 0 with data line
endif
!
!* When the float is on LAND case, perform all qc tests except clim & anal.
!
if(land_test.eq.1) go to 55       
!
!* Read in the monthly temperature climatology and standard deviation.
!
call tintp(jyr,jmo,jda,hr,m1,m2,w1,w2)

do k = 1,2                       ! need to read 2 months of climatology
  if(k.eq.1) mr=m1
  if(k.eq.2) mr=m2
  lastnb = lnblnk(pathname_clima_s)
  clima_s(1:lastnb+8)=pathname_clima_s(1:lastnb)//'_'//cmon(mr)// &
    '.dat'
  write(LOG, '(A, ": Opening CLIMATOLOGY_S file - ", A)') PRGMAIN, clima_s(1:lastnb+8)
  open(21,status='old',form='unformatted',file=clima_s,  &
    iostat=ios)
  if(ios.ne.0) then
    status=9
    write(LOG,  &
    '(A, ": Error opening CLIMATOLOGY_S file unit 21. ios= ", i4)')  PRGMAIN, ios
    write(LOG,'("      File =", A)') clima_s(1:lastnb)
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
    write(ERR,*) PRGMAIN,  &
    ': Error opening CLIMATOLOGY_S file unit 21. ios=',ios
    write(ERR,*) '      File =', clima_s(1:lastnb)
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at s13")'); call exit (status)!stop '9'
  endif
  if(k.eq.1) then
    read(21) clma
    read(21) sdma
  else if(k.eq.2) then
    read(21) clmb
    read(21) sdmb
  endif
  close(21)
enddo                           ! do k = 1, 2

write(LOG,'(A, ": CLIMATOLOGY_S file read successfully")')  PRGMAIN

do k=1,km1
  do j=1,jm1
    do i=1,im1
      cl1(i,j,k)=w1*clma(i,j,k)+w2*clmb(i,j,k)
      sd1(i,j,k)=w1*sdma(i,j,k)+w2*sdmb(i,j,k)
    enddo
  enddo
enddo  
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 
!
!* Temporary standard deviations for anlysis on grid2 (sd2).
!  
do k=1,km2
  do j=1,jm2
    do i=1,im2
      sd2(i,j,k)=-999.999                ! dummy sd value
    enddo
  enddo
enddo
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 
!
!* Read in the previous week's ocean-temperature analysis from NetCDF file
!  which Dave Behringer will generate and provide us on weekly basis.
!
if(ianal.eq.1) then
!rs      lastnb = lnblnk(pathname_analysis_s)
!        analysis_s=pathname_analysis_s(1:lastnb)//'00'//dmon(jmo)//
!     *'.nc'
!        analysis_s=pathname_analysis_s(1:lastnb)//'.nc'
!rs      analysis_s=pathname_analysis_s(1:lastnb)

  inquire(file=pathname_analysis_s,exist=ncep_exist)
  if(ncep_exist) then

    write(*, '(A, ": Opening ANALYSIS_FILE NetCDF file - ", A)') PRGMAIN, pathname_analysis_s 

    call rdocn_anlz(pathname_analysis_s,an2_t,an2,atime, &
    ana_version)

    write(LOG,'(A, ": ANALYSIS_FILE NetCDF file read successfully")') PRGMAIN
 else                     ! No ncep file case
    status=9
    lastnb = lnblnk(pathname_analysis_s)
    write(LOG, '(A,": Opening Ncep weekly file error - ", A)')  PRGMAIN, pathname_analysis_s
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(ERR, '(A,": Opening Ncep weekly file error - ", A)')  PRGMAIN, pathname_analysis_s
    write(LOG,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at s14")'); call exit (status)!stop '9'
 endif
 if(DEBUG) write(DBG,*) PRGD,' debug time atime: ',atime,' rtime: ',rtime
 if(int(atime*1000).ne.int(rtime*1000).and.nlev.gt.0) then
   status=9
   write(msg,'(80a)')'T_ANALYSIS TIME is different from S_ANALYSIS TIME.'
   write(DBG,*)PRGMAIN,msg
   write(LOG,  &
    '(A, ": T_ANALYSIS TIME is different from S_ANALYSIS TIME. ")')  PRGMAIN
   write(LOG,*)'T_ANALYSIS TIME:',rtime,' S_ANALYSIS TIME:',atime
   write(ERR,  &
    '(A, ": T_ANALYSIS TIME is different from S_ANALYSIS TIME. ")')  PRGMAIN
   write(ERR,*)'T_ANALYSIS TIME:',rtime,' S_ANALYSIS TIME:',atime
   write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
   write(ERR,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
   write(LOG,'("call exit at s15")'); call exit (status)!stop '9'
 endif

endif

 110  format(1x,a,' lat:',f7.2,' lon:',f8.2,' yr:',i4,' mon:',i2, &
    ' day:',i2)

if(rlon.lt.0.0) alon=rlon+360.0                  ! 09-08-2000
call find_closest_pos(1,rlat,alon,xt1,yt1,i1,j1)  ! climatology
call find_closest_pos(2,rlat,alon,xt2,yt2,i2,j2)  ! analysis

do n=1,nlev
  call sintp(1,rlat,alon,dep(n),im1,jm1,km1,cl1,sd1,xt1,yt1,cj1, &
    df1,i1,j1,cl0,sd0)     ! 1--> climatology on grid1
!        write(LOG,*)dep(n),' cl0=',cl0,' sd0=',sd0
  call sintp(2,rlat,alon,dep(n),im2,jm2,km2,an2,sd2,xt2,yt2,cj2, &
    df2,i2,j2,an,sd)       ! 2--> analysis on grid2
!          write(LOG,*)dep(n),' an=',an,' sd=',sd
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
!     Analysis currently has no standard deviation, so we use climatology
!     standard deviation until we get one from Dave Behringer.
!     When sd0 is so small (i.e. 0.0), make it 1.0E-03 to avoid "Arithematic
!     Exception" error.
!
  if(sd0.eq.0.0) then
    sd0=1.0E-03
  endif
  sd=sd0
!
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

  if(sd0.lt.5e-3) sd0=5.e-3    ! deal with unrealistic standard deviations
  if(sd.lt.5e-3)  sd=5.e-3     ! deal with unrealistic standard deviations

  !
  ! Analysis flag.
  !
  if(ianal.eq.1) then
    ta=0.0
    ta=abs(sal(n)-an)/sd
    is_anlz(n)=1
    if(ta.gt.sd_anal) then     ! analysis flag
      is_anlz(n)=4
    endif                        !if(ta.gt.stddev_anal) then 
    if(psal_adj_exist) then
      ta_adj=0.0
      ta_adj=abs(sal_adj(n)-an)/sd
      is_anlza(n)=1
      if(ta_adj.gt.sd_anal) then
        is_anlza(n)=4
      endif                        !if(ta_adj.gt.sd_anal) then  
    endif                          !if(psal_adj_exist) then 
  else
    is_anlz(n)=1               ! when there is no analysis data.
    if(psal_adj_exist) is_anlza(n)=1
  endif                          ! if(ianal.eq.1) then

  !
  ! Climatology flag.

  tt=abs(sal(n)-cl0)/sd0
  if(tt.gt.sd_clim) then
    is_clim(n)=4
  else
    is_clim(n)=1
  endif                          ! if(tt.gt.stddev_clim) then

  if(psal_adj_exist) then
    tt_adj=abs(sal_adj(n)-cl0)/sd0
    if(tt_adj.gt.sd_clim) then
      is_clima(n)=4
    else
      is_clima(n)=1
    endif                        ! if(tt_adj.gt.sd_clim) then
  endif                          ! if(psal_adj_exist) then
 enddo                           ! do n=1,nlev

 111  format(1x,'clim:',i4,' d:',f7.2,' s:',f6.2,' cl0:',e12.5,' sd0:', &
    f7.3,' tt:',e12.5)
 112  format(1x,'anlz:',i4,' d:',f7.2,' s:',f6.2,' an :',e12.5,' sd0:', &
    f7.3,' ta:',e12.5)
 106  format(1x,'pass:',i4,' d:',f7.2,' s:',f6.2,' an :',e12.5,' cl0:', &
    f7.3,' sd0:',f7.3,' ta:',e12.5,' tt:',f6.2)
!
!* Flag values bracketed by rejected values for salinity.
!
do n=2,nlev-1
  if(is_clim(n).eq.1)then
    if(is_clim(n-1).eq.4.and.is_clim(n+1).eq.4) is_clim(n)=4
  endif
enddo

do n=2,nlev-1
  if(is_anlz(n).eq.1)then
    if(is_anlz(n-1).eq.4.and.is_anlz(n+1).eq.4)  &
    is_anlz(n)=4
  endif
enddo

 55   continue
write(LOG,119)
write(LOG,*)'Profile_id: ', profile_id,' lat:',rlat,' lon:',rlon
write(LOG,119)
write(TRC,119)
write(TRC,*)'Profile_id:', profile_id,' lat:',rlat,' lon:',rlon
if(DEBUG) write(DBG,*)'<<< Begin DEEP CHECK >>>'
if(nlev.eq.0.or.dmax.eq.0) then
  write(LOG,*) 'DEEP CHECK TEST S    can not be determined.'
  write(TRC,*)'DEEP CHECK TEST S    can not be determined.'
  deep_flag='N'
  iover_deep=0
  go to 8
endif
do n=1,nlev
  if(deepest_pres_flag(n)==4) then            
    write(LOG,*) 'DEEP CHECK TEST S    failed.'
    write(TRC,*)'DEEP CHECK TEST S    failed.'
    deep_flag='F'
    iover_deep=4
    go to 8
  else
    deep_flag='P'
    iover_deep=1
  endif
enddo
write(LOG,*) 'DEEP CHECK TEST S    passed.'
write(TRC,*)'DEEP CHECK TEST S    passed.'
 8    continue
if(DEBUG) write(DBG,*)'<<< End DEEP CHECK >>>'
!
!* Test 6: Grobal Range check test. 
!
if(DEBUG) write(DBG,*)'<<< Begin GROSS CHECK >>>'
if(nlev.eq.0) then
  if(prof_num.eq.0) status=3    ! yes positions but no data line case
else
  call gross_check_salinity(.false., sal, nlev, icksm_flag, &
    is_gros, iover_gros, gros_flag)
  if(psal_adj_exist) then 
    call gross_check_salinity(.true.,sal_adj,nlev,icksm_flag, &
    is_grosa,iover_grosa,grosa_flag)
  endif
endif

if(DEBUG) write(DBG,*)'<<< End GROSS CHECK >>>'
!
!*  Test 7: Regional Range Test
!
if(DEBUG) write(DBG,*)'<<< Begin REGION CHECK >>>'
!      if(rlat.eq.99.999.and.rlon.eq.999.999) then
!        write(LOG,*) 'REGION CHECK         can not be determined.'
!        write(TRC,*)'REGION CHECK         can not be determined.'
!        iover_regi=0
!        regi_flag='N'
!        go to 62
!      endif

iregion=0
call redsea_check(rlon,rlat,tem,sal,nlev,ireds_region, &
    ireds_t,ireds_s)

call meditsea_check(rlon,rlat,tem,sal,nlev,imeds_region, &
    imeds_t,imeds_s)

if(ireds_region.eq.1.or.imeds_region.eq.1) then
  call regi_check_s(1,nlev,tem,sal,pres,rlon,rlat,ireds_s,imeds_s, &
    rmin,rmax,iregion,imeds_region,ireds_region,is_regi, &
    regi_flag,iover_regi)
  if(psal_adj_exist) call regi_check_s(2,nlev,tem,sal, &
    pres,rlon,rlat,ireds_s,imeds_s, &
    ramin,ramax,iregion,imeds_region,ireds_region,is_regia, &
    regia_flag,iover_regia)
endif

!      if(ireds_region.eq.1) then
!        iregion=1      
!        rmax=0
!        rmin=1000
!        do n=1,nlev
!          if(ireds_s(n).eq.4) then 
!	    is_regi(n)=4
!          else
!            is_regi(n)=1
!          endif
!          if(is_regi(n).gt.rmax) rmax=is_regi(n)
!          if(is_regi(n).lt.rmin) rmin=is_regi(n)
!        enddo
!      else if(imeds_region.eq.1) then
!        iregion=2
!        do n=1,nlev
!          if(imeds_s(n).eq.4) then 
!	    is_regi(n)=4
!          else
!            is_regi(n)=1
!          endif
!          if(is_regi(n).gt.rmax) rmax=is_regi(n)
!          if(is_regi(n).lt.rmin) rmin=is_regi(n)
!          if(tem(n).eq.0.0.and.pres(n).eq.0.0.and.sal(i).eq.0.0) then
!            is_regi(n)=0
!          endif
!        enddo
!      endif

!      if(nlev.eq.0.or.rmax.eq.0) then
!        write(LOG,*) 'REGIONAL TEST S      can not be applied.'
!        write(TRC,*)'REGIONAL TEST S      can not be applied.'
!        regi_flag='N'
!        iover_regi=0
!        go to 62
!      endif

!      do n=1,nlev
!        if(is_regi(n).eq.4) then
!          write(LOG,*) 'REGION CHECK S       failed.'
!          write(TRC,*)'REGION CHECK S       failed.'
!          iover_regi=4
!          regi_flag='F'
!          go to 62
!        else
!          iover_regi=1
!          regi_flag='P'
!        endif
!      enddo
!      write(LOG,*) 'REGION CHECK S       passed.'
!      write(TRC,*)'REGION CHECK S       passed.'
! 62   continue
  
if(DEBUG) write(DBG,*)'<<< End REGION CHECK >>>'
!
!* Check Sum flag test.
!
if(DEBUG) write(DBG,*)'<<< Begin CHECK SUM CHECK >>>'
if(nlev.eq.0) then
  write(LOG,*) 'CHECK SUM FLAG       can not be determined.'
  write(TRC,*)'CHECK SUM FLAG       can not be determined.'
  cksm_flag='N'
  iover_cksm=0
  go to 72
endif

do n=1,nlev
  if(icksm_flag(n).eq.0) then
    write(LOG,*) 'CHECK SUM FLAG       can not be determined.'
    write(TRC,*)'CHECK SUM FLAG       can not be determined.'
    cksm_flag='N'
    iover_cksm=0
    go to 72
  else if(icksm_flag(n).eq.4) then  ! 01-26-2001
    write(LOG,*) 'CHECK SUM FLAG       failed.'
    write(TRC,*)'CHECK SUM FLAG       failed.'
    cksm_flag='F'
    iover_cksm=4
    go to 72
  else
    cksm_flag='P'
    iover_cksm=1
  endif
enddo
write(LOG,*) 'CHECK SUM FLAG       passed.'
write(TRC,*)'CHECK SUM FLAG       passed.'
 72   continue
if(DEBUG) write(DBG,*)'<<< End CHECK SUM CHECK >>>'
! 
!* 3) Third, Constant value check test.
!
if(DEBUG) write(DBG,*)'<<< Begin CONSTANT CHECK >>>'
if(nlev.le.1) then 
  write(LOG,*) 'CONSTANT VALUE TEST  can not be applied.'
  write(TRC,*)'CONSTANT VALUE TEST  can not be applied.'
  cnsv_flag='N'
  iover_cnsv=0
  go to 73
endif
 
call constv_check(nlev,sal,iover_cnsv)
if(iover_cnsv.eq.4) then
  write(LOG,*) 'CONSTANT VALUE TEST  failed.'
  write(TRC,*)'CONSTANT VALUE TEST  failed.'
  cnsv_flag='F'
  go to 73
else if(iover_cnsv.eq.1) then
  cnsv_flag='P'
else if(iover_cnsv.eq.0) then
  write(LOG,*) 'CONSTANT VALUE TEST  can not be applied.'
  write(TRC,*)'CONSTANT VALUE TEST  can not be applied.'
  cnsv_flag='N'
  iover_cnsv=0
  go to 73
else
  status=9
  write(LOG,'(A, ":  CONSTANT VALUE CHECK ERROR:")') PRGMAIN
  write(ERR,'(A, ":  CONSTANT VALUE CHECK ERROR:")') PRGMAIN
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(ERR,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at s16")'); call exit(status)!stop 'abnormal exit'
endif
write(LOG,*) 'CONSTANT CHECK TEST  passed.'
write(TRC,*)'CONSTANT CHECK TEST  passed.'
 73   continue
if(DEBUG) write(DBG,*)'<<< End CONSTANT CHECK >>>'
!
!* 4) Test 14: Density Inversion test.
!
if(DEBUG) write(DBG,*)'<<< Begin DENSITY CHECK >>>'
if(DEBUG) write(msg,*)'<<< Begin DENSITY CHECK >>>'; call LogDBG(PRG,msg)
if(nlev.eq.0) then
  write(LOG,*) 'DENSITY GR.TEST S    can not be applied.(nlev=0)'
  write(TRC,*) 'DENSITY GR.TEST S    can not be applied.(nlev=0)'
  if(DEBUG) write(DBG,*) 'DENSITY GR.TEST S    can not be applied.(nlev=0) at 1'
  dens_flag='N'
  iover_dens=0
  go to 74
endif
do n=1,nlev
  if(pres(n)==fv .or. tem(n)==fv .or. sal(n)==fv) then
    density_grad_flag(n)=0
  else 
    vmax=1
  endif
enddo
if(vmax==0) then
  write(LOG,*)'DENSITY GR.TEST S    can not be applied.(vmax=0)'
  write(TRC,*)'DENSITY GR.TEST S    can not be applied.(vmax=0)'
  if(DEBUG) write(DBG,*)'DENSITY GR.TEST S    can not be applied.(vmax=0) at 2'
  dens_flag='N'
  iover_dens=0
  go to 74
endif

! This was done later, do it now and test the pres
call pres_check(tem,sal,pres,nlev,icksm_flag,ipres_flag)

ndg = 0
do i=1,nlev
  if(ipres_flag(i) == 4) then
	if(DEBUG)write(LOG,2011)i,ipres_flag(i),pres(i)
  else if(i>1 .and. pres(i) == 0.0) then
	if(DEBUG)write(LOG,2012)i,pres(i),ipres_flag(i)
  else if(pres(i) == fv) then
	if(DEBUG)write(LOG,2013)i,pres(i)
  else if(tem(i) == fv) then 
	if(DEBUG)write(LOG,2014)i,tem(i)
  else if(sal(i) == fv) then
	if(DEBUG)write(LOG,2015)i,sal(i)
  else if(sal(i) < 0.00001) then
	if(DEBUG)write(LOG,2016)i,sal(i)
  else
	ndg = ndg + 1;
	dgpres(ndg) = pres(i)
	dgtemp(ndg) =  tem(i)
	dgpsal(ndg) =  sal(i)
	iloc(ndg) = i
	if(DEBUG)write(LOG,2012)i,ipres_flag(i),pres(i),ndg,dgpres(ndg),dgtemp(ndg),dgpsal(ndg)
  endif
enddo
2011 format('BD1 ',i4,f18.4,i4)
2012 format('BD2 ',i4,f18.4)
2013 format('BD3 ',i4,f18.4)
2014 format('BD4 ',i4,f18.4)
2015 format('BD5 ',i4,f18.4)
2016 format('BD6 ',i4,f18.4)
if(DEBUG) write(DBG,*)'TEST_NDG ndg: ',ndg
if(ndg < 2) then
    write(msg,*)'TEST_NDG W ndg < 2, test cannot be performed'; call LogDBG(PRG,msg)
  write(LOG,*)'DENSITY GR.TEST S    can not be applied.(ndg=0,1)'
  write(TRC,*)'DENSITY GR.TEST S    can not be applied.(ndg=0,1)'
  if(DEBUG) write(DBG,*)'DENSITY GR.TEST S    can not be applied.(ndc=0,1) at 4'
  dens_flag='N'
  iover_dens=0
  go to 74
elseif(ndg .ne. nlev) then
    write(msg,2026)nlev,ndg; call LogDBG(PRG,msg)
    write(msg,*)PRGD,'DG call dengrad_check for dg-arrays'; call LogDBG(PRG,msg)
    call dengrad_check(ndg,jwndo,lmax,dgpsal,dgtemp,dgpres,rlon,rlat,test_density_grad_flag)
    do i=1,ndg
	if(DEBUG)write(LOG,*)'TEST_NDG flag: ',i,test_density_grad_flag(i)
	density_grad_flag(iloc(i))=test_density_grad_flag(i)
    enddo
else
    write(msg,2017)nlev; call LogDBG(PRG,msg)
    write(msg,*)PRGD,'DG call dengrad_check for regular arrays'; call LogDBG(PRG,msg)
    call dengrad_check(nlev,jwndo,lmax,sal,tem,pres,rlon,rlat,density_grad_flag)
endif
write(msg,*)'return from dengrad_check'; call LogDBG(PRG,msg)
2026 format('There are bad points, nlev: ',i5,' npts to dengrad: ',i5)
2017 format('There are NO bad points, nlev: ',i5)
if(DEBUG_LEV == 3) then
    if(ndg == nlev) then
	if(DEBUG)write(msg,*)'TEST_NDG nlev=ndg'
    else
	do i=1,nlev
	    write(msg,2021)i,density_grad_flag(i),pres(i),tem(i),sal(i); call RawDBG(PRG,msg);
	enddo
    endif
endif
2021 format('GUD ',i4,i4,f18.4,f18.4,f18.4)
!if(DEBUG_LEV==33) then
!    do n=1,nlev
!       test_density_grad_flag(i)=0
!    enddo 
!    write(DBG,*)PRGD,'DG call dengrad_check_old'
!    call dengrad_check_old(nlev,jwndo,lmax,sal,tem,pres,rlon,rlat,density_grad_flag)
!    write(DBG,*)PRGD,'DG rtrn dengrad_check_old'
!    do n=1,nlev
!       write(DBG,'(i3,2x,i3,i3," 999.99")')i,density_grad_flag(i),test_density_grad_flag(i)
!    enddo
!endif

vmax=0
do n=1,nlev
  if(pres(n)==fv .or. tem(n)==fv .or. sal(n)==fv) then
    density_grad_flag(n)=0
  endif
  if(density_grad_flag(n)>vmax) vmax=density_grad_flag(n)
enddo
if((nlev==1 .and. density_grad_flag(nlev)==0) .or. vmax==0)  &
    then
  write(LOG,*)'DENSITY GR.TEST S    can not be applied.(nlev=1&)'
  write(TRC,*)'DENSITY GR.TEST S    can not be applied.(nlev=1&)'
  if(DEBUG) write(DBG,*) 'DENSITY GR.TEST S    can not be applied.(nlev=1&) at 3'
  write(msg,'(a)')'DENSITY GR.TEST  S    can not be applied.(nlev=1&)'; call LogTRC(PRG,msg)
  if(nlev==1 .and. density_grad_flag(nlev)==0) then
     write(DBG,*)'DENSITY GR.TEST  S    can not be applied.(nlev=1&) CASE ONE'; call LogTRC(PRG,msg)
  else
     write(DBG,*)'DENSITY GR.TEST  S    can not be applied.(nlev=1&) CASE TWO'; call LogTRC(PRG,msg)
  endif
  dens_flag='N'
  iover_dens=0
  go to 74
endif
do n=1,nlev
  if(icksm_flag(n)==0 .and. tem(n)==0. .and. &
    pres(n)==0. .and. sal(n)==0.) then
    density_grad_flag(n)=0
  endif
  if((pres(n)==fv .and. tem(n)==fv .and. sal(n)==fv) .or. &
    sal(n)==fv) then
    density_grad_flag(n)=0
  endif
enddo
do n=1,nlev
  if(density_grad_flag(n).eq.4) then
    write(LOG,*) 'DENSITY GR.TEST      failed.'
    write(TRC,*)'DENSITY GR.TEST      failed.'
    write(msg,'(a)')'DENSITY GR.TEST      failed.'; call LogTRC(PRG,msg)
    dens_flag='F'
    iover_dens=4
    go to 74
  else if(density_grad_flag(n).eq.1) then
    dens_flag='P'
    iover_dens=1
  endif
enddo
write(LOG,*) 'DENSITY GR.TEST      passed.'
write(TRC,*)'DENSITY GR.TEST      passed.'
write(msg,'(a)')'DENSITY GR.TEST      passed.'; call LogTRC(PRG,msg)
 74   continue
if(DEBUG) write(DBG,*)'<<< End DENSITY CHECK >>>'
!
!* 5) Test 9: Spike check test.
!
if(DEBUG) write(DBG,*)'<<< Begin SPIKE CHECK >>>'
if(nlev.eq.0) then
  write(LOG,*) 'SPIKE CHECK TEST S   can not be applied.'
  write(TRC,*)'SPIKE CHECK TEST S   can not be applied.'
  spik_flag='N'
  iover_spik=0
  go to 75
endif
call spike_check(sal,tem,pres,nlev,icksm_flag,is_spik)

if(nlev.eq.1.and.is_spik(nlev).eq.0) then
  write(LOG,*) 'SPIKE CHECK TEST S   can not be applied.'
  write(TRC,*)'SPIKE CHECK TEST S   can not be applied.'
  spik_flag='N'
  iover_spik=0
  go to 75
endif
do n=1,nlev
  if(icksm_flag(n).eq.0 .and. tem(n).eq.0.  &
    .and. pres(n).eq.0. .and. sal(n).eq.0.) is_spik(n)=0
  if((pres(n).eq.fv.and.tem(n).eq.fv.and.sal(n).eq.fv).or. &
    sal(n).eq.fv) then
    is_spik(n)=0
  endif
  if(is_spik(n).gt.smax) smax=is_spik(n)
enddo
if(smax.eq.0) then
  write(LOG,*) 'SPIKE CHECK TEST S   can not be applied.'
  write(TRC,*)'SPIKE CHECK TEST S   can not be applied.'
  spik_flag='N'
  iover_spik=0
  go to 75
endif
do n=1,nlev
  if(is_spik(n).eq.4) then
    write(LOG,*) 'SPIKE CHECK TEST S   failed.'
    write(TRC,*)'SPIKE CHECK TEST S   failed.'
    spik_flag='F'
    iover_spik=4
    go to 75
  else
    spik_flag='P'
    iover_spik=1
  endif
enddo
write(LOG,*) 'SPIKE CHECK S        passed.'
write(TRC,*)'SPIKE CHECK S        passed.'
 75   continue
if(DEBUG) write(DBG,*)'<<< End SPIKE CHECK >>>'
!
!* 6) Speed check test has been called from the "qc_t", don't
!     need to repeat from the "qc_s" unless there isn't any speed flag.
!
if(isped_flag.eq.0.or.isped_flag.eq.1.or.isped_flag.eq.2.or. &
    isped_flag.eq.4) then
  iover_sped=isped_flag
  if(isped_flag.eq.0) sped_flag='N'
  if(isped_flag.eq.1.or.isped_flag.eq.2) sped_flag='P'
  if(isped_flag.eq.4) then
    sped_flag='F'
    status=7   ! 10-25-07
  endif
else
  if(prof_num.gt.1) then
    prof_num_prev=prof_num-1
    if(bounce_ts.eq.'y') prof_num_prev=prof_num-1
    write(profile_id(12:14),'(i3.3)') prof_num_prev
    last = index(pathname_infile, '.')
    phyfile=pathname_infile(1:last-4)//profile_id(12:14)//'.phy'
    write(LOG,*)'phyfile:',phyfile
  endif
   lastnb = lnblnk(pathname_infile)
   write(*, '(A, ": Opening File to QC_S - ", A)')  PRGMAIN, phyfile(1:lastnb)

  inquire(file=phyfile,exist=phy_exist)
  if(phy_exist) then
    open(iunit,status='old',file=phyfile,form='formatted', &
    iostat=ios)
    if(ios.ne.0) then
      status=9
      write(LOG,  &
    '(A, ": Error opening PHY file unit 24. ios= ", i4)')  PRGMAIN, ios
      write(LOG,'("      File =", A)') phyfile
      write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

      write(ERR,*) PRGMAIN,  &
    ': Error opening PHY file unit 24. ios=',ios
      write(ERR,*)'file =', phyfile
      write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
      if(DEBUG)write(LOG,'("call exit at s17")'); call exit (status)!stop '9'
    endif         ! if(ios.ne.0) then

    nlev_p = 0       ! initialize pres/sal pair to be zero.
    icnt_p = 0       ! initialize surface positions to be zero.

    ! Read the phy file for the previous profile
    call rd_phy(iunit,int_num,wmo_num,trans_id, &
    prof_num_p,file_num,inst_type,ireverse,whoi_c_date,juld_qc, &
    wmo_inst,wmo_reco,argos_prg_num,pi, &
    hasTemp_prev,hasPsal_prev,hasCond_prev,hasO2_prev,land_test, &
    surface_pressure, &
    prev_st_trans_time,prev_st_trans_time_qc, &
    prev_ascent_end_time, prev_ascent_end_time_qc, &
    whoi_pos_qc, &
    sigma_clim,sigma_anal,adate, &
    n_drift,drift_t,drift_p,drift_s,drift_o,drift_c, &
    nparam,t_param,t_value, &
    num_col,column,num_cal,calib, &
    ipres_qc,ip_vis_qc,isped_flag_qc,icksm_flag_p, &
    icnt_p,alat_hist_p,alon_hist_p,itime_hist_p,iclass_hist, &
    nlev_p,pres_p,tem_p,sal_p,cond_qc,oxy_qc,ibad_phy,ibad_pos, &
    type_ts32,pres2,temp2,ipres2,itemp2, &
    pres_doxy2, &
    pres_doxy2_qc, &
    psal_adj_exist,sal_adj, &
    pres_adj_exist,pres_adj, &
    spd_table,most_likely_frame_status)

    if(icnt_p.gt.np) then
      status=9
      write(LOG,  &
    '(A, ": Error dimension check icnt_p gt np:")')  PRGMAIN
      write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

      write(ERR,  &
    '(A, ": Error dimension check icnt_p gt np:")')  PRGMAIN
      write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
      write(LOG,'("call exit at s18")'); call exit (status)!stop '9'
    endif         ! if(icnt_p.gt.np) then
    if(nlev_p.gt.lmax) then
      status=9
      write(LOG,  &
    '(A, ": Error dimension check nlev_p gt lmax:")')  PRGMAIN
      write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

      write(ERR,  &
    '(A, ": Error dimension check nlev_p gt lmax:")')  PRGMAIN
      write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
      write(LOG,'("call exit at s19")'); call exit (status)!stop '9'
    endif       ! if(nlev_p.gt.lmax) then
  endif         ! if(phy_exist) then

  if(isped_flag.eq.4) then
    write(LOG,*) 'SPEED CHECK TEST     failed.'
    write(TRC,*)'SPEED CHECK TEST     failed.'
    sped_flag='F'
    iover_sped=4
    status=7   ! 10-25-07
    go to 77
  else if(isped_flag.eq.0) then
    write(LOG,*) 'SPEED CHECK TEST     can not be applied.'
    write(TRC,*)'SPEED CHECK TEST     can not be applied.'
    sped_flag='N'
    iover_sped=0
    go to 77
  else
    sped_flag='P'
    iover_sped=1
    if(isped_flag.eq.2) iover_sped=2
  endif         ! if(isped_flag.eq.4) then

  write(LOG,*) 'SPEED CHECK TEST     passed.'
  write(TRC,*)'SPEED CHECK TEST     passed.'
 77     continue
endif      ! if(isped_flag.eq.0.or.isped_flag.eq.1.....
!
!* 7) ANALYSIS and CLIMATOLOGY TESTS if both fail then make it
!     GOOD profile. (Bob M. latest decision 19-Nov-2001)
!
!* Make all other flags to be zero when check sum flag is zero.
!
if(DEBUG) write(DBG,*)'<<< Begin CLIM & ANAL CHECK >>>'

if(status.ne.7) then
  call anlz_check_s(1,tem,sal,dep,nlev,icksm_flag,amin,amax, &
    status,icomplet,is_anlz,iover_anlz,anlz_flag)

  if(psal_adj_exist)  &
    call anlz_check_s(2,tem,sal_adj,dep,nlev,icksm_flag,aamin,aamax, &
    status,icomplet,is_anlz,iover_anlz,anlz_flag)

  call clim_check_s(1,tem,sal,dep,nlev,icksm_flag,cmin,cmax, &
    status,icomplet,is_clim,iover_clim,clim_flag)

  if(psal_adj_exist)  &
    call clim_check_s(2,tem,sal_adj,dep,nlev,icksm_flag,camin,camax, &
    status,icomplet,is_clim,iover_clim,clim_flag)
endif

if(wmo_reco.eq.62) icomplet=1         ! ORBCOMM floats=complete profile
if(land_test==1 .or. status==8) then
  write(LOG,*) 'CLIM. & ANAL TEST S  can not be applied.'
  write(TRC,*)'CLIM. & ANAL TEST S  can not be applied.'
  clim_flag='N'
  iover_clim=0
  anlz_flag='N'
  iover_anlz=0
  do n=1,nlev
    is_clim(n)=0
    is_anlz(n)=0
  enddo
endif
 
do n=1,nlev
  if(status.ne.7.and.status.ne.8) then
    if(is_clim(n).lt.cmin) cmin=is_clim(n)
    if(is_clim(n).gt.cmax) cmax=is_clim(n)
    if(is_anlz(n).lt.amin) amin=is_anlz(n)
    if(is_anlz(n).gt.amax) amax=is_anlz(n)
  endif             ! if(status.ne.7.and.status.ne.8) then
 enddo
 do n=1,nlev
  if(is_gros(n).lt.gmin) gmin=is_gros(n)
  if(is_gros(n).gt.gmax) gmax=is_gros(n)
  if(is_spik(n).lt.smin) smin=is_spik(n)
  if(is_spik(n).gt.smax) smax=is_spik(n)
  if(density_grad_flag(n)<vmin) then
    vmin=density_grad_flag(n)
  endif
  if(density_grad_flag(n)>vmax) then 
    vmax=density_grad_flag(n)
  endif
  if(psal_adj_exist) then
   if(is_grosa(n).lt.gamin) gamin=is_grosa(n)
   if(is_grosa(n).gt.gamax) gamax=is_grosa(n)
   if(is_regia(n).lt.ramin) ramin=is_regia(n)
   if(is_regia(n).gt.ramax) ramax=is_regia(n)
  endif
enddo
if(DEBUG) write(DBG,*)'<<< End CLIM & ANAL CHECK >>>'
!
!* 8) Test 8: Pressure Increasing test.
!
if(DEBUG) write(DBG,*)'<<< Begin PRES CHECK >>>'
if(nlev.eq.1.and.tem(1).eq.0.0.and.sal(1).eq.0.0.and. &
    pres(1).eq.0.0) then
  write(LOG,*) 'PRES CHECK TEST      can not be determined.'
  write(TRC,*)'PRES CHECK TEST      can not be determined.'
  pres_flag='N'
  iover_pres=0
  go to 88
endif

call pres_check(tem,sal,pres,nlev,icksm_flag,ipres_flag)

do n=1,nlev
  if(ipres_flag(n).lt.pmin) pmin=ipres_flag(n)
  if(ipres_flag(n).gt.pmax) pmax=ipres_flag(n)
enddo

if(nlev.eq.0) then
  write(LOG,*) 'PRES CHECK TEST      can not be determined.'
  write(TRC,*)'PRES CHECK TEST      can not be determined.'
  pres_flag='N'
  iover_pres=0
  go to 88
endif
do n=1,nlev
  if(icksm_flag(n).eq.0 .and. tem(n).eq.0.  &
    .and. pres(n).eq.0. .and. sal(n).eq.0.) then
    ipres_flag(n)=0
  endif
enddo

do n=1,nlev
  if(ipres_flag(n).eq.4) then  
    write(LOG,*) 'PRES CHECK TEST      failed.'
    write(TRC,*)'PRES CHECK TEST      failed.'
    pres_flag='F'
    iover_pres=4
    go to 88
  else
    pres_flag='P'
    iover_pres=1
  endif
enddo
write(LOG,*) 'PRES CHECK TEST      passed.'
write(TRC,*)'PRES CHECK TEST      passed.'
 88   continue

if(DEBUG) write(DBG,*)'<<< End PRES CHECK >>>'

!
!* 9)  Test 16: Sensor Jump test.
!
if(DEBUG) write(DBG,*)'<<< Begin SENSOR JUMP S CHECK >>>'
if(nlev == 0) then
    if(DEBUG) write(DBG,*) 'W nlev=0, do NOT call jump_check_t'
else
    call jump_check_s(sal,pres,nlev,sal_qc,pres_qc,nlev_qc, &
	is_gros,density_grad_flag,is_spik,ipres_flag, &
	iover_s_qc,is_gros_qc,is_dens_qc,is_spik_qc, &
	ipres_qc,is_jump)
endif
do n=1,nlev
  if(is_jump(n).lt.jmin) jmin=is_jump(n)
  if(is_jump(n).gt.jmax) jmax=is_jump(n)
enddo

if(nlev.eq.0.or.jmax.eq.0) then
  write(LOG,*) 'JUMP CHECK TEST S    can not be determined.'
  write(TRC,*)'JUMP CHECK TEST S    can not be determined.'
  jump_flag='N'
  iover_jump=0
  go to 98
endif
do n=1,nlev
  if(is_jump(n).eq.4) then            
    write(LOG,*) 'JUMP CHECK TEST S    failed.'
    write(TRC,*)'JUMP CHECK TEST S    failed.'
    jump_flag='F'
    iover_jump=4
    go to 98
  else
    jump_flag='P'
    iover_jump=1
  endif
enddo
write(LOG,*) 'JUMP CHECK TEST S    passed.'
write(TRC,*)'JUMP CHECK TEST S    passed.'
 98   continue
if(DEBUG) write(DBG,*)'<<< End SENSOR JUMP S CHECK >>>'

!
!---  Test 17: Frozen Profile test.
!
if(DEBUG) write(DBG,*)'<<< Begin FROZEN S CHECK >>>'
if(nlev.eq.0) then
  write(LOG,*) 'FROZEN CHECK TEST S  can not be determined.'
  write(TRC,*)'FROZEN CHECK TEST S  can not be determined.'
  frzn_flag='N'
  iover_frzn=0
  go to 108
endif

call frozen_s(sal,pres,nlev,sal_qc,pres_qc,nlev_qc,ifrzn_flag)
if(ifrzn_flag.eq.4) then            
   write(LOG,*) 'FROZEN CHECK TEST S  failed.'
   write(TRC,*)'FROZEN CHECK TEST S  failed.'
   frzn_flag='F'
   iover_frzn=4
else
  frzn_flag='P'
  iover_frzn=1
  write(LOG,*) 'FROZEN CHECK TEST S  passed.'
  write(TRC,*)'FROZEN CHECK TEST S  passed.'
endif
 108  continue
if(DEBUG) write(DBG,*)'<<< End FROZEN S CHECK >>>'
!
!--- Test 11: Gradient test.
!
if(DEBUG) write(DBG,*)'<<< Begin SALGRAD  CHECK >>>'
if(nlev.eq.0) then
  write(LOG,*) 'SALINITY GRADIENT    can not be determined.'
  write(TRC,*)'SALINITY GRADIENT    can not be determined.'
  salg_flag='N'
  iover_salg=0
  go to 118
endif

call vert_gradient_check_s(sal,pres,nlev,vert_grad_sal_flag)
do n=1,nlev
  if(tem(n)==0. .and. pres(n)==0. .and. sal(n)==0.) then
    vert_grad_sal_flag(n)=0
  endif
  if(pres(n)==PRES_FILLVAL .or. sal(n)==SAL_FILLVAL) then
    vert_grad_sal_flag(n)=0
  endif
  if(vert_grad_sal_flag(n)<kmin) then
    kmin=vert_grad_sal_flag(n)
  endif
  if(vert_grad_sal_flag(n)>kmax) then 
    kmax=vert_grad_sal_flag(n)
  endif
enddo

if(kmax.eq.0) then
  write(LOG,*) 'SALINITY GRADIENT    can not be determined.'
  write(TRC,*)'SALINITY GRADIENT    can not be determined.'
  salg_flag='N'
  iover_salg=0
  go to 118
endif

do n=1,nlev
  if(vert_grad_sal_flag(n)==4) then            
    write(LOG,*) 'SALINITY GRADIENT    failed.'
    write(TRC,*)'SALINITY GRADIENT    failed.'
    salg_flag='F'
    iover_salg=4
    go to 118
  else
    salg_flag='P'
    iover_salg=1
  endif
enddo
write(LOG,*) 'SALINITY GRADIENT    passed.'
write(TRC,*)'SALINITY GRADIENT    passed.'
118   continue
if(DEBUG) write(DBG,*)'<<< End SALGRAD  CHECK >>>'
!
!* What are the overall flag for climatology, analysis, dengrad, checksum,
!* and gross tests?
!
write(LOG,119) 
write(TRC,119)
write(LOG,119)
!
!    Each individual tests are group by following category:
!    1) Profile standard 1 : gross, cnsv, spik, verg, deep, regi, pres incre
!    2) SPED : sped
!    3) grey_list : frzn
!    4) analysis
!    5) climatology
!    6) overall 

if(iregion.ge.1) then
  group1=max(iover_gros,iover_cnsv,iover_spik,iover_spik, &
    iover_dens,iover_deep,iover_regi,iover_pres, &
    iover_salg)
else
  group1=max(iover_gros,iover_cnsv,iover_spik,iover_spik, &
    iover_dens,iover_deep,iover_salg,iover_pres)
  regi_flag='N'
endif

group2=iover_sped
group3=iover_frzn
group4=iover_anlz
group5=iover_clim

pres_in_gl = .false.
temp_in_gl = .false.
psal_in_gl = .false.
pres_gl_flag = 0
temp_gl_flag = 0
psal_gl_flag = 0
max_gl_flag  = 0
if(grey_list(1:1)=='y' .or. grey_list(1:1)=='Y') then
  read(grey_list(3:3),*) num_grey

  aux_profile_date = itime_hist(1)(1:8)
  aux_grey_date_st = grey_date_st(num_grey)(1:4) // &
    grey_date_st(num_grey)(6:7) // &
    grey_date_st(num_grey)(9:10)

  aux_grey_date_en = grey_date_en(num_grey)(1:4) // &
    grey_date_en(num_grey)(6:7) // &
    grey_date_en(num_grey)(9:10)

  if(aux_profile_date>=aux_grey_date_st .and. &
    aux_profile_date<=aux_grey_date_en)  then

    if(grey_parm(num_grey)(1:4)=='PSAL') then
      psal_in_gl = .true.
      read(grey_flag(num_grey),'(i1)') psal_gl_flag
    endif 
    if(grey_parm(num_grey)(6:9)=='PSAL') then 
      psal_in_gl = .true.
      read(grey_flag(num_grey)(3:3),'(i1)') psal_gl_flag
    endif
    if(grey_parm(num_grey)(11:14)=='PSAL') then
      psal_in_gl = .true.
      read(grey_flag(num_grey)(5:5),'(i1)') psal_gl_flag
    endif

    if(psal_in_gl) then
      max_gl_flag = psal_gl_flag
      iover_all = max_gl_flag

      if(nlev==0 .and. icnt==0) then      ! no position/no data
        over_all='N'
        status=5
      else if(nlev==0 .and. icnt==0) then ! yes position/no data
        over_all='F'
        status=3
      else if(nlev<>0 .and. icnt==0) then ! no position/yes data
        over_all='F'
        if(ibad_pos==0) status=8
      endif   
    endif                  
  endif
endif                         

if(psal_in_gl) then
  group3=max(iover_frzn,4) 
endif

write(LOG,*)'group1:',group1,' group2:',group2,' group3:',group3, &
    ' group4:',group4,' group5:',group5

if(group1==1 .and. group2<=1) then
  write(LOG,*) 'QC_TESTS for S passed   -----> GOOD profile.'
  write(TRC,*)'QC_TESTS for S passed   -----> GOOD profile.'
  if(icomplet==1) iover_all=max(1,max_gl_flag)
  if(icomplet==0) iover_all=max(2,max_gl_flag)
  over_all='P'
else if(group1==4 .or. group2==4 .or. group3==4) then
  write(LOG,*) 'QC_TESTS for S failed   -----> BAD profile.'
  write(TRC,*)'QC_TESTS for S failed   -----> BAD profile.'
  iover_all=4
  over_all='F'
else if(group1==0 .and. group2<=1) then
  write(LOG,*) 'QC_TESTS for S can not be applied.'
  write(TRC,*)'QC_TESTS for S can not be applied.'
  iover_all=max(0,max_gl_flag)
  over_all='N'
else if(group1==1 .and. group2<=2) then
  write(LOG,*) 'QC_TESTS for S passed   -----> GOOD profile.'
  write(TRC,*)'QC_TESTS for S passed   -----> GOOD profile.'
  if(icomplet==1) iover_all=max(1,max_gl_flag)
  if(icomplet==0) iover_all=max(2,max_gl_flag)
  over_all='P'
endif               

 78   continue
! See if the dates need to be tested
if(st_trans_time_qc .eq. '0') then
   date_check_result=0
   call cdate_check(st_trans_time,date_check_result)
   if(date_check_result==0) st_trans_time_qc='1'
   if(date_check_result==1) st_trans_time_qc='4'
   if(DEBUG) write(DBG,*)PRGD,'st_trans_time_qc: ',st_trans_time_qc
endif
if(ascent_end_time_qc .eq. '0') then
   date_check_result=0
   call cdate_check(ascent_end_time,date_check_result)
   if(date_check_result==0) ascent_end_time_qc='1'
   if(date_check_result==1) ascent_end_time_qc='4'
   if(DEBUG) write(DBG,*)PRGD,'scent_end_time_qc: ',ascent_end_time_qc
endif
if(DEBUG) write(DBG,*)'<<< Begin flags2qcfile >>>'
call flags2qcfile(2, hasTemp, hasPsal, hasCond, hasO2, &
    phyfile,nlev,iover_all, pres_in_gl,temp_in_gl,psal_in_gl, &
    pres_gl_flag, temp_gl_flag, psal_gl_flag, &
    iover_cnsv,iover_frzn, iregion,ireverse,no_pos,land_test, &
    date_global_test, sd_clim,sd_anal,atime,ana_version, &
    isped_flag,is_anlz,is_clim, &
    gross_pres_flag, gross_temp_flag, is_gros, &
    is_spik, dummy_vector_flag, ipres_flag, &
    deepest_pres_flag, deepest_pres_adj_flag, &
    gross_pres_adj_flag, is_jump,is_regi, &
    density_grad_flag, vert_grad_sal_flag, is_anlza, &
    is_clima,is_grosa,is_regia, &
    type_ts32,ipres2_flag,ideep2_flag,itemp2_flag, &
    gross_pres2_flag, it_gros2, &
    st_trans_time, st_trans_time_qc, &
    ascent_end_time, ascent_end_time_qc, &
    it_spik2,bad_row,surface_pressure)
    if(DEBUG) write(DBG,*)'<<< End flags2qcfile >>>'

!* END of QC LOOP
!
!* Fill out Pass/Fail TABLE.
!
write(LOG, '("Pass/Fail Table follows:")')
lastnb=lnblnk(profile_id)
write(LOG, 113) profile_id(1:lastnb),group1,group2,group3,group4, &
    group5,over_all
write(TRC, 113) profile_id(1:lastnb),group1,group2,group3,group4, &
    group5,over_all

if(lastnb.eq.14) then
    ! OLDMSG write(TAB,115) profile_id(1:lastnb),cnsv_flag,deep_flag, &
    ! OLDMSG gros_flag,jump_flag,pres_flag,spik_flag, &
    ! OLDMSG salg_flag,regi_flag,dens_flag,   & ! group1
    ! OLDMSG spd_table,                       & ! group2
    ! OLDMSG frzn_flag,                       & ! group3
    ! OLDMSG anlz_flag,clim_flag,             & ! group4/5
    ! OLDMSG over_all
    write(msg,115) profile_id(1:lastnb),cnsv_flag,deep_flag, &
    gros_flag,jump_flag,pres_flag,spik_flag, &
    salg_flag,regi_flag,dens_flag,   & ! group1
    spd_table,                       & ! group2
    frzn_flag,                       & ! group3
    anlz_flag,clim_flag,             & ! group4/5
    over_all
    call LogTAB(PRG,msg)
else
    ! OLDMSG write(TAB,117) profile_id(1:lastnb),cnsv_flag,deep_flag, &
    ! OLDMSG gros_flag,jump_flag,pres_flag,spik_flag, &
    ! OLDMSG salg_flag,regi_flag,dens_flag,   & ! group1
    ! OLDMSG spd_table,                       & ! group2
    ! OLDMSG frzn_flag,                       & ! group3
    ! OLDMSG anlz_flag,clim_flag,             & ! group4/5
    ! OLDMSG over_all
    write(msg,117) profile_id(1:lastnb),cnsv_flag,deep_flag, &
    gros_flag,jump_flag,pres_flag,spik_flag, &
    salg_flag,regi_flag,dens_flag,   & ! group1
    spd_table,                       & ! group2
    frzn_flag,                       & ! group3
    anlz_flag,clim_flag,             & ! group4/5
    over_all
    call LogTAB(PRG,msg)
endif

if(DEBUG) write(DBG,*)'<<< End QC_S >>>'
if(DEBUG) close(66)               ! close debug file
close(48)                             ! close trace_qc file
close(49)                             ! close table_qc file
close(50)                             ! close error_qc  file
!
!* Create 'QC' files except status=8 or 9.
!
if(status.eq.11) then                 ! Bad phy file case.
  write(LOG,  &
    '(A, ": Error phy file bad case:")')  PRGMAIN
  write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

  write(ERR,  '(A, ": Error phy file incomplete case:")')  PRGMAIN
  write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
  write(LOG,'("call exit at s20")'); call exit (status)!stop '11'
endif

if(status.ne.5) then
  if(date_global_test==4) status=6
  if(location_check_result==1) status=6
  if(iover_sped.eq.4) status=7              ! 10-25-07
  if(iover_sped.ne.4.and.status.ne.7.and.status.ne.8.and. &
    ibad_pos.eq.1) status=6
endif

if(status.eq.3) then                      ! '000' profile with no data
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at s21")'); call exit(status)!stop '3'
else if(status.eq.5) then                 ! '000' profile with data
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at s22")'); call exit(status)!stop '5'
else if(status.eq.6) then                 ! impossible date/location
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at s23")'); call exit(status)!stop '6'
else if(status.eq.7) then                 ! LAND or SPEED failure
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at s24")'); call exit(status)!stop '7'
else if(status.eq.8) then                 ! No position case
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at s25")'); call exit(status)!stop '8'
else
  if(prof_num==0) then
    ! Ramos 13-Oct-09
    ! Add most likely frame status test
    if(most_likely_frame_status==1) then
      status=2
      if(DEBUG) write(DBG,*)PRGD,'set status=2 at 1'
    else
      status=1
    endif
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at s26")'); call exit(status)!stop '1'
  else if(iover_all.eq.1) then
    if(nlev.eq.1) then
      status=0
      write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
      write(LOG,'("call exit at s27")'); call exit(status)!stop '0'
    else
      ! Ramos 13-Oct-09
      ! Add most likely frame status test
      if(most_likely_frame_status==1) then
        status=2
        if(DEBUG) write(DBG,*)PRGD,'set status=2 at 2'
      else
        status=1
      endif
      write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
      write(LOG,'("call exit at s28")'); call exit(status)!stop '1'
    endif
  else if(iover_all.eq.2) then
    status=2
    if(DEBUG) write(DBG,*)PRGD,'set status=2 at 3'
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at s29")'); call exit(status)!stop '2'
  else if(iover_all.eq.3.or.iover_all.eq.4) then
    ! Ramos 13-Oct-09
    ! Add most likely frame status test
    if(most_likely_frame_status==1) then
      status=2
      if(DEBUG) write(DBG,*)PRGD,'set status=2 at 4'
    else
      status=4
    endif
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at s30")'); call exit(status)!stop '4'
  else if(iover_all.eq.0) then
    status=2
    if(DEBUG) write(DBG,*)PRGD,'set status=2 at 5'
    if(nlev.eq.0) status=3
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at s31")'); call exit(status)!stop '2'
  else
    status=9
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at s32")'); call exit(status)!stop 'abnormal exit'
  endif                       ! if(iover_anlz.eq.1) then
endif                         ! if(status.eq.7) then

 83   format(300i2)
 85   format(300f6.2)
 113  format(1x,a,' profile standard:',i1,' speed:',i1, &
    ' grey_list/frozen:',i1,' anlz:',i1,' clim:',i1, &
    ' overall:',a1)
  114  format(a,2x,'S',3x,8(a1,1x),6x,a1,5x,a1,5x,2(a1,1x),4x,a1)
  115  format(a,2x,'S',3x,9(a1,1x),6x,a1,5x,a1,5x,2(a1,1x),4x,a1)
  116  format(a,1x,'S',3x,8(a1,1x),6x,a1,5x,a1,5x,2(a1,1x),4x,a1)
  117  format(a,1x,'S',3x,9(a1,1x),6x,a1,5x,a1,5x,2(a1,1x),4x,a1)
  119  format(59('+'))

call DATE_AND_TIME(big_ben(1),big_ben(2),big_ben(3),end_datetime)
write(LOG, '(A, ": vmh end_datetime: ", 8I6)') PRGMAIN,end_datetime 

end
!******  END of MAIN PROGRAM   ******
!****************************************************************************
!* To linearly interpolate a monthly climatology to a given time.

subroutine tintp(iyr,imo,ida,hr,m1,m2,w1,w2)

use communication                       ! module

implicit none

character(len=11), parameter :: SUB = 'qc_s:tintp '

integer ndmo(12),ndmu(12),iyr,imo,ida,i,j,k,m,m1,m2,status
real d0,d1,d2,hr,x1,x2,xx,w1,w2
data ndmo/31,28,31,30,31,30,31,31,30,31,30,31/

do m=1,12
  ndmu(m)=ndmo(m)
enddo
if(mod(iyr,4).eq.0) ndmu(2)=29
m1=imo
d1=real(ndmu(imo))
d2=d1/2.0
d0=real(ida)+hr/24.0
if(d0.gt.d1)d0=d1
if(d0.le.d2)then
  m2=imo-1
  if(m2.lt.1)m2=12
  x1=d2-d0
  x2=d0+real(ndmu(m2))/2.0
else
  m2=imo+1
  if(m2.gt.12)m2=1
  x1=d0-d2
  x2=d1-d0+real(ndmu(m2))/2.0
endif
xx=x1+x2

if(xx.eq.0.0) then
  status=9
  write(LOG,*)SUB,': Error calculating x1/xx and x2/xx: x1=',x1,' x2=',x2,' xx=',xx
  write(ERR,*)SUB,': STOP -> STATUS= ', status
  write(ERR,*)SUB,': Error calculating x1/xx and x2/xx: x1=',x1,' x2=',x2,' xx=',xx
  write(ERR,*)SUB,': STOP -> STATUS= ', status
  write(LOG,'("call exit at s33")'); call exit (status)!stop '9'
endif

w1=x2/xx
w2=x1/xx

return
end
!
!* To spatially interpolate a field of data to a point using
!* optimal interpolation (OI) with normalization of the weights. 
!* The horizontal scales are given in km, the vertical scales in
!* meters.  The vertical scale and data/guess error variance ratio
!* are partially dependant on the climatology vertical gradiend
!* near the point of interest.

subroutine sintp(isel,rlat,rlon,dep1,im,jm,km,cl_an1,sd1, &
    xl,yl,cj,df,i0,j0,cl_an0,sd0)

use communication                       ! module

implicit none

character(len=11), parameter :: SUB = 'qc_s:sintp '

integer im,jm,km,nmx,isel
real sx,sy,sz,sz1,sz2,vr1,vr2
parameter(nmx=400)
parameter(sx=400.0,sy=300.0,sz1=30.0,sz2=100.0,vr1=1.5,vr2=0.5)
real cl_an1(im,jm,km),sd1(im,jm,km),xl(im),yl(jm)
real df(km),cj(jm),da1(nmx),da2(nmx),xav(nmx),xc(nmx)
real yav(nmx),zav(nmx)
integer mask(im,jm),status
double precision a(nmx,nmx),b(nmx)
integer indx(nmx),i,i0,i1,i2,id,j,j0,j1,j2,k,k0,k1,k2,kn,np1
real arg,cl_an0,dck,dd,dep1,dmin,dx,dy,dz,rlat,rlon,sd0,vr,xcj
!
!* Get the climatology point nearest the point of interest and estimate
!* the vertical scale and error from the vertical gradient.
!
k0=0
dmin=1.e9
do k=1,km
  dd=abs(df(k)-dep1)
  if(dd.lt.dmin)then
    dmin=dd
    k0=k
  endif
enddo
if(cl_an1(i0,j0,k0).le.-98.00)then
!      if(mask(i0,j0).ge.k0) then
  sz=sz1
  vr=vr1
else
  if(k0.gt.1)then
   if(df(k0-1).eq.df(k0)) then
     status=9
     write(LOG,*)SUB,': Error calculating df(k0-1)-df(k0) : df(k0-1)=',df(k0-1),' df(k0)=',df(k0)
     write(LOG,*)SUB,': STOP -> STATUS= ', status
     write(ERR,*)SUB,': Error calculating df(k0-1)-df(k0) : df(k0-1)=',df(k0-1),' df(k0)=',df(k0)
     write(ERR,*)SUB,': STOP -> STATUS= ', status
     write(LOG,'("call exit at s34")'); call exit (status)!stop '9'
   endif
   dd=abs((cl_an1(i0,j0,k0-1)-cl_an1(i0,j0,k0))/(df(k0-1)-df(k0)))
  else
    if(df(k0).eq.df(k0+1)) then
     status=9
     write(LOG,*)SUB,': Error calculating df(k0)-df(k0+1) : df(k0)=',df(k0),' df(k0+1)=',df(k0+1)
     write(LOG,*)SUB,': STOP -> STATUS= ', status
     write(ERR,*)SUB,': Error calculating df(k0)-df(k0+1) : df(k0)=',df(k0),' df(k0+1)=',df(k0+1)
     write(ERR,*)SUB,': STOP -> STATUS= ', status
     write(LOG,'("call exit at s35")'); call exit (status)!stop '9'
   endif
  dd=abs((cl_an1(i0,j0,k0)-cl_an1(i0,j0,k0+1))/(df(k0)-df(k0+1)))
  endif
  if(dd.gt.0.1) dd=0.1
  sz=sz2-(sz2-sz1)*dd/0.1
  vr=vr2+(vr1-vr2)*dd/0.1
endif
!* Interpolate to the point using only near-by data.
 i1=i0-1
 if(i1.lt.1) i1=1
 i2=i0+1
 if(i2.gt.im) i2=im
 j1=j0-1
 if(j1.lt.1) j1=1
 j2=j0+1
 if(j2.gt.jm)j2=jm
!       k1=k0-1                 ! bug found 09/29/00
!       if(k1.lt.1) k1=1        ! bug found 09/29/00
!       k2=k0+1                 ! bug found 09/29/00
!       if(k2.gt.km)k2=km       ! bug found 09/29/00
 if(dep1.ge.df(k0)) then
   k1=k0
 else
   k1=k0-1
   if(k1.lt.1) k1=1
 endif
 if(dep1.le.df(k0)) then
   k2=k0
 else
   k2=k0+1
 endif
 if(k2.gt.km)k2=km

 kn=0
 do 1 k=k1,k2
 do 1 j=j1,j2
 do 1 i=i1,i2
   id=i
   if(id.lt.1) id=id+im
   if(id.gt.im)id=id-im
!         if(mask(id,j).ge.k)then
   if(cl_an1(id,j,k).gt.-98.00) then
     kn=kn+1
     if(kn.ge.nmx) then
       status=9
       write(ERR,*)SUB,': Error on kn .ge. nmx case'
       write(ERR,*)SUB,': STOP -> STATUS= ', status
       write(LOG,'("call exit at s36")'); call exit (status)!stop '9'
     endif
     da1(kn)=cl_an1(id,j,k)
     da2(kn)=sd1(id,j,k)
!           da3(kn)=an1(id,j,k)
     xav(kn)=xl(id)
     xc(kn) =cj(j)
     yav(kn)=yl(j)
     zav(kn)=df(k)
   endif
 1     enddo
 if(kn.le.1)then
   if(kn.eq.1)then
    cl_an0=da1(1)
    sd0=da2(1)
!          an0=da3(1)
    return
   else
    cl_an0=-999.9
!          an0=-999.9
    sd0=1.0
    return
   endif
 endif
!* First set up array A.
do k1=1,kn
 a(k1,k1)=1.0+vr
enddo
do 2 k1=2,kn
 do 2 k2=1,k1-1
  xcj=(xc(k1)+xc(k2))/2.0
  dx=abs(xav(k1)-xav(k2))
  if(dx.gt.180.)dx=360.0-dx
  dx=111.19*xcj*dx/sx
  dy=111.19*(yav(k1)-yav(k2))/sy
  dz=(zav(k1)-zav(k2))/sz
  arg=dx*dx+dy*dy+dz*dz
  if(arg.gt.16.0)then
   a(k1,k2)=0.0
  else
   a(k1,k2)=exp(-arg)
  endif
  a(k2,k1)=a(k1,k2)
 2    enddo
!
np1=kn+1
do k=1,np1
 a(np1,k)=1.0
 a(k,np1)=1.0
enddo
a(np1,np1)=0.0
!* Get the vector b.
do k1=1,kn
 dx=abs(xav(k1)-rlon)
 if(dx.gt.180.)dx=360.0-dx
 dx=111.19*xc(k1)*dx/sx
 dy=111.19*(yav(k1)-rlat)/sy
 dz=(zav(k1)-dep1)/sz
 arg=dx*dx+dy*dy+dz*dz
 b(k1)=0.0
 if(arg.le.16.0)b(k1)=exp(-arg)
enddo
b(np1)=1.0
!* Get the LU decomposition of A and solve the linear system Aw=b.
!* The solution w is returned in b.
call ludcmp(a,np1,nmx,indx,dck)
call lubksb(a,np1,nmx,indx,b)
!* Get the OI estimate.
cl_an0=0.0
sd0=0.0
!      an0=0.0
do k1=1,kn
 cl_an0=cl_an0+b(k1)*da1(k1)
 sd0=sd0+b(k1)*da2(k1)
!       an0=an0+b(k1)*da3(k1)
enddo
 112  format(1x,'sintp->end: cl_an0:',f12.4,' sd0:',f12.5)
return
end

!
! Revision Date: 29-Apr-04 (YHD - 'nmax' was 200 now it is set to 400)
!
!* To vertically interpolate to fill a trace using
!* optimal interpolation (OI) with normalization of the weights. 
!* The vertical scale and data/guess error variance ratio
!* are fixed.
subroutine vintp(tem,dep,nl)

use communication                       ! module

implicit none

character(len=11), parameter :: SUB = 'qc_s:vintp '

integer nmx
real sz,vr
parameter(nmx=400,sz=45.0,vr=1.0)
real tem(*),dep(*),da1(nmx),zav(nmx),vw(2*nmx),arg,dck,dz, &
    sum,z0
double precision a(nmx,nmx),b(nmx)
integer indx(nmx),k,k1,k2,kn,n,nl,np1,status

do n=1,nl
 vw(n)=tem(n)
enddo
!* Interpolate to the point.
do 10 n=1,nl
 if(tem(n).gt.-990.) go to 10
 z0=dep(n)
 kn=0
 do k=1,nl
  if(vw(k).gt.-990.)then
   kn=kn+1
   if(kn.ge.nmx) then
     status=9
     write(ERR,*)SUB,': Error on kn .ge. nmx case ',kn,nmx
     write(ERR,*)SUB,': STOP -> STATUS= ', status
     write(LOG,'("call exit at s37")'); call exit (status)!stop '9'
   endif
   da1(kn)=vw(k)
   zav(kn)=dep(k)
  endif
 enddo
 if(kn.le.2) return
!* First set up array A.
 do k1=1,kn
  a(k1,k1)=1.0+vr
 enddo
 do 2 k1=2,kn
  do 2 k2=1,k1-1
   dz=(zav(k1)-zav(k2))/sz
   arg=dz*dz
   if(arg.gt.16.0)then
    a(k1,k2)=0.0
   else
    a(k1,k2)=exp(-arg)
   endif
   a(k2,k1)=a(k1,k2)
 2     enddo
 np1=kn+1
 do k=1,np1
  a(np1,k)=1.0
  a(k,np1)=1.0
 enddo
 a(np1,np1)=0.0
!* Get the vector b.
 do k1=1,kn
  dz=(zav(k1)-z0)/sz
  arg=dz*dz
  b(k1)=0.0
  if(arg.le.16.0)b(k1)=exp(-arg)
 enddo
 b(np1)=1.0
!* Get the LU decomposition of A and solve the linear system Aw=b.
!* The solution w is returned in b.
 call ludcmp(a,np1,nmx,indx,dck)
 call lubksb(a,np1,nmx,indx,b)
!* Get the OI estimate.
 sum=0.0
 do k1=1,kn
  sum=sum+b(k1)*da1(k1)
 enddo
 tem(n)=sum
 10   continue
return
end
!  Revision Date: 29-Apr-04 (YHD - 'nmax' was 200 now it is set to 400)
!* This does an LU decomposition on the matrix A, size nxn.  The
!* output is returned in A.  This is Crout's method with partial
!* pivoting, described in Numerical Recepies, sec 2.3.

subroutine ludcmp(a,n,np,indx,d)

use communication                       ! module

implicit none

integer nmax
real tiny
parameter (nmax=400,tiny=1.0e-20)
integer indx(*),i,imax,j,k,n,np
real vv(nmax),aamax,d,sum,dum
double precision a(np,np)

d=1.
do 12 i=1,n
 aamax=0.
 do 11 j=1,n
  if(abs(a(i,j)).gt.aamax) aamax=abs(a(i,j))
 11    continue
 if(aamax.eq.0.) then
   write(LOG,*)'qc_s,sintp: Error... singular matrix.'
   write(ERR,*)'qc_s,sintp: Error... singular matrix.'
 endif
 vv(i)=1./aamax
 12   continue
do 19 j=1,n
 if(j.gt.1) then
  do 14 i=1,j-1
   sum=a(i,j)
   if(i.gt.1)then
    do 13 k=1,i-1
     sum=sum-a(i,k)*a(k,j)
 13       continue
    a(i,j)=sum
   endif
 14     continue
 endif
 aamax=0.
 do 16 i=j,n
  sum=a(i,j)
  if(j.gt.1)then
   do 15 k=1,j-1
    sum=sum-a(i,k)*a(k,j)
 15      continue
   a(i,j)=sum
  endif
  dum=vv(i)*abs(sum)
  if(dum.ge.aamax) then
   imax=i
   aamax=dum
  endif
 16    continue
 if(j.ne.imax)then
  do 17 k=1,n
   dum=a(imax,k)
   a(imax,k)=a(j,k)
   a(j,k)=dum
 17     continue
  d=-d
  vv(imax)=vv(j)
 endif
 indx(j)=imax
 if(j.ne.n)then
  if(a(j,j).eq.0.)a(j,j)=tiny
   dum=1./a(j,j)
   do 18 i=j+1,n
    a(i,j)=a(i,j)*dum
 18      continue
 endif
 19   continue
if(a(n,n).eq.0.)a(n,n)=tiny
return
end
!
!* This solves the system Ax=b, where here A is the LU decomposition of
!* the matrix A that was passed into ludcmp()

subroutine lubksb(a,n,np,indx,b)

use communication                       ! module
                                                                
implicit none

character(len=12), parameter :: SUB = 'qc_s:lubksb '

integer indx(*),i,ii,j,ll,n,np,status
double precision a(np,np),b(*)
real sum

ii=0
do 12 i=1,n
 ll=indx(i)
 sum=b(ll)
 b(ll)=b(i)
 if(ii.ne.0)then
  do 11 j=ii,i-1
   sum=sum-a(i,j)*b(j)
 11     continue
 else if(sum.ne.0.) then
  ii=i
 endif
 b(i)=sum
 12   continue
do 14 i=n,1,-1
 sum=b(i)
 if(i.lt.n)then
  do 13 j=i+1,n
   sum=sum-a(i,j)*b(j)
 13     continue
 endif
 if(a(i,i).eq.0.0) then
   status=9
   write(LOG,*)SUB,': Error sum/a(i,i) : a(i,i)=',a(i,i)
   write(LOG,*)SUB,': STOP -> STATUS= ', status
   write(ERR,*)SUB,': Error  sum/a(i,i) : a(i,i)=',a(i,i)
   write(ERR,*)SUB,': STOP -> STATUS= ', status
   write(LOG,'("call exit at s38")'); call exit (status)!stop '9'
 endif
 b(i)=sum/a(i,i)
 14   continue
return
end
!
!* To fill the lons, lats, and depths for grid 2.
subroutine fill2(x,im,y,jm,z,km)

implicit none
integer im2,jm2,km2
parameter(im2=360,jm2=200,km2=40)
integer i,j,k,im,jm,km
real x2(im2),y2(jm2),z2(km2),x(*),y(*),z(*)

data x2/  0.50,  1.50,  2.50,  3.50,  4.50,  5.50,  6.50,  7.50, &
    8.50,  9.50, 10.50, 11.50, 12.50, 13.50, 14.50, 15.50, &
    16.50, 17.50, 18.50, 19.50, 20.50, 21.50, 22.50, 23.50, &
    24.50, 25.50, 26.50, 27.50, 28.50, 29.50, 30.50, 31.50, &
    32.50, 33.50, 34.50, 35.50, 36.50, 37.50, 38.50, 39.50, &
    40.50, 41.50, 42.50, 43.50, 44.50, 45.50, 46.50, 47.50, &
    48.50, 49.50, 50.50, 51.50, 52.50, 53.50, 54.50, 55.50, &
    56.50, 57.50, 58.50, 59.50, 60.50, 61.50, 62.50, 63.50, &
    64.50, 65.50, 66.50, 67.50, 68.50, 69.50, 70.50, 71.50, &
    72.50, 73.50, 74.50, 75.50, 76.50, 77.50, 78.50, 79.50, &
    80.50, 81.50, 82.50, 83.50, 84.50, 85.50, 86.50, 87.50, &
    88.50, 89.50, 90.50, 91.50, 92.50, 93.50, 94.50, 95.50, &
    96.50, 97.50, 98.50, 99.50,100.50,101.50,102.50,103.50, &
    104.50,105.50,106.50,107.50,108.50,109.50,110.50,111.50, &
    112.50,113.50,114.50,115.50,116.50,117.50,118.50,119.50, &
    120.50,121.50,122.50,123.50,124.50,125.50,126.50,127.50, &
    128.50,129.50,130.50,131.50,132.50,133.50,134.50,135.50, &
    136.50,137.50,138.50,139.50,140.50,141.50,142.50,143.50, &
    144.50,145.50,146.50,147.50,148.50,149.50,150.50,151.50, &
    152.50,153.50,154.50,155.50,156.50,157.50,158.50,159.50, &
    160.50,161.50,162.50,163.50,164.50,165.50,166.50,167.50, &
    168.50,169.50,170.50,171.50,172.50,173.50,174.50,175.50, &
    176.50,177.50,178.50,179.50,180.50,181.50,182.50,183.50, &
    184.50,185.50,186.50,187.50,188.50,189.50,190.50,191.50, &
    192.50,193.50,194.50,195.50,196.50,197.50,198.50,199.50, &
    200.50,201.50,202.50,203.50,204.50,205.50,206.50,207.50, &
    208.50,209.50,210.50,211.50,212.50,213.50,214.50,215.50, &
    216.50,217.50,218.50,219.50,220.50,221.50,222.50,223.50, &
    224.50,225.50,226.50,227.50,228.50,229.50,230.50,231.50, &
    232.50,233.50,234.50,235.50,236.50,237.50,238.50,239.50, &
    240.50,241.50,242.50,243.50,244.50,245.50,246.50,247.50, &
    248.50,249.50,250.50,251.50,252.50,253.50,254.50,255.50, &
    256.50,257.50,258.50,259.50,260.50,261.50,262.50,263.50, &
    264.50,265.50,266.50,267.50,268.50,269.50,270.50,271.50, &
    272.50,273.50,274.50,275.50,276.50,277.50,278.50,279.50, &
    280.50,281.50,282.50,283.50,284.50,285.50,286.50,287.50, &
    288.50,289.50,290.50,291.50,292.50,293.50,294.50,295.50, &
    296.50,297.50,298.50,299.50,300.50,301.50,302.50,303.50, &
    304.50,305.50,306.50,307.50,308.50,309.50,310.50,311.50, &
    312.50,313.50,314.50,315.50,316.50,317.50,318.50,319.50, &
    320.50,321.50,322.50,323.50,324.50,325.50,326.50,327.50, &
    328.50,329.50,330.50,331.50,332.50,333.50,334.50,335.50, &
    336.50,337.50,338.50,339.50,340.50,341.50,342.50,343.50, &
    344.50,345.50,346.50,347.50,348.50,349.50,350.50,351.50, &
    352.50,353.50,354.50,355.50,356.50,357.50,358.50,359.50/
data y2/-74.50,-73.50,-72.50,-71.50,-70.50,-69.50,-68.50,-67.50, &
    -66.50,-65.50,-64.50,-63.50,-62.50,-61.50,-60.50,-59.50, &
    -58.50,-57.50,-56.50,-55.50,-54.50,-53.50,-52.50,-51.50, &
    -50.50,-49.50,-48.50,-47.50,-46.50,-45.50,-44.50,-43.50, &
    -42.50,-41.50,-40.50,-39.50,-38.50,-37.50,-36.50,-35.50, &
    -34.50,-33.50,-32.50,-31.50,-30.50,-29.50,-28.50,-27.51, &
    -26.53,-25.55,-24.60,-23.66,-22.75,-21.86,-21.00,-20.16, &
    -19.36,-18.59,-17.85,-17.15,-16.49,-15.85,-15.26,-14.69, &
    -14.16,-13.66,-13.19,-12.75,-12.33,-11.93,-11.55,-11.19, &
    -10.84,-10.50,-10.17, -9.83, -9.50, -9.17, -8.83, -8.50, &
    -8.17, -7.83, -7.50, -7.17, -6.83, -6.50, -6.17, -5.83, &
    -5.50, -5.17, -4.83, -4.50, -4.17, -3.83, -3.50, -3.17, &
    -2.83, -2.50, -2.17, -1.83, -1.50, -1.17, -0.83, -0.50, &
    -0.17,  0.17,  0.50,  0.83,  1.17,  1.50,  1.83,  2.17, &
    2.50,  2.83,  3.17,  3.50,  3.83,  4.17,  4.50,  4.83, &
    5.17,  5.50,  5.83,  6.17,  6.50,  6.83,  7.17,  7.50, &
    7.83,  8.17,  8.50,  8.83,  9.17,  9.50,  9.83, 10.17, &
    10.50, 10.84, 11.19, 11.55, 11.93, 12.33, 12.75, 13.19, &
    13.66, 14.16, 14.69, 15.26, 15.85, 16.49, 17.15, 17.85, &
    18.59, 19.36, 20.16, 21.00, 21.86, 22.75, 23.66, 24.60, &
    25.55, 26.53, 27.51, 28.50, 29.50, 30.50, 31.50, 32.50, &
    33.50, 34.50, 35.50, 36.50, 37.50, 38.50, 39.50, 40.50, &
    41.50, 42.50, 43.50, 44.50, 45.50, 46.50, 47.50, 48.50, &
    49.50, 50.50, 51.50, 52.50, 53.50, 54.50, 55.50, 56.50, &
    57.50, 58.50, 59.50, 60.50, 61.50, 62.50, 63.50, 64.50/
data z2/   5.00,  15.00,  25.00,  35.00,  45.00,  55.00,  65.00, &
    75.00,  85.00,  95.00, 105.00, 115.00, 125.00, 135.00, &
    145.00, 155.00, 165.00, 175.00, 185.00, 195.00, 205.00, &
    215.00, 225.00, 238.48, 262.29, 303.03, 366.80, 459.09, &
    584.62, 747.19, 949.59,1193.53,1479.59,1807.19,2174.62, &
    2579.09,3016.80,3483.03,3972.29,4478.48/
do i=1,im
 x(i)=x2(i)
enddo
do j=1,jm
 y(j)=y2(j)
enddo
do k=1,km
 z(k)=z2(k)
enddo
return
end
!
!* To fill the lons, lats, and depths for grid 1 (360x180x33).
!
subroutine fill1(x,im,y,jm,z,km)

implicit none
integer im1,jm1,km1
parameter(im1=360,jm1=180,km1=33)
integer i,j,k,im,jm,km
real z1(km1),x(*),y(*),z(*)

data z1/   0.00,  10.00,  20.00,  30.00,  50.00,  75.00, 100.00, &
    125.00, 150.00, 200.00, 250.00, 300.00, 400.00, 500.00, &
    600.00, 700.00, 800.00, 900.00,1000.00,1100.00,1200.00, &
    1300.00,1400.00,1500.00,1750.00,2000.00,2500.00,3000.00, &
    3500.00,4000.00,4500.00,5000.0,5500.00/

do i=1,im
 x(i)=0.5+(i-1)*1.0
enddo
do j=1,jm
 y(j)=-89.5+(j-1)*1.0
enddo
do k=1,km
 z(k)=z1(k)
enddo
return
end

!
!*   Get the alimatology point nearest the point of interest and estimate
!    the verticle scale and error from the vertical gradient.
!
subroutine find_closest_pos(isel,rlat,rlon,xt,yt,i0,j0)
implicit none
!
!* isel=1 finding a closest location from climatology grids;
!  isel=2 finding a closest location from analysis grids.
!
integer isel,i0,j0,im,jm,im1,jm1,im2,jm2,i,j
parameter (im1=360,jm1=180)
parameter (im2=360,jm2=200)
real rlat,rlon,xt(*),yt(*),xl(im2),yl(jm2)
real dmin,dd 
!
!--- Initialize xl and yl arraies.
!
do i=1,im2
  xl(i)=0.0
enddo
do j=1,jm2
  yl(j)=0.0
enddo

if(isel.eq.1) then
  im=im1
  jm=jm1
  do i=1,im
    xl(i)=xt(i)
  enddo
  do j=1,jm
    yl(j)=yt(j)
  enddo
else
  im=im2
  jm=jm2
  do i=1,im
    xl(i)=xt(i)
  enddo
  do j=1,jm
    yl(j)=yt(j)
  enddo
endif

i0=0
dmin=1.e9
do i=1,im
 dd=abs(xl(i)-rlon)
 if(dd.lt.dmin)then
   dmin=dd
   i0=i
 endif
enddo
j0=0
dmin=1.e9
do j=1,jm
  dd=abs(yl(j)-rlat)
  if(dd.lt.dmin)then
    dmin=dd
    j0=j
  endif
enddo

return
end
