!===================================================================
! Revision date: 24-Dec-13 CS - if statements after vert_gradient_check_t caused
!                               segmentation fault if nlev=0 -> fixed)
!                18-Dec-13 CS,RS - replaced the unofficial with official tests
!                                   based on the vert_gradient_check_s.
!                05-Apr-13 RS   - replace QCFILES_DIR with QCFILES_AOMLID_DIR
!                                 in GETENV('QCFILES_DIR', pathname_qc)
!                                   Fixed problem related to 'i1' or 'i2' being out of range 
!                06-May-13 VMH  - increased max number of position results (nnp) to 3000
!                25-Apr-13 VMH  - Skip call to jump_check if nlev=0
!                02-Apr-13 VMH  - Adapted from the old qc_t.f,f. use communication
!                                 for LUNS, array sizes, parameters, messaging
!                14-Aug-12 VMH  - Read st_trans_time_qc & ascent_end_time_qc
!                                 in rd_phy & rd_qc, do impossible date test;
!                                 move reading most_likely_frame_status from 
!                                 rd_float_meta, mv to rd_phy.
!                16-May-11 (ER  - Variable itype replaced by hasTemp, 
!                                 hasPsal, hasCond, hasO2
!                          (ER  - Changes to deal with new gross pressure
!                                 check
!                               - Fixed bug: when the pressure <= 0, program 
!                                 was assigning 0 to the deepest pressure flag, 
!                                 which it is not necessarily  the case.
!                               - Changes in variable names to make it more
!                                 readable
!                16-Jul-10 (ER  - Changes dealing with surface 
!                                 pressure = null
!                09-Jun-10 (ER  - If float is on land and prof # = 000 
!                                 speed check is deemed failed.
!                16-Mar-10 (ER  - Add treatment of pressure adjustment 
!                05-Nov-09 (ER  - Grey list treatment rewrote 
!                22-Oct-09 (ER  - If date test fails, return status=6
!                20-Oct-09 (ER  - New function open_file to standardize
!                                 the opening of files)
!                20-Oct-09 (ER  - Fixed treatment of Deep Pressure flag
!                13-Oct-09 (ER  - Add Most Likely Frame Variable) 
!                24-Sep-09 (ER  - Following changes related to speed check: 
!                                 * if float was on land no need to run
!                                 * speed check
!                                 * some logic moved to speed_check.f
!                                 * adding comments for readability.
!                                 * changes in layout of statements to make
!                                   them easier to read.)
!                04-Mar-09 (YHD - pres2 and temp2 are introduced)
!                16-Jul-08 (YHD - 'prof_num_prev' in a second call rd_phy_qc
!                                 caused an infinite printing for a bounce
!                                 float. Correction made. )
!                23-Jun-08 (YHD - A 'ibad_pos' was introduced.)
!                19-Feb-08 (YHD - A trap for ill phy files from Breck Owens
!                                 iridium floats case, exit with a status=10)
!                30-Jan-08 (YHD - Breck Owens' float with a wrong number of
!                                 column line case, 2586_08580_###--->
!                                 program stops with a status=9)
!                10-Dec-07 (YHD - No position with data case correction)
!                27-Nov-07 (YHD - speed check failed status=7;
!                                 speed check passed & (0.0,0.0) status=6)
!                26-Nov-07 (YHD - speed flag is 4 when (0.0, 0.0) case.)
!                15-Nov-07 (YHD - 5 frozen test failed consecutively will  
!                                 write in as a grey list in meta file.
!                                 Reversing ZengHong's finding.)
!                09-Nov-07 (YHD - When the frozen test fails, it should marked
!                                 as a bad profile. Thanks to ZengHong Liu).
!                24-Oct-07 (YHD - A new speed check modification)
!                11-Oct-07 (YHD - When a position is (0.0,0.0) make a status=
!                                 7 purposely so it gets examined by operator)
!                17-Sep-p7 (YHD - More correction on spd_table)
!
!--- Exit status=7 (i.e. speed check failure) cases: 17-sep-07
!    1) only 1 position and failed against the previous profile.
!    2) only 2 positions speed within failed and passed against the
!       previous profile.
!    Otherwise put - sign front of the class and use the next good position
!    for all other tests.
!
!                11-Sep-07 (YHD - A speed check failed position gets '-' in
!                                 front of class, climatology/analysis/etopo
!                                 will use a good position.)
!                07-Sep-07 (YHD - spd(np) dimension increased to 2000).
!                11-Jun-07 (YHD - A bug fixed for a bounce float with a 
!                                 missing cycle case i.e. 1595_47649_165.qc)
!                07-May-07 (YHD - For bounce float, jump_check test modified)
!                03-Apr-07 (YHD - Sensor jump check is now activated)
!                02-Apr-07 (YHD - Deepest pressure check in deepest pressure
!                                 *10)
!                29-Mar-07 (YHD - grey_list conrrection; GREY LIST FLAG FOR P
!                                 is now added to qc file.)
!                16-Jan-07 (YHD - When the float is in land, examine all 
!                                 surrounding grids to decide.)
!                27-Jul-06 (YHD - inquire if a file exists or not)
!                18-May-06 (YHD - group1=1&group2=2-->make a good profile).
!                15-Dec-05 (YHD - Now, (lmax=1100)  for iridium float).
!                17-Oct-05 (YHD - "land" problem fixed)
!                27-Jun-05 (YHD - A bounce float with bounce cycle (i.e. odd
!                                 number of cycle exits with a status=10).
!                14-Jun-05 (YHD - A bounce float is introduced.)
!                13-May-05 (YHD - A bug fixed on line 1398. A profile '000'
!                                 with positions but no data line should exit
!                                 with a status equals 3.)
!                05-May-05 (YHD - Exit with status=5 when no position/no
!                                 data case)
!                03-May-05 (YHD - 1) Add 'grey list flag for T/s' line in qc,
!                                 2) Flag it when pres equals 0.0 case, 
!                                 3) exit status=3 when no position & no data)
!                28-Mar-05 (YHD - Inst_type='APEX_T3' added; time_diff can be
!                                 more than 28 days; nx increased to 50)
!                08-Mar-05 (YHD - Write flags in following order for QC:
!                                 c/d/g/j/p/s/v/r/d --- constant,deep,gross,
!                                 jump,pressure increasing,spike,vertical,
!                                 regional,density)
!                17-Dec-04 (YHD - Tests 15,16,17 & 18 added)
!                02-Dec-04 (YHD - one data line with all 0.0 and no position
!                                 case occurred. 0362_02785_064.phy)
!                30-Nov-04 (YHD - s/r 'rd_qc_get_data' introduced)
!                26-May-04 (YHD - Exits with status=9 when no ncep file case)
!                12-May-04 (YHD - 'isped_flag' equals 2 is a still good prof.)
!                29-Apr-04 (YHD - ETOPO is called once from qc_t run and
!                                 not called from qc_s run.  If a profile is
!                                 on land it will get written in qc file.)
!                28-Apr-04 (YHD - pressure has to be increasing order(p2>p1))
!                14-Apr-04 (YHD - Previous profile has no position case added)
!                15-Mar-04 (YHD - For profile '000' case, use Launch time &
!                                 position for speed check.)
!                19-Feb-04 (YHD - 'j_qc' correction)
!                11-Feb-04 (YHD - debug on line 1637 error; subscript number
!                                 2 has value 0 in array 'cl_an1')
!                22-Dec-03 (YHD - pres,tem and sal are initiaized as 0.0)
!                18-Dec-03 (YHD - Do not look for any more qc files after time
!                                 diff is more than 20 days.)
!                03-Nov-03 (YHD - 2 lines of data case; spik can not applied)
!                14-Oct-03 (YHD - status=3 when no data lines with positions)
!                07-Oct-03 (YHD - Now 'iover_pres' also determins the status
!                                 ORBCOMM floats are complete.)
!                02-Oct-03 (YHD - All dimensions check)
!                30-Sep-03 (YHD - array boundary check & null character check)
!                25-Sep-03 (YHD - it_clim,idens_flag,igros_flag... set to 
!                                  max=1000.
!                11-Sep-03 (YHD - '000' profile with data ---> status=5;
!                                 '000' profile with no data ---> status=3
!                03-Sep-03 (YHD - Constant value check=0 (i.e. temp/sal=fill
!                                 value case) & spike check=0 case
!                10-Jul-03 (YHD - In trajectory, 'JULD_QC' gets 8 for interpolated value
!                01-Jul-03 (YHD - "JULD_QC" line added in qc file.)
!                12-Jun-03 (CS  - dep can not be used in vgrad_check_t
!                                 because it does not exist for no position
!                                 cases -> use pres)
!                06-Jun-03 (YHD - prof_num error on profile 001 case)
!                04-Jun-03 (YHD - 1)All salinity is fillvalue, max.cont=0 -->
!                                 ioverall=0 --> exit with 2;
!                                 2) Partial salinity is fillvalue, max.cont=1
!                                 ioverall=1 or 4 depends on other tests -->
!                                 exit with 2.)
!                03-Jun-03 (YHD - WHOI float: pres increasing, t & s -999.0,
!                                 flags should be 0; otherwise t & s are not
!                                 -999.0, apply qc tests.)
!                                 be 0; otherwise perform individual qc tests)
!                22-May-03 (YHD - icnt_qc needs to intialize to 0)
!                19-May-03 (YHD - Check against days(times) for speed not the
!                                 cycle number.)
!                19-May-03 (YHD - When a profile is on land, )
!                                 iover_sped gets 4 and sped_flag gets 'F'.
!                16-May-03 (YHD - Maximum 20 days(i.e. 2 cycles) old float is 
!                                 allowed to use calculate the speed.)
!                16-May-03 (YHD - QCFILES_DIR should not have '/' at the end.)
!                15-May-03 (YHD - Meta file is needed)
!                14-May-03 (YHD - If previous profile has a bad speed flag,
!                                 use a launch position & time to check speed.
!                01-May-03 (YHD - Statement number 114 changed.)
!                30-Apr-03 (YHD - ORBCOMM float descending profile case (i.e.
!                                 profile number gt 1000))
!                29-Apr-03 (YHD - "ANALYSIS VERSION USED" and "CLIMATOLOGY
!                                  VERSION USED" lines are added in qc
!                                  file.)
!                28-Apr-03 (YHD - As of 29-Apr-2003, the Levitus 2001 
!                                 climatology, WOA01 is replaced the Levitus
!                                 WOA98 climatology.)
!                03-Apr-03 (YHD - no_pos=1 when '000' profile with no position
!                02-Apr-03 (YHD - WHOI floats 0242_001 0245_007 cases)
!                11-Feb-03 (YHD - WHOI float with -999.0 data line)
!                29-Jan-03 (YHD - argos_id=trans_id as char*16)
!                28-Jan-03 (YHD - profile_id to handle for "ORBCOMM" float)
!                21-Jan-03 (YHD - treat pres flag as dens flag)
!                31-Oct-02 (YHD - nlev=1 & passed qc exit with status=0)
!                15-Oct-02 (YHD - profile '000' with data; force to exit=5
!                10-Oct-02 (YHD - SOLO TS12 with profile data in '000
!                                 force exit status=0)
!                03-Oct-02 (YHD - pressure flag added)
!                02-Oct-02 (YHD - status=6 and status=7 added)
!                25-Jul-02 (YHD - No data point case again)
!                24-Jul-02 (YHD - QC files created except status=9)
!                12-Jun-02 (YHD - no data point case)
!                07-Jun-02 (YHD - Gradient test=0.0 Do not set overall_flag
!                                 to be 0; let the rest of flags result decide
!                22-Apr-02 (YHD - s/r sintp -99.0 changed to -98.0)
!                19-Apr-02 (CS & YHD - eliminate abs(tem).gt.50 and execution
!                           of vintp)
!                02-Apr-02 (CS - force sd0 and sd to be at least 5.e-3
!                12-Dec-01 (YHD - profile with no data case)
!                26-Nov-01 (YHD - analysis time check from qc_t and qc_s run)
!                20-Nov-01 (YHD - constant value check test added)
!                19-Nov-01 (YHD - non-existance of previous profile case
!                14-Nov-01 (YHD - previous profile with no position case added)
!                11-Oct-01 (YHD - date_check/location_check added)
!                19-Sep-01 (YHD - global variable "TOPO" introduced to
!                           access ETOPO5 (water/land) data)
!                23-Jul-01 (RS - changes ANALYSIS global variable)
!                19-Jul-01 (YHD - argos id back to 5 digits)
!                10-Jul-01 (RS - argos id expansion)
!                25-Jun-01 (YHD - val changed to tem;
!                                 pres2dep added right after rd_palace; 
!                                 icksm_flag checked no more than once
!                19-Jun-01 (YHD - Read 2 "phy" files for speed check)
!                31-May-01 (YHD - Analysis read from NetCDF file)
!                02-Apr-01 (YHD - Median_check added)
!                02-Feb-01 (CS - new t2 )
!                05-Sep-00 (CS - new speed_check)
!                02-Aug-00 (RS - updates for automatization)
!
!   qc_t.f
!   ======
! Differences from the last qc code include:
! (i)  A new parameter ianal must be set to 1 if the previous week's
!      analysis is to be used.
!      Also set the file name and the type of read for
!      the previous weeks analysis (unit 22)
! (ii) The mask must be read in (unit 23).
!
!     7  1         2         3         4         5         6         7 2
!* This does a quality control on tropical Pacific XBT temperature
!* profiles as a test of methods as well as on Atlantic XBT.
!* Each depth for each cast is assigned a flag as follows, for values
!* both inside and outside of the tropical Pacific (OTP):
!     0...the value is accepted       1...the value is rejected
!     2...the value is missing (rej)  9...the location is OTP.
!
! Quality control test and order of execution are:
!    Gross:
!    CheckSum:
!    Speed:
!    Vertical Gradient:
!    Spike:
!    Bottom/Top Spike:
!    Climatology: 
!    Analysis:
!
! Set parameters: 
!    lmax.....maximum number of levels in a cast,
!    stdev_clim......the absolute clim difference level check (s.d.),
!    stdev_anal......the absolute analysis difference level check (s.d.),
!    dfm.....estimate of the number of degrees of freedom/month
!    vgmx....the (-) maximum allowable vertical temperature gradiend
!    vgmi....the maximum allowable size of a vertical temp. inversion
!    ianal...switch for use of the previous weeks analysis (1=use).
!
! Input units:
!    unit 21: WOA98 Climatology and Standard Deviations on grid2.
!    unit 22: NCEP's weekly analysis 
!    unit 23: Mask
!    unit 24: Palace phy file (profile to qc)

!* Output units:
!    unit 52: QC-T file with added meta header and observation flags 
!    unit 48: trace of flag tests (trace_qc.yyyy_mm_dd)
!    unit 49: pass/fail table file (table_qc.yyyy_mm_dd)
!    unit 50: error log file (error_qc.yyyy_mm_dd)
!    unit 66: Debug file
!
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
!    There is no analysis standard deviation available and dummy values
!    are temporary used.  The codes surrounded by &&&&&&& are needed to
!    change later on.
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 
!    program qc_t.f
!    written by Tom Smith/modified by YHD 03-29-2000/10-03-2000
! ===================================================================

use communication                       ! module

implicit none

character(len=6), parameter :: PRGMAIN = 'qc_t: '
character(len=10), parameter :: PRGD = 'qc_t    D '
character(len=4), parameter :: PRG = 'qc_t'

integer, parameter :: nx = 50
integer, parameter :: im1=360,jm1=180,km1=33
integer, parameter :: im2=360,jm2=200,km2=40
integer, parameter :: ianal=1,np=500,nnp=3000 ! nnp - max number of speed check results
real, parameter :: dfm=3.0,vgmx=1.0,vgmi=0.2  ! if you change nnp, change also in speed_check
real :: w1,w2
integer :: i1,j1,i2,j2

!     new var defs from qc_s =========================================
integer, parameter :: jwndo = 5 ! do not know what this is yet
!     old var defs below =============================================

integer :: date_global_test = 0 ! Impossible date test
integer :: date_check_result = 0
integer :: location_check_result = 0
integer ii,j,n,nlev,iunit,int_num,wmo_num,prof_num, &
    file_num,wmo_inst, &
    wmo_reco,icnt, &
    iyr(np),imo(np),ida(np),ihr(np),imin(np),isec(np),  & ! positions
    ios,status, &
    jyr,jmo,jda,k,m1,m2,mr,icomplet,prof_num_prev, &
    num_prof_read,no_pos,land,ireverse,max_cyc_lim
logical :: hasTemp, hasPsal, hasCond, hasO2

integer iunit_meta,iunit_qc,icnt_qc,land_qc,isped_flag_qc, &
    prof_num_qc

!
! Pressure and temperature GROSS vectors and variables
!
integer, dimension(lmax) ::  &
    gross_pres_flag,  gross_temp_flag, gross_sal_flag,  &
    gross_pres2_flag, gross_temp2_flag,  &
    gross_pres_adj_flag
integer ::  &
    min_gross_pres_flag,  max_gross_pres_flag,  &
    min_gross_temp_flag,  max_gross_temp_flag, &
    min_gross_pres2_flag, max_gross_pres2_flag, &
    min_gross_temp2_flag, max_gross_temp2_flag, &
    min_gross_pres_adj_flag,  max_gross_pres_adj_flag
! Global fail/pass variables (integer)
!   {0, 1, 4}=={imposible to apply, Failed, Passed}
integer ::  &
    over_gross_pres_flag_int, over_gross_temp_flag_int, &
    over_gross_pres2_flag_int, over_gross_temp2_flag_int, &
    over_gross_pres_adj_flag_int
! Global fail/pass variables (char)
!   {N, F, P}=={imposible to apply, Failed, Passed}
character(len=1) ::  &
    over_gross_pres_flag_chr, over_gross_temp_flag_chr, &
    over_gross_pres2_flag_chr, over_gross_temp2_flag_chr, &
    over_gross_pres_adj_flag_chr

integer mask(im2,jm2),amin,amax,cmin,cmax, &
    smin,smax,vmin,vmax,pmin,pmax, &
    irej(lmax),  & ! local only
    it_clim(lmax),it_vert(lmax),it_anlz(lmax), &
    icksm_flag(lmax),isped_flag,it_spik(lmax)
integer :: iover_all,iover_cksm,iover_clim,iover_verg, &
    iover_anlz,  &
    iover_sped,iover_spik,iover_cnsv,iover_pres
integer i,lchar_occur,idate(6)
integer depth
integer group1
integer group2 
integer group3
integer group4
integer group5

real    alon_hist(np),alat_hist(np),spd(nnp),              & ! positions
    alon_hist_qc(np),alat_hist_qc(np),                 & ! positions
    hr,an,sd,cl0,sd0,ta,tt,rlat,rlon,alon, &
    alon_prev,alat_prev
real :: std_clim  ! standard deviation factor clima
real :: std_anal  ! standard deviation factor analysis

real clma(im1,jm1,km1),sdma(im1,jm1,km1)
real pres(lmax),tem(lmax),sal(lmax),dep(lmax)
real clmb(im1,jm1,km1),sdmb(im1,jm1,km1)
real cl1(im1,jm1,km1),sd1(im1,jm1,km1)
real an2(im2,jm2,km2),sd2(im2,jm2,km2),an2_s(im2,jm2,km2)
real xt1(im1),yt1(jm1),df1(km1),cj1(jm1)
real xt2(im2),yt2(jm2),df2(km2),cj2(jm2)
real dlay_down_hours

double precision atime,rtime,down_days,up_hours,cycle_days, &
    descent_hours,neutral_depth_days,ascent_hours,surface_hours, &
    laun_pos_lat,laun_pos_lon,juldays1950,time_now,time_before, &
    time_diff

integer rdtbase
external rdtbase

character itime_hist(np)*14,itime*14,cksm_flag*1,clim_flag*1, &
    anlz_flag*1,verg_flag*1,over_all*1, &
    cnsv_flag*1,pres_flag*1

character itime_prev*14,itime_hist_qc(np)*14
character sped_flag*1,spik_flag*1,profile_id*20,cprof_num_prev*3

character cmon(12)*3,dmon(12)*2
character profname*20,d_dir*5,ana_version*50

character pathname_infile*128,pathname_outfile*128, &
    pathname_infile_prev*128,pathname_meta*128, &
    pathname_clima_t*128,clima_t*128, &
    pathname_mask_t*128,pathname_qc*128, &
    stddev_factor_clima*128,stddev_factor_analysis*128, &
    pathname_analysis_t*128,analysis_t*128, &
    pathname_trace*128, pathname_error*128,  &
    pathname_table*128, pathname_debug*128, &
    phyfile*128,qcfile*128
character trans_id_meta*16,inst_ref*64,st_time*64,laun_time*64, &
    float_snum*4,trans_sys*16,pos_sys*8,trans_id*16

integer*4 lnblnk,last,lastnb,lastdir,lenstr,lasb,lase, &
    lastdir_qc,ilen
integer   lyr,lmon,lday,lhour,lmin,lsec

logical   phy_exist, qc_exist, ncep_exist

equivalence (idate(1),lyr),(idate(2),lmon),(idate(3),lday), &
    (idate(4),lhour),(idate(5),lmin),(idate(6),lsec)

!
! For JUMP, FROZEN and DEEPEST Pressure tests.
! Each element of the vectors is a result flag
! of a test of one of the lmax levels
!
integer,dimension(lmax) :: &
    deepest_pres_flag,      & ! Deepest pressure flag 
    deepest_pres_adj_flag,  & ! Deepest pressure adjusted flag 
    pres_incr_flag          ! Pressure increasing flag

integer :: over_deepest_pres_flag,    & ! Overall deepest pres flag
    over_deepest_pres_adj_flag ! Overall deepest pres adj flag
 
integer ifrzn_flag,nlev_qc,iover_jump, &
    iover_frzn,it_frzn,iover_s,is_frzn

integer, dimension(lmax) :: it_jump, it_cntv, it_vis,  ip_vis, &
    is_anlz, is_clim, is_gros, is_spik, is_dens, is_cntv, &
    is_jump, is_vis,  icksm_flag_p, dummy_vector_flag

integer n_drift,nparam
real    drift_p(nx),drift_t(nx),drift_s(nx),drift_o(nx), &
    drift_c(nx)

real    pres_qc(lmax),tem_qc(lmax),sal_qc(lmax),cond_qc(lmax), &
    oxy_qc(lmax),oxy2_qc(lmax), sigma_clim,sigma_anal

real :: surface_pressure
real :: surf_pres_aux

real :: deepest_pres_limit ! to be found in meta file

integer num_col,num_cal
character iclass_hist(lmax)*2

double precision adate
integer it_anlz_qc(lmax),it_clim_qc(lmax), &
    it_gros_qc(lmax),it_spik_qc(lmax),it_vert_qc(lmax), &
    ipres_qc(lmax),it_vis_qc(lmax),ip_vis_qc(lmax), &
    it_cntv_qc(lmax),it_jump_qc(lmax), &
    iover_t,iover_t_qc,it_frzn_qc, &
    is_anlz_qc(lmax),is_clim_qc(lmax), &
    is_gros_qc(lmax),is_spik_qc(lmax),is_dens_qc(lmax), &
    is_cntv_qc(lmax),is_salg_qc(lmax),is_jump_qc(lmax), &
    is_vis_qc(lmax),iover_s_qc,is_frzn_qc,is_cntv_qc(lmax)
    
real cond(lmax), oxy(lmax), oxy2(lmax)
integer dmin,      & ! The min pressure in the profile
    dmax,      & ! The max pressure in the profile
    d_adjmin,  & ! The min pressure adj in the profile
    d_adjmax   ! The max pressure adj in the profile
integer jmin,jmax,dmin,dmax,argos_prg_num
character jump_flag*1,frzn_flag*1,inst_type*16,whoi_c_date*14, &
    pi*64,juld_qc*1, &
    st_trans_time*19,st_trans_time_qc*1, &
    ascent_end_time*19,ascent_end_time_qc*1, &
    prev_st_trans_time*19,prev_st_trans_time_qc*1, &
    prev_ascent_end_time*19,prev_ascent_end_time_qc*1, &
    whoi_pos_qc*1, &
    column(lmax)*256,calib(lmax)*256, &
    t_param(lmax)*32,t_value(lmax)*32,deep_flag*1
integer, parameter :: dummy_flag = 'N' ! dummy density gradient flag
!
!--- For Regional Check
!
integer iover_regi,ireds_region,imeds_region, &
    ireds_t(lmax),ireds_s(lmax), &
    imeds_t(lmax),imeds_s(lmax),it_regi(lmax),is_regi(lmax)
integer rmin,rmax,iregion
character regi_flag*1

character(len=1) :: send_gts  ! Send to GTS

!
! GREY LIST 
!
character(len=3) :: grey_list ! Add to grey list?
integer :: num_grey  ! Number of grey list updates in meta file
character(len=11), dimension(5) :: &
    grey_date_st, & ! First date for which the grey list is operative
    grey_date_en  ! Last date for which the grey list is operative
character(len=15), dimension(5) :: &
    grey_parm     ! Parameters in grey list
character(len=5), dimension(5)  :: &
    grey_flag     ! Flag the parameter should get
character(len=80), dimension(5) :: &
    grey_reason   ! Why the parameter was added to the grey list
character(len=64) :: proj_name
! Used to compare profile date against grey list date range
character(len=8) :: aux_profile_date, aux_grey_date_st, &
    aux_grey_date_en
logical :: pres_in_gl   ! Pressure in the grey list?
logical :: temp_in_gl   ! Temperature in the grey list?
logical :: psal_in_gl   ! Salinity in the grey list?
integer :: pres_gl_flag ! Grey list flag for pressure
integer :: temp_gl_flag ! Grey list flag for temperature
integer :: psal_gl_flag ! Grey list flag for salinity
integer :: max_gl_flag  ! Maximum value of grey list flags

!
! Bounce float related variables
!
character(len=1) :: bounce_t = '2', &
    bounce_ts = 'n'

!
! Salinity adjusted related variables
!
logical :: psal_adj_exist ! Salinity adjusted exist in phy file?
real, dimension(lmax) :: sal_adj   ! values of salinity adjusted
                                   ! taken from phy file
integer sal_adj_dd,sal_adj_mm,sal_adj_yyyy,sal_adj_pnum
real :: sal_offset, sal_std
character(len=256) :: sal_adj_line 
integer iover_grosa,iover_regia,is_regia(lmax), &
    is_anlza(lmax),is_clima(lmax),is_grosa(lmax)

! 
! Pressure Ajusted related variables
logical :: pres_adj_exist ! Pressure adjusted exist in phy file?
real, dimension(lmax) :: pres_adj  ! values of pressure adjusted
                                   ! taken from phy file

integer :: most_likely_frame_status 

!
!--- For speed check flag
!
integer bad_row(100),ivalid_pos,ibad_row_cnt,igood_row_cnt
character spd_table*1,spd_table_qc*1
data      ibad_row_cnt,igood_row_cnt /2*0/
data      spd_table,spd_table_qc /2*'P'/
!
!--- Detect a bad phy file.
!
integer ibad_phy,ibad_phy_qc
data    ibad_phy,ibad_phy_qc/2*0/
!
!--- Bad position  case
!
integer ibad_pos, ibad_pos_qc
data    ibad_pos,ibad_pos_qc/2*0/

! 
! For optode float (APEXIR_TSO3)
real, dimension(lmax) :: pres_doxy2
integer, dimension(lmax) :: pres_doxy2_qc

!
!--- Pressure2(sea surface pressure) and Temperature2.
!
integer, dimension(lmax) :: ipres2, itemp2,  &
    ipres2_qc, itemp2_qc, ipres2_flag, itemp2_flag,  &
    ideep2_flag, it_spik2

integer iover_pres2, iover_temp2, pmin2, pmax2,  &
    iover_deep2, iover_spik2

real, parameter :: PRES_FILLVAL = -999.0
real, parameter :: TEMP_FILLVAL = -9.0
real, parameter :: FILLVAL = -999.0

real pres2(lmax),temp2(lmax),pres2_qc(lmax),temp2_qc(lmax), &
    dmin2,dmax2,smin2,smax2

character spik2_flag*1
character temp2_flag*1,pres2_flag*1,type_ts32*1

data cmon/'jan','feb','mar','apr','may','jun','jul','aug', &
    'sep','oct','nov','dec'/
data dmon/'01','02','03','04','05','06','07','08','09','10', &
    '11','12'/
data iunit,iunit_meta/24,25/
data d_dir/'done/'/
data no_pos,land/2*0/
data max_cyc_lim/2/
data profile_id/'                    '/
data profname/'                    '/

integer beg_datetime(8),tmp_datetime(8),end_datetime(8)
character (len=10) big_ben(3)

write(msg,*)'Entering Program Execution'; msgout=TimeStampMsg(msg)
call LogIt(PRG,msgout)
!
! Initialize flags.
!
anlz_flag='N'
cksm_flag='N'
clim_flag='N'
over_gross_pres_flag_chr='N'
over_gross_pres_adj_flag_chr='N'
over_gross_temp_flag_chr='N'
sped_flag='N'
spik_flag='N'
verg_flag='N'
cnsv_flag='N'
pres_flag='N'
jump_flag='N'
deep_flag='N'
regi_flag='N'
frzn_flag='N'
over_all='N'
amin=1000
cmin=1000
min_gross_pres_flag=1000
min_gross_pres_adj_flag=1000
min_gross_temp_flag=1000
smin=1000
vmin=1000
pmin=1000
jmin=1000
dmin=1000
amax=0
cmax=0
max_gross_pres_flag=0
max_gross_pres_adj_flag=0
max_gross_temp_flag=0
smax=0
vmax=0
pmax=0
jmax=0
dmax=0
iover_anlz=0
iover_clim=0
over_gross_pres_flag_int=0
over_gross_pres_adj_flag_int=0
over_gross_temp_flag_int=0
iover_sped=0
iover_verg=0
isped_flag=0
iover_spik=0
iover_cnsv=0
iover_pres=0
over_deepest_pres_flag=0
over_deepest_pres_adj_flag=0
iover_regi=0
iover_frzn=0
do i = 1, lmax
  irej(i)=0
  it_anlz(i)=0
  icksm_flag(i)=0
  it_clim(i)=0
  gross_pres_flag(i)=0
  gross_pres_adj_flag(i)=0
  gross_temp_flag(i)=0
  gross_sal_flag(i)=0
  it_spik(i)=0
  it_vert(i)=0
  pres_incr_flag(i)=0
  deepest_pres_flag(i)=0
  deepest_pres_adj_flag(i)=0
  it_regi(i)=0
  is_regi(i)=0
  ireds_t(i)=0
  ireds_s(i)=0
  imeds_t(i)=0
  imeds_s(i)=0
  pres(i)=0.0
  dep(i)=0.0
  tem(i)=0.0
  sal(i)=0.0
enddo
do i=1,14
  itime(i:i)=' '
  itime_prev(i:i)=' '
enddo
do j=1,np
  do i=1,14
    itime_hist(j)(i:i)=' '
  enddo
enddo
do i=1,50
  ana_version(i:i)=' '
enddo
do i=1, 128
  pathname_infile(i:i)=' '
  pathname_outfile(i:i)=' '
  pathname_infile_prev(i:i)=' '
  pathname_meta(i:i)=' '
  pathname_clima_t(i:i)=' '
  clima_t(i:i)=' '        
  pathname_mask_t(i:i)=' '
  stddev_factor_clima(i:i)=' '
  stddev_factor_analysis(i:i)=' '
  pathname_analysis_t(i:i)=' '
  analysis_t(i:i)=' '
  pathname_trace(i:i)=' '
  pathname_error(i:i)=' '
  pathname_debug(i:i)=' '
  pathname_table(i:i)=' '
  phyfile(i:i)=' '
  qcfile(i:i)=' '
enddo
do i=1,im1
  do j=1,jm1
    do k=1,km1
      cl1(i,j,k)=0.0
      sd1(i,j,k)=0.0
      clma(i,j,k)=0.0
      sdma(i,j,k)=0.0
      clmb(i,j,k)=0.0
      sdmb(i,j,k)=0.0
    enddo
  enddo
enddo
do i=1,im2
  do j=1,jm2
    do k=1,km2
      an2(i,j,k)=0.0
      sd2(i,j,k)=0.0
      an2_s(i,j,k)=0.0
    enddo
  enddo
enddo
do i=1,np
  spd(i)=0.0
  alon_hist(i)=0.0
  alat_hist(i)=0.0
  alon_hist_qc(i)=0.0
  alat_hist_qc(i)=0.0
  iyr(i)=0
  imo(i)=0
  ida(i)=0
  ihr(i)=0
  imin(i)=0
  isec(i)=0
enddo
do i=1,im1
  xt1(i)=0.0
enddo
do i=1,im2
  xt2(i)=0.0
enddo
do i=1,jm1
  yt1(i)=0.0
  cj1(i)=0.0
enddo
do i=1,jm2
  yt2(i)=0.0
  cj2(i)=0.0
enddo
do i=1,km1
  df1(i)=0.0
enddo
do i=1,km2
  df2(i)=0.0
enddo

!
! Get environmental variables.
!
call GETENV('CLIMATOLOGY_T', pathname_clima_t) 
call GETENV('MASK_T', pathname_mask_t) 
call GETENV('ANALYSIS_FILE', pathname_analysis_t) 
call GETENV('QCFILES_AOMLID_DIR', pathname_qc) 

call GETENV('STDDEV_FACTOR_CLIMA',stddev_factor_clima)
read(stddev_factor_clima,*) std_clim
call GETENV('STDDEV_FACTOR_ANALYSIS',stddev_factor_analysis)
read(stddev_factor_analysis,*) std_anal

call GETENV('results_outfile', pathname_table)
call GETENV('trace_outfile', pathname_trace)
call GETENV('error_outfile', pathname_error)
call GETENV('debug_outfile', pathname_debug)

!
! Get command arguments:
!
call GETARG(1, pathname_infile)  ! PHY input file 
call GETARG(2, pathname_meta)    ! meta file
call GETARG(3, pathname_outfile) ! QC output file

print *, "PATHNAME_INFILE: ", pathname_infile
print *, "PATHNAME_META: ", pathname_meta
print *, "PATHNAME_OUTFILE: ", pathname_outfile

lastdir = lchar_occur(pathname_infile,'/')
lastdir_qc = lnblnk(pathname_qc)
lenstr = len(pathname_infile) 

profname = pathname_infile(lastdir+1:lenstr)
last = index(pathname_infile, '.')
lasb = lchar_occur(profname(1:last-lastdir),'_')
lase = index(profname,'.')
if(lasb.gt.lase) then
  status=9
  write(LOG, '(A,": Profname error - ", A)')  PRGMAIN, profname
  write(ERR, '(A,": Profname error - ", A)')  PRGMAIN, profname
  write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
  write(LOG,'("call exit at t01")'); call exit(status)
endif

profile_id = profname(1:lase-1)

write(LOG, '(A, ": Profile File Name = ", A)')  PRGMAIN, profile_id

read(profile_id(lasb+1:lase-1),*) prof_num

lastnb = lnblnk(pathname_error)
write(LOG,'(A, ": Opening ", A)')PRGMAIN, pathname_error(1:lastnb)
if(open_file(ERR,pathname_error,'ERROR','QC_T',6,0)==9) then
  status = 9
  write(LOG,'("call exit at t02")'); call exit(status)
endif

lastnb = lnblnk(pathname_trace)
write(LOG,'(A,": Opening ", A)')PRGMAIN, pathname_trace(1:lastnb)
if(open_file(48,pathname_trace,'trace','QC_T',6,50)==9) then
  status = 9
  write(LOG,'("call exit at t03")'); call exit(status)
endif

lastnb = lnblnk(pathname_table)
write(LOG,'(A,": Opening ", A)')PRGMAIN, pathname_table(1:lastnb)
if(open_file(49,pathname_table,'table','QC_T',6,50)==9) then
  status = 9
  write(LOG,'("call exit at t04")'); call exit(status)
endif

lastnb = lnblnk(pathname_debug)
write(LOG,'(A, "Opening ", A)') PRGMAIN, pathname_debug(1:lastnb)
if(open_file(DBG,pathname_debug,'debug','QC_T',6,50)==9) then
  write(LOG, '(A,"Opening debug file error - ", A)') PRGMAIN,pathname_debug
  status = 9
  write(LOG,'("call exit at t05")'); call exit(status)
endif
if(DEBUG) write(msg,*)'DEBUG is ON'; call LogDBG(PRG,msg)
!
! Get the lats, lons, depths for the grid1 and grid2.
!
call fill1(xt1,im1,yt1,jm1,df1,km1)   ! grid 1
call fill2(xt2,im2,yt2,jm2,df2,km2)   ! grid 2
   
do j=1,jm1
  cj1(j)=cos(0.017453293*yt1(j))
enddo
do j=1,jm2
  cj2(j)=cos(0.017453293*yt2(j))
enddo

!* Read in the grid 2 mask.

lastnb = lnblnk(pathname_mask_t)
write(*, '(A, ": Opening MASK_T file - ", A)')  PRGMAIN, pathname_mask_t(1:lastnb)
open(23,status='old',form='unformatted',file=pathname_mask_t,  &
    iostat=ios)
if(ios.ne.0) then
  status=9
  write(LOG, '(A, ":Error opening mask file unit 23. ios= ", A)')  PRGMAIN, ios 
  write(LOG, '(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
  write(ERR,*) PRGMAIN, ': Error opening mask file unit 23. ios=',ios
  write(ERR,*) PRGMAIN, ': STOP -> STATUS=', status 
  write(LOG,'("call exit at t06")'); call exit (status)!stop '9'
endif
read(23) mask
close(23)

write(LOG,'(A, ": MASK_T file read successfully", A)') PRGMAIN

open(iunit_meta,status='old',file=pathname_meta, &
    form='formatted',iostat=ios)
if(ios.ne.0) then
  status=9
  write(LOG,  &
    '(A, ": Error opening META file unit 25. ios= ", i4)')  PRGMAIN, ios
  write(LOG,'("      File =", A)') pathname_meta
  write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
  write(ERR,*) PRGMAIN,  &
    ': Error opening META file unit 25. ios=',ios
  write(ERR,*)'file =', pathname_meta
  write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
  write(LOG,'("call exit at t07")'); call exit (status)!stop '9'
endif
write(LOG,'(A, ": Reading  META file - ", A)') PRGMAIN,  &
    pathname_meta
call rd_float_meta(iunit_meta,int_num,prof_num,wmo_num, &
    trans_id_meta,proj_name, &
    inst_ref,st_time,laun_time,dlay_down_hours,down_days, &
    up_hours, &
    cycle_days,descent_hours,neutral_depth_days,ascent_hours, &
    surface_hours,laun_pos_lat,laun_pos_lon,float_snum, &
    trans_sys,pos_sys,deepest_pres_limit, &
    send_gts,grey_list,grey_date_st,grey_date_en,grey_flag, &
    grey_parm,grey_reason, &
    sal_adj_dd,sal_adj_mm,sal_adj_yyyy,sal_adj_pnum,sal_offset, &
    sal_std,sal_adj_line)

     
!==================================================================
! Beginning of QC loop
!
! Read a previous QC file (prof_num_prev) from /qc directory
! and a requesting profile (prof_num) to check the speed between the 
! trajectories.
!
if(prof_num.gt.1000) then   ! ORBCOMM descending profiles?
  prof_num=prof_num-1000
endif           

! QC Loop.1) Get a previous qc profile
!
if(prof_num>=1) then      
  prof_num_prev=prof_num-1
  write(cprof_num_prev,'(i3.3)') prof_num_prev
  pathname_infile_prev=pathname_qc(1:lastdir_qc)//'/'// &
    pathname_infile(lastdir+1:last-4)// &
    cprof_num_prev//'.qc'
  qcfile=pathname_infile_prev
else
  prof_num_prev=prof_num
  write(cprof_num_prev,'(i3.3)') prof_num_prev
endif

! QC Loop.2) Get a time from the PHY profile
!
phyfile=pathname_infile
inquire(file=phyfile,exist=phy_exist)
if(phy_exist) then    
  open(iunit,status='old',file=phyfile,form='formatted', &
    iostat=ios)
  if(ios.ne.0) then
    status=9
    write(LOG,  &
    '(A, ": Error opening PHY file unit 24. ios= ", i4)')  PRGMAIN, ios
    write(LOG,'("      File =", A)') phyfile
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
    write(ERR,*) PRGMAIN,  &
    ': Error opening PHY file unit 24. ios=',ios
    write(ERR,*)'file =', phyfile
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at t08")'); call exit (status)!stop '9'
  endif

  write(LOG, '(A, ": Opening  PHY file - ", A)') PRGMAIN,phyfile
 
  nlev = 0   ! initialize pressure/temp pair to be zero.
  icnt = 0   ! initialize surface positions to be zero.
  write(LOG, '(A, ": Reading  PHY file - ", A)') PRGMAIN,phyfile
    
  ! Read the phy file for the current profile
  call rd_phy(iunit,int_num,wmo_num,trans_id,prof_num, &
    file_num,inst_type, &
    ireverse,whoi_c_date,juld_qc, &
    wmo_inst,wmo_reco,argos_prg_num,pi, &
    hasTemp, hasPsal, hasCond, hasO2, land, &
    surface_pressure, &
    st_trans_time, st_trans_time_qc, &
    ascent_end_time, ascent_end_time_qc, &
    whoi_pos_qc, &
    sigma_clim,sigma_anal,adate, &
    n_drift,drift_t,drift_p,drift_s,drift_o,drift_c, &
    nparam,t_param,t_value, &
    num_col,column,num_cal,calib, &
    pres_incr_flag,ip_vis,isped_flag,icksm_flag, &
    icnt,alat_hist,alon_hist,itime_hist,iclass_hist, &
    nlev,pres,tem,sal,cond,oxy,oxy2,ibad_phy,ibad_pos, &
    type_ts32,pres2,temp2,ipres2,itemp2, &
    pres_doxy2, &
    pres_doxy2_qc, &
    psal_adj_exist,sal_adj, &
    pres_adj_exist,pres_adj, &
    spd_table,most_likely_frame_status)
   
  if(nlev<0) nlev=0

  !
  ! Bad phy file case
  !  
  if(nlev<=0 .and. icnt==0 .and. ibad_phy==1) then
    status=11
    over_all='F'
    go to 78
  endif

  if(inst_type=='APEX_TSB1') then
    if(prof_num==7 .and. mod(file_num,2)==0) then 
      bounce_t='y'
      prof_num=file_num
    endif
    if(prof_num<>7 .and. mod(file_num,2)==1) then
      bounce_ts='y'
      prof_num=file_num
    endif
  endif

  if(bounce_t=='y') then
    write(LOG,*)'float with 7 bounce_t ? ',bounce_t
  endif

  if(icnt>np) then
    status=9
    write(LOG, '(A, ": Error dimension check icnt > np:")') PRGMAIN
    write(LOG, '(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
    write(ERR, '(A, ": Error dimension check icnt > np:")') PRGMAIN
    write(ERR, '(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
    write(LOG,'("call exit at t09")'); call exit (status)!stop '9'
    endif

	if(nlev>lmax) then
write(LOG,*)
	status=9
	write(LOG,  &
			'(A, ": Error dimension check nlev gt lmax: nlev,lmax",I5, i5)') PRGMAIN,nlev,lmax
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

    write(ERR,  &
    '(A, ": Error dimension check nlev gt lmax: nlev,lmax",I5, i5)') PRGMAIN,nlev,lmax
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at t10")'); call exit (status)!stop '9'
  endif

  rlat = alat_hist(1)
  rlon = alon_hist(1)
  alon = rlon

  read(itime_hist(1)(1:4),'(i4)') lyr
  read(itime_hist(1)(5:6),'(i2)') lmon
  read(itime_hist(1)(7:8),'(i2)') lday
  read(itime_hist(1)(9:10),'(i2)') lhour
  read(itime_hist(1)(11:12),'(i2)') lmin
  read(itime_hist(1)(13:14),'(i2)') lsec

  time_now=juldays1950(idate)                 ! time_now
endif      ! if(phy_exist) then

!
!--- Is there a previous QC profile?
!
 10   continue
if(bounce_ts=='y') then
  prof_num_prev=prof_num_prev-1
  write(cprof_num_prev,'(i3.3)') prof_num_prev
  pathname_infile_prev=pathname_qc(1:lastdir_qc)//'/'// &
    pathname_infile(lastdir+1:last-4)// &
    cprof_num_prev//'.qc'
  qcfile=pathname_infile_prev
endif
inquire(file=qcfile,exist=qc_exist)
if(qc_exist) then
  open(iunit,status='old',file=qcfile,form='formatted', &
    iostat=ios)
  if(ios.ne.0) then
    status=9
    write(LOG,  &
    '(A, ": Error opening Previous QC file unit 24. ios= ", i4)')  PRGMAIN, ios
    write(LOG,'("      File =", A)') qcfile
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
    write(ERR,*) PRGMAIN,  &
    ': Error opening Previous QC file unit 24. ios=',ios
    write(ERR,*)'file =', qcfile
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at t11")'); call exit (status)!stop '9'
  endif
  write(LOG, '(A, ": Reading Previous QC file - ", A)') PRGMAIN,  &
    qcfile



  !
  ! Read QC file.
  !
  icnt_qc=0
  call rd_qc(iunit,int_num,wmo_num,trans_id, &
    prof_num_qc,file_num,inst_type,ireverse,whoi_c_date, &
    juld_qc, &
    wmo_inst,wmo_reco,argos_prg_num,pi, &
    hasTemp, hasPsal, hasCond, hasO2, land_qc, &
    surf_pres_aux, &
    prev_st_trans_time,prev_st_trans_time_qc, &
    prev_ascent_end_time, prev_ascent_end_time_qc, &
    whoi_pos_qc, &
    sigma_clim,sigma_anal,adate, &
    n_drift,drift_t,drift_p,drift_s,drift_o,drift_c, &
    nparam,t_param,t_value, &
    num_col,column,num_cal,calib, &
    iover_t_qc,it_anlz_qc,it_clim_qc,it_gros_qc,it_vert_qc, &
    it_spik_qc,it_vis_qc,it_cntv_qc, &
    it_jump_qc,it_frzn_qc,it_regi, &
    iover_s_qc,is_anlz_qc,is_clim_qc,is_gros_qc,is_dens_qc, &
    is_spik_qc,is_vis_qc,is_cntv_qc, &
    is_salg_qc,is_jump_qc,is_frzn_qc,is_regi, &
    ipres_qc,ip_vis_qc,isped_flag,icksm_flag_p, &
    icnt_qc,alat_hist_qc,alon_hist_qc,itime_hist_qc,iclass_hist, &
    nlev_qc,pres_qc,tem_qc,sal_qc,cond_qc,oxy_qc,oxy2_qc, &
    ibad_phy_qc, ibad_pos_qc, &
    type_ts32,pres2_qc,temp2_qc,ipres2_qc,itemp2_qc, &
    spd_table_qc)
          

  if(icnt_qc.le.0) then             ! previous profile has no position
    time_diff=time_now
  else
    read(itime_hist_qc(1)(1:4),'(i4)') lyr
    read(itime_hist_qc(1)(5:6),'(i2)') lmon
    read(itime_hist_qc(1)(7:8),'(i2)') lday
    read(itime_hist_qc(1)(9:10),'(i2)') lhour
    read(itime_hist_qc(1)(11:12),'(i2)') lmin
    read(itime_hist_qc(1)(13:14),'(i2)') lsec
    time_before=juldays1950(idate)
    time_diff=time_now-time_before
  endif
  write(LOG,*)'qc_t:isped_flag=',isped_flag,' time_diff=',time_diff
  if(isped_flag.ne.4.and.isped_flag.ne.0) then
    if(time_diff.le.20.0.and. &
    alat_hist_qc(1).ge.-90 .and. alat_hist_qc(1).le.90) then
     alon_prev=alon_hist_qc(icnt_qc)
     alat_prev=alat_hist_qc(icnt_qc)
     itime_prev=itime_hist_qc(icnt_qc)
   else
     if(icnt_qc.le.0) then
       alon_prev=999.999           ! time_diff is more than 20 days
       alat_prev=999.999
       itime_prev='99999999999999'
     else
       alon_prev=alon_hist_qc(icnt_qc)
       alat_prev=alat_hist_qc(icnt_qc)
       itime_prev=itime_hist_qc(icnt_qc)
       if(inst_type.eq.'APEX_T3') then
         alon_prev=alon_hist_qc(icnt_qc)
         alat_prev=alat_hist_qc(icnt_qc)
         itime_prev=itime_hist_qc(icnt_qc)
       endif                      ! if(inst_type.eq.'APEX_T3') then
     endif                        ! if(icnt_qc.le.0) then
    endif                         ! if(time_diff.le.20.0.and ...
  else                             ! If speed check not ok then read
     if(time_diff.gt.20.0) then   ! do not read previous qc file if
       alon_prev=999.999           ! time_diff is more than 20 days
       alat_prev=999.999
       itime_prev='99999999999999'
       write(LOG,*)'time_diff is > 20 days and read no more qc file'
       go to 11
     endif
!                                        ! read qc file one before.
     prof_num_prev=prof_num_prev-1 
     if(bounce_ts.eq.'y') prof_num_prev=prof_num_prev-1
     write(cprof_num_prev,'(i3.3)') prof_num_prev
     pathname_infile_prev=pathname_qc(1:lastdir_qc)//'/'// &
    pathname_infile(lastdir+1:last-4)//cprof_num_prev//'.qc'
     qcfile=pathname_infile_prev
     if(prof_num_prev.lt.0) then
!
!--- Need to read META file to get a launch position and time.
!
!             write(LOG,'(A, ": Reading  META file - ", A)') PRGMAIN, 
!     *       pathname_meta
!             call rd_float_meta(iunit_meta,int_num,wmo_num,
!     *       trans_id_meta,
!     *       inst_ref,st_time,laun_time,dlay_down_hours,down_days,
!     *       up_hours,
!     *       cycle_days,descent_hours,neutral_depth_days,ascent_hours,
!     *       surface_hours,laun_pos_lat,laun_pos_lon,float_snum,
!     *       trans_sys,pos_sys,deepest_pres_limit)

       alon_prev=laun_pos_lon      ! read launch time/position
       alat_prev=laun_pos_lat
       itime_prev(1:4)=laun_time(7:10)
       itime_prev(5:6)=laun_time(4:5)
       itime_prev(7:8)=laun_time(1:2)
       itime_prev(9:10)=laun_time(12:13)
       itime_prev(11:12)=laun_time(15:16)
       itime_prev(13:14)='00'
       read(itime_prev(1:4),'(i4)') lyr
       read(itime_prev(5:6),'(i2)') lmon
       read(itime_prev(7:8),'(i2)') lday
       read(itime_prev(9:10),'(i2)') lhour
       read(itime_prev(11:12),'(i2)') lmin
       read(itime_prev(13:14),'(i2)') lsec
       time_before=juldays1950(idate)
       time_diff=time_now-time_before
       if(time_diff.lt.20.0) then
         write(LOG,'(A, ": Launch time lt 20 days - Ok to use for speed check: Time_diff=",f12.5)') PRGMAIN,time_diff
       else
         write(LOG,'(A, ": Launch time gt 20 days - Not Ok to use for speed check: Time_diff=",f12.5)') PRGMAIN, time_diff
        alon_prev=999.999
        alat_prev=999.999
        itime_prev='99999999999999'
       endif
     else
       write(LOG,*)'here qc_file=',qcfile,' bounce_ts=',bounce_ts
       go to 10
     endif
  endif
else
  write(LOG,*)PRGMAIN,': Previous QC file NOT exist. unit 24'
  write(LOG,*)PRGMAIN,': TEST force exit after one failure'
  if(prof_num_prev.ge.1000) then ! TEST 1) then
    lastnb = lnblnk(qcfile)
    write(LOG,'(A,": File =", A," not exist!")') PRGMAIN, &
    qcfile(1:lastnb)
    write(ERR,  &
    '(A, ": Previous QC file NOT exist. unit 24")')  PRGMAIN
    write(ERR,'(A,": File =", A)') PRGMAIN,qcfile
  endif
!
!--- Previous QC time is 20 days old then can't get the speed.
!
  prof_num_prev=prof_num_prev-1 ! qc file one before.
  write(cprof_num_prev,'(i3.3)') prof_num_prev
  pathname_infile_prev=pathname_qc(1:lastdir_qc)//'/'// &
    pathname_infile(lastdir+1:last-4)//cprof_num_prev//'.qc'
  qcfile=pathname_infile_prev

  if(prof_num_prev.lt.0) then
!          write(LOG,'(A, ": Reading  META file - ", A)') PRGMAIN, 
!     *       pathname_meta
!          call rd_float_meta(iunit_meta,int_num,wmo_num,
!     *       trans_id_meta,
!     *       inst_ref,st_time,laun_time,dlay_down_hours,down_days,
!     *       up_hours,
!     *       cycle_days,descent_hours,neutral_depth_days,ascent_hours,
!     *       surface_hours,laun_pos_lat,laun_pos_lon,float_snum,
!     *       trans_sys,pos_sys,deepest_pres_limit)

     alon_prev=laun_pos_lon      ! read launch time/position
     alat_prev=laun_pos_lat
     itime_prev(1:4)=laun_time(7:10)
     itime_prev(5:6)=laun_time(4:5)
     itime_prev(7:8)=laun_time(1:2)
     itime_prev(9:10)=laun_time(12:13)
     itime_prev(11:12)=laun_time(15:16)
     itime_prev(13:14)='00'
     read(itime_prev(1:4),'(i4)') lyr
     read(itime_prev(5:6),'(i2)') lmon
     read(itime_prev(7:8),'(i2)') lday
     read(itime_prev(9:10),'(i2)') lhour
     read(itime_prev(11:12),'(i2)') lmin
     read(itime_prev(13:14),'(i2)') lsec
     time_before=juldays1950(idate)
     time_diff=time_now-time_before
     if(time_diff.lt.20.0) then
       write(LOG,'(A, ": Launch time lt 20 days - Ok to use for speed check: Time_diff=",f12.5)') PRGMAIN,time_diff
     else
       write(LOG,'(A, ": Launch time gt 20 days - Not Ok use for speed check: Time_diff=",f12.5)') PRGMAIN, time_diff
      alon_prev=999.999
      alat_prev=999.999
      itime_prev='99999999999999'
     endif
  else
     go to 10
  endif
endif                             ! if(qc_exist) then

 11   continue


!
! Test 18: Deepest Pressure Test
!
over_deepest_pres_flag=0
do n=1,nlev
  if(pres(n)>(deepest_pres_limit*1.1)) then    ! + 10%
    write(LOG,*) 'deep pres=',(deepest_pres_limit*1.1), &
    ' pres=',pres(n)
    write(ERR,'(A, ": Error DEEPEST PRESSURE case: ")')  PRGMAIN
    write(ERR,*) 'deep pres=',(deepest_pres_limit*1.1), &
    ' pres=',pres(n)
    deepest_pres_flag(n)=4
    over_deepest_pres_flag=4
  else
    if(icksm_flag(n)==0 .and. pres(n)==0. .and. &
    tem(n)==0. .and. sal(n)==0.) then
      deepest_pres_flag(n)=0
    else if(pres(n)==PRES_FILLVAL) then
      deepest_pres_flag(n)=0
    else
      deepest_pres_flag(n)=1
      if(over_deepest_pres_flag==0) then
        over_deepest_pres_flag=1
      endif 
    endif
  endif
  !
  ! Minimum, Maximum
  !
  if(deepest_pres_flag(n)<dmin) dmin=deepest_pres_flag(n)
  if(deepest_pres_flag(n)>dmax) dmax=deepest_pres_flag(n)
enddo

!
! Test 18.a: Deepest Pressure Adjusted Test
!
if(pres_adj_exist) then
  over_deepest_pres_adj_flag=0
  do n=1,nlev
    if(pres_adj(n)>(deepest_pres_limit*1.1)) then    ! + 10%
      write(LOG,*) 'deep pres=',(deepest_pres_limit*1.1), &
    ' pres adj=',pres_adj(n)
      write(ERR,'(A, ": Error DEEPEST PRESSURE case: ")')  PRGMAIN
      write(ERR,*) 'deep pres=',(deepest_pres_limit*1.1), &
    ' pres adj=',pres_adj(n)
      deepest_pres_adj_flag(n)=4
      over_deepest_pres_adj_flag=4
    else
      if(icksm_flag(n)==0 .and. pres(n)==0. .and. &
    tem(n)==0. .and. sal(n)==0.) then
        deepest_pres_adj_flag(n)=0
      else if(pres_adj(n)==PRES_FILLVAL) then
        deepest_pres_adj_flag(n)=0
      else
        deepest_pres_adj_flag(n)=1
        if(over_deepest_pres_flag==0) then
          over_deepest_pres_adj_flag=1
        endif 
      endif
    endif
    !
    ! Minimum, Maximum
    !
    if(deepest_pres_adj_flag(n)<d_adjmin) then
      d_adjmin=deepest_pres_adj_flag(n)
    endif
    if(deepest_pres_adj_flag(n)>d_adjmax) then 
      d_adjmax=deepest_pres_adj_flag(n)
    endif
  enddo
endif

if(icnt==0) then
   if(nlev==0) status=5              ! no position and no data
   if(nlev>=1) status=8              ! no position with data
   no_pos=1                           ! no position indicator
   spd_table='N'
   go to 55                             
endif

rlat = alat_hist(1)
rlon = alon_hist(1)
alon = rlon

do n=1,icnt
  read(itime_hist(n)(1:4),'(i4)') iyr(n)
  read(itime_hist(n)(5:6),'(i2)') imo(n)
  read(itime_hist(n)(7:8),'(i2)') ida(n)
  read(itime_hist(n)(9:10),'(i2)') ihr(n)
  read(itime_hist(n)(11:12),'(i2)') imin(n)
  read(itime_hist(n)(13:14),'(i2)') isec(n)
enddo
jyr = iyr(1)
jmo = imo(1)
jda = ida(1)
hr = float(ihr(1)) + float(imin(1))/60.0
itime = itime_hist(1)

! ==============================================
!  Speed Check Test 
! ==============================================
if(DEBUG) write(DBG,*)'<<< Begin SPEED CHECK >>>'

if( (status.ne.7) .and. (status.ne.8) ) then  
  !! status=7 float is in land 
  !! status=8 there are no pos. in profile 

  call speed_check (profile_id,prof_num,icnt,iyr,imo,ida,ihr,imin, &
    isec,alon_hist,alat_hist,itime_prev,alon_prev, &
    alat_prev,isped_flag,spd,bad_row)

  if(isped_flag.ne.1) then
    ! profile failed speed check
    spd_table='F'
  else
    ! profile passed speed check
    spd_table='T'
    ! find the first position that passed the speed check
    do i=1,np
      if(bad_row(i).ne.4) then
        ivalid_pos=i
        exit
      endif
    enddo
    ! Latitude, longitude & time of the position
    ! that defines the profile
    rlat = alat_hist(ivalid_pos)
    rlon = alon_hist(ivalid_pos)
    alon = rlon
    do n=1,icnt
      read(itime_hist(n)(1:4),'(i4)') iyr(n)
      read(itime_hist(n)(5:6),'(i2)') imo(n)
      read(itime_hist(n)(7:8),'(i2)') ida(n)
      read(itime_hist(n)(9:10),'(i2)') ihr(n)
      read(itime_hist(n)(11:12),'(i2)') imin(n)
      read(itime_hist(n)(13:14),'(i2)') isec(n)
    enddo
    jyr = iyr(ivalid_pos)
    jmo = imo(ivalid_pos)
    jda = ida(ivalid_pos)
    hr = float(ihr(ivalid_pos)) + float(imin(ivalid_pos))/60.0
    itime = itime_hist(ivalid_pos)
  endif

  if(isped_flag.eq.4) then
    write(LOG,*) 'SPEED CHECK TEST     failed.'
    write(TRC,*)'SPEED CHECK TEST     failed.'
    sped_flag='F'
    iover_sped=4
    status=7
  else 
    if(isped_flag.eq.0) then
      write(LOG,*) 'SPEED CHECK TEST     can not be determined.'
      write(TRC,*)'SPEED CHECK TEST     can not be determined.'
      sped_flag='N'
      iover_sped=0
    else
      sped_flag='P'
      iover_sped=1
      if(isped_flag.eq.2) then 
        iover_sped=2
      endif
    endif
  endif
  write(LOG,*) 'SPEED CHECK TEST     finished.'
  write(TRC,*)'SPEED CHECK TEST     finished.'
endif ! if(status.ne.8)


if(DEBUG) write(DBG,*)'<<< End SPEED CHECK >>>'   
!
! --- Status=8 (NO SURFACE POSITION CASE)
!     1) profile num>=1; 2) profile num = 0
!
if(icnt.le.0) then  
  if(nlev.eq.0) then
    status=5                  ! no position & no data
    go to 78
  endif
  if(prof_num.ne.0) then
    status=8                  ! 02-07-2001
    write(LOG,'(A, ": Error NO SURFACE locations case: ")')  PRGMAIN
    write(LOG,'("      PROFILE ID =", A)') profile_id
    write(LOG,'(A, ": CONTINUE -> STATUS = ", I3)') PRGMAIN, status
    write(ERR,'(A, ": Error NO SURFACE locations case: ")')  PRGMAIN
    write(ERR,'("      PROFILE ID =", A)') profile_id
    write(ERR,*)'file =', phyfile
    write(ERR,*) PRGMAIN, ': CONTINUE -> STATUS = ', status
    no_pos=1
    go to 55                   ! perform all qc tests except clim & anal
  else
    status=8                  ! 02-07-2001
    write(LOG,'(A, ": Error NO SURFACE locations case: ")')  PRGMAIN
    write(LOG,'("      PROFILE ID =", A)') profile_id
    write(LOG,'(A, ": CONTINUE -> STATUS = ", I3)') PRGMAIN, status
    write(ERR,'(A, ": Error NO SURFACE locations case: ")')  PRGMAIN
    write(ERR,'("      PROFILE ID =", A)') profile_id
    no_pos=1
    go to 55                   ! perform all qc tests except clim & anal
  endif
endif                         ! if(icnt.le.0) then
!
!--- Test 3: Impossible Location test.
!
call location_check(rlon,rlat,location_check_result)
!
!--- Convert Pressure to depth.
!
do i=1,nlev
  call pres2dep(pres(i),rlat,dep(i))
enddo
!
!--- Data is on Water or Land test. Joaquin Trinanes's ETOPO5 database. 
!--- If ETOPO5 returns as Land point then call land_or_water.

write(LOG,*)' '
call land_or_water(depth,rlat,rlon)

write(LOG,*) 'ETOPO: depth=',depth,' rlat,rlon=',rlat,rlon
if(DEBUG) write(DBG,*)'<<<<< DEBUG from QC_T >>>>>'
if(DEBUG) write(DBG,*)'ETOPO: depth=',depth
if(depth.gt.0) then         ! + depth:land; - depth:water
  status=7
  if(depth.eq.99999) then   ! No TOPO file case
    write(LOG,'(A, ": Error No TOPO file exist: ")')  PRGMAIN
    write(ERR,'(A, ": Error No TOPO file exist: ")')  PRGMAIN
  else
    write(LOG,'(A, ": Error data is on Land case: ")')  PRGMAIN
    write(ERR,'(A, ": Error data is on Land case: ")')  PRGMAIN
    land=1
    iover_sped=4
    sped_flag='F'
  endif
  write(LOG,'("      PROFILE ID =", A)') profile_id
  write(ERR,'("      PROFILE ID =", A)') profile_id
  write(LOG,'(A, ": CONTINUE -> STATUS=", I3)') PRGMAIN, status
  write(ERR,'(A, ": CONTINUE -> STATUS=", I3)') PRGMAIN, status
  write(ERR,*)'file =', phyfile
endif

!
! Test 2: Impossible Date test.
!
date_check_result=0
call date_check(jyr,jmo,jda,ihr(1),imin(1),date_check_result)
if(DEBUG_LEV==4) then
    write(msg,'(132a)')PRGD,'4 Call date_check, icnt: ',icnt,' qc: ',date_global_test, &
         ' ck: ',date_check_result,' (0=g,1=b) at (1) for vals: ',jyr,jmo,jda,ihr(1),imin(1) ! DEBUG date_check
    write(LOG,*)msg; write(DBG,*)msg
endif
if(date_check_result==0) date_global_test=1
if(date_check_result==1) date_global_test=4
! 
!* 0) Profile, '000' case.
!
if(prof_num.eq.0) then
  if( (status.ne.7) .and. (status.ne.8) ) then  
    alon_prev=laun_pos_lon
    alat_prev=laun_pos_lat
    itime_prev(1:4)=laun_time(7:10)
    itime_prev(5:6)=laun_time(4:5)
    itime_prev(7:8)=laun_time(1:2)
    itime_prev(9:10)=laun_time(12:13)
    itime_prev(11:12)=laun_time(15:16)
    itime_prev(13:14)='00'

    call speed_check (profile_id,prof_num,icnt,iyr,imo,ida, &
    ihr,imin,isec,alon_hist,alat_hist,itime_prev, &
    alon_prev,alat_prev,isped_flag,spd,bad_row)

    if(isped_flag.eq.4) then
      write(LOG,*) 'SPEED CHECK TEST     failed.'
      write(TRC,*)'SPEED CHECK TEST     failed.'
      sped_flag='F'
      iover_sped=4
      over_all='F'
      iover_all=4
      status=7      ! 10-25-07
    else if(isped_flag.eq.0) then
      write(LOG,*) 'SPEED CHECK TEST can not be determined.'
      write(TRC,*)'SPEED CHECK TEST can not be determined.'
      sped_flag='N'
      iover_sped=0
      over_all='N'
      iover_all=0
    else 
      sped_flag='P'
      iover_sped=1
      if(isped_flag.eq.2) iover_sped=2
      over_all='P'
      iover_all=1
      write(LOG,*) 'SPEED CHECK TEST    passed.'
      write(TRC,*)'SPEED CHECK TEST    passed.'
    endif

    if(nlev==0) status=5          ! profile 0 with no data line
    if(nlev>=1.and.status<>7) status=1  ! profile 0 with data line
  endif
endif
!
!* When the float is on LAND case, perform all qc tests except clim & anal.
! 
write(LOG,*)'-------->>>>  land=',land
!      if(status.eq.7) go to 55
if(land.eq.1) go to 55
!
!* Read in the monthly temperature climatology and standard deviation.
!
call tintp(jyr,jmo,jda,hr,m1,m2,w1,w2)
 
do k = 1,2                       ! need to read 2 months of climatology
  if(k.eq.1) mr=m1
  if(k.eq.2) mr=m2
  lastnb = lnblnk(pathname_clima_t)
  clima_t(1:lastnb+8)=pathname_clima_t(1:lastnb)//'_'//cmon(mr)// &
    '.dat'
  write(LOG, '(A, ": Opening CLIMATOLOGY_T file  - ", A)') PRGMAIN, clima_t(1:lastnb+8)
  open(21,status='old',form='unformatted',file=clima_t,  &
    iostat=ios)
  if(ios.ne.0) then
    status=9
    write(LOG,  &
    '(A, ": Error opening CLIMATOLOGY_T file unit 21. ios= ", i4)')  PRGMAIN, ios
    write(LOG,'("      File =", A)') clima_t(1:lastnb)
    write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status
    write(ERR,*) PRGMAIN,  &
    ': Error opening CLIMATOLOGY_T file unit 21. ios=',ios
    write(ERR,*) '      File =', clima_t(1:lastnb)
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at t12")'); call exit (status)!stop '9'
  endif
  if(k.eq.1) then
    read(21) clma
    read(21) sdma
  else if(k.eq.2) then
    read(21) clmb
    read(21) sdmb
  endif
  close(21)
enddo                           ! do k = 1, 2

write(LOG,'(A, ": CLIMATOLOGY_T file read successfully", A)')  PRGMAIN

do k=1,km1
  do j=1,jm1
    do i=1,im1
      cl1(i,j,k)=w1*clma(i,j,k)+w2*clmb(i,j,k)
      sd1(i,j,k)=w1*sdma(i,j,k)+w2*sdmb(i,j,k)
    enddo
  enddo
enddo
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 
!
!* Temporary standard deviations for anlysis on grid2 (sd2).
!  
do k=1,km2
  do j=1,jm2
    do i=1,im2
      sd2(i,j,k)=-999.999                ! dummy sd value
    enddo
  enddo
enddo
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 
!
!* Read in the previous week's ocean-temperature analysis from NetCDF file
!  which Dave Behringer will generate and provide us on weekly basis.
!
if(ianal.eq.1) then
!       lastnb = lnblnk(pathname_analysis_t)
!rs     analysis_t=pathname_analysis_t(1:lastnb)//'00'//dmon(jmo)//
!     *'.nc'
!        analysis_t=pathname_analysis_t(1:lastnb)//'.nc'
!rs      analysis_t=pathname_analysis_t(1:lastnb)
  
  inquire(file=pathname_analysis_t,exist=ncep_exist)
  if(ncep_exist) then
    write(*, '(A, ": Opening ANALYSIS_FILE NetCDF file - ", A)') PRGMAIN, pathname_analysis_t 

    call rdocn_anlz(pathname_analysis_t,an2,an2_s,atime, &
    ana_version)
    
    write(LOG,'(A,": ANALYSIS_FILE NetCDF file read successfully",A)') PRGMAIN, pathname_analysis_t
  else                     ! No ncep file case
    status=9
    lastnb = lnblnk(pathname_analysis_t)
    write(LOG, '(A,": Opening Ncep weekly file error - ", A)')  PRGMAIN, pathname_analysis_t
    write(ERR, '(A,": Opening table file error - ",A)')  PRGMAIN, pathname_analysis_t(1:lastnb)
    write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,*) PRGMAIN, ': STOP -> STATUS = ', status
    write(LOG,'("call exit at t13")'); call exit (status)!stop '9'
  endif
endif
!
do n=1,nlev
  irej(n)=0             ! initialize climatology flags to be zero.
enddo
!
!* Check to make sure the lat/lon are within the region.
!
ii=0
if(rlat.lt.yt1(1)) ii=1
if(rlat.gt.yt1(jm1)) ii=1
if(ii.gt.0)then
  do n=1,nlev
    irej(n)=9               ! outside of region
  enddo
endif

!* Check against climatology & the previous week's analysis.

 110  format(1x,a,' lat:',f7.2,' lon:',f8.2,' yr:',i4,' mon:',i2, &
    ' day:',i2)

if(rlon.lt.0.0) alon=rlon+360.0      ! 09-08-2000

call find_closest_pos(1,rlat,alon,xt1,yt1,i1,j1)  ! climatology
call find_closest_pos(2,rlat,alon,xt2,yt2,i2,j2)  ! analysis

do n=1,nlev
  call sintp(1,rlat,alon,dep(n),im1,jm1,km1,cl1,sd1,xt1,yt1, &
    cj1,df1,i1,j1,cl0,sd0)     ! 1--> climatology on grid1
!        write(LOG,*)dep(n),' cl0=',cl0,' sd0=',sd0
  call sintp(2,rlat,alon,dep(n),im2,jm2,km2,an2,sd2,xt2,yt2, &
    cj2,df2,i2,j2,an,sd)       ! 2--> analysis on grid2
!         write(LOG,*)dep(n),' an=',an,' sd=',sd
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
!     Analysis currently has no standard deviation, so we use climatology
!     standard deviation until we get one from Dave Behringer.
!
    sd=sd0
!
!*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
  if(sd0.lt.5e-3) sd0=5.e-3 ! deal with unrealistic standard deviations
  if(sd.lt.5e-3)  sd=5.e-3  ! deal with unrealistic standard deviations

    tt=abs(tem(n)-cl0)/sd0
    ta=0.0
  if(ianal.eq.1) then
      ta=abs(tem(n)-an)/sd
      it_anlz(n)=1
      if(ta.gt.std_anal) then
        it_anlz(n)=4
      endif                        !if(ta.gt.t2) then 
  else
      it_anlz(n)=1               ! when there is no analysis data.
  endif                          ! if(ianal.eq.1) then
  if(tt.gt.std_clim) then
    irej(n)=1
  endif                          ! if(tt.gt.t2) then
enddo                               !  n=1,nlev

 111  format(1x,'clim:',i4,' d:',f7.2,' t:',f6.2,' cl0:',e12.5,' sd0:', &
    f7.3,' tt:',e12.5)
 112  format(1x,'anlz:',i4,' d:',f7.2,' t:',f6.2,' an :',e12.5,' sd0:', &
    f7.3,' ta:',e12.5)
 106  format(1x,'pass:',i4,' d:',f7.2,' t:',f6.2,' an :',e12.5,' cl0:', &
    f7.3,' sd0:',f7.3,' ta:',e12.5,' tt:',f6.2)
!
!* Flag values bracketed by rejected values for temp.
!
do n=2,nlev-1
  if(irej(n).eq.0)then
    if(irej(n-1).eq.1.and.irej(n+1).eq.1) irej(n)=1
  endif
enddo

do n=2,nlev-1
  if(it_anlz(n).eq.4)then
    if(it_anlz(n-1).eq.1.and.it_anlz(n+1).eq.1)  &
    it_anlz(n)=4
  endif
enddo

 55   continue
write(LOG,118)
write(LOG,*)'Profile_id:', profile_id,' lat:',rlat,' lon:',rlon
write(TRC,118)
write(TRC,*)'Profile_id:', profile_id,' lat:',rlat,' lon:',rlon
!
if(DEBUG) write(DBG,*)'<<< Begin DEEP CHECK >>>'
if(nlev.eq.0.or.dmax.eq.0) then
  write(LOG,*) 'DEEP CHECK TEST T    can not be determined.'
  write(TRC,*)'DEEP CHECK TEST T    can not be determined.'
  deep_flag='N'
  over_deepest_pres_flag=0
  go to 8
endif
do n=1,nlev
  if(deepest_pres_flag(n).eq.4) then            
    write(LOG,*) 'DEEP CHECK TEST T    failed.'
    write(TRC,*)'DEEP CHECK TEST T    failed.'
    deep_flag='F'
    over_deepest_pres_flag=4
    go to 8
  else
    deep_flag='P'
    over_deepest_pres_flag=1
  endif
enddo
write(LOG,*) 'DEEP CHECK TEST T    passed.'
write(TRC,*)'DEEP CHECK TEST T    passed.'
 8    continue
if(DEBUG) write(DBG,*)'<<< End DEEP CHECK >>>'


if(DEBUG) write(DBG,*)'<<< Begin DEEP CHECK (ADJ) >>>'
if(nlev==0 .or. d_adjmax==0) then
  !
  ! If profile is empty, check cannot be done
  !
  write(LOG,*) 'DEEP (ADJ) CHECK TEST T can not be determined.'
  write(TRC,*)'DEEP (ADJ) CHECK TEST T can not be determined.'
  deep_flag='N'
  over_deepest_pres_adj_flag=0
else
  !
  ! If one pressure adjusted is "bad" (4), then test fails
  !
  over_deepest_pres_flag=1  ! Innocent until proven guilty
  do n=1,nlev
    if(deepest_pres_flag(n)==4) then            
      over_deepest_pres_adj_flag=4
      exit
    endif
  enddo
  if(over_deepest_pres_adj_flag==4) then 
    deep_flag='F'
    write(LOG,*) 'DEEP CHECK TEST T    failed.'
    write(TRC,*)'DEEP CHECK TEST T    failed.'
  else
    deep_flag='P'
    write(LOG,*) 'DEEP CHECK TEST T    passed.'
    write(TRC,*)'DEEP CHECK TEST T    passed.'
  endif
endif
if(DEBUG) write(DBG,*)'<<< DEEP CHECK >>>'

!
! Test 6: Global range check tests. 
!
if(DEBUG) write(DBG,*)'<<< Begin GROSS CHECKS >>>'
if(nlev==0) then
  !
  ! Profile has no levels
  write(LOG,*) 'GROSS CHECK TEST P   can not be determined.'
  write(LOG,*) 'GROSS CHECK TEST T   can not be determined.'
  write(TRC,*)'GROSS CHECK TEST P   can not be determined.'
  write(TRC,*)'GROSS CHECK TEST T   can not be determined.'
  over_gross_pres_flag_chr='N'
  over_gross_temp_flag_chr='N'
  over_gross_pres_flag_int=0
  over_gross_temp_flag_int=0
  if(pres_adj_exist) then
    write(LOG,*) 'GROSS CHECK TEST P ADJ can not be determined.'
    write(TRC,*)'GROSS CHECK TEST P ADJ can not be determined.'
    over_gross_pres_adj_flag_chr='N'
    over_gross_pres_adj_flag_int=0
  endif
  if(prof_num==0) then
    ! profile has position but no data lines
    status=3  
  endif
else
  !
  ! 6.1 Global range pressure test
  call gross_check_pressure(pres, nlev, gross_pres_flag)
  ! Flag to be set to 0 when the whole row is 0 or fielvalue
  do n=1,nlev
    if(icksm_flag(n)==0 .and. pres(n)==0. .and. &
    tem(n)==0. .and. sal(n)==0.) then
      gross_pres_flag(n)=0
    endif
    if(pres(n)==PRES_FILLVAL) then
      gross_pres_flag(n)=0
    endif
  enddo
  ! Get maximum value of gross_pres_flag array
  ! which will tell us if the profile passed test
  do n=1,nlev
    if(gross_pres_flag(n)>max_gross_pres_flag) then
      max_gross_pres_flag=gross_pres_flag(n)
    endif
  enddo
  if(max_gross_pres_flag==0) then
    write(LOG,*) 'GROSS CHECK TEST P   can not be determined.'
    write(TRC,*)'GROSS CHECK TEST P   can not be determined.'
    over_gross_pres_flag_chr='N'
    over_gross_pres_flag_int=0
  else if(max_gross_pres_flag==1) then
    write(LOG,*) 'GROSS CHECK TEST P   passed.'
    write(TRC,*)'GROSS CHECK TEST P   passed.'
    over_gross_pres_flag_chr='P'
    over_gross_pres_flag_int=1
  else
    write(LOG,*) 'GROSS CHECK TEST P   failed.'
    write(TRC,*)'GROSS CHECK TEST P   failed.'
    over_gross_pres_flag_chr='F'
    over_gross_pres_flag_int=4
  endif
  !
  ! 6.2 Global range temperature test
  call gross_check_temperature(tem,nlev,gross_temp_flag)
  ! Flag to be set to 0 when the whole row is 0 or fielvalue
  do n=1,nlev
    if(icksm_flag(n)==0 .and. tem(n)==0. .and. &
    pres(n)==0. .and. sal(n)==0.) then
      gross_temp_flag(n)=0
    endif
    if((pres(n)==PRES_FILLVAL .and. tem(n)==FILLVAL) .or. &
    tem(n)==FILLVAL) then
      gross_temp_flag(n)=0
    endif
  enddo
  ! Get maximum value of gross_temp_flag array
  ! which will tell us if the profile passed test
  do n=1,nlev
    if(gross_temp_flag(n)>max_gross_temp_flag) then 
      max_gross_temp_flag=gross_temp_flag(n)
    endif
  enddo
  if(max_gross_temp_flag==0) then
    write(LOG,*) 'GROSS CHECK TEST T   can not be determined.'
    write(TRC,*)'GROSS CHECK TEST T   can not be determined.'
    over_gross_temp_flag_chr='N'
    over_gross_temp_flag_int=0
  else if(max_gross_temp_flag==1) then
    write(LOG,*) 'GROSS CHECK TEST T   passed.'
    write(TRC,*)'GROSS CHECK TEST T   passed.'
    over_gross_temp_flag_chr='P'
    over_gross_temp_flag_int=1
  else
    write(LOG,*) 'GROSS CHECK TEST T   failed.'
    write(TRC,*)'GROSS CHECK TEST T   failed.'
    over_gross_temp_flag_chr='F'
    over_gross_temp_flag_int=4
  endif
  !
  ! 6.3 Global range pressure ajusted test
  if(pres_adj_exist) then
    call gross_check_pressure(pres_adj, nlev, gross_pres_adj_flag)
    ! Flag to be set to 0 when the whole row is 0 or fielvalue
    do n=1,nlev
      if(icksm_flag(n)==0 .and. pres(n)==0. .and. &
    tem(n)==0. .and. sal(n)==0.) then
        gross_pres_adj_flag(n)=0
      endif
      if(pres_adj(n)==PRES_FILLVAL) then
        gross_pres_adj_flag(n)=0
      endif
    enddo
    ! Get maximum value of gross_pres_adj_flag array
    ! which will tell us if the profile passed test
    do n=1,nlev
      if(gross_pres_adj_flag(n)>max_gross_pres_adj_flag) then
        max_gross_pres_adj_flag=gross_pres_adj_flag(n)
      endif
    enddo
    if(max_gross_pres_adj_flag==0) then
      write(LOG,*) 'GROSS CHECK TEST P ADJ can not be determined.'
      write(TRC,*)'GROSS CHECK TEST P ADJ can not be determined.'
      over_gross_pres_adj_flag_chr='N'
      over_gross_pres_adj_flag_int=0
    else if(max_gross_pres_adj_flag==1) then
      write(LOG,*) 'GROSS CHECK TEST P ADJ passed.'
      write(TRC,*)'GROSS CHECK TEST P ADJ passed.'
      over_gross_pres_adj_flag_chr='P'
      over_gross_pres_adj_flag_int=1
    else
      write(LOG,*) 'GROSS CHECK TEST P ADJ failed.'
      write(TRC,*)'GROSS CHECK TEST P ADJ failed.'
      over_gross_pres_adj_flag_chr='F'
      over_gross_pres_adj_flag_int=4
    endif
  endif
endif
if(DEBUG) write(DBG,*)'<<< End GROSS CHECK >>>'

!
!  Test 7: Regional Range Test.
!
if(DEBUG) write(DBG,*)'<<< Begin REGION CHECK >>>'

ireds_region=0
imeds_region=0

call redsea_check(rlon,rlat,tem,sal,nlev,ireds_region, &
    ireds_t,ireds_s)

call meditsea_check(rlon,rlat,tem,sal,nlev,imeds_region, &
    imeds_t,imeds_s)

iregion=0

rmax=0
rmin=1000
if(ireds_region.eq.1) then
  iregion=1
  do n=1,nlev
    if(ireds_t(n).eq.4) then 
	    it_regi(n)=4
    else
      it_regi(n)=1
    endif
    if(it_regi(n).gt.rmax) rmax=it_regi(n)
    if(it_regi(n).lt.rmin) rmin=it_regi(n)
  enddo
else if(imeds_region.eq.1) then
  iregion=2
  do n=1,nlev
    if(imeds_t(n).eq.4) then 
	    it_regi(n)=4
    else
      it_regi(n)=1
    endif
    if(it_regi(n).gt.rmax) rmax=it_regi(n)
    if(it_regi(n).lt.rmin) rmin=it_regi(n)
    if(tem(n).eq.0..and. pres(n).eq.0. .and. sal(n).eq.0.) then
    it_regi(n)=0
  endif
  enddo
endif

if(nlev.eq.0.or.rmax.eq.0) then
  write(LOG,*) 'REGIONAL TEST T      can not be determined.'
  write(TRC,*)'REGIONAL TEST T      can not be determined.'
  regi_flag='N'
  iover_regi=0
  go to 62
endif

do n=1,nlev
  if(it_regi(n).eq.4) then
    write(LOG,*) 'REGION CHECK T       failed.'
    write(TRC,*)'REGION CHECK T       failed.'
    iover_regi=4
    regi_flag='F'
    go to 62
  else
    iover_regi=1
    regi_flag='P'
  endif
enddo
write(LOG,*) 'REGION CHECK T       passed.'
write(TRC,*)'REGION CHECK T       passed.'
 62   continue
if(DEBUG) write(DBG,*)'<<< End REGION CHECK >>>'
!
!*  Check Sum flag test.
!
if(DEBUG) write(DBG,*)'<<< Begin CHECK SUM CHECK >>>'
if(nlev.eq.0) then
  write(LOG,*) 'CHECK SUM FLAG       can not be determined.'
  write(TRC,*)'CHECK SUM FLAG       can not be determined.'
  cksm_flag='N'
  iover_cksm=0
  go to 72
endif
do n=1,nlev
  if(icksm_flag(n).eq.0) then
    write(LOG,*) 'CHECK SUM FLAG       can not be determined.'
    write(TRC,*)'CHECK SUM FLAG       can not be determined.'
    cksm_flag='N'
    iover_cksm=0
    go to 72
  else if(icksm_flag(n).eq.4) then  ! 01-26-2001
    write(LOG,*) 'CHECK SUM FLAG       failed.'
    write(TRC,*)'CHECK SUM FLAG       failed.'
    cksm_flag='F'
    iover_cksm=4
    go to 72
  else
    cksm_flag='P'
    iover_cksm=1
  endif
enddo
write(LOG,*) 'CHECK SUM FLAG       passed.'
write(TRC,*)'CHECK SUM FLAG       passed.'
 72   continue
if(DEBUG) write(DBG,*)'<<< End CHECK SUM CHECK >>>'
! 
!* Constant value check test.
!
if(DEBUG) write(DBG,*)'<<< Begin CONSTANT CHECK >>>'
if(nlev.le.1) then 
  write(LOG,*) 'CONSTANT VALUE TEST  can not be determined.'
  write(TRC,*)'CONSTANT VALUE TEST  can not be determined.'
  cnsv_flag='N'
  iover_cnsv=0
  go to 73
endif
call constv_check(nlev,tem,iover_cnsv)
if(iover_cnsv.eq.4) then
  write(LOG,*) 'CONSTANT VALUE TEST  failed.'
  write(TRC,*)'CONSTANT VALUE TEST  failed.'
  cnsv_flag='F'
  go to 73
else if(iover_cnsv.eq.1) then
  cnsv_flag='P'
else if(iover_cnsv.eq.0) then
  write(LOG,*) 'CONSTANT VALUE TEST  can not be determined.'
  write(TRC,*)'CONSTANT VALUE TEST  can not be determined.'
  cnsv_flag='N'
  iover_cnsv=0
  go to 73
else
  status=9
  write(LOG,'(A, ":  CONSTANT VALUE CHECK ERROR:")') PRGMAIN
  write(ERR,'(A, ":  CONSTANT VALUE CHECK ERROR:")') PRGMAIN
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(ERR,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at t14")'); call exit(status)!stop 'abnormal exit'
endif
write(LOG,*) 'CONSTANT VALUE TEST  passed.'
write(TRC,*)'CONSTANT VALUE TEST  passed.'
 73   continue
if(DEBUG) write(DBG,*)'<<< End CONSTANT CHECK >>>'
!
!* Test 11: Gradient check test.
!
if(DEBUG) write(DBG,*)'<<< Begin VERTICAL CHECK >>>'
if(nlev.eq.0) then
  write(LOG,*) 'VERTICAL GR.TEST T   can not be determined.'
  write(TRC,*)'VERTICAL GR.TEST T   can not be determined.'
  verg_flag='N'
  iover_verg=0
  go to 75
endif

if(bounce_t.eq.'y') then
  write(LOG,*) 'VERTICAL GR.TEST T   can not be determined.'
  write(TRC,*)'VERTICAL GR.TEST T   can not be determined.'
  verg_flag='N'
  iover_verg=0
  do n=1,nlev
    it_vert(n)=0
  enddo
  vmin=0
  vmax=0
else
  call vert_gradient_check_t(tem,pres,nlev,it_vert)
  if(nlev.le.2) then
    write(LOG,*) 'VERTICAL GR.TEST T   can not be determined.'
    write(TRC,*)'VERTICAL GR.TEST T   can not be determined.'
    verg_flag='N'
    iover_verg=0
    go to 75
  endif
  vmax=0
  do n=1,nlev
    if(icksm_flag(n).eq.0 .and. tem(n).eq.0.  &
    .and. pres(n).eq.0. .and. sal(n).eq.0.) then
    it_vert(n)=0
    endif
    if(pres(n)==PRES_FILLVAL .or. tem(n)==FILLVAL) then
      it_vert(n)=0
    endif
    if(it_vert(n).gt.vmax) vmax=it_vert(n)
  enddo
  if(vmax.eq.0) then
    write(LOG,*) 'VERTICAL GR.TEST T   can not be determined.'
    write(TRC,*)'VERTICAL GR.TEST T   can not be determined.'
    verg_flag='N'
    iover_verg=0
    go to 75
  endif
  do n=1,nlev
    if(it_vert(n).eq.4) then
      write(LOG,*) 'VERTICAL GR.TEST T   failed.'
      write(TRC,*)'VERTICAL GR.TEST T   failed.'
      verg_flag='F'
      iover_verg=4
      go to 75
    else
      verg_flag='P'
      iover_verg=1
    endif
  enddo
  write(LOG,*) 'VERTICAL GRADIENT T  passed.'
  write(TRC,*)'VERTICAL GRADIENT T  passed.'
endif                 ! if(bounce_t.eq.'y') then
 75   continue
if(DEBUG) write(DBG,*)'<<< End VERTICAL CHECK >>>'

if(type_ts32.eq.'y') then
  if(DEBUG) write(DBG,*)'<<< Begin VERTICAL2 CHECK >>>'
  call vert_gradient_check_t(temp2,pres2,nlev,itemp2_flag)
  if(nlev.le.2) then
    write(LOG,*) 'VERTICAL GR.TEST2 T  can not be determined.'
    write(TRC,*)'VERTICAL GR.TEST2 T  can not be determined.'
    temp2_flag='N'
    iover_temp2=0
    go to 175
  endif
  vmax=0
  do n=1,nlev
    if(icksm_flag(n)==0 .and. temp2(n)==0. .and. &
    pres2(n)==0. .and. sal(n)==0.) then
     itemp2_flag(n)=0
    endif
    if(pres2(n)==PRES_FILLVAL .or. temp2(n)==TEMP_FILLVAL) then
      itemp2_flag(n)=0
    endif
    if(itemp2_flag(n).gt.vmax) vmax=itemp2_flag(n)
  enddo
  if(vmax.eq.0) then
    write(LOG,*) 'VERTICAL GR.TEST2 T  can not be determined.'
    write(TRC,*)'VERTICAL GR.TEST2 T  can not be determined.'
    temp2_flag='N'
    iover_temp2=0
    go to 175
  endif
  do n=1,nlev
    if(itemp2_flag(n).eq.4) then
      write(LOG,*) 'VERTICAL GR.TEST T2  failed.'
      write(TRC,*)'VERTICAL GR.TEST T2  failed.'
      temp2_flag='F'
      iover_temp2=4
      go to 175
    else
      temp2_flag='P'
      iover_temp2=1
    endif
  enddo
  write(LOG,*) 'VERTICAL GRADIENT T2 passed.'
  write(TRC,*)'VERTICAL GRADIENT T2 passed.'
 175    continue
  if(DEBUG) write(DBG,*)'<<< End VERTICAL2 CHECK >>>'

  if(DEBUG) write(DBG,*)'<<< Begin GROSS2 CHECK >>>'
  !
  ! Global range pressure 2 test
  call gross_check_pressure(pres2, nlev, gross_pres2_flag)
  ! Flag to be set to 0 when the whole row is 0 or fielvalue
  do n=1,nlev
    if(icksm_flag(n)==0 .and. pres2(n)==0. .and. &
    temp2(n)==0. .and. sal(n)==0.) then
      gross_pres2_flag(n)=0
    endif
    if(pres2(n)==PRES_FILLVAL) then
      gross_pres2_flag(n)=0
    endif
  enddo
  ! Get maximum value of gross_pres2_flag array
  ! which will tell us if the profile passed test
  do n=1,nlev
    if(gross_pres2_flag(n)>max_gross_pres2_flag) then
      max_gross_pres2_flag=gross_pres2_flag(n)
    endif
  enddo
  if(max_gross_pres2_flag==0) then
    write(LOG,*) 'GROSS CHECK TEST P2   can not be determined.'
    write(TRC,*)'GROSS CHECK TEST P2   can not be determined.'
    over_gross_pres2_flag_chr='N'
    over_gross_pres2_flag_int=0
  else if(max_gross_pres2_flag==1) then
    write(LOG,*) 'GROSS CHECK TEST P2   passed.'
    write(TRC,*)'GROSS CHECK TEST P2   passed.'
    over_gross_pres2_flag_chr='P'
    over_gross_pres2_flag_int=1
  else
    write(LOG,*) 'GROSS CHECK TEST P2   failed.'
    write(TRC,*)'GROSS CHECK TEST P2   failed.'
    over_gross_pres2_flag_chr='F'
    over_gross_pres2_flag_int=4
  endif

  call gross_check_temperature(temp2,nlev,gross_temp2_flag)
  do n=1,nlev
    if(icksm_flag(n).eq.0 .and. temp2(n).eq.0.  &
    .and. pres2(n).eq.0. .and. sal(n).eq.0.) then
      gross_temp2_flag(n)=0
    endif
    if((pres2(n)==PRES_FILLVAL .and. temp2(n)==TEMP_FILLVAL) .or.  &
    temp2(n)==FILLVAL) then
      gross_temp2_flag(n)=0
    endif
  enddo
  do n=1,nlev
    if(gross_temp2_flag(n)>max_gross_temp2_flag) then
      max_gross_temp2_flag=gross_temp2_flag(n)
    endif
  enddo
  if(max_gross_temp2_flag==0) then
    write(LOG,*) 'GROSS CHECK TEST T2   can not be determined.'
    write(TRC,*)'GROSS CHECK TEST T2   can not be determined.'
    over_gross_temp2_flag_chr='N'
    over_gross_temp2_flag_int=0
    go to 171
  endif
  do n=1,nlev
    if(gross_temp2_flag(n).eq.4) then
      write(LOG,*) 'GROSS CHECK TEST T2   failed.'
      write(TRC,*)'GROSS CHECK TEST T2   failed.'
      over_gross_temp2_flag_chr='F'
      over_gross_temp2_flag_int=4
      go to 171
    else
      over_gross_temp2_flag_chr='P'
      over_gross_temp2_flag_int=1
    endif
  enddo
  write(LOG,*) 'GROSS CHECK TEST T2   passed.'
  write(TRC,*)'GROSS CHECK TEST T2   passed.'
 171    continue
  if(DEBUG) write(DBG,*)'<<< End GROSS2 CHECK >>>'

endif ! if(type_ts32.eq.'y') then
!
!* Test 9: Spike check test.
!
if(DEBUG) write(DBG,*)'<<< Begin SPIKE CHECK >>>'
if(nlev.eq.0) then
  write(LOG,*) 'SPIKE CHECK TEST T   can not be determined.'
  write(TRC,*)'SPIKE CHECK TEST T   can not be determined.'
  spik_flag='N'
  iover_spik=0
  go to 76
endif

if(bounce_t.eq.'y') then
  write(LOG,*) 'SPIKE CHECK TEST T   can not be determined.'
  write(TRC,*)'SPIKE CHECK TEST T   can not be determined.'
  spik_flag='N'
  iover_spik=0
  smin=0.0
  smax=0.0
  go to 76
else
  call spike_check(tem,sal,pres,nlev,icksm_flag,it_spik)

  if(nlev.eq.1.and.it_spik(nlev).eq.0) then
    write(LOG,*) 'SPIKE CHECK TEST T   can not be determined.'
    write(TRC,*)'SPIKE CHECK TEST T   can not be determined.'
    spik_flag='N'
    iover_spik=0
    go to 76
  endif

  do n=1,nlev
    if(icksm_flag(n).eq.0 .and. tem(n).eq.0.  &
    .and. pres(n).eq.0. .and. sal(n).eq.0.) then
      it_spik(n)=0
    endif
    if(pres(n)==PRES_FILLVAL .or. tem(n)==FILLVAL) then
      it_spik(n)=0
    endif
    if(it_spik(n).gt.smax) smax=it_spik(n)
  enddo
  if(smax.eq.0) then
    write(LOG,*) 'SPIKE CHECK TEST T   can not be determined.'
    write(TRC,*)'SPIKE CHECK TEST T   can not be determined.'
    spik_flag='N'
    iover_spik=0
    go to 76
  endif
  do n=1,nlev
    if(it_spik(n).eq.4) then
      write(LOG,*) 'SPIKE CHECK TEST T   failed.'
      write(TRC,*)'SPIKE CHECK TEST T   failed.'
      spik_flag='F'
      iover_spik=4
      go to 76
    else
      spik_flag='P'
      iover_spik=1
    endif
  enddo
  write(LOG,*) 'SPIKE CHECK T        passed.'
  write(TRC,*)'SPIKE CHECK T        passed.'
endif
 76   continue
if(DEBUG) write(DBG,*)'<<< End SPIKE CHECK >>>'

if(type_ts32.eq.'y') then
  if(DEBUG) write(DBG,*)'<<< Begin SPIKE2 CHECK >>>'
  if(nlev.eq.0) then
    write(LOG,*) 'SPIKE CHECK TEST T2   can not be determined.'
    write(TRC,*)'SPIKE CHECK TEST T2   can not be determined.'
    spik2_flag='N'
    iover_spik2=0
    go to 176
  endif

  if(bounce_t.eq.'y') then
    write(LOG,*) 'SPIKE CHECK TEST T2   can not be determined.'
    write(TRC,*)'SPIKE CHECK TEST T2   can not be determined.'
    spik2_flag='N'
    iover_spik2=0
    smin2=0.0
    smax2=0.0
    go to 176
  else
    call spike_check(temp2,sal,pres2,nlev,icksm_flag,it_spik2)

    if(nlev.eq.1.and.it_spik2(nlev).eq.0) then
      write(LOG,*) 'SPIKE CHECK TEST T2   can not be determined.'
      write(TRC,*)'SPIKE CHECK TEST T2   can not be determined.'
      spik2_flag='N'
      iover_spik2=0
      go to 176
    endif

    do n=1,nlev
      if(icksm_flag(n).eq.0 .and. temp2(n).eq.0.  &
    .and. pres2(n).eq.0. .and. sal(n).eq.0.) then
      it_spik2(n)=0
      endif
      if(pres2(n)==PRES_FILLVAL .or. temp2(n)==TEMP_FILLVAL) then
        it_spik2(n)=0
      endif
      if(it_spik2(n).gt.smax2) smax2=it_spik2(n)
    enddo
    if(smax2.eq.0) then
      write(LOG,*) 'SPIKE CHECK TEST T2   can not be determined.'
      write(TRC,*)'SPIKE CHECK TEST T2   can not be determined.'
      spik2_flag='N'
      iover_spik2=0
      go to 176
    endif
    do n=1,nlev
      if(it_spik2(n).eq.4) then
        write(LOG,*) 'SPIKE CHECK TEST T2   failed.'
        write(TRC,*)'SPIKE CHECK TEST T2   failed.'
        spik2_flag='F'
        iover_spik2=4
        go to 176
      else
        spik2_flag='P'
        iover_spik2=1
      endif
    enddo
    write(LOG,*) 'SPIKE CHECK T2        passed.'
    write(TRC,*)'SPIKE CHECK T2        passed.'
  endif
 176    continue
  if(DEBUG) write(DBG,*)'<<< End SPIKE2 CHECK >>>'
endif     ! if(type_ts32.eq.'y') then
!
!*  When ANALYSIS and CLIMATOLOGY TESTS both fail,
!      make it GOOD profile. (Bob M. latest decision 19-Nov-2001) 
!
!* Make all other flags to be zero when check sum flag, press, sal and tem 
!  are zeros.
!
if(DEBUG) write(DBG,*)'<<< Begin CLIM & ANAL CHECK >>>'
if(nlev.eq.0) then
  write(LOG,*) 'CLIM. & ANALY TEST T can not be determined.'
  write(TRC,*)'CLIM. & ANALY TEST T can not be determined.'
  clim_flag='N'
  iover_clim=0
  anlz_flag='N'
  iover_anlz=0
  go to 77
endif

icomplet=1                             ! complete profile
do n=1,nlev
  if(irej(n).eq.0) it_clim(n)=1    ! good 
  if(irej(n).ge.1) it_clim(n)=4    ! bad
  if(icksm_flag(n).eq.0 .and. tem(n).eq.0.  &
    .and. pres(n).eq.0. .and. sal(n).eq.0.) then
    gross_temp_flag(n)=0
    it_spik(n)=0
    it_vert(n)=0
    it_clim(n)=0
    it_anlz(n)=0
    icomplet=0                         ! incomplete profile
  endif                          
  if(pres(n)==FILLVAL .or. tem(n)==FILLVAL) then
    it_clim(n)=0
    it_anlz(n)=0
    if(type_ts32.ne.'y') icomplet=0
  endif
enddo
if(wmo_reco.eq.62) icomplet=1         ! ORBCOMM floats=complete profile

!      if(status.eq.7.or.status.eq.8) then
if(land.eq.1.or.status.eq.8) then
  write(LOG,*) 'CLIM. & ANAL TEST T  can not be determined.'
  write(TRC,*)'CLIM. & ANAL TEST T  can not be determined.'
  clim_flag='N'
  iover_clim=0
  anlz_flag='N'
  iover_anlz=0
  do n=1,nlev
    it_clim(n)=0
    it_anlz(n)=0
  enddo
endif

do n=1,nlev
  if(status.ne.7.and.status.ne.8) then
    if(it_clim(n).lt.cmin) cmin=it_clim(n)
    if(it_clim(n).gt.cmax) cmax=it_clim(n)
    if(it_anlz(n).lt.amin) amin=it_anlz(n)
    if(it_anlz(n).gt.amax) amax=it_anlz(n)
  endif           ! if(status.ne.7.and.status.ne.8) then 
  if(gross_temp_flag(n)<min_gross_temp_flag) then
    min_gross_temp_flag=gross_temp_flag(n)
  endif
  if(gross_temp_flag(n)>max_gross_temp_flag) then
    max_gross_temp_flag=gross_temp_flag(n)
  endif
  if(it_spik(n).lt.smin) smin=it_spik(n)
  if(it_spik(n).gt.smax) smax=it_spik(n)
  if(it_vert(n).lt.vmin) vmin=it_vert(n)
  if(it_vert(n).gt.vmax) vmax=it_vert(n)
enddo

if(bounce_t.eq.'y') then
  write(LOG,*) 'ANALYSIS & CLIMA. T  can not be determined.'
  write(TRC,*)'ANALYSIS & CLIMA. T  can not be determined.'
  anlz_flag='N'                          
  iover_anlz=0
  clim_flag='N'                          
  iover_clim=0
  amin=0.0
  amax=0.0
  cmin=0.0
  cmax=0.0
  go to 77
else
  if(cmax.eq.4.and.amax.eq.4) then
    write(LOG,*) 'ANALYSIS & CLIMA. T  failed.'
    write(TRC,*)'ANALYSIS & CLIMA. T  failed.'
    anlz_flag='F'                          ! 01-26-2001
    iover_anlz=4
    clim_flag='F'                          ! 01-26-2001
    iover_clim=4
    go to 77
  else if(amax.eq.4.and.cmax.eq.1) then
    write(LOG,*)  'ANALYSIS failed, CLIMA. T passed.'
    write(TRC,*) 'ANALYSIS failed, CLIMA. T passed.'
    anlz_flag='F'                          ! 01-26-2001
    iover_anlz=4
    clim_flag='P'
    iover_clim=1
  else if(amax.eq.1.and.cmax.eq.4) then
    write(LOG,*) 'ANALYSIS  passed, CLIMA. T failed.'
    write(TRC,*) 'ANALYSIS passed, CLIMA. T failed.'
    clim_flag='F'                          ! 01-26-2001
    iover_clim=4
    anlz_flag='P'      
    iover_anlz=1       
  else if(amax.eq.1.and.cmax.eq.1) then
    write(LOG,*) 'ANALYSIS & CLIMA. T  passed.'
    write(TRC,*)'ANALYSIS & CLIMA. T  passed.'
    clim_flag='P'
    iover_clim=1
    anlz_flag='P'      
    iover_anlz=1       
  else 
  endif
endif                 ! if(bounce_t.eq.'y') then
 77   continue
if(DEBUG) write(DBG,*)'<<< End CLIM & ANAL CHECK >>>'
!
!* Test 8: Pressure Increasing test.
!
if(DEBUG) write(DBG,*)'<<< Begin PRES CHECK >>>'
if(nlev.eq.1.and.tem(1).eq.0.0.and.sal(1).eq.0.0.and. &
    pres(1).eq.0.0) then
  write(LOG,*) 'PRES CHECK FLAG      can not be determined.'
  write(TRC,*)'PRES CHECK FLAG      can not be determined.'
  pres_flag='N'
  iover_pres=0
  go to 88
endif

if(bounce_t.eq.'y') then
  write(LOG,*) 'PRES CHECK TEST      can not be determined.'
  write(TRC,*)'PRES CHECK TEST      can not be determined.'
  pres_flag='N'
  iover_pres=0
  pmin=0.0
  pmax=0.0
  go to 88
else
  call pres_check(tem,sal,pres,nlev,icksm_flag,pres_incr_flag)

  do n=1,nlev
    if(pres_incr_flag(n).lt.pmin) pmin=pres_incr_flag(n)
    if(pres_incr_flag(n).gt.pmax) pmax=pres_incr_flag(n)
  enddo

  if(nlev.eq.0) then
    write(LOG,*) 'PRES CHECK TEST      can not be determined.'
    write(TRC,*)'PRES CHECK TEST      can not be determined.'
    pres_flag='N'
    iover_pres=0
    go to 88
  endif
  do n=1,nlev
    if(icksm_flag(n).eq.0 .and. tem(n).eq.0.  &
    .and. pres(n).eq.0. .and. sal(n).eq.0.) then
      pres_incr_flag(n)=0
    endif
  enddo
  do n=1,nlev
    if(pres_incr_flag(n).eq.4) then            
      write(LOG,*) 'PRES CHECK TEST      failed.'
      write(TRC,*)'PRES CHECK TEST      failed.'
      pres_flag='F'
      iover_pres=4
      go to 88
    else
      pres_flag='P'
      iover_pres=1
    endif
  enddo
  write(LOG,*) 'PRES CHECK TEST      passed.'
  write(TRC,*)'PRES CHECK TEST      passed.'
endif                   ! if(bounce_t.eq.'y') then
 88   continue

if(DEBUG) write(DBG,*)'<<< End PRES CHECK >>>'

if(type_ts32.eq.'y') then
  if(DEBUG) write(DBG,*)'<<< Begin PRES2 CHECK >>>'
  pmin2=0
  pmax2=0
  call pres_check(temp2,sal,pres2,nlev,icksm_flag,ipres2_flag)

  do n=1,nlev
  if(ipres2_flag(n).lt.pmin2) pmin2=ipres2_flag(n)
  if(ipres2_flag(n).gt.pmax2) pmax2=ipres2_flag(n)
  enddo

  if(nlev.eq.0) then
    write(LOG,*) 'PRES2 CHECK TEST     can not be determined.'
    write(TRC,*)'PRES2 CHECK TEST     can not be determined.'
    pres2_flag='N'
    iover_pres2=0
    go to 89
  endif
  do n=1,nlev
    if(icksm_flag(n).eq.0 .and. temp2(n).eq.0.  &
    .and. pres2(n).eq.0. .and. sal(n).eq.0.) then
    ipres2_flag(n)=0
    endif
    if(temp2(n)==TEMP_FILLVAL .and. pres2(n)==PRES_FILLVAL) then
      ipres2_flag(n)=0
    endif
!          write(LOG,*)'pres2:',n,pres_incr_flag(n)
  enddo
  do n=1,nlev
    if(ipres2_flag(n).eq.4) then            
      write(LOG,*) 'PRES2 CHECK TEST     failed.'
      write(TRC,*)'PRES2 CHECK TEST     failed.'
      pres2_flag='F'
      iover_pres2=4
      go to 89
    else
      pres2_flag='P'
      iover_pres2=1
    endif
  enddo
  write(LOG,*) 'PRES2 CHECK TEST     passed.'
  write(TRC,*)'PRES2 CHECK TEST     passed.'
 89     continue
  if(DEBUG) write(DBG,*)'<<< End PRES2 CHECK >>>'
  if(DEBUG) write(DBG,*)'<<< Begin DEEP2 CHECK >>>'
  iover_deep2=1
  do n=1,nlev
    ideep2_flag(n)=1
    if(pres2(n)>(deepest_pres_limit*1.1)) then     ! + 10%
      write(LOG,*) 'deep pres=',(deepest_pres_limit*1.1), &
    ' pres=',pres2(n)
      write(ERR,'(A, ": Error DEEPEST PRESSURE case: ")')  PRGMAIN
      write(ERR,*) 'deep pres=',(deepest_pres_limit*1.1), &
    ' pres=',pres2(n)
      ideep2_flag(n)=4
      iover_deep2=4
    endif
    if(temp2(n)==TEMP_FILLVAL .and. pres2(n)==PRES_FILLVAL) then
      ideep2_flag(n)=0
    endif
  enddo
  do n=1,nlev
    if(ideep2_flag(n).lt.dmin2) dmin2=ideep2_flag(n)
    if(ideep2_flag(n).gt.dmax2) dmax2=ideep2_flag(n)
  enddo
  if(DEBUG) write(DBG,*)'<<< End DEEP2 CHECK >>>'
 endif ! if(type_ts32.eq.'y') then
!
!
!* Test 16: Sensor Jump test.
!
if(DEBUG) write(DBG,*)'<<< Begin SENSOR JUMP T CHECK >>>'
if(nlev == 0) then
    if(DEBUG) write(DBG,*) 'W nlev=0, do NOT call jump_check_t'
else
    call jump_check_t(tem,pres,nlev,tem_qc,pres_qc,nlev_qc, &
	gross_temp_flag,it_vert,it_spik,pres_incr_flag, &
	iover_t_qc,it_gros_qc,it_vert_qc,it_spik_qc, &
	ipres_qc,it_jump)
endif
do n=1,nlev
!        it_jump(n)=0            ! WAIT until any decision is made
  if(it_jump(n).lt.jmin) jmin=it_jump(n)
  if(it_jump(n).gt.jmax) jmax=it_jump(n)
enddo

if(nlev.eq.0.or.jmax.eq.0) then
  write(LOG,*) 'JUMP CHECK TEST T    can not be determined.'
  write(TRC,*)'JUMP CHECK TEST T    can not be determined.'
  jump_flag='N'
  iover_jump=0
  go to 98
endif
do n=1,nlev
  if(it_jump(n).eq.4) then            
    write(LOG,*) 'JUMP CHECK TEST T    failed.'
    write(TRC,*)'JUMP CHECK TEST T    failed.'
    jump_flag='F'
    iover_jump=4
    go to 98
  else
    jump_flag='P'
    iover_jump=1
  endif
enddo
write(LOG,*) 'JUMP CHECK TEST T    passed.'
write(TRC,*)'JUMP CHECK TEST T    passed.'
 98   continue
if(DEBUG) write(DBG,*)'<<< End SENSOR JUMP T CHECK >>>'
!
!*  Test 17: Frozen Profile test.
!
if(DEBUG) write(DBG,*)'<<< Begin FROZEN T CHECK >>>'
if(nlev.eq.0) then
  write(LOG,*) 'FROZEN CHECK TEST T  can not be determined.'
  write(TRC,*)'FROZEN CHECK TEST T  can not be determined.'
  frzn_flag='N'
  iover_frzn=0
  go to 108
endif

call frozen_t(tem,pres,nlev,tem_qc,pres_qc,nlev_qc,ifrzn_flag)
if(ifrzn_flag.eq.4) then            
   write(LOG,*) 'FROZEN CHECK TEST T  failed.'
   write(TRC,*)'FROZEN CHECK TEST T  failed.'
   frzn_flag='F'
   iover_frzn=4
else
  frzn_flag='P'
  iover_frzn=1
  write(LOG,*) 'FROZEN CHECK TEST T  passed.'
  write(TRC,*)'FROZEN CHECK TEST T  passed.'
endif
 108  continue
if(DEBUG) write(DBG,*)'<<< End FROZEN T CHECK >>>'
!
!* What are the overall flag for climatology, analysis, vgrad, checksum,
!* gross, and spike tests?
!
write(LOG,118)
write(TRC,118)

!
!    Each individual tests are group by following category:
!    1) Profile standard 1 : gross, cnsv, spik, verg, deep, regi, pres incre
!    2) SPED : sped
!    3) grey_list : frzn
!    4) analysis
!    5) climatology
!    6) overall 

group1=max(over_gross_pres_flag_int, over_gross_temp_flag_int,  &
    iover_cnsv, iover_spik, iover_verg, over_deepest_pres_flag,  &
    over_gross_pres_adj_flag_int, over_deepest_pres_adj_flag,  &
    iover_regi, iover_pres )
if(iregion>=1) then
  regi_flag='N'
endif
group2=iover_sped
group3=iover_frzn
group4=iover_anlz
group5=iover_clim

pres_in_gl = .false. 
temp_in_gl = .false. 
psal_in_gl = .false. 
pres_gl_flag = 0 
temp_gl_flag = 0 
psal_gl_flag = 0 
max_gl_flag  = 0 
if(grey_list(1:1)=='y' .or. grey_list(1:1)=='Y') then
  read(grey_list(3:3),*) num_grey

  aux_profile_date = itime_hist(1)(1:8)
  aux_grey_date_st = grey_date_st(num_grey)(1:4) // &
    grey_date_st(num_grey)(6:7) // &
    grey_date_st(num_grey)(9:10)

  aux_grey_date_en = grey_date_en(num_grey)(1:4) // &
    grey_date_en(num_grey)(6:7) // &
    grey_date_en(num_grey)(9:10)

  if(aux_profile_date>=aux_grey_date_st .and. &
    aux_profile_date<=aux_grey_date_en)  then

    if(DEBUG) write(DBG,*)PRGD,'Checking grey list'

    select case(grey_parm(num_grey)(1:4)) 
      case ('PRES')
        pres_in_gl = .true.
        read(grey_flag(num_grey)(1:1),'(i1)') pres_gl_flag
      case ('TEMP')
        temp_in_gl = .true.
        read(grey_flag(num_grey)(1:1),'(i1)') temp_gl_flag
    end select

    if(grey_parm(num_grey)(6:9)=='TEMP') then
        temp_in_gl = .true.
        read(grey_flag(num_grey)(3:3),'(i1)') temp_gl_flag
    endif 


    if(pres_in_gl .or. temp_in_gl) then
      max_gl_flag = max(pres_gl_flag, temp_gl_flag)
      iover_all = max_gl_flag

      if(DEBUG) write(DBG,*)PRGD,'Grey Flag should be ', max_gl_flag

      if(nlev==0 .and. icnt==0) then      ! no position/no data
        over_all='N'
        status=5
      else if(nlev==0 .and. icnt<>0) then ! yes position/no data
        over_all='F'
        status=3
      else if(nlev<>0 .and. icnt==0) then ! no position/yes data
        over_all='F'
        status=8
      endif     
   
      if(DEBUG) write(DBG,*)PRGD,'Grey Flag should be ', max_gl_flag

    endif        
  else
    if(DEBUG) write(DBG,*)PRGD,' Not doing grey list ', max_gl_flag
  endif
endif 

if(pres_in_gl .or. temp_in_gl) then
  group3=max(iover_frzn,4)
endif

write(LOG,*)'group1:',group1,' group2:',group2,' group3:',group3, &
    ' group4:',group4,' group5:',group5

if(group1==1.and.group2<=1) then
  write(LOG,*) 'QC_TESTS for T passed   -----> GOOD profile.'
  write(TRC,*)'QC_TESTS for T passed   -----> GOOD profile.'
  if(icomplet==1) iover_all=max(1,max_gl_flag)
  if(icomplet==0) iover_all=max(2,max_gl_flag)
  over_all='P'
else if(group1==4 .or. group2==4 .or. group3==4) then
  write(LOG,*) 'QC_TESTS for T failed   -----> BAD profile.'
  write(TRC,*)'QC_TESTS for T failed   -----> BAD profile.'
  iover_all=4
  over_all='F'
else if(group1==0 .and. group2<=1) then
  write(LOG,*) 'QC_TESTS for T can not be determined.'
  write(TRC,*)'QC_TESTS for T can not be determined.'
  iover_all=max(0,max_gl_flag)
  over_all='N'
else if(group1==1 .and. group2<=2) then
  write(LOG,*) 'QC_TESTS for T passed   -----> GOOD profile.'
  write(TRC,*)'QC_TESTS for T passed   -----> GOOD profile.'
  if(icomplet==1) iover_all=max(1,max_gl_flag)
  if(icomplet==0) iover_all=max(2,max_gl_flag)
  over_all='P'
endif               

 78   continue
! See if the dates need to be tested
if(st_trans_time_qc .eq. '0') then
   date_check_result=0
   call cdate_check(st_trans_time,date_check_result)
   if(date_check_result==0) st_trans_time_qc='1'
   if(date_check_result==1) st_trans_time_qc='4'
   if(DEBUG) write(DBG,*)PRGD,'st_trans_time_qc: ',st_trans_time_qc
    if(DEBUG_LEV==4) then
        write(msg,'(a)')'dbg4 Call cdate_check, qc: ',st_trans_time_qc,' ck: ',date_check_result, &
                ' (0=g,1=b) at (2) for date: ',st_trans_time ! DEBUG date_check
       call LogDEB(PRG,msg)
   endif
endif
if(ascent_end_time_qc .eq. '0') then
   date_check_result=0
   call cdate_check(ascent_end_time,date_check_result)
   if(date_check_result==0) ascent_end_time_qc='1'
   if(date_check_result==1) ascent_end_time_qc='4'
   if(DEBUG) write(DBG,*)PRGD,'scent_end_time_qc ',ascent_end_time_qc
   if(DEBUG_LEV==4) then
       write(msg,'(a)')'dbg4 Call cdate_check, qc: ',ascent_end_time_qc,' ck: ',date_check_result, &
            ' (0=g,1=b) at (3) for date: ',ascent_end_time ! DEBUG date_check
       call LogDEB(PRG,msg)
   endif
endif
if(DEBUG) write(DBG,*)'<<< Begin flags2qcfile >>>'   
call flags2qcfile(1, hasTemp, hasPsal, hasCond, hasO2, &
    phyfile,nlev,iover_all, pres_in_gl,temp_in_gl,psal_in_gl, &
    pres_gl_flag, temp_gl_flag, psal_gl_flag, &
    iover_cnsv,iover_frzn, iregion,ireverse,no_pos,land, &
    date_global_test, std_clim,std_anal,atime,ana_version, &
    iover_sped,it_anlz,it_clim, &
    gross_pres_flag, gross_temp_flag, gross_sal_flag,  &
    it_spik, it_vert, pres_incr_flag, &
    deepest_pres_flag, deepest_pres_adj_flag, &
    gross_pres_adj_flag, it_jump,it_regi, &
    dummy_vector_flag, dummy_vector_flag, is_anlza, &
    is_clima,is_grosa,is_regia, &
    type_ts32,ipres2_flag,ideep2_flag,itemp2_flag, &
    gross_pres2_flag, gross_temp2_flag, &
    st_trans_time, st_trans_time_qc, &
    ascent_end_time, ascent_end_time_qc, &
    it_spik2, bad_row, surface_pressure)
    if(DEBUG) write(DBG,*)'<<< End flags2qcfile >>>'

!
!* END of QC LOOP

!
! Fill out Pass/Fail TABLE.
!
write(LOG, '("Pass/Fail Table follows:")')
lastnb=lnblnk(profile_id)
write(LOG, 113) profile_id(1:lastnb),group1,group2,group3,group4, &
    group5,over_all
write(TRC, 113) profile_id(1:lastnb),group1,group2,group3,group4, &
    group5,over_all

if(lastnb==14) then
  ! OLDMSG write(TAB,115) profile_id(1:lastnb),cnsv_flag,deep_flag, &
  ! OLDMSG   over_gross_pres_flag_chr, over_gross_temp_flag_chr, &
  ! OLDMSG   jump_flag,pres_flag,spik_flag, &
  ! OLDMSG   verg_flag,regi_flag,dummy_flag,  & ! group1
  ! OLDMSG   spd_table,                       & ! group2
  ! OLDMSG   frzn_flag,                       & ! group3
  ! OLDMSG   anlz_flag,clim_flag,             & ! group4/5
  ! OLDMSG   over_all
  write(msg,115) profile_id(1:lastnb),cnsv_flag,deep_flag, &
    over_gross_pres_flag_chr, over_gross_temp_flag_chr, &
    jump_flag,pres_flag,spik_flag, &
    verg_flag,regi_flag,dummy_flag,  & ! group1
    spd_table,                       & ! group2
    frzn_flag,                       & ! group3
    anlz_flag,clim_flag,             & ! group4/5
    over_all
    call LogTAB(PRG,msg)
else
  ! OLDMSG write(TAB,117) profile_id(1:lastnb),cnsv_flag,deep_flag, &
  ! OLDMSG   over_gross_pres_flag_chr, over_gross_temp_flag_chr, &
  ! OLDMSG   jump_flag,pres_flag,spik_flag, &
  ! OLDMSG   verg_flag,regi_flag,dummy_flag,  & ! group1
  ! OLDMSG   spd_table,                       & ! group2
  ! OLDMSG   frzn_flag,                       & ! group3
  ! OLDMSG   anlz_flag,clim_flag,             & ! group4/5
  ! OLDMSG   over_all
  write(msg,117) profile_id(1:lastnb),cnsv_flag,deep_flag, &
    over_gross_pres_flag_chr, over_gross_temp_flag_chr, &
    jump_flag,pres_flag,spik_flag, &
    verg_flag,regi_flag,dummy_flag,  & ! group1
    spd_table,                       & ! group2
    frzn_flag,                       & ! group3
    anlz_flag,clim_flag,             & ! group4/5
    over_all
    call LogTAB(PRG,msg)
endif

if(DEBUG) write(DBG,*)'<<< QC_T >>>'
if(DEBUG) close(DBG)                  ! close debug file
close(TRC)                            ! close trace_qc file
close(49)                             ! close table_qc file
close(50)                             ! close error_qc  file
!
!* Create 'QC' files except status=9.
!
if(bounce_t.eq.'y') then
  status=10
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at t15")'); call exit(status)!stop '10'
endif

if(status.eq.11) then                 ! Bad phy file case.
  write(LOG,  &
    '(A, ": Error phy file bad case:")')  PRGMAIN
  write(LOG,'(A, ": STOP -> STATUS=", I3)') PRGMAIN, status

  write(ERR,  &
    '(A, ": Error phy file incomplete case:")')  PRGMAIN
  write(ERR,*) PRGMAIN, ': STOP -> STATUS = ', status
  write(LOG,'("call exit at t16")'); call exit (status)!stop '11'
endif

if(status.ne.5) then
  if(date_global_test==4) status=6
  if(location_check_result==1) status=6
  if(iover_sped.eq.4) status=7              ! 10-25-07
  if(iover_sped.ne.4.and.status.ne.7.and.status.ne.8.and. &
    ibad_pos.eq.1) status=6
endif

if(status.eq.3) then                      ! '000' profile with no data
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at t17")'); call exit(status)!stop '3'
else if(status.eq.5) then                 ! '000' profile with data
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at t18")'); call exit(status)!stop '5'
else if(status.eq.6) then                 ! impossible date/location.
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at t19")'); call exit(status)!stop '6'
else if(status.eq.7) then                 ! LAND or SPEED failure.
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at t20")'); call exit(status)!stop '7'
else if(status.eq.8) then                 ! No position case.
  write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
  write(LOG,'("call exit at t21")'); call exit(status)!stop '8'
else
  if(iover_all.eq.0) then
    status=2
    if(nlev.eq.0) status=3
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at t22")'); call exit(status)!stop '2'
  else if(iover_all.eq.1) then
    if(nlev.eq.1) then
      status=0
      write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
      write(LOG,'("call exit at t23")'); call exit(status)!stop '0'
    else
      ! Ramos 13-Oct-09
      ! Add most likely frame status test
      if(most_likely_frame_status==1) then
        status=2
      else
        status=1
      endif
      write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
      write(LOG,'("call exit at t24")'); call exit(status)!stop '1'
    endif
  else if(iover_all.eq.2) then
    status=2
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at t25")'); call exit(status)!stop '2'
  else if(iover_all.ge.3.and.iover_all.le.5) then
    ! Ramos 13-Oct-09
    ! Add most likely frame status test
    if(most_likely_frame_status==1) then
      status=2
    else
      status=4
    endif
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at t26")'); call exit(status)!stop '4'
  else if(prof_num.eq.0) then
    status=1
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at t27")'); call exit(status)!stop '1'
  else
    status=9
    write(LOG,'(A, ":  STOP -> STATUS: ", I3)') PRGMAIN, status
    write(LOG,'("call exit at t28")'); call exit(status)!stop 'abnormal exit'
  endif                       ! if(iover_anlz.eq.1) then
endif                         ! if(status.eq.7) then

 83   format(300i2)
 85   format(300f8.2)
 113  format(1x,a,' profile standard:',i1,' speed:',i1,' grey_list:',i1, &
    ' anlz:',i1,' clim:',i1,' overall:',a1)
 114  format(a,2x,'T',3x,7(a1,1x),8x,a1,5x,a1,5x,2(a1,1x),4x,a1)
 115  format(a,2x,'T',3x,10(a1,1x),6x,a1,5x,a1,5x,2(a1,1x),4x,a1)
 116  format(a,1x,'T',3x,7(a1,1x),8x,a1,5x,a1,5x,2(a1,1x),4x,a1)
 117  format(a,1x,'T',3x,10(a1,1x),6x,a1,5x,a1,5x,2(a1,1x),4x,a1)
 118  format(59('+'))

call DATE_AND_TIME(big_ben(1),big_ben(2),big_ben(3),end_datetime)
write(LOG, '(A, ": vmh end_datetime: ", 8I6)') PRGMAIN,end_datetime 

end



!******  END of MAIN PROGRAM   ******
!****************************************************************************
!* To linearly interpolate a monthly climatology to a given time.

subroutine tintp(iyr,imo,ida,hr,m1,m2,w1,w2)

use communication

implicit none

character(len=11), parameter :: SUB = 'qc_t:tintp '

integer ndmo(12),ndmu(12),iyr,imo,ida,i,j,k,m,m1,m2,status
real d0,d1,d2,hr,x1,x2,xx,w1,w2
data ndmo/31,28,31,30,31,30,31,31,30,31,30,31/

do m=1,12
  ndmu(m)=ndmo(m)
enddo
if(mod(iyr,4).eq.0) ndmu(2)=29
m1=imo
d1=real(ndmu(imo))
d2=d1/2.0
d0=real(ida)+hr/24.0
if(d0.gt.d1)d0=d1
if(d0.le.d2)then
  m2=imo-1
  if(m2.lt.1)m2=12
  x1=d2-d0
  x2=d0+real(ndmu(m2))/2.0
else
  m2=imo+1
  if(m2.gt.12)m2=1
  x1=d0-d2
  x2=d1-d0+real(ndmu(m2))/2.0
endif
xx=x1+x2
if(xx.eq.0.0) then
  status=9
  write(LOG,*)SUB,': Error calculating x1/xx and x2/xx: x1=',x1,' x2=',x2,' xx=',xx
  write(ERR,*)SUB,': STOP -> STATUS= ', status
  write(ERR,*)SUB,': Error calculating x1/xx and x2/xx: x1=',x1,' x2=',x2,' xx=',xx
  write(ERR,*)SUB,': STOP -> STATUS= ', status
  write(LOG,'("call exit at t29")'); call exit (status)!stop '9'
endif
w1=x2/xx
w2=x1/xx
return
end
!
!* To spatially interpolate a field of data to a point using
!* optimal interpolation (OI) with normalization of the weights. 
!* The horizontal scales are given in km, the vertical scales in
!* meters.  The vertical scale and data/guess error variance ratio
!* are partially dependant on the climatology vertical gradiend
!* near the point of interest.
!* This program works for dummy value of -98.00 or less.

subroutine sintp(isel,rlat,rlon,dep1,im,jm,km,cl_an1,sd1, &
    xl,yl,cj,df,i0,j0,cl_an0,sd0)

use communication

implicit none

character(len=11), parameter :: SUB = 'qc_t:sintp '

integer im,jm,km,nmx,isel
real sx,sy,sz,sz1,sz2,vr1,vr2
parameter(nmx=400)
parameter(sx=400.0,sy=300.0,sz1=30.0,sz2=100.0,vr1=1.5,vr2=0.5)
real cl_an1(im,jm,km),sd1(im,jm,km),xl(im),yl(jm)
real df(km),cj(jm),da1(nmx),da2(nmx),xav(nmx),xc(nmx)
real yav(nmx),zav(nmx)
integer mask(im,jm),status
double precision a(nmx,nmx),b(nmx)
integer indx(nmx),i,i0,i1,i2,id,j,j0,j1,j2,k,k0,k1,k2,kn,np1
real arg,cl_an0,dck,dd,dep1,dmin,dx,dy,dz,rlat,rlon,sd0,vr,xcj

!
!* Get the climatology point nearest the point of interest and estimate
!* the vertical scale and error from the vertical gradient.
!
k0=0
dmin=1.e9
do k=1,km
  dd=abs(df(k)-dep1)
  if(dd.lt.dmin)then
    dmin=dd
    k0=k
  endif
enddo

if(cl_an1(i0,j0,k0).le.-98.00) then
!      if(mask(i0,j0).ge.k0) then
  sz=sz1
  vr=vr1
else
  if(k0.gt.1)then
   if(df(k0-1).eq.df(k0)) then
     status=9
     write(LOG,*)SUB,': Error calculating df(k0-1)-df(k0) : df(k0-1)=',df(k0-1),' df(k0)=',df(k0)
     write(LOG,*)SUB,': STOP -> STATUS= ', status
     write(ERR,*)SUB,': Error calculating df(k0-1)-df(k0) : df(k0-1)=',df(k0-1),' df(k0)=',df(k0)
     write(ERR,*)SUB,': STOP -> STATUS= ', status
     write(LOG,'("call exit at t30")'); call exit (status)!stop '9'
   endif
   dd=abs((cl_an1(i0,j0,k0-1)-cl_an1(i0,j0,k0))/(df(k0-1)-df(k0)))
  else
   if(df(k0).eq.df(k0+1)) then
     status=9
     write(LOG,*)SUB,': Error calculating df(k0)-df(k0+1) : df(k0)=',df(k0),' df(k0+1)=',df(k0+1)
     write(LOG,*)SUB,': STOP -> STATUS= ', status
     write(ERR,*)SUB,': Error calculating df(k0)-df(k0+1) : df(k0)=',df(k0),' df(k0+1)=',df(k0+1)
     write(ERR,*)SUB,': STOP -> STATUS= ', status
     write(LOG,'("call exit at t31")'); call exit (status)!stop '9'
   endif
   dd=abs((cl_an1(i0,j0,k0)-cl_an1(i0,j0,k0+1))/(df(k0)-df(k0+1)))
  endif
  if(dd.gt.0.1) dd=0.1
  sz=sz2-(sz2-sz1)*dd/0.1
  vr=vr2+(vr1-vr2)*dd/0.1
endif
!* Interpolate to the point using only near-by data.
 i1=i0-1
 if(i1.lt.1) i1=1
 i2=i0+1
 if(i2.gt.im) i2=im
 j1=j0-1
 if(j1.lt.1) j1=1
 j2=j0+1
 if(j2.gt.jm) j2=jm
!       k1=k0-1                 ! bug found 9/29/00
!       if(k1.lt.1) k1=1        ! bug found 9/29/00
!       k2=k0+1                 ! bug found 9/29/00
!       if(k2.gt.km)k2=km       ! bug found 9/29/00

 if(dep1.ge.df(k0)) then
   k1=k0
 else
   k1=k0-1
   if(k1.lt.1) k1=1
 endif
 if(dep1.le.df(k0)) then
   k2=k0
 else
   k2=k0+1
 endif
 if(k2.gt.km)k2=km

 kn=0
 if(DEBUG) write(DBG,*)'sintp->:dep=',dep1,' lon=',rlon,' lat=',rlat
 if(DEBUG) write(DBG,*)'sintp->:i1,i0,i2: ',i1,i0,i2,xl(i1),xl(i0),xl(i2)
 if(DEBUG) write(DBG,*)'sintp->:j1,j0,j2: ',j1,j0,j2,yl(j1),yl(j0),yl(j2)
 if(DEBUG) write(DBG,*)'sintp->:k1,k0,k2: ',k1,k0,k2,df(k1),df(k0),df(k2)
 do 1 k=k1,k2
 do 1 j=j1,j2
 do 1 i=i1,i2
   id=i
   if(id.lt.1) id=id+im
   if(id.gt.im)id=id-im
!         if(mask(id,j).ge.k)then
!         if(cl_an1(id,j,k).gt.-99.00) then   ! bug found 22-Apr-2002
   if(cl_an1(id,j,k).gt.-98.00) then
     kn=kn+1
     if(kn.ge.nmx) then
       status=9
       write(ERR,*)SUB,': Error on kn .ge. nmx case'
       write(ERR,*)SUB,': STOP -> STATUS= ', status
       write(LOG,'("call exit at t32")'); call exit (status)!stop '9'
     endif
     da1(kn)=cl_an1(id,j,k)
     da2(kn)=sd1(id,j,k)
!           da3(kn)=an1(id,j,k)
     xav(kn)=xl(id)
     xc(kn) =cj(j)
     yav(kn)=yl(j)
     zav(kn)=df(k)
   endif
 1     continue

 if(kn.le.1)then
   if(kn.eq.1)then
    cl_an0=da1(1)
    sd0=da2(1)
!          an0=da3(1)
    return
   else
    cl_an0=-999.9
!          an0=-999.9
    sd0=1.0
    return
   endif
 endif
!* First set up array A.
do k1=1,kn
 a(k1,k1)=1.0+vr
enddo
do 2 k1=2,kn
 do 2 k2=1,k1-1
  xcj=(xc(k1)+xc(k2))/2.0
  dx=abs(xav(k1)-xav(k2))
  if(dx.gt.180.)dx=360.0-dx
  dx=111.19*xcj*dx/sx
  dy=111.19*(yav(k1)-yav(k2))/sy
  dz=(zav(k1)-zav(k2))/sz
  arg=dx*dx+dy*dy+dz*dz
  if(arg.gt.16.0)then
   a(k1,k2)=0.0
  else
   a(k1,k2)=exp(-arg)
  endif
  a(k2,k1)=a(k1,k2)
  ! TOO MUCH if(DEBUG) write(DBG,*)'ex,dy,dz:',dx,dy,dz
  ! TOO MUCH if(DEBUG) write(DBG,*)'k1,k2:',k1,k2,' arg:',arg,' a:',a(k2,k1)
 2    continue
!
np1=kn+1
do k=1,np1
 a(np1,k)=1.0
 a(k,np1)=1.0
enddo
a(np1,np1)=0.0
!* Get the vector b.
do k1=1,kn
 dx=abs(xav(k1)-rlon)
 if(dx.gt.180.)dx=360.0-dx
 dx=111.19*xc(k1)*dx/sx
 dy=111.19*(yav(k1)-rlat)/sy
 dz=(zav(k1)-dep1)/sz
 arg=dx*dx+dy*dy+dz*dz
 b(k1)=0.0
 if(arg.le.16.0)b(k1)=exp(-arg)
enddo
b(np1)=1.0
!* Get the LU decomposition of A and solve the linear system Aw=b.
!* The solution w is returned in b.
call ludcmp(a,np1,nmx,indx,dck)
call lubksb(a,np1,nmx,indx,b)
!* Get the OI estimate.
cl_an0=0.0
sd0=0.0
!      an0=0.0
do k1=1,kn
 cl_an0=cl_an0+b(k1)*da1(k1)
 sd0=sd0+b(k1)*da2(k1)
!       an0=an0+b(k1)*da3(k1)
enddo
if(DEBUG) write(DBG,112 )cl_an0,sd0
 112  format(1x,'sintp->end: cl_an0:',f12.4,' sd0:',f12.5)
return
end

!
!* To vertically interpolate to fill a trace using
!* optimal interpolation (OI) with normalization of the weights. 
!* The vertical scale and data/guess error variance ratio
!* are fixed.
!
subroutine vintp(tem,dep,nl)
use communication

implicit none

character(len=11), parameter :: SUB = 'qc_t:vintp '

integer nmx
real sz,vr
parameter(nmx=400,sz=45.0,vr=1.0)
real tem(*),dep(*),da1(nmx),zav(nmx),vw(2*nmx),arg,dck,dz, &
    sum,z0
double precision a(nmx,nmx),b(nmx)
integer indx(nmx),k,k1,k2,kn,n,nl,np1,status
  
do n=1,nl
 vw(n)=tem(n)
enddo
!* Interpolate to the point.
do 10 n=1,nl
 if(tem(n).gt.-990.) go to 10
 z0=dep(n)
 kn=0
 do k=1,nl
  if(vw(k).gt.-990.)then
   kn=kn+1
   if(kn.ge.nmx) then
     status=9
     write(ERR,*)SUB,': Error on kn .ge. nmx case ',kn,nmx
     write(ERR,*)SUB,': STOP -> STATUS= ', status
     write(LOG,'("call exit at t33")'); call exit (status)!stop '9'
   endif
   da1(kn)=vw(k)
   zav(kn)=dep(k)
  endif
 enddo
 if(kn.le.2) return
!* First set up array A.
 do k1=1,kn
  a(k1,k1)=1.0+vr
 enddo
 do 2 k1=2,kn
  do 2 k2=1,k1-1
   dz=(zav(k1)-zav(k2))/sz
   arg=dz*dz
   if(arg.gt.16.0)then
    a(k1,k2)=0.0
   else
    a(k1,k2)=exp(-arg)
   endif
   a(k2,k1)=a(k1,k2)
 2     continue
 np1=kn+1
 do k=1,np1
  a(np1,k)=1.0
  a(k,np1)=1.0
 enddo
 a(np1,np1)=0.0
!* Get the vector b.
 do k1=1,kn
  dz=(zav(k1)-z0)/sz
  arg=dz*dz
  b(k1)=0.0
  if(arg.le.16.0)b(k1)=exp(-arg)
 enddo
 b(np1)=1.0
!* Get the LU decomposition of A and solve the linear system Aw=b.
!* The solution w is returned in b.
 call ludcmp(a,np1,nmx,indx,dck)
 call lubksb(a,np1,nmx,indx,b)
!* Get the OI estimate.
 sum=0.0
 do k1=1,kn
  sum=sum+b(k1)*da1(k1)
 enddo
 tem(n)=sum
 10   continue

return
end
!
!* This does an LU decomposition on the matrix A, size nxn.  The
!* output is returned in A.  This is Crout's method with partial
!* pivoting, described in Numerical Recepies, sec 2.3.

subroutine ludcmp(a,n,np,indx,d)

use communication

implicit none

integer nmax
real tiny
parameter (nmax=400,tiny=1.0e-20)
integer indx(*),i,imax,j,k,n,np
real vv(nmax),aamax,d,sum,dum
double precision a(np,np)

d=1.
do 12 i=1,n
 aamax=0.
 do 11 j=1,n
  if(abs(a(i,j)).gt.aamax) aamax=abs(a(i,j))
 11    continue
 if(aamax.eq.0.) then
   write(LOG,*)'qc_t,sintp: Error... singular matrix. aamax:',aamax
   write(ERR,*)'qc_t,sintp: Error... singular matrix. aamax:',aamax
!         status=9
!         write(ERR,*) 'qc_t,sintp, ': STOP -> STATUS = ', status
!        write(LOG,'("call exit at t34")'); call exit (status)!stop '9'
 endif
 vv(i)=1./aamax
 12   continue
do 19 j=1,n
 if(j.gt.1) then
  do 14 i=1,j-1
   sum=a(i,j)
   if(i.gt.1)then
    do 13 k=1,i-1
     sum=sum-a(i,k)*a(k,j)
 13       continue
    a(i,j)=sum
   endif
 14     continue
 endif
 aamax=0.
 do 16 i=j,n
  sum=a(i,j)
  if(j.gt.1)then
   do 15 k=1,j-1
    sum=sum-a(i,k)*a(k,j)
 15      continue
   a(i,j)=sum
  endif
  dum=vv(i)*abs(sum)
  if(dum.ge.aamax) then
   imax=i
   aamax=dum
  endif
 16    continue
 if(j.ne.imax)then
  do 17 k=1,n
   dum=a(imax,k)
   a(imax,k)=a(j,k)
   a(j,k)=dum
 17     continue
  d=-d
  vv(imax)=vv(j)
 endif
 indx(j)=imax
 if(j.ne.n)then
  if(a(j,j).eq.0.)a(j,j)=tiny
   dum=1./a(j,j)
   do 18 i=j+1,n
    a(i,j)=a(i,j)*dum
 18      continue
 endif
 19   continue
if(a(n,n).eq.0.)a(n,n)=tiny

return
end
!
!* This solves the system Ax=b, where here A is the LU decomposition of
!* the matrix A that was passed into ludcmp()

subroutine lubksb(a,n,np,indx,b)

use communication

implicit none

character(len=12), parameter :: SUB = 'qc_t:lubksb '

integer indx(*),i,ii,j,ll,n,np,status
double precision a(np,np),b(*)
real sum

ii=0
do 12 i=1,n
 ll=indx(i)
 sum=b(ll)
 b(ll)=b(i)
 if(ii.ne.0)then
  do 11 j=ii,i-1
   sum=sum-a(i,j)*b(j)
 11     continue
 else if(sum.ne.0.) then
  ii=i
 endif
 b(i)=sum
 12   continue
do 14 i=n,1,-1
 sum=b(i)
 if(i.lt.n)then
  do 13 j=i+1,n
   sum=sum-a(i,j)*b(j)
 13     continue
 endif
 if(a(i,i).eq.0.0) then
   status=9
   write(LOG,*)SUB,': Error sum/a(i,i) : a(i,i)=',a(i,i)
   write(LOG,*)SUB,': STOP -> STATUS= ', status
   write(ERR,*)SUB,': Error  sum/a(i,i) : a(i,i)=',a(i,i)
   write(ERR,*)SUB,': STOP -> STATUS= ', status
   write(LOG,'("call exit at t35")'); call exit (status)!stop '9'
 endif
 b(i)=sum/a(i,i)
 14   continue

return
end
!
!* To fill the lons, lats, and depths for grid 2.
subroutine fill2(x,im,y,jm,z,km)

implicit none
integer im2,jm2,km2
parameter(im2=360,jm2=200,km2=40)
integer i,j,k,im,jm,km
real x2(im2),y2(jm2),z2(km2),x(*),y(*),z(*)

data x2/  0.50,  1.50,  2.50,  3.50,  4.50,  5.50,  6.50,  7.50, &
    8.50,  9.50, 10.50, 11.50, 12.50, 13.50, 14.50, 15.50, &
    16.50, 17.50, 18.50, 19.50, 20.50, 21.50, 22.50, 23.50, &
    24.50, 25.50, 26.50, 27.50, 28.50, 29.50, 30.50, 31.50, &
    32.50, 33.50, 34.50, 35.50, 36.50, 37.50, 38.50, 39.50, &
    40.50, 41.50, 42.50, 43.50, 44.50, 45.50, 46.50, 47.50, &
    48.50, 49.50, 50.50, 51.50, 52.50, 53.50, 54.50, 55.50, &
    56.50, 57.50, 58.50, 59.50, 60.50, 61.50, 62.50, 63.50, &
    64.50, 65.50, 66.50, 67.50, 68.50, 69.50, 70.50, 71.50, &
    72.50, 73.50, 74.50, 75.50, 76.50, 77.50, 78.50, 79.50, &
    80.50, 81.50, 82.50, 83.50, 84.50, 85.50, 86.50, 87.50, &
    88.50, 89.50, 90.50, 91.50, 92.50, 93.50, 94.50, 95.50, &
    96.50, 97.50, 98.50, 99.50,100.50,101.50,102.50,103.50, &
    104.50,105.50,106.50,107.50,108.50,109.50,110.50,111.50, &
    112.50,113.50,114.50,115.50,116.50,117.50,118.50,119.50, &
    120.50,121.50,122.50,123.50,124.50,125.50,126.50,127.50, &
    128.50,129.50,130.50,131.50,132.50,133.50,134.50,135.50, &
    136.50,137.50,138.50,139.50,140.50,141.50,142.50,143.50, &
    144.50,145.50,146.50,147.50,148.50,149.50,150.50,151.50, &
    152.50,153.50,154.50,155.50,156.50,157.50,158.50,159.50, &
    160.50,161.50,162.50,163.50,164.50,165.50,166.50,167.50, &
    168.50,169.50,170.50,171.50,172.50,173.50,174.50,175.50, &
    176.50,177.50,178.50,179.50,180.50,181.50,182.50,183.50, &
    184.50,185.50,186.50,187.50,188.50,189.50,190.50,191.50, &
    192.50,193.50,194.50,195.50,196.50,197.50,198.50,199.50, &
    200.50,201.50,202.50,203.50,204.50,205.50,206.50,207.50, &
    208.50,209.50,210.50,211.50,212.50,213.50,214.50,215.50, &
    216.50,217.50,218.50,219.50,220.50,221.50,222.50,223.50, &
    224.50,225.50,226.50,227.50,228.50,229.50,230.50,231.50, &
    232.50,233.50,234.50,235.50,236.50,237.50,238.50,239.50, &
    240.50,241.50,242.50,243.50,244.50,245.50,246.50,247.50, &
    248.50,249.50,250.50,251.50,252.50,253.50,254.50,255.50, &
    256.50,257.50,258.50,259.50,260.50,261.50,262.50,263.50, &
    264.50,265.50,266.50,267.50,268.50,269.50,270.50,271.50, &
    272.50,273.50,274.50,275.50,276.50,277.50,278.50,279.50, &
    280.50,281.50,282.50,283.50,284.50,285.50,286.50,287.50, &
    288.50,289.50,290.50,291.50,292.50,293.50,294.50,295.50, &
    296.50,297.50,298.50,299.50,300.50,301.50,302.50,303.50, &
    304.50,305.50,306.50,307.50,308.50,309.50,310.50,311.50, &
    312.50,313.50,314.50,315.50,316.50,317.50,318.50,319.50, &
    320.50,321.50,322.50,323.50,324.50,325.50,326.50,327.50, &
    328.50,329.50,330.50,331.50,332.50,333.50,334.50,335.50, &
    336.50,337.50,338.50,339.50,340.50,341.50,342.50,343.50, &
    344.50,345.50,346.50,347.50,348.50,349.50,350.50,351.50, &
    352.50,353.50,354.50,355.50,356.50,357.50,358.50,359.50/
data y2/-74.50,-73.50,-72.50,-71.50,-70.50,-69.50,-68.50,-67.50, &
    -66.50,-65.50,-64.50,-63.50,-62.50,-61.50,-60.50,-59.50, &
    -58.50,-57.50,-56.50,-55.50,-54.50,-53.50,-52.50,-51.50, &
    -50.50,-49.50,-48.50,-47.50,-46.50,-45.50,-44.50,-43.50, &
    -42.50,-41.50,-40.50,-39.50,-38.50,-37.50,-36.50,-35.50, &
    -34.50,-33.50,-32.50,-31.50,-30.50,-29.50,-28.50,-27.51, &
    -26.53,-25.55,-24.60,-23.66,-22.75,-21.86,-21.00,-20.16, &
    -19.36,-18.59,-17.85,-17.15,-16.49,-15.85,-15.26,-14.69, &
    -14.16,-13.66,-13.19,-12.75,-12.33,-11.93,-11.55,-11.19, &
    -10.84,-10.50,-10.17, -9.83, -9.50, -9.17, -8.83, -8.50, &
    -8.17, -7.83, -7.50, -7.17, -6.83, -6.50, -6.17, -5.83, &
    -5.50, -5.17, -4.83, -4.50, -4.17, -3.83, -3.50, -3.17, &
    -2.83, -2.50, -2.17, -1.83, -1.50, -1.17, -0.83, -0.50, &
    -0.17,  0.17,  0.50,  0.83,  1.17,  1.50,  1.83,  2.17, &
    2.50,  2.83,  3.17,  3.50,  3.83,  4.17,  4.50,  4.83, &
    5.17,  5.50,  5.83,  6.17,  6.50,  6.83,  7.17,  7.50, &
    7.83,  8.17,  8.50,  8.83,  9.17,  9.50,  9.83, 10.17, &
    10.50, 10.84, 11.19, 11.55, 11.93, 12.33, 12.75, 13.19, &
    13.66, 14.16, 14.69, 15.26, 15.85, 16.49, 17.15, 17.85, &
    18.59, 19.36, 20.16, 21.00, 21.86, 22.75, 23.66, 24.60, &
    25.55, 26.53, 27.51, 28.50, 29.50, 30.50, 31.50, 32.50, &
    33.50, 34.50, 35.50, 36.50, 37.50, 38.50, 39.50, 40.50, &
    41.50, 42.50, 43.50, 44.50, 45.50, 46.50, 47.50, 48.50, &
    49.50, 50.50, 51.50, 52.50, 53.50, 54.50, 55.50, 56.50, &
    57.50, 58.50, 59.50, 60.50, 61.50, 62.50, 63.50, 64.50/
data z2/   5.00,  15.00,  25.00,  35.00,  45.00,  55.00,  65.00, &
    75.00,  85.00,  95.00, 105.00, 115.00, 125.00, 135.00, &
    145.00, 155.00, 165.00, 175.00, 185.00, 195.00, 205.00, &
    215.00, 225.00, 238.48, 262.29, 303.03, 366.80, 459.09, &
    584.62, 747.19, 949.59,1193.53,1479.59,1807.19,2174.62, &
    2579.09,3016.80,3483.03,3972.29,4478.48/
do i=1,im
 x(i)=x2(i)
enddo
do j=1,jm
 y(j)=y2(j)
enddo
do k=1,km
 z(k)=z2(k)
enddo
return
end
!
!* To fill the lons, lats, and depths for grid 1 (360x180x33).
!
subroutine fill1(x,im,y,jm,z,km)

implicit none
integer im1,jm1,km1
parameter(im1=360,jm1=180,km1=33)
integer i,j,k,im,jm,km
real z1(km1),x(*),y(*),z(*)

data z1/   0.00,  10.00,  20.00,  30.00,  50.00,  75.00, 100.00, &
    125.00, 150.00, 200.00, 250.00, 300.00, 400.00, 500.00, &
    600.00, 700.00, 800.00, 900.00,1000.00,1100.00,1200.00, &
    1300.00,1400.00,1500.00,1750.00,2000.00,2500.00,3000.00, &
    3500.00,4000.00,4500.00,5000.0,5500.00/

do i=1,im
 x(i)=0.5+(i-1)*1.0
enddo
do j=1,jm
 y(j)=-89.5+(j-1)*1.0
enddo
do k=1,km
 z(k)=z1(k)
enddo
return
end

!
!*   Get the alimatology point nearest the point of interest and estimate
!    the verticle scale and error from the vertical gradient.
!
subroutine find_closest_pos(isel,rlat,rlon,xt,yt,i0,j0)
implicit none
!
!* isel=1 finding a closest location from climatology grids;
!  isel=2 finding a closest location from analysis grids.
!
integer isel,i0,j0,im,jm,im1,jm1,im2,jm2,i,j
parameter (im1=360,jm1=180)
parameter (im2=360,jm2=200)
real rlat,rlon,xt(*),yt(*),xl(im2),yl(jm2)
real dmin,dd 
!
!--- Initialize xl and yl arraies.
!
do i=1,im2
  xl(i)=0.0
enddo
do j=1,jm2
  yl(j)=0.0
enddo

if(isel.eq.1) then
  im=im1
  jm=jm1
  do i=1,im
    xl(i)=xt(i)
  enddo
  do j=1,jm
    yl(j)=yt(j)
  enddo
else
  im=im2
  jm=jm2
  do i=1,im
    xl(i)=xt(i)
  enddo
  do j=1,jm
    yl(j)=yt(j)
  enddo
endif

i0=0
dmin=1.e9
do i=1,im
 dd=abs(xl(i)-rlon)
 if(dd.lt.dmin)then
   dmin=dd
   i0=i
 endif
enddo
j0=0
dmin=1.e9
do j=1,jm
  dd=abs(yl(j)-rlat)
  if(dd.lt.dmin)then
    dmin=dd
    j0=j
  endif
enddo

return
end
