c------------------------------------------------------------------- 
c Revision date:    2013-04-02 VMH - Increase aline to 256 chars
c                   04-Jan-13 VMH  - Increase cline to 256 chars
c                   14-Aug-12 VMH  - Add vars st_trans_time_qc and 
c                                    ascent_end_time_qc reading 
c                                    most_likely_frame_status
c                   16-May-11 (ER  - Variable ityp replaced by hasTemp, 
c                                    hasPsal, hasCond, hasO2
c                   03-May-11 (ER  - Add treatment of columns PRES_DOXY2,
c                                    BPHASE_DOXY2, TEMP_DOXY2
c                   16-Jul-10 (ER  - Changes dealing with surface 
c                                    pressure = null
c                   16-Mar-10 (ER  - Added treatment of pres adjusted
c                                    column )
c                   18-Feb-10 (ER  - From now on, this subroutine will
c                                    take care only of phy files not qc.
c                                    Following parameters eliminated:
c                                    iover_t, it_anlz, it_clim, it_gros, 
c                                    it_vert, it_spik, it_vis, it_cntv,
c                                    it_jump, it_frzn, it_regi, iover_s,
c                                    is_anlz, is_clim, is_gros, is_dens,
c                                    is_spik, is_vis, is_cntv, is_salg,
c                                    is_jump, is_frzn, is_regi, 
c                                    is_anlza, is_clima, is_grosa, 
c                                    is_regia )
c                   05-May-09 (YHD - 'PSAL ADJUST [' kine in phy file case.
c                   04-Mar-09 (YHD - pressure2 and temperature2 introduced)
c                   23-Jun-08 (YHD - A 'ibad_pos' was introduced.)
c                   15-Apr-08 (YHD - Num_col is checked against data line)
c                   19-Feb-08 (YHD - 'ibad_phy' introduced to detect a bad phy
c                                     file)
c                   11-Jan-08 (YHD - Optode oxygen float information) 
c                   24-Oct-07 (YHD - 'trace' output modification)
c                   07-Feb-07 (YHD - Added 'PSAL_ADJST' case.)
c                   04-Jan-07 (YHD - Fool prof of reading the position lines.)
c                   23-Jan-06 (YHD - Recorder type '88' is changed to '64'(up)
c                                    or '65' (down) transit.
c                   20-Jan-06 (YHD - For profile, '000' case, ispd_flag is now
c                                    read properly.)
c                   11-Jan-06 (YHD - For iridium float, recorder type is now 
c                                    set to '88')
c                   15-Dec-05 (YHD - wmo_recorder type '99 (i.e.unknown)' case
c                   08-Jul-05 (YHD - phy file without the number of col case)
c                   14-Jun-05 (YHD - A bounce float is roduced.)
c                   28-Apr-05 (YHD - Do not count lat=99.999 and lon=999.999
c                                    line to icnt.)
c                   28-Mar-05 (YHD - nx is increased to 50 for drift p,t,s lis
c                                    ts)
c                   23-Mar-05 (YHD - Checking class equals '-' line got  
c                                    deleted when I switched from rd_palace.f
c                                    to rd_phy_qc.f)
c                   21-Mar-05 (YHD - A prof_num=0, positions with no data case
c                                     --> status=3)
c                   17-Mar-05 (YHD - "SALINITY GRADIENT FLAG" changed to 
c                   "VERTICAL GRADIENT CHECK_SFLAG" in QC output.)
c                   16-Feb-05 (YHD - 'POSITION ON LAND INDICATOR' line fixed)
c                   27-Jan-05 (YHD - iclass is now character)
c                   14-Jan-05 (YHD - 'ityp' is different from 'netcdf' version)
c                   30-Nov-04 (YHD - 'rd_phy_qc.f' created from rw_palace_qc.f
c                                     I need to come up with something more
c                                     flexible s/r for reading.)
c                   09-Jul-04 (YHD - 'DRIFT OXYGEN' line unit changed from
c                                     (ML/L) to (MICROMOL/KG))
c                   19-Apr-04 (YHD - change factor=1; oxygen unit changed from
c                       end if
c                         ml/l to micromol/kg)
c                   29-Dec-03 (YHD - TECH_PARAM_NAME: upper case & no blank)
c                   16-Dec-03 (YHD - 'max' changed to nmax and incrse to 2500)
c                   21-Jul-03 (YHD - Defined what lines from 'qc' are not
c                                    to store as technical items.)
c                   09-Jul-03 (YHD - Pass 'juld_qc' to main program and it
c                                    can have 'argo' or 'whoi' juld_qc.)
c                   19-May-03 (YHD - More than 2 drift pressure cases)
c                   09-May-03 (YHD - "POSITION_QC" is passed to main program
c                                    in 'whoi_pos_qc' for WHOI float.)
c                   08-May-03 (YHD - Reverse data when the recoder type=60 or
c                                    62 and prof_num .lt. 1000)
c                   04-Apr-03 (YHD - Do not skip -999.0 line for WHOI float)
c                   28-Feb-03 (YHD - "DATE_CREATION" & "JULD_QC" provided
c                                    for 'WHOI" floats)
c                   07-Feb-03 (YHD - s/r/ data_reverse.f not needed anymore;
c                                    check recorder_type(table 4770) to decide
c                   27-Jan-03 (YHD - At least 2 lines provided for the
c                                    positions)
c                   27-Jan-03 (YHD - every read statements handle 'err' case
c                   21-Jan-03 (YHD - read pres flag)
c                   24-Dec-02 (CS -  changed the way alat, alon, jul is
c                                    handled (missing 999.999 cases)
c                   18-Dec-02 (YHD - read line not depend on the 'num_col')
c                   12-Nov-02 (YHD - oxygen factor(=44.6596) added to drift
c                                    oxygen)
c                   08-Nov-02 (YHD - drift_o1,drif_o2 added)
c                   07-Nov-02 (YHD - oxygen parameter added)
c                   27-Aug-02 (YHD - writing qc from MATLAB is different
c                                    from writing qc from 'qc_t(s)'
c                   23-Jul-02 (YHD - st_trans_time added)
c                   16-Jul-02 (YHD - PALACE_TS1 case added)
c                   16-Jul-02 (YHD - num_col 17 case added)
c                   14-Jun-02 (YHD - nparam,tparam,t_value added)
c   
c     rd_phy.f
c     ===============
c     Reads a palace float "PHY" or "QC" file.
c     YHD, 10-29-2001
c
       subroutine rd_phy(iunit,int_num,wmo_num,trans_id,
     1  prof_num,file_num,inst_type,ireverse,whoi_c_date,
     2  juld_qc,
     3  wmo_inst,wmo_reco,argos_prg_num,pi,
     4  hasTemp, hasPsal, hasCond, hasO2, land,
     5  sur_prs,
     a  st_trans_time, st_trans_time_qc,
     b  ascent_end_time, ascent_end_time_qc,
     c  whoi_pos_qc,
     6  sigma_clim,sigma_anal,adate,
     7  n_drift,drift_t,drift_p,drift_s,drift_o,drift_c,
     8  nparam,t_param,t_value,
     9  num_col,column,num_cal,calib,
     *  ipres,ip_vis,ispd,cksm,
     1  icnt,alat_hist,alon_hist,itime_hist,iclass_hist,
     2  nlev,p,t,s,c,o,o2,ibad_phy,ibad_pos,
     3  type_ts32,p2,t2,ipres2,itemp2,
     4  pres_doxy2,
     5  pres_doxy2_qc,
     6  psal_adj_exist,s_adj,
     7  pres_adj_exist,p_adj,
     8    spd_table,most_likely_frame_status)
c     
c     iunit:     unit for reading
c     int_num:   internal id number
c     wmo_num:   wmo id
c     whoi_c_date: date that nc file was created by WHOI  --- WHOI float only
c     trans_id:  transmission id number
c     prof_num:  profile number
c     file_num:  file number (*.phy i.e. actual phy file profile number)
c     wmo_inst:  instrument type (table 1770)
c     wmo_reco:  recorder type (table 4770)
c     st_trans_time: start of transmission
c     nparam  : number of parameters for technical meta file
c     t_param : lists technical parameters
c     t_value : values of technical parameters
c     icnt    :  number of positions reported
c     alat_hist: latitudes of positions
c     alon_hist: longitudes of positions
c     itime_hist:year/mo/day/hour/min/sec
c     nlev:      number of data points
c     t:         temperature
c     s:         salinity
c     p:         pressure
c     cksm:      check-sum flag
c     ispd:      speed check flag 0:can't apply; 1:pass; 4:fail
c     hasTemp, hasPsal, hasCond, hasO2: has the phy file columns associated with temp? ...

      implicit none

      integer, parameter :: nmax = 2500
      integer, parameter :: nx = 50
      logical, parameter :: DEBUG_ON = .false. 
      integer, parameter :: DEBUG = 66         ! debug file handler.

      integer i,iunit,icnt,icnt_start,iyear,imon,iday,ihr,imin,isec,
     *        int_num,wmo_num,prof_num,n_drift,
     *        num_col,cksm(*),
     *        nlev,wmo_inst,wmo_reco,
     *        icksm(nmax),status,ispd,num_cal,
     *        icksm_col,ipres_col,icond_col,isal_col,itemp_col,
     *        ioxy_col,ioxy2_col,ibatt_col,
     *        ipvis_col,
     *        ios,lastnb,lnblnk,itcolum,argos_prg_num,
     *        nparam,const_t,const_s,
     *        icol_read, ireverse,lnb,ncnt,land,
     *        file_num,num_bounce(7),iboun_col
      logical :: hasTemp, hasPsal, hasCond, hasO2

      integer :: pres_incr_flag_col = 0 ! Which column is pressure increasing flag

      integer ip_vis(*), ipres(*)
      integer one_time

      ! vars and parameter related to surface pressure 
      !
      real :: sur_prs                  ! surface pressure value
      character(len=10) :: sur_prs_aux  ! auxiliar var. to validate surf press value
      real, parameter :: SUR_PRS_FILLVALUE = -999.00 ! fillvalue in case surf press
                                                     ! is not a real number.
      integer :: IO_result ! IO_result = 0 if all went OK in an IO operation


      real alat,alon,bot_tem,bot_prs,
     *     alon_hist(*),alat_hist(*),p(*),t(*),s(*),c(*),o(*),o2(*),
     *     bat,
     *     sigma_clim,sigma_anal,fill_value,
     *     factor,dummy(50,nmax),pres_check(nmax),
     *     drift_p(nx),drift_t(nx),drift_s(nx),drift_o(nx),
     *     drift_c(nx)

      character(len=6), parameter :: prg_sub = 'RD_PHY'
      character cline*256,cline1*256,column(*)*256,typ*3,
     *          calib(*)*256,itime_hist(*)*14,outqcfile*80,
     *          manual_qc_dir*29,inst_type*16,pi*64,whoi_c_date*14,
     *          trans_id*16,
     *          st_trans_time*19,st_trans_time_qc*1,
     *          ascent_end_time*19,ascent_end_time_qc*1,
     *          juld_qc*1,
     *          whoi_pos_qc*1,drift_line*256,pos_sys*3,
     *          iclass*2,iclass_hist(*)*2
      character bat_cpu*25,bat_pump*25,bat_cnt*25,
     *             bat_cur_sbe*25,prof_term*25
      character t_param(*)*32,t_value(*)*32
      character bounce*1

      double precision adate
      data     manual_qc_dir/'/b4/qc_test/uniras/visual_qc/'/
      data     fill_value/99999./
      data     factor /1.0/
      data     ncnt /0/

      data  itemp_col,isal_col,icond_col,ipres_col,icksm_col,
     *      ioxy_col,ioxy2_col,ibatt_col,
     *      ipvis_col, iboun_col/10*0/
c
c--- Fool prof reading the position lines case especially for B. Owens floats.
c  
      integer ll,mm,nn,jj,lchar_occur
     
      ! 
      ! Salinity adjusted related variables
      !
      logical :: psal_adj_exist  ! Salinity adjusted column in phy file?
      real    :: s_adj(*)        ! Salinity adjusted values
      integer :: sal_adj_col     ! Which column is salinity adjusted?

      ! 
      ! Pressure adjusted related variables
      !
      logical :: pres_adj_exist  ! Pressure adjusted column found in phy file?
      real    :: p_adj(*)        ! Pressure adjusted values
      integer :: pres_adj_col    ! Which column is salinity adjusted?


c
c--- For speed check flag.
c
      character spd_table*1
c
c--- Detect ill (bad) phy files case. 'ibad_phy' will be 1 in that case.
c
      integer ibad_phy
c
c--- Verify 'num_col' equals a number of columns read from a data line.
c
      integer ncol
      character(len=256) :: aline

      !
      ! For optode float (APEXIR_TSO3)
      character(len=1) :: optode = 'n'
      integer :: pres_doxy2_col, temp_doxy2_col
      real :: pres_doxy2(*) 
      integer :: pres_doxy2_qc(*) 

c
c--- Detect bad position (0.0,0.0) case. 'ibad_pos' will be 1 in that case.
c
      integer ibad_pos

c
c--- pressure2(sea surface pressure) and temperature2 introduced.
c
      integer ipres2_col,itemp2_col,ipres2(*),itemp2(*)
      real p2(*),t2(*)
      character type_ts32*1
      integer :: most_likely_frame_status ! Most Likely Frame Status
       most_likely_frame_status = 0

      !
      !  Initializations
      !
      ibad_phy=1               ! start by assuming this is a bad phy file
      ibad_pos=0               ! 
      psal_adj_exist=.false.   ! salinity adjusted column not found YET
      sal_adj_col=0            ! ... therefore sal adj. column = 0 so far
      pres_adj_exist=.false.   ! pressure adjusted column not found YET 
      pres_adj_col=0           ! ... therefore pres adj column = 0 so far
      st_trans_time='                   '   ! start of transmission time not found YET
      st_trans_time_qc='9'                  ! start of transmission time missing unless found
      ascent_end_time='                   ' ! initialize to blank
      ascent_end_time_qc='9'                ! end of ascent time missing unless found

      icnt_start=icnt+1

      ! Read header information.
      !
      num_col=0
      if (DEBUG_ON) then
        write(DEBUG,*)'<<<<< DEBUG from RD_PHY >>>>>'
      end if
      
 1    continue
      read(iunit,25,end=100,err=999) cline

      if (cline(1:11)=='INTERNAL ID') then
        read(cline(41:51),*,err=999)int_num    
      else if (cline(1:13)=='WMO ID NUMBER') then
        if (cline(46:47)=='  ') then
          read(cline(41:51),*,err=999) wmo_num
        else
          read(cline(41:51),*,err=999) wmo_num
        end if                    ! if (cline(46:47)=='  ') then
      else if (cline(1:15)=='TRANSMISSION ID') then
        read(cline(41:56),25,err=999) trans_id
      else if (cline(1:14)=='PROFILE NUMBER') then
        if (cline(42:42)=='-') then              ! bounce float
          bounce='y'
          prof_num=7                               ! always 7 bounces ?
        else
          read(cline(41:51),*,err=999) prof_num
        end if
      else if (cline(1:11)=='FILE NUMBER') then
        read(cline(41:51),*,err=999) file_num
      else if (cline(1:25)=='1ST BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(1)
      else if (cline(1:25)=='2ND BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(2)
      else if (cline(1:25)=='3RD BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(3)
      else if (cline(1:25)=='4TH BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(4)
      else if (cline(1:25)=='5TH BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(5)
      else if (cline(1:25)=='6TH BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(6)
      else if (cline(1:25)=='7TH BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(7)
      else if (cline(1:15)=='INSTRUMENT TYPE') then
        read(cline(41:56),25,err=999) inst_type
      else if (cline(1:3)=='PI ') then
        read(cline(41:80),25,err=999) pi
      else if (cline(1:18)=='POSITIONING SYSTEM') then
        read(cline(41:80),25,err=999) pos_sys
      else if (cline(1:19)=='DATE_CREATION OF NC') then
        read(cline(41:54),25,err=999) whoi_c_date
      else if (cline(1:7)=='JULD_QC') then
        read(cline(41:41),25,err=999) juld_qc
      else if (cline(1:11)=='POSITION_QC') then
        whoi_pos_qc=cline(41:41)
      else if (cline(1:20)=='ARGOS PROGRAM NUMBER') then
        read(cline(41:56),25,err=999) argos_prg_num
      else if (cline(1:10)=='WMO INSTRU') then
        read(cline(41:43),30,err=999) wmo_inst 
      else if (cline(1:10)=='WMO RECORD') then
        read(cline(41:42),41,err=999) wmo_reco
      else if (cline(1:23)=='START OF TRANSMISSION  ') then
        read(cline(41:59),25,err=999) st_trans_time
        if (st_trans_time_qc == '9') then
           st_trans_time_qc = '0' ! unevaluated SO FAR
        end if
      else if (cline(1:24)=='START OF TRANSMISSION QC') then
        read(cline(41:41),25,err=999) st_trans_time_qc
      else if (cline(1:21)=='TIME ASCENT END (YYYY') then
        read(cline(41:59),25,err=999) ascent_end_time
        if(ascent_end_time_qc == '9') then
           ascent_end_time_qc = '0' ! unevaluated SO FAR
        end if
      else if (cline(1:17)=='TIME ASCENT END QC') then
        read(cline(41:41),25,err=999) ascent_end_time_qc
      else if (cline(1:22)=='START SURFACE PRESSURE'.or.
     *         cline(1:16)=='SURFACE PRESSURE') then
        lnb=lnblnk(cline)
        read(cline(41:lnb), '(A10)', iostat=IO_result) sur_prs_aux
        sur_prs_aux = ADJUSTL( sur_prs_aux );
        read(sur_prs_aux, '(F10.2)', iostat=IO_result) sur_prs
        if (IO_result <> 0) then 
          ! It is not a number; therefore we will 
          ! make sur_prs = SUR_PRS_FILLVALUE
          sur_prs = SUR_PRS_FILLVALUE
        end if
      else if (cline(1:17)=='DRIFT TEMPERATURE') then
        ncnt=0
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
          if (drift_line(i:i)=='.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_t(i),i=1,ncnt)
        n_drift=ncnt
      else if (cline(1:15)=='DRIFT PRESSURE') then
        ncnt=0                ! set number of drift pressure to be zero
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
          if (drift_line(i:i)=='.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_p(i),i=1,ncnt)
        n_drift=ncnt
      else if (cline(1:20)=='DRIFT SALINITY (PSU)') then
        ncnt=0                ! set number of drift pressure to be zero
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
          if (drift_line(i:i)=='.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_s(i),i=1,ncnt)
        n_drift=ncnt
      else if (cline(1:12)=='DRIFT OXYGEN') then   ! (micromol/kg)
        ncnt=0                ! set number of drift pressure to be zero
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
           if (drift_line(i:i)=='.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_o(i),i=1,ncnt)
        do i=1,ncnt
          drift_o(i)=drift_o(i)*factor
        end do
        n_drift=ncnt
      else if (cline(1:26)=='DRIFT CONDUCTIVITY (MS/CM)') then
        ncnt=0                ! set number of drift conductivity to be zero
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
          if (drift_line(i:i)=='.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_c(i),i=1,ncnt)
        n_drift=ncnt
      else if (cline(1:28)=='POSITION LINE PREVIOUS CYCLE') then 
      else if (cline(1:24)=='MOST LIKELY FRAME STATUS') then
         read(cline(41:41),'(i1)',err=999) most_likely_frame_status
      else if (cline(1:17)=='NUMBER OF COLUMNS') then 
        read(cline(41:51),*,err=999) num_col
        !
        ! Read columns information.
        !
         
        do i = 1, num_col                
          read(iunit,25,end=100,err=999) cline
          column(i) = cline
        end do        

        !
        ! Read calib information.
        !
        i = 0
 5      read(iunit,26,end=100,err=998) cline1 ! calib line
        if (cline1(1:5)=='CALIB') then
          i=i+1
          calib(i) = cline1
          num_cal=i
          go to 5
        else

          !
          ! Decide which type of float is?
          !    
          typ=''
          hasTemp=.false.
          hasPsal=.false.
          hasCond=.false.
          hasO2=.false.
          itemp_col=0
          itemp2_col=0
          isal_col=0
          icond_col=0
          ipres_col=0
          ipres2_col=0
          ioxy_col=0
          ioxy2_col=0
          ibatt_col=0
          pres_doxy2_col=0
          temp_doxy2_col=0
          icol_read=0
          do i = 1, num_col
            if (column(i)(41:62)=='TEMPERATURE-90 (DEG C)') then
              hasTemp=.true.
              typ(1:1)='t'
              itemp_col=i
              icol_read=icol_read+1
            else if (column(i)(41:63)=='TEMPERATURE2-90 (DEG C)') then
              itemp2_col=i
              icol_read=icol_read+1
            else if (column(i)(41:54)=='SALINITY (PSU)') then
              hasPsal=.true.
              typ(2:2)='s'
              isal_col=i
              icol_read=icol_read+1
            else if (column(i)(41:59)=='PSAL_ADJUSTED (PSU)') then
              typ(2:2)='s'
              sal_adj_col=i
              icol_read=icol_read+1
              psal_adj_exist=.true.
            else if (column(i)(41:59)=='PRESSURE_ADJ (DBAR)') then
              pres_adj_col=i
              icol_read=icol_read+1
              pres_adj_exist=.true.
            else if (column(i)(41:48)=='CONDUCTI') then
              hasCond=.true.
              typ(3:3)='c'
              icond_col=i
              icol_read=icol_read+1
            else if (column(i)(41:55)=='PRESSURE (DBAR)') then
              ipres_col=i
              icol_read=icol_read+1
            else if (column(i)(41:56)=='PRESSURE2 (DBAR)') then
              ipres2_col=i
              icol_read=icol_read+1
            else if (column(i)(41:57)=='PRES_DOXY2 (DBAR)') then
              pres_doxy2_col=i                 
              icol_read=icol_read+1
            else if (column(i)(41:58)=='TEMP_DOXY2 (DEG C)') then        
              icol_read=icol_read+1
            else if (column(i)(41:48)=='CHECKSUM') then
              icksm_col=i
              icol_read=icol_read+1
            else if (column(i)(41:61)=='BOUNCE PROFILE NUMBER') then
              iboun_col=i
              icol_read=icol_read+1
            else if (column(i)(41:59)=='PRESSURE INCREASING') then
              pres_incr_flag_col=i
              icol_read=icol_read+1
            else if (column(i)(41:70)==
     *               'DISSOLVED OXYGEN (MICROMOL/KG)') then                         
              hasO2=.true.
              ioxy_col=i
              icol_read=icol_read+1
            else if (column(i)(41:71)==
     *               'DISSOLVED OXYGEN2 (MICROMOL/KG)') then
              ioxy2_col=i
              icol_read=icol_read+1
            else if (column(i)(41:54)=='BATTERY (VOLT)') then
              ibatt_col=i
              icol_read=icol_read+1
            else if (column(i)(41:67)=='CONSTANT VALUE CHECK_T FLAG') 
     *      then
              icol_read=icol_read+1
            else if (column(i)(41:67)=='CONSTANT VALUE CHECK_S FLAG') 
     *      then
              icol_read=icol_read+1
            else if (column(i)(41:56)=='VISUAL QC_P FLAG') then
              ipvis_col=i
              icol_read=icol_read+1
            else if (column(i)(41:57)=='PSAL_ADJUST GROSS') then
              icol_read=icol_read+1
            else if (column(i)(41:57)=='PSAL_ADJUST CLIMA') then
              icol_read=icol_read+1
            else if (column(i)(41:57)=='PSAL_ADJUST ANALY') then
              icol_read=icol_read+1
            else if (column(i)(41:56)=='PRES_DOXY (DBAR)') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:57)=='TEMP_DOXY (DEG C)') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:53)=='BPHASE_DOXY2') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:56)=='SIGMATHETA_DOXY') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:54)=='FREQUENCY_DOXY') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:51)=='BPHASE_DOXY') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:50)=='O2SAT_DOXY') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:65)=='NUMBER OF VALUES AVERAGED') then
              icol_read=icol_read+1
            end if
          end do  
          
          if (icol_read<>num_col) then
            write(6,*)'WARNING on reading column rd_phy.f'
            write(6,*)'A new column has been added.'
            write(6,*)'num_col=',num_col,' icol_read=',icol_read
          end if                 ! if (icol_read.ne.num_col) then
        end if                  ! if (cline1(1:5)=='CALIB') then

        if (itemp2_col>0.and.ipres2_col>0) type_ts32='y'
c
c --- PSAL ADJUST line.         ! 05-May-09 added
c
       if (cline1(1:13)=='PSAL ADJUST [') then
         read(iunit,25,end=100,err=999) cline1    ! reading land indicator
       end if
c
c --- Land indicator.
c
       if (cline1(1:26)=='POSITION ON LAND INDICATOR') then
        read(cline1(41:41),*,err=999) land
       end if
c
c --- Read lat/lon information.
c
        if (cline1(1:10)=='==========') then
          ibad_phy=0                            ! good phy file
          read(iunit,25,end=100,err=999) cline  ! Latitude Long.. line
          read(iunit,25,end=100,err=999) cline  ! +99.999 ... line
          if (cline(5:11).ne.'+99.999') go to 60 ! comment for netcdf
        else
c
c --- Read Overall flag and individual test flags.
c
          if (hasTemp .or. hasPsal .or. hasCond .or. hasO2) then
           if (cline1(1:13)=='MAXIMUM SPEED') then
             read(cline1(41:41),41,err=999) ispd
           end if
 133       read(iunit,25,end=100,err=999) cline
           lastnb=lnblnk(cline)
           if (cline(1:13)=='MAXIMUM SPEED') then
              read(cline(41:41),41,err=999) ispd
           end if
           if (cline(1:13)=='ANALYSIS TIME') then
               read(cline(53:67),'(f15.9)',err=999) adate
           end if
           if (cline(1:10).ne.'==========') go to 133
            ibad_phy=0
            read(iunit,25,end=100,err=999) cline  ! Latitude Long.. line
            read(iunit,25,end=100,err=999) cline  ! +99.999 ... line
            if (cline(5:11).ne.'+99.999') go to 60 ! comment when for netcdf
          end if                           ! if (hasTemp .or. hasPsal .or....
        end if                             ! if (cline1(1:10)=='====.....
 40     read(iunit,25,end=100,err=999) cline
        lastnb=lnblnk(cline)

 60     if (cline(1:10).ne. '==========') then
          ll=index(cline(1:11),'.')
          mm=lchar_occur(cline,'.')
          nn=lchar_occur(cline,'/')
          jj=lchar_occur(cline,':')
          lastnb=lnblnk(cline)

          read(cline(1:ll+3),37,err=999) alat
          read(cline(mm-4:mm+3),38,err=999) alon
          read(cline(nn-7:nn-4),30,err=999) iyear
          read(cline(nn-2:nn-1),41,err=999) imon
          read(cline(nn+1:nn+2),41,err=999) iday
          read(cline(jj-5:jj-4),41,err=999) ihr
          read(cline(jj-2:jj-1),41,err=999) imin
          read(cline(jj+1:jj+2),41,err=999) isec
          iclass=cline(lastnb-1:lastnb)
          if (cline(lastnb-1:lastnb-1)=='-') then ! bad position case 
            spd_table='F'
            if (alat>-0.0001.and.alat.lt.0.00001.and.
     *alon>-0.0001.and.alon.lt.0.00001) ibad_pos=1
            go to 40                        ! 27-Nov-2001
          end if
          if (alat>99.0.and.alon>999.0) then
          else
            icnt = icnt+ 1
            alon_hist(icnt) = alon
            alat_hist(icnt) = alat
            itime_hist(icnt) = cline(nn-7:nn-4)//cline(nn-2:nn-1)//
     *      cline(nn+1:nn+2)//cline(jj-5:jj-4)//cline(jj-2:jj-1)//
     *      cline(jj+1:jj+2)
            iclass_hist(icnt) = iclass
          end if
          go to 40
        else
          ibad_phy=1
        end if                   ! if (cline(1:10).ne. '==...
c        icnt = icnt - 1

c
c --- Read pres/tem/sal information.
c
        nlev=0
 50     continue
        nlev=nlev+1

        if (nlev==1) then
          read(iunit,25,end=100,err=993) aline
          write(6,*)aline
          call verify_num_col(aline,ncol)
          if (ncol.ne.num_col) then
            status=9
            write(6,*)prg_sub,': "ncol" from data line differs "num_col" 
     * from header.'
            write(6,*)prg_sub,': ncol=',ncol,' num_col=',num_col
            write(6,*)prg_sub,': STOP -> STATUS = ', status
            write(50,*)prg_sub,': "ncol" from data line differs "num_col" 
     * from header.'
            write(50,*)prg_sub,': ncol=',ncol,' num_col=',num_col
            write(50,*)prg_sub,': STOP -> STATUS = ', status
            call exit(status)
          end if
          backspace(iunit)   ! 
        end if

        read(iunit,*,end=100,err=993) (dummy(i,nlev),i=1,num_col)

c --- Do not skip -999.0 data line in 'WHOI' float
        do i=1,num_col
c          if (trans_id(1:4)=='WHOI'.and.dummy(i,nlev)==-999.0) then
c            write(6,*)'WHOI float with -999.0 in data line'
c            nlev=nlev-1
c            go to 50
c          end if                  ! if (trans_id(1:4).....
        end do                    ! do i=1,num_col
        if (nlev>nmax) then
          status=9
          write(50,*) prg_sub,': Data points are more than ',nmax
          write(50,*) prg_sub,': Increase a value nmax.'
          write(50,*) prg_sub,': STOP-> STATUS=',status
          call exit(status)
          stop '9'
        end if                    !  if (nlev>nmax) then
        go to 50

c
c --- Profile number '000' case.
c
      else if (cline(1:13)=='MAXIMUM SPEED') then
       read(cline(41:41),41,err=999) ispd
c       write(6,*)'rd_phy(prof=0): ispd=',ispd
      else if (cline(1:10)=='=========='.and.
     *        (prof_num==0.or.num_col==0)) then
        ibad_phy=0
        read(iunit,25,end=100,err=999) cline  ! Latitude Long.. line
        lastnb=lnblnk(cline)
        read(iunit,25,end=100,err=999) cline  ! 99.999 line
        lastnb=lnblnk(cline)
        if (cline(5:11).ne.'+99.999') go to 90
 80     read(iunit,25,end=100,err=999) cline
        lastnb=lnblnk(cline)

 90     if (cline(1:10).ne. '==========') then
          ll=index(cline(1:11),'.')
          mm=lchar_occur(cline,'.')
          nn=lchar_occur(cline,'/')
          jj=lchar_occur(cline,':')
          lastnb=lnblnk(cline)

          read(cline(1:ll+3),37,err=999) alat
          read(cline(mm-4:mm+3),38,err=999) alon
          read(cline(nn-7:nn-4),30,err=999) iyear
          read(cline(nn-2:nn-1),41,err=999) imon
          read(cline(nn+1:nn+2),41,err=999) iday
          read(cline(jj-5:jj-4),41,err=999) ihr
          read(cline(jj-2:jj-1),41,err=999) imin
          read(cline(jj+1:jj+2),41,err=999) isec
          iclass=cline(lastnb-1:lastnb)
          if (cline(lastnb-1:lastnb-1)=='-') then ! bad position case;
             spd_table='F'
             if (alat>-0.0001.and.alat.lt.0.00001.and.
     *alon>-0.0001.and.alon.lt.0.00001) ibad_pos=1
             go to 80                      ! 27-Nov-2001
          end if
          if (alat>99.0.and.alon>999.0) then
          else
            icnt = icnt+ 1
            alon_hist(icnt) = alon
            alat_hist(icnt) = alat
            itime_hist(icnt) = cline(nn-7:nn-4)//cline(nn-2:nn-1)//
     *      cline(nn+1:nn+2)//cline(jj-5:jj-4)//cline(jj-2:jj-1)//
     *      cline(jj+1:jj+2)
            iclass_hist(icnt) = iclass
          end if
          go to 80
        end if                 ! if (cline(1:10).ne. '==========') then
        close (iunit)
        one_time=one_time+1
        return
      else
        nparam=nparam+1
        read(cline(41:73),25,err=999) t_value(nparam)
        do i=1,31
         if (cline(i:i)==' '.and.cline(i+1:i+1).ne.' ') cline(i:i)='_'
        end do
        t_param(nparam)=cline(1:32)    
c        go to 1                   ! read next line
      end if                       ! if (cline(1:11)=='INTERNAL ID') then
      go to 1
 100  continue                     ! end of "phy" or "qc" file
      nlev=nlev-1

c     write(6,*)'End of file.'

      !
      ! Reverse the pres, sal, and tem, cndc, flag values if data was collected
      ! while the float is coming up; otherwise leave them as they are.
      !
      do i = 1, nlev
        pres_check(i)=dummy(ipres_col,i)
      end do  

      !
      ! Iridium float has a recorder type, 99 just like recording data on upward.
      !
      if ((wmo_reco==60 .or. wmo_reco==62 .or. wmo_reco==64) .and.
     *    prof_num<1000) ireverse=1    ! YES reverse
      if (wmo_reco==61 .or. wmo_reco==63  .or. wmo_reco==65) 
     *                   ireverse=0    ! NO  reverse

      lastnb=lnblnk(trans_id)
      if (ireverse<>0 .and. ireverse<>1 ) then
        write(6,*) 'Warning!!! Unknown case',ireverse
      end if                      
      
      if (ireverse==1) then     ! YES reverse
        do i = 1, nlev
          if (ipres_col>0) p(nlev-i+1) = dummy(ipres_col,i)
          if (ipres2_col>0) p2(nlev-i+1) = dummy(ipres2_col,i)
          if (pres_doxy2_col>0) then
            pres_doxy2(nlev-i+1) = dummy(pres_doxy2_col,i)
          end if
          if (pres_adj_exist) then
            p_adj(nlev-i+1) = dummy(pres_adj_col,i)
          end if 
          if (itemp_col>0) t(nlev-i+1) = dummy(itemp_col,i)
          if (itemp2_col>0) t2(nlev-i+1) = dummy(itemp2_col,i)
          if (isal_col>0) s(nlev-i+1) = dummy(isal_col,i)
          if (sal_adj_col>0) s_adj(nlev-i+1)=dummy(sal_adj_col,i)
          if (icond_col>0) c(nlev-i+1) = dummy(icond_col,i)
          if (ioxy_col>0) o(nlev-i+1) = dummy(ioxy_col,i)*factor 
          if (ioxy2_col>0) o2(nlev-i+1) = dummy(ioxy_col,i)*factor 
          ! conversion for ml/l to mmols/m**3
          if (icksm_col>0) cksm(nlev-i+1) = dummy(icksm_col,i)
          if (pres_incr_flag_col>0) then
            ipres(nlev-i+1)=dummy(pres_incr_flag_col,i)
          end if
          if (ipvis_col>0) ip_vis(nlev-i+1)=dummy(ipvis_col,i)
        end do
      else                  ! NO reverse 
        do i = 1, nlev
          if (ipres_col>0) p(i) = dummy(ipres_col,i)
          if (ipres2_col>0) p2(i) = dummy(ipres2_col,i)
          if (pres_doxy2_col>0) then
            pres_doxy2(i) = dummy(pres_doxy2_col,i)
          end if
          if (pres_adj_exist) then
            p_adj(i) = dummy(pres_adj_col,i)
          end if 
          if (itemp_col>0) t(i) = dummy(itemp_col,i)
          if (itemp2_col>0) t2(i) = dummy(itemp2_col,i)
          if (isal_col>0) s(i) = dummy(isal_col,i)
          if (icond_col>0) c(i) = dummy(icond_col,i)
          if (ioxy_col>0) o(i) = dummy(ioxy_col,i)*factor 
          if (ioxy2_col>0) o(i) = dummy(ioxy2_col,i)*factor 
          ! conversion for ml/l to mmols/m**3
          if (icksm_col>0) cksm(i) = dummy(icksm_col,i)
          if (pres_incr_flag_col>0) then
            ipres(i)=dummy(pres_incr_flag_col,i)
          end if
          if (ipvis_col>0) ip_vis(i)=dummy(ipvis_col,i)
        end do                   ! do i = 1, nlev
      end if                     ! if (ireverse==1) then
      bot_tem=t(nlev)
      bot_prs=p(nlev)
 120  close (iunit)

c
c--- Making sure that the last line in the position is 99.999 999.999 line.
c
c      if (alat_hist(icnt).le.90 .or. icnt==icnt_start) then
c         icnt=icnt+1
c         alon_hist(icnt) = 999.999
c         alat_hist(icnt) = 99.999
c         itime_hist(icnt) = itime_hist(icnt-1)
c         iclass_hist(icnt) = '0'
c      endif                      ! if (alat_hist(icnt).le.90 .or. icnt.e...
      go to 1000
 25   format(a)
 26   format(a256)
 30   format(i4)
 37   format(f11.3)
 38   format(f8.3)
 41   format(i2)
 42   format(f5.2)
 111  format(1x,'This dataset needs to reverse ---> ',
     *i4.4,'_',a,'_',i3.3)
 112  format(1x,'This dataset needs NO reverse ---> ',
     *i4.4,'_',a,'_',i3.3)
 993  write(6,*)'Reading rd_phy.f(read dummy) error=993'
      write(50,*)'Reading rd_phy.f(read dummy) error=993'
      status=9
      call exit(status)
 998  write(6,*)'Reading rd_phy.f error=998 --->',cline1(1:80)
      write(50,*)'Reading rd_phy.f error=998 --->',cline1(1:80)
      status=9
      call exit(status)
 999  write(6,*)'Reading rd_phy.f error=999 --->',cline(1:80)
      write(50,*)'Reading rd_phy.f error=999 --->',cline(1:80)
      status=9
      call exit(status)
 1000 continue
      close (iunit)
      one_time=one_time+1
      return
      end 
