c------------------------------------------------------------------- 
c     Revised date: 04-Jan-13 VMH  - Increase cline to 256 chars
c                   14-Aug-12 VMH  - Add vars st_trans_time_qc and 
c                                    ascent_end_time_qc
c                   16-May-11 (ER  - Variable ityp replaced by hasTemp, 
c                                    hasPsal, hasCond, hasO2
c                   16-Jul-10 (ER  - Changes dealing with surface 
c                                 pressure = null
c                   16-Mar-10 (ER  - Added treatment of pres adjusted
c                                    column )
c                   03-Mar-10 (ER  - Add Number of Values Adjusted columm
c                                    for some Iridium floats )
c                   05-May-09 (YHD - 'PSAL ADJUST [' kine in phy file case.
c                   04-Mar-09 (YHD - pressure2 and temperature2 introduced)
c                   23-Jun-08 (YHD - A 'ibad_pos' was introduced.)
c                   15-Apr-08 (YHD - Num_col is checked against data line)
c                   19-Feb-08 (YHD - 'ibad_phy' introduced to detect a bad phy
c                                     file)
c                   11-Jan-08 (YHD - Optode oxygen float information) 
c                   24-Oct-07 (YHD - 'trace' output modification)
c                   07-Feb-07 (YHD - Added 'PSAL_ADJST' case.)
c                   04-Jan-07 (YHD - Fool prof of reading the position lines.)
c                   23-Jan-06 (YHD - Recorder type '88' is changed to '64'(up)
c                                    or '65' (down) transit.
c                   20-Jan-06 (YHD - For profile, '000' case, ispd_flag is now
c                                    read properly.)
c                   11-Jan-06 (YHD - For iridium float, recorder type is now 
c                                    set to '88')
c                   15-Dec-05 (YHD - wmo_recorder type '99 (i.e.unknown)' case
c                   08-Jul-05 (YHD - phy file without the number of col case)
c                   14-Jun-05 (YHD - A bounce float is roduced.)
c                   28-Apr-05 (YHD - Do not count lat=99.999 and lon=999.999
c                                    line to icnt.)
c                   28-Mar-05 (YHD - nx is increased to 50 for drift p,t,s lis
c                                    ts)
c                   23-Mar-05 (YHD - Checking class equals '-' line got  
c                                    deleted when I switched from rd_palace.f
c                                    to rd_phy_qc.f)
c                   21-Mar-05 (YHD - A prof_num=0, positions with no data case
c                                     --> status=3)
c                   17-Mar-05 (YHD - "SALINITY GRADIENT FLAG" changed to 
c                   "VERTICAL GRADIENT CHECK_SFLAG" in QC output.)
c                   16-Feb-05 (YHD - 'POSITION ON LAND INDICATOR' line fixed)
c                   27-Jan-05 (YHD - iclass is now character)
c                   14-Jan-05 (YHD - 'ityp' is different from 'netcdf' version)
c                   30-Nov-04 (YHD - 'rd_phy_qc.f' created from rw_palace_qc.f
c                                     I need to come up with something more
c                                     flexible s/r for reading.)
c                   09-Jul-04 (YHD - 'DRIFT OXYGEN' line unit changed from
c                                     (ML/L) to (MICROMOL/KG))
c                   19-Apr-04 (YHD - change factor=1; oxygen unit changed from
c                       end if
c                         ml/l to micromol/kg)
c                   29-Dec-03 (YHD - TECH_PARAM_NAME: upper case & no blank)
c                   16-Dec-03 (YHD - 'max' changed to nmax and incrse to 2500)
c                   21-Jul-03 (YHD - Defined what lines from 'qc' are not
c                                    to store as technical items.)
c                   09-Jul-03 (YHD - Pass 'juld_qc' to main program and it
c                                    can have 'argo' or 'whoi' juld_qc.)
c                   19-May-03 (YHD - More than 2 drift pressure cases)
c                   09-May-03 (YHD - "POSITION_QC" is passed to main program
c                                    in 'whoi_pos_qc' for WHOI float.)
c                   08-May-03 (YHD - Reverse data when the recoder type=60 or
c                                    62 and prof_num .lt. 1000)
c                   04-Apr-03 (YHD - Do not skip -999.0 line for WHOI float)
c                   28-Feb-03 (YHD - "DATE_CREATION" & "JULD_QC" provided
c                                    for 'WHOI" floats)
c                   07-Feb-03 (YHD - s/r/ data_reverse.f not needed anymore;
c                                    check recorder_type(table 4770) to decide
c                   27-Jan-03 (YHD - At least 2 lines provided for the
c                                    positions)
c                   27-Jan-03 (YHD - every read statements handle 'err' case
c                   21-Jan-03 (YHD - read pres flag)
c                   24-Dec-02 (CS -  changed the way alat, alon, jul is
c                                    handled (missing 999.999 cases)
c                   18-Dec-02 (YHD - read line not depend on the 'num_col')
c                   12-Nov-02 (YHD - oxygen factor(=44.6596) added to drift
c                                    oxygen)
c                   08-Nov-02 (YHD - drift_o1,drif_o2 added)
c                   07-Nov-02 (YHD - oxygen parameter added)
c                   27-Aug-02 (YHD - writing qc from MATLAB is different
c                                    from writing qc from 'qc_t(s)'
c                   23-Jul-02 (YHD - st_trans_time added)
c                   16-Jul-02 (YHD - PALACE_TS1 case added)
c                   16-Jul-02 (YHD - num_col 17 case added)
c                   14-Jun-02 (YHD - nparam,tparam,t_value added)
c   
c     rd_qc.f
c     ===============
c     Reads a QC file.
c     YHD, 10-29-2001
c
       subroutine rd_qc(iunit,int_num,wmo_num,trans_id,
     1  prof_num,file_num,inst_type,ireverse,whoi_c_date,
     2  juld_qc,
     3  wmo_inst,wmo_reco,argos_prg_num,pi,
     4  hasTemp, hasPsal, hasCond, hasO2, land,
     4  sur_prs,
     a  st_trans_time, st_trans_time_qc,
     b  ascent_end_time, ascent_end_time_qc,
     c  whoi_pos_qc,
     5  sigma_clim,sigma_anal,adate,
     6  n_drift, drift_t, drift_p, drift_s, drift_o, drift_c,
     7  nparam, t_param, t_value,
     8  num_col, column, num_cal, calib,
     9  iover_t, it_anlz, it_clim, it_gros, it_vert,
     *  it_spik, it_vis, it_cntv,
     a  it_jump,it_frzn,it_regi,
     b  iover_s, is_anlz, is_clim, is_gros, is_dens, 
     c  is_spik, is_vis, is_cntv,
     d  is_salg, is_jump, is_frzn, is_regi,
     e  ipres, ip_vis, ispd, cksm,
     f  icnt, alat_hist, alon_hist, itime_hist, iclass_hist,
     g  nlev, p, t, s, c, o, o2,
     h  ibad_phy, ibad_pos,
     i  type_ts32, p2, t2, ipres2, itemp2,
     j  spd_table)
c     
c     iunit:     unit for reading
c     int_num:   internal id number
c     wmo_num:   wmo id
c     whoi_c_date: date that nc file was created by WHOI  --- WHOI float only
c     trans_id:  transmission id number
c     prof_num:  profile number
c     file_num:  file number (*.phy i.e. actual phy file profile number)
c     wmo_inst:  instrument type (table 1770)
c     wmo_reco:  recorder type (table 4770)
c     st_trans_time: start of transmission
c     nparam  : number of parameters for technical meta file
c     t_param : lists technical parameters
c     t_value : values of technical parameters
c     icnt    :  number of positions reported
c     alat_hist: latitudes of positions
c     alon_hist: longitudes of positions
c     itime_hist:year/mo/day/hour/min/sec
c     nlev:      number of data points
c     t:         temperature
c     s:         salinity
c     p:         pressure
c     cksm:      check-sum flag
c     ispd:      speed check flag 0:can't apply; 1:pass; 4:fail
c     hasTemp, hasPsal, hasCond, hasO2: has the qc file columns associated with temp? ...

      implicit none

      integer, parameter :: nmax = 2500
      integer, parameter :: nx = 50
      logical, parameter :: DEBUG_ON = .false. 
      integer, parameter :: DEBUG = 66         ! debug file handler.

      integer i,iunit,icnt,icnt_start,iyear,imon,iday,ihr,imin,isec,
     *        int_num,wmo_num,prof_num,n_drift,
     *        num_col,cksm(*),
     *        nlev,wmo_inst,wmo_reco,
     *        icksm(nmax),status,ispd,num_cal,
     *        icksm_col,ipres_col,icond_col,isal_col,itemp_col,
     *        ioxy_col,
     *        ioxy2_col,ibatt_col,isdens_col,itspik_col,isspik_col,
     *        itgros_col,isgros_col,itclim_col,isclim_col,ipvis_col,
     *        itanlz_col,isanlz_col,itvis_col,isvis_col,itvert_col,
     *        itregi_col,isregi_col,issalg_col,
     *        ideep_col,itjump_col,isjump_col,
     *        ios,lastnb,lnblnk,itcolum,argos_prg_num,
     *        nparam,const_t,const_s,
     *        icol_read,ipres_flag_col,ireverse,lnb,ncnt,land,
     *        file_num,num_bounce(7),iboun_col
      logical :: hasTemp, hasPsal, hasCond, hasO2

      integer iover_t,it_anlz(*),it_clim(*),it_gros(*),it_vert(*),
     *        it_vis(*),it_spik(*),it_cntv,ip_vis(*),it_jump(*),
     *        it_frzn,it_regi(*),
     *        iover_s,is_anlz(*),is_clim(*),is_gros(*),is_dens(*),
     *        is_vis(*),is_spik(*),is_cntv,ipres(*),is_jump(*),
     *        is_frzn,is_salg(*),is_regi(*)
      integer one_time

      ! vars and parameter related to surface pressure 
      !
      real :: sur_prs                  ! surface pressure value
      character(len=10) :: sur_prs_aux  ! auxiliar var. to validate surf press value
      real, parameter :: SUR_PRS_FILLVALUE = -999.00 ! fillvalue in case surf press
                                                     ! is not a real number.
      integer :: IO_result ! IO_result = 0 if all went OK in an IO operation
      real    alat,alon,bot_tem,bot_prs,
     *        alon_hist(*),alat_hist(*),p(*),t(*),s(*),c(*),o(*),o2(*),
     *        bat,
     *        sigma_clim,sigma_anal,fill_value,
     *        factor,dummy(50,nmax),pres_check(nmax),
     *        drift_p(nx),drift_t(nx),drift_s(nx),drift_o(nx),
     *        drift_c(nx)

      character(len=5), parameter :: prg_sub = 'RD_QC'
      character cline*256,cline1*256,column(*)*256,typ*3,
     *          calib(*)*256,itime_hist(*)*14,outqcfile*80,
     *          manual_qc_dir*29,inst_type*16,pi*64,whoi_c_date*14,
     *          trans_id*16,
     *          st_trans_time*19,st_trans_time_qc*1,
     *          ascent_end_time*19,ascent_end_time_qc*1,
     *          juld_qc*1,
     *          whoi_pos_qc*1,drift_line*256,pos_sys*3,
     *          iclass*2,iclass_hist(*)*2
      character bat_cpu*25,bat_pump*25,bat_cnt*25,
     *             bat_cur_sbe*25,prof_term*25
      character t_param(*)*32,t_value(*)*32
      character bounce*1

      double precision adate
      data     manual_qc_dir/'/b4/qc_test/uniras/visual_qc/'/
      data     fill_value/99999./
      data     factor /1.0/
      data     ncnt /0/

      data  itemp_col,isal_col,icond_col,ipres_col,icksm_col,
     *  ipres_flag_col, ioxy_col, ioxy2_col, 
     *  ibatt_col,itgros_col,
     *  isgros_col,itvert_col,isdens_col,itspik_col,
     *  isspik_col,itanlz_col,isanlz_col,itclim_col,
     *  isclim_col,itvis_col,isvis_col,ipvis_col,ideep_col,
     *  itjump_col,isjump_col,iboun_col/26*0/
c
c--- Fool prof reading the position lines case especially for B. Owens floats.
c  
      integer ll,mm,nn,jj,lchar_occur

c
c--- For speed check flag.
c
      character spd_table*1
c
c--- Detect ill (bad) phy files case. 'ibad_phy' will be 1 in that case.
c
      integer ibad_phy
c
c--- Verify 'num_col' equals a number of columns read from a data line.
c
      integer ncol
      character(len=256) :: aline
c
c--- For optode float (APEXIR_TSO3)
c
      character optode*1
      data optode /'n'/
c
c--- Detect bad position (0.0,0.0) case. 'ibad_pos' will be 1 in that case.
c
      integer ibad_pos

c
c--- pressure2(sea surface pressure) and temperature2 introduced.
c
      integer ipres2_col,itemp2_col,ipres2(*),itemp2(*)
      real p2(*),t2(*)
      character type_ts32*1

      ibad_phy=1               ! initialize as bad phy file
      ibad_pos=0               ! inilialize
      
      icnt_start=icnt+1
c
c---Read header information.
c
      num_col=0
      if (DEBUG_ON) write(66,*)'<<<<< DEBUG from RD_QC >>>>>'
      st_trans_time='                   '      ! initialize 
      st_trans_time_qc='9'                     ! missing unless found
      ascent_end_time='                   '    ! initialize
      ascent_end_time_qc='9'                   ! missing unless found

 1    continue
      read(iunit,25,end=100,err=999) cline

      if (cline(1:11).eq.'INTERNAL ID') then
        read(cline(41:51),*,err=999)int_num    
      else if (cline(1:13).eq.'WMO ID NUMBER') then
        if (cline(46:47).eq.'  ') then
          read(cline(41:51),*,err=999) wmo_num
        else
          read(cline(41:51),*,err=999) wmo_num
        end if                    ! if (cline(46:47).eq.'  ') then
      else if (cline(1:15).eq.'TRANSMISSION ID') then
        read(cline(41:56),25,err=999) trans_id
      else if (cline(1:14).eq.'PROFILE NUMBER') then
        if (cline(42:42).eq.'-') then              ! bounce float
          bounce='y'
          prof_num=7                               ! always 7 bounces ?
        else
          read(cline(41:51),*,err=999) prof_num
        end if
      else if (cline(1:11).eq.'FILE NUMBER') then
        read(cline(41:51),*,err=999) file_num
      else if (cline(1:25).eq.'1ST BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(1)
      else if (cline(1:25).eq.'2ND BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(2)
      else if (cline(1:25).eq.'3RD BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(3)
      else if (cline(1:25).eq.'4TH BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(4)
      else if (cline(1:25).eq.'5TH BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(5)
      else if (cline(1:25).eq.'6TH BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(6)
      else if (cline(1:25).eq.'7TH BOUNCE PROFILE LENGTH') then
        read(cline(41:51),*,err=999) num_bounce(7)
      else if (cline(1:15).eq.'INSTRUMENT TYPE') then
        read(cline(41:56),25,err=999) inst_type
      else if (cline(1:3).eq.'PI ') then
        read(cline(41:80),25,err=999) pi
      else if (cline(1:18).eq.'POSITIONING SYSTEM') then
        read(cline(41:80),25,err=999) pos_sys
      else if (cline(1:19).eq.'DATE_CREATION OF NC') then
c        nparam=nparam+1
        read(cline(41:54),25,err=999) whoi_c_date
c        read(cline(41:73),25,err=999) t_value(nparam)
c        t_param(nparam)='DATE_CREATION OF NC'
      else if (cline(1:7).eq.'JULD_QC') then
        read(cline(41:41),25,err=999) juld_qc
      else if (cline(1:11).eq.'POSITION_QC') then
        whoi_pos_qc=cline(41:41)
      else if (cline(1:20).eq.'ARGOS PROGRAM NUMBER') then
        read(cline(41:56),25,err=999) argos_prg_num
      else if (cline(1:10).eq.'WMO INSTRU') then
        read(cline(41:43),30,err=999) wmo_inst 
      else if (cline(1:10).eq.'WMO RECORD') then
        read(cline(41:42),41,err=999) wmo_reco
      else if (cline(1:23).eq.'START OF TRANSMISSION  ') then
        read(cline(41:59),25,err=999) st_trans_time
        if (st_trans_time_qc == '9') then
           st_trans_time_qc = '0' ! unevaluated SO FAR
        end if
      else if (cline(1:24)=='START OF TRANSMISSION QC') then
        read(cline(41:41),25,err=999) st_trans_time_qc
      else if (cline(1:21)=='TIME ASCENT END (YYYY') then
        read(cline(41:59),25,err=999) ascent_end_time
        if(ascent_end_time_qc == '9') then
           ascent_end_time_qc = '0' ! unevaluated SO FAR
        end if
      else if (cline(1:17)=='TIME ASCENT END QC') then
        read(cline(41:41),25,err=999) ascent_end_time_qc
      else if (cline(1:22).eq.'START SURFACE PRESSURE'.or.
     *         cline(1:16).eq.'SURFACE PRESSURE') then
        lnb=lnblnk(cline)
        read(cline(41:lnb), '(A10)', iostat=IO_result) sur_prs_aux
        sur_prs_aux = ADJUSTL( sur_prs_aux );
        read(sur_prs_aux, '(F10.2)', iostat=IO_result) sur_prs
        if (IO_result <> 0) then 
          ! It is not a number; therefore we will 
          ! make sur_prs = SUR_PRS_FILLVALUE
          sur_prs = SUR_PRS_FILLVALUE
        end if
      else if (cline(1:17).eq.'DRIFT TEMPERATURE') then
        ncnt=0
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
          if (drift_line(i:i).eq.'.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_t(i),i=1,ncnt)
        n_drift=ncnt
      else if (cline(1:15).eq.'DRIFT PRESSURE') then
        ncnt=0                ! set number of drift pressure to be zero
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
          if (drift_line(i:i).eq.'.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_p(i),i=1,ncnt)
        n_drift=ncnt
      else if (cline(1:20).eq.'DRIFT SALINITY (PSU)') then
        ncnt=0                ! set number of drift pressure to be zero
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
          if (drift_line(i:i).eq.'.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_s(i),i=1,ncnt)
        n_drift=ncnt
c      else if (cline(1:19).eq.'DRIFT OXYGEN (ML/L)') then
      else if (cline(1:12).eq.'DRIFT OXYGEN') then   ! (micromol/kg)
        ncnt=0                ! set number of drift pressure to be zero
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
           if (drift_line(i:i).eq.'.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_o(i),i=1,ncnt)
        do i=1,ncnt
          drift_o(i)=drift_o(i)*factor
        end do
        n_drift=ncnt
      else if (cline(1:26).eq.'DRIFT CONDUCTIVITY (MS/CM)') then
        ncnt=0                ! set number of drift conductivity to be zero
        read(cline(41:256),25,err=999) drift_line
        lnb=lnblnk(drift_line)
        do i=1,lnb
          if (drift_line(i:i).eq.'.') ncnt=ncnt+1
        end do
        read(cline(41:256),*,err=999) (drift_c(i),i=1,ncnt)
        n_drift=ncnt
      else if (cline(1:28).eq.'POSITION LINE PREVIOUS CYCLE') then 
      else if (cline(1:17).eq.'NUMBER OF COLUMNS') then 
        read(cline(41:51),*,err=999) num_col
c
c --- Read column information.
c
        do i = 1, num_col                
          read(iunit,25,end=100,err=999) cline
          lastnb=lnblnk(cline)
          column(i) = cline
        end do                                ! do i = 1, num_col
c
c --- Read calib information.
c
        i = 0
 5      read(iunit,26,end=100,err=998) cline1 ! calib line
        lastnb=lnblnk(cline1)
        if (cline1(1:5).eq.'CALIB') then
          i=i+1
          calib(i) = cline1
          num_cal=i
          go to 5
        else
          !
          ! Which type of float is?
          !
          typ=''
          hasTemp=.false.
          hasPsal=.false.
          hasCond=.false.
          hasO2=.false.
          itemp_col=0
          itemp2_col=0
          isal_col=0
          icond_col=0
          ipres_col=0
          ipres2_col=0
          ioxy_col=0
          ioxy2_col=0
          ibatt_col=0
          icol_read=0
          itgros_col=0
          isgros_col=0
          itvert_col=0
          isdens_col=0
          itspik_col=0
          isspik_col=0
          itvis_col=0
          isvis_col=0
          itclim_col=0
          isclim_col=0
          itanlz_col=0
          isanlz_col=0
          do i = 1, num_col
            if (column(i)(41:62).eq.'TEMPERATURE-90 (DEG C)') then
              typ(1:1)='t'
              hasTemp=.true.
              itemp_col=i
              icol_read=icol_read+1
            else if (column(i)(41:63).eq.'TEMPERATURE2-90 (DEG C)') then
              itemp2_col=i
              icol_read=icol_read+1
            else if (column(i)(41:54).eq.'SALINITY (PSU)') then
              typ(2:2)='s'
              hasPsal=.true.
              isal_col=i
              icol_read=icol_read+1
            else if (column(i)(41:59).eq.'PSAL_ADJUSTED (PSU)') then
              typ(2:2)='s'
              icol_read=icol_read+1
            else if (column(i)(41:48).eq.'CONDUCTI') then
              typ(3:3)='c'
              hasCond=.true.
              icond_col=i
              icol_read=icol_read+1
            else if (column(i)(41:55).eq.'PRESSURE (DBAR)') then
              ipres_col=i
              icol_read=icol_read+1
            else if (column(i)(41:56).eq.'PRESSURE2 (DBAR)') then
              ipres2_col=i
              icol_read=icol_read+1
            else if (column(i)(41:48).eq.'CHECKSUM') then
              icksm_col=i
              icol_read=icol_read+1
            else if (column(i)(41:61).eq.'BOUNCE PROFILE NUMBER') then
              iboun_col=i
              icol_read=icol_read+1
            else if (column(i)(41:59).eq.'PRESSURE INCREASING') then
              ipres_flag_col=i
              icol_read=icol_read+1
            else if (column(i)(41:70)==
     *        'DISSOLVED OXYGEN (MICROMOL/KG)') then
              ioxy_col=i
              hasO2=.true.
              icol_read=icol_read+1    
            else if (column(i)(41:71)==
     *        'DISSOLVED OXYGEN2 (MICROMOL/KG)') then
              ioxy2_col=i
              icol_read=icol_read+1
            else if (column(i)(41:54).eq.'BATTERY (VOLT)') then
              ibatt_col=i
              icol_read=icol_read+1
            else if (column(i)(41:58).eq.'GROSS CHECK_T FLAG') then
              itgros_col=i
              icol_read=icol_read+1
            else if (column(i)(41:58).eq.'GROSS CHECK_S FLAG') then
              isgros_col=i
              icol_read=icol_read+1
            else if (column(i)(41:65).eq.'VERTICAL GRADIENT CHECK_T') 
     *      then
              itvert_col=i
              icol_read=icol_read+1
            else if (column(i)(41:56).eq.'DENSITY GRADIENT') then
              isdens_col=i
              icol_read=icol_read+1
            else if (column(i)(41:58).eq.'SPIKE CHECK_T FLAG') then
              itspik_col=i
              icol_read=icol_read+1
            else if (column(i)(41:58).eq.'SPIKE CHECK_S FLAG') then
              isspik_col=i
              icol_read=icol_read+1
            else if (column(i)(41:61).eq.'ANALYSIS CHECK_T FLAG') then
              itanlz_col=i
              icol_read=icol_read+1
            else if (column(i)(41:61).eq.'ANALYSIS CHECK_S FLAG') then
              isanlz_col=i
              icol_read=icol_read+1
            else if (column(i)(41:64).eq.'CLIMATOLOGY CHECK_T FLAG') 
     *      then
              itclim_col=i
              icol_read=icol_read+1
            else if (column(i)(41:64).eq.'CLIMATOLOGY CHECK_S FLAG') 
     *      then
              isclim_col=i
              icol_read=icol_read+1
            else if (column(i)(41:67).eq.'CONSTANT VALUE CHECK_T FLAG') 
     *      then
              icol_read=icol_read+1
            else if (column(i)(41:67).eq.'CONSTANT VALUE CHECK_S FLAG') 
     *      then
              icol_read=icol_read+1
            else if (column(i)(41:56).eq.'VISUAL QC_T FLAG') then
              itvis_col=i
              icol_read=icol_read+1
            else if (column(i)(41:56).eq.'VISUAL QC_S FLAG') then
              isvis_col=i
              icol_read=icol_read+1
            else if (column(i)(41:56).eq.'VISUAL QC_P FLAG') then
              ipvis_col=i
              icol_read=icol_read+1
            else if (column(i)(41:62).eq.'DEEPEST PRESSURE CHECK') then
              ideep_col=i
              icol_read=icol_read+1
            else if (column(i)(41:52).eq.'JUMP CHECK_T') then
              itjump_col=i
              icol_read=icol_read+1
            else if (column(i)(41:52).eq.'JUMP CHECK_S') then
              isjump_col=i
              icol_read=icol_read+1
            else if (column(i)(41:54).eq.'REGION CHECK_T') then
              itregi_col=i
              icol_read=icol_read+1
            else if (column(i)(41:54).eq.'REGION CHECK_S') then
              isregi_col=i
              icol_read=icol_read+1
            else if (column(i)(41:57).eq.'PSAL_ADJUST GROSS') then
              icol_read=icol_read+1
            else if (column(i)(41:57).eq.'PSAL_ADJUST CLIMA') then
              icol_read=icol_read+1
            else if (column(i)(41:57).eq.'PSAL_ADJUST ANALY') then
              icol_read=icol_read+1
            else if (column(i)(41:65).eq.'VERTICAL GRADIENT CHECK_S') 
     *      then
              issalg_col=i
              icol_read=icol_read+1
            else if (column(i)(41:56).eq.'PRES_DOXY (DBAR)') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:57).eq.'TEMP_DOXY (DEG C)') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:56).eq.'SIGMATHETA_DOXY') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:51).eq.'BPHASE_DOXY') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:50).eq.'O2SAT_DOXY') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:57)=='PRES_DOXY2 (DBAR)') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:58)=='TEMP_DOXY2 (DEG C)') then        
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:52)=='BPHASE_DOXY2') then
              icol_read=icol_read+1
              optode='y'
            else if (column(i)(41:65)=='NUMBER OF VALUES AVERAGED') then
              icol_read=icol_read+1
            end if              ! if (column(i)(41:48).eq.'TEMPERAT') then
          end do                ! do i = 1, num_col
          
          if (icol_read.ne.num_col) then
            write(6,*)'WARNING on reading column rd_qc.f'
            write(6,*)'A new column has been added.'
            write(6,*)'num_col=',num_col,' icol_read=',icol_read
          end if                 ! if (icol_read.ne.num_col) then
        end if                  ! if (cline1(1:5).eq.'CALIB') then

        if (itemp2_col.gt.0.and.ipres2_col.gt.0) type_ts32='y'
c
c --- PSAL ADJUST line.         ! 05-May-09 added
c
       if (cline1(1:13).eq.'PSAL ADJUST [') then
         write(6,*)'psal adjust line read'        ! 05-May-09 0391-16923_214
         read(iunit,25,end=100,err=999) cline1    ! reading land indicator
       end if
c
c --- Land indicator.
c
       if (cline1(1:26).eq.'POSITION ON LAND INDICATOR') then
        read(cline1(41:41),*,err=999) land
       end if
c
c --- Read lat/lon information.
c
        if (cline1(1:10).eq.'==========') then
          ibad_phy=0                            ! good phy file
          if (one_time.eq.0) write(48,*) cline1(1:70)
          read(iunit,25,end=100,err=999) cline  ! Latitude Long.. line
c          write(6,*)'lat line reading',cline
          lastnb=lnblnk(cline)
          if (one_time.eq.0) write(48,*) cline(1:lastnb)
          read(iunit,25,end=100,err=999) cline  ! +99.999 ... line
          lastnb=lnblnk(cline)
          if (one_time.eq.0) write(48,*) cline(1:lastnb)
          if (cline(5:11).ne.'+99.999') go to 60 ! comment for netcdf
        else
c
c --- Read Overall flag and individual test flags.
c
          if (hasTemp .or. hasPsal .or. hasCond .or. hasO2) then
           if (cline1(1:13).eq.'MAXIMUM SPEED') then
              read(cline1(41:41),41,err=999) ispd
           end if
           if (cline1(1:18).eq.'OVERALL FLAG FOR T') 
     *      read(cline1(41:41),41) iover_t 
 133       read(iunit,25,end=100,err=999) cline
           if (cline(1:18).eq.'OVERALL FLAG FOR T') 
     *     read(cline(41:41),41) iover_t 
           lastnb=lnblnk(cline)
           if (cline(1:13).eq.'MAXIMUM SPEED') then
              read(cline(41:41),41,err=999) ispd
           end if
           if (cline(1:30).eq.'MAXIMUM CONSTANT VALUE CHECK_T')
     *     read(cline(41:41),41,err=999) it_cntv
           if (cline(1:13).eq.'ANALYSIS TIME') then
               read(cline(53:67),'(f15.9)',err=999) adate
           end if
           if (cline(1:18).eq.'OVERALL FLAG FOR S') 
     *     read(cline(41:41),41,err=999) iover_s 
           if (cline(1:30).eq.'MAXIMUM CONSTANT VALUE CHECK_S')
     *     read(cline(41:41),41,err=999) is_cntv
           if (cline(1:10).ne.'==========') go to 133
c            read(iunit,25,end=100) cline  ! =====...... line   ! bug 04-26-02
c            lastnb=lnblnk(cline)                               ! bug 04-26-02
            ibad_phy=0
            if (one_time.eq.0.and.icol_read.le.5)write(48,*) cline(1:70)
            read(iunit,25,end=100,err=999) cline  ! Latitude Long.. line
            lastnb=lnblnk(cline)
            if (one_time.eq.0.and.icol_read.le.5)write(48,*) cline(1:70)
            read(iunit,25,end=100,err=999) cline  ! +99.999 ... line
            lastnb=lnblnk(cline)
            if (one_time.eq.0.and.icol_read.le.5)write(48,*) cline(1:70)
            if (cline(5:11).ne.'+99.999') go to 60 ! comment when for netcdf
          end if                           ! if (hasTemp .or. hasPsal ...
        end if                             ! if (cline1(1:10).eq.'====.....
 40     read(iunit,25,end=100,err=999) cline
        lastnb=lnblnk(cline)
        if (one_time.eq.0.and.icol_read.le.5)write(48,*) cline(1:lastnb)

 60     if (cline(1:10).ne. '==========') then
          ll=index(cline(1:11),'.')
          mm=lchar_occur(cline,'.')
          nn=lchar_occur(cline,'/')
          jj=lchar_occur(cline,':')
          lastnb=lnblnk(cline)

          read(cline(1:ll+3),37,err=999) alat
          read(cline(mm-4:mm+3),38,err=999) alon
          read(cline(nn-7:nn-4),30,err=999) iyear
          read(cline(nn-2:nn-1),41,err=999) imon
          read(cline(nn+1:nn+2),41,err=999) iday
          read(cline(jj-5:jj-4),41,err=999) ihr
          read(cline(jj-2:jj-1),41,err=999) imin
          read(cline(jj+1:jj+2),41,err=999) isec
          iclass=cline(lastnb-1:lastnb)
          if (cline(lastnb-1:lastnb-1).eq.'-') then ! bad position case 
            spd_table='F'
            if (alat.gt.-0.0001.and.alat.lt.0.00001.and.
     *alon.gt.-0.0001.and.alon.lt.0.00001) ibad_pos=1
            go to 40                        ! 27-Nov-2001
          end if
          if (alat.gt.99.0.and.alon.gt.999.0) then
          else
            icnt = icnt+ 1
            alon_hist(icnt) = alon
            alat_hist(icnt) = alat
            itime_hist(icnt) = cline(nn-7:nn-4)//cline(nn-2:nn-1)//
     *      cline(nn+1:nn+2)//cline(jj-5:jj-4)//cline(jj-2:jj-1)//
     *      cline(jj+1:jj+2)
            iclass_hist(icnt) = iclass
          end if
          go to 40
        else
          ibad_phy=1
        end if                   ! if (cline(1:10).ne. '==...
c
c --- Read pres/tem/sal information.
c
        nlev=0
 50     continue
        nlev=nlev+1

        if (nlev.eq.1) then
          read(iunit,25,end=100,err=993) aline
          write(6,*)aline
          call verify_num_col(aline,ncol)
          if (ncol.ne.num_col) then
            status=9
            write(6,*)prg_sub,': "ncol" from data line differs "num_col" 
     * from header.'
            write(6,*)prg_sub,': ncol=',ncol,' num_col=',num_col
            write(6,*)prg_sub,': STOP -> STATUS = ', status
            write(50,*)prg_sub,': "ncol" from data line differs "num_col" 
     * from header.'
            write(50,*)prg_sub,': ncol=',ncol,' num_col=',num_col
            write(50,*)prg_sub,': STOP -> STATUS = ', status
            call exit(status)
          end if
          backspace(iunit)   ! 
        end if

        read(iunit,*,end=100,err=993) (dummy(i,nlev),i=1,num_col)
c        write(6,*)'dummy:', (dummy(i,nlev),i=1,num_col)
c
c --- Do not skip -999.0 data line in 'WHOI' float
        do i=1,num_col
c          if (trans_id(1:4).eq.'WHOI'.and.dummy(i,nlev).eq.-999.0) then
c            write(6,*)'WHOI float with -999.0 in data line'
c            nlev=nlev-1
c            go to 50
c          end if                  ! if (trans_id(1:4).....
        end do                    ! do i=1,num_col
        if (nlev.gt.nmax) then
          status=9
          write(50,*) prg_sub,': Data points are more than ',nmax
          write(50,*) prg_sub,': Increase a value nmax.'
          write(50,*) prg_sub,': STOP-> STATUS=',status
          call exit(status)
          stop '9'
        end if                    !  if (nlev.gt.nmax) then
        go to 50

c
c --- Profile number '000' case.
c
      else if (cline(1:13).eq.'MAXIMUM SPEED') then
       read(cline(41:41),41,err=999) ispd
c       write(6,*)'rd_qc(prof=0): ispd=',ispd
      else if (cline(1:10).eq.'=========='.and.
     *        (prof_num.eq.0.or.num_col.eq.0)) then
        ibad_phy=0
        read(iunit,25,end=100,err=999) cline  ! Latitude Long.. line
        lastnb=lnblnk(cline)
        read(iunit,25,end=100,err=999) cline  ! 99.999 line
        lastnb=lnblnk(cline)
        if (cline(5:11).ne.'+99.999') go to 90
 80     read(iunit,25,end=100,err=999) cline
        lastnb=lnblnk(cline)

 90     if (cline(1:10).ne. '==========') then
          ll=index(cline(1:11),'.')
          mm=lchar_occur(cline,'.')
          nn=lchar_occur(cline,'/')
          jj=lchar_occur(cline,':')
          lastnb=lnblnk(cline)

          read(cline(1:ll+3),37,err=999) alat
          read(cline(mm-4:mm+3),38,err=999) alon
          read(cline(nn-7:nn-4),30,err=999) iyear
          read(cline(nn-2:nn-1),41,err=999) imon
          read(cline(nn+1:nn+2),41,err=999) iday
          read(cline(jj-5:jj-4),41,err=999) ihr
          read(cline(jj-2:jj-1),41,err=999) imin
          read(cline(jj+1:jj+2),41,err=999) isec
          iclass=cline(lastnb-1:lastnb)
          if (cline(lastnb-1:lastnb-1).eq.'-') then ! bad position case;
             spd_table='F'
             if (alat.gt.-0.0001.and.alat.lt.0.00001.and.
     *alon.gt.-0.0001.and.alon.lt.0.00001) ibad_pos=1
             go to 80                      ! 27-Nov-2001
          end if
          if (alat.gt.99.0.and.alon.gt.999.0) then
          else
            icnt = icnt+ 1
            alon_hist(icnt) = alon
            alat_hist(icnt) = alat
            itime_hist(icnt) = cline(nn-7:nn-4)//cline(nn-2:nn-1)//
     *      cline(nn+1:nn+2)//cline(jj-5:jj-4)//cline(jj-2:jj-1)//
     *      cline(jj+1:jj+2)
            iclass_hist(icnt) = iclass
          end if
          go to 80
        end if                 ! if (cline(1:10).ne. '==========') then
        close (iunit)
        one_time=one_time+1
        return
      else
        nparam=nparam+1
        read(cline(41:73),25,err=999) t_value(nparam)
        do i=1,31
         if (cline(i:i).eq.' '.and.cline(i+1:i+1).ne.' ') cline(i:i)='_'
        end do
        t_param(nparam)=cline(1:32)    
c        go to 1                   ! read next line
      end if                       ! if (cline(1:11).eq.'INTERNAL ID') then
      go to 1
 100  continue                     ! end of "phy" or "qc" file
      nlev=nlev-1

c     write(6,*)'End of file.'
c --- Reverse the pres, sal, and tem, cndc, flag values if data was collected
c --- while the float is coming up; otherwise leave them as they are.

      do i = 1, nlev
        pres_check(i)=dummy(ipres_col,i)
      end do                       ! do i = 1, nlev
c
c--- Iridium float has a recorder type, 99 just like recording data on upward.
c
      if ((wmo_reco.eq.60.or.wmo_reco.eq.62.or.wmo_reco.eq.64).and.
     *prof_num.lt.1000)  ireverse=1     ! YES reverse
      if (wmo_reco.eq.61.or.wmo_reco.eq.63.or.wmo_reco.eq.65) 
     *                   ireverse=0     ! NO  reverse

      lastnb=lnblnk(trans_id)
      if (ireverse.eq.1) then
c        write(6,111) int_num,trans_id(1:lastnb),prof_num
      else if (ireverse.eq.0) then
c        write(6,112) int_num,trans_id(1:lastnb),prof_num
      else
        write(6,*) 'Warning!!! Unknown case',ireverse
      end if                       ! if (ireverse.eq.1) then
      
      if (ireverse.eq.1) then     ! YES reverse
        do i = 1, nlev
          if (ipres_col.gt.0) p(nlev-i+1) = dummy(ipres_col,i)
          if (ipres2_col.gt.0) p2(nlev-i+1) = dummy(ipres2_col,i)
          if (itemp_col.gt.0) t(nlev-i+1) = dummy(itemp_col,i)
          if (itemp2_col.gt.0) t2(nlev-i+1) = dummy(itemp2_col,i)
          if (isal_col.gt.0) s(nlev-i+1) = dummy(isal_col,i)
          if (icond_col.gt.0) c(nlev-i+1) = dummy(icond_col,i)
          if (ioxy_col.gt.0) o(nlev-i+1) = dummy(ioxy_col,i)*factor 
          if (ioxy2_col>0) o2(nlev-i+1) = dummy(ioxy2_col,i)*factor 
c       ! conversion for ml/l to mmols/m**3
          if (icksm_col.gt.0) cksm(nlev-i+1) = dummy(icksm_col,i)
          if (ipres_flag_col.gt.0) 
     *       ipres(nlev-i+1)=dummy(ipres_flag_col,i)
          if (itgros_col.gt.0) it_gros(nlev-i+1)=dummy(itgros_col,i)
          if (itvert_col.gt.0) it_vert(nlev-i+1)=dummy(itvert_col,i)
          if (itclim_col.gt.0) it_clim(nlev-i+1)=dummy(itclim_col,i)
          if (itanlz_col.gt.0) it_anlz(nlev-i+1)=dummy(itanlz_col,i)
          if (itspik_col.gt.0) it_spik(nlev-i+1)=dummy(itspik_col,i)
          if (itjump_col.gt.0) it_jump(nlev-i+1)=dummy(itjump_col,i)
          if (isgros_col.gt.0) is_gros(nlev-i+1)=dummy(isgros_col,i)
          if (isdens_col.gt.0) is_dens(nlev-i+1)=dummy(isdens_col,i)
          if (isclim_col.gt.0) is_clim(nlev-i+1)=dummy(isclim_col,i)
          if (isanlz_col.gt.0) is_anlz(nlev-i+1)=dummy(isanlz_col,i)
          if (isspik_col.gt.0) is_spik(nlev-i+1)=dummy(isspik_col,i)
          if (itvis_col.gt.0) it_vis(nlev-i+1)=dummy(itvis_col,i)
          if (isvis_col.gt.0) is_vis(nlev-i+1)=dummy(isvis_col,i)
          if (ipvis_col.gt.0) ip_vis(nlev-i+1)=dummy(ipvis_col,i)
          if (itregi_col.gt.0) it_regi(nlev-i+1)=dummy(itregi_col,i)
          if (isregi_col.gt.0) is_regi(nlev-i+1)=dummy(isregi_col,i)
          if (issalg_col.gt.0) is_salg(nlev-i+1)=dummy(issalg_col,i)
          if (isjump_col.gt.0) is_jump(nlev-i+1)=dummy(isjump_col,i)
        end do
      else                  ! NO reverse 
        do i = 1, nlev
          if (ipres_col.gt.0) p(i) = dummy(ipres_col,i)
          if (ipres2_col.gt.0) p2(i) = dummy(ipres2_col,i)
          if (itemp_col.gt.0) t(i) = dummy(itemp_col,i)
          if (itemp2_col.gt.0) t2(i) = dummy(itemp2_col,i)
          if (isal_col.gt.0) s(i) = dummy(isal_col,i)
          if (icond_col.gt.0) c(i) = dummy(icond_col,i)
          if (ioxy_col.gt.0) o(i) = dummy(ioxy_col,i)*factor 
          if (ioxy2_col>0) o2(i) = dummy(ioxy2_col,i)*factor 
c       ! conversion for ml/l to mmols/m**3
          if (icksm_col.gt.0) cksm(i) = dummy(icksm_col,i)
          if (ipres_flag_col.gt.0)
     *       ipres(i)=dummy(ipres_flag_col,i)
          if (itgros_col.gt.0) it_gros(i)=dummy(itgros_col,i)
          if (itvert_col.gt.0) it_vert(i)=dummy(itvert_col,i)
          if (itclim_col.gt.0) it_clim(i)=dummy(itclim_col,i)
          if (itanlz_col.gt.0) it_anlz(i)=dummy(itanlz_col,i)
          if (itspik_col.gt.0) it_spik(i)=dummy(itspik_col,i)
          if (itjump_col.gt.0) it_jump(i)=dummy(itjump_col,i)
          if (isgros_col.gt.0) is_gros(i)=dummy(isgros_col,i)
          if (isdens_col.gt.0) is_dens(i)=dummy(isdens_col,i)
          if (isclim_col.gt.0) is_clim(i)=dummy(isclim_col,i)
          if (isanlz_col.gt.0) is_anlz(i)=dummy(isanlz_col,i)
          if (isspik_col.gt.0) is_spik(i)=dummy(isspik_col,i)
          if (itvis_col.gt.0) it_vis(i)=dummy(itvis_col,i)
          if (isvis_col.gt.0) is_vis(i)=dummy(isvis_col,i)
          if (ipvis_col.gt.0) ip_vis(i)=dummy(ipvis_col,i)
          if (itregi_col.gt.0) it_regi(i)=dummy(itregi_col,i)
          if (isregi_col.gt.0) is_regi(i)=dummy(isregi_col,i)
          if (issalg_col.gt.0) is_salg(i)=dummy(issalg_col,i)
          if (isjump_col.gt.0) is_jump(i)=dummy(isjump_col,i)
        end do                   ! do i = 1, nlev
      end if                     ! if (ireverse.eq.1) then
      bot_tem=t(nlev)
      bot_prs=p(nlev)
 120  close (iunit)

c
c--- Making sure that the last line in the position is 99.999 999.999 line.
c
c      if (alat_hist(icnt).le.90 .or. icnt.eq.icnt_start) then
c         icnt=icnt+1
c         alon_hist(icnt) = 999.999
c         alat_hist(icnt) = 99.999
c         itime_hist(icnt) = itime_hist(icnt-1)
c         iclass_hist(icnt) = '0'
c      endif                      ! if (alat_hist(icnt).le.90 .or. icnt.e...
      go to 1000
 25   format(a)
 26   format(a256)
 30   format(i4)
 37   format(f11.3)
 38   format(f8.3)
 41   format(i2)
 42   format(f5.2)
 111  format(1x,'This dataset needs to reverse ---> ',
     *i4.4,'_',a,'_',i3.3)
 112  format(1x,'This dataset needs NO reverse ---> ',
     *i4.4,'_',a,'_',i3.3)
 993  write(6,*)'Reading rd_qc.f(read dummy) error=993'
      write(50,*)'Reading rd_qc.f(read dummy) error=993'
      status=9
      call exit(status)
 998  write(6,*)'Reading rd_qc.f error=998 --->',cline1(1:80)
      write(50,*)'Reading rd_qc.f error=998 --->',cline1(1:80)
      status=9
      call exit(status)
 999  write(6,*)'Reading rd_qc.f error=999 --->',cline(1:80)
      write(50,*)'Reading rd_qc.f error=999 --->',cline(1:80)
      status=9
      call exit(status)
 1000 continue
      close (iunit)
      one_time=one_time+1
      return
      end 

   
