c     Revision Date : 08-Feb-07 (YHD - 'ilen' no longer needed)
c                     18-May-04 (RS - modify include stmt)
c                     02-Oct-03 (YHD - All dimensions check)
c                     30-Sep-03 (YHD - 'ilen' lenth of mpp_version is passed)
c                     29-Apr-03 (YHD - "ANALYSIS VERSION USED" extracted from
c                                      Dave Behringer's analysis NetCDF file.)
c
c
      subroutine rdocn_anlz(ocn_name,anlz_tem,anlz_sal,time,
     *                      mpp_version)
c
crs   include '/usr/local/include/netcdf.inc'
      include 'netcdf.inc'
c
      integer i,j,k,t
      parameter (i=360,j=200,k=40,t=1)
      integer ii,jj,kk,ncid,status,idbug
      integer ndims, nvars, natts, idunlm,ilen
      integer dsiz(20), vtype, nvdm, vdm(10), nvatts, indx(4)
      integer start(4), count(4)
      integer lnblnk,last,lastnb,lenstr,iostat,iret,lbeg
      intrinsic index,len
      character dname*20, vname*20
      character ocn_name*128,prg_sub*12,cmon(12)*2,month*2,
     *          mpp_version*50,version*50
      data cmon/'01','02','03','04','05','06',
     *          '07','08','09','10','11','12'/
c
      double precision time
      real temp(i,j,k,t),anlz_tem(i,j,k),
     *     salinity(i,j,k,t),anlz_sal(i,j,k),xt_i(i)
      data idbug /0/                        ! make it 1 to debug

      prg_sub = 'rdocn_anlz_t'
      
      if (idbug.gt.0) write(66,*)'<<<<< DEBUG from RDOCN_ANLZ >>>>>'
c
c  open existing netCDF dataset
c
        ncid=NCOPN(ocn_name,NCNOWRIT,status)
        if (idbug.gt.0) write(66,*)'open NetCDF file=',ocn_name
        if (idbug.gt.0) write(66,*)'ncid=',ncid,' status=',status
c
c inquire about the file
c
        call NCINQ(ncid, ndims, nvars, natts, idunlm, status)
        if (idbug.gt.0) write(66,*)'ndims=',ndims,' nvars=',nvars,
     *' natts=',natts
c
c inquire about the dimensions
c
        if (idbug.gt.0) write(66,*) 'DIMENSIONS'
        do n = 1,ndims
          call NCDINQ(ncid, n, dname, dsiz(n), status)
          if (idbug.gt.0) write(66,*)'n=',n,'  name=',dname,'  size=',
     *    dsiz(n)
        enddo
c
c inquire about the variables
c
        if (idbug.gt.0) write(66,*) 'VARIABLES'
        do n = 1,nvars
        call NCVINQ(ncid, n, vname, vtype, nvdm, vdm, nvatts, status)
        if (idbug.gt.0) write(66,*)'n=',n,'  name=',vname,'  n.dims=',nvdm
        enddo
c
c inquire about the variable named 'Time'
c
        if (idbug.gt.0) write(66,*) 'TIME'
        nid = NCVID(ncid,'Time',status)
        call NCVINQ(ncid, nid, vname, vtype, nvdm, vdm, nvatts, status)
        if (idbug.gt.0) write(66,*) '  name=',vname,'  n.dims=',nvdm
        call NCVGT1(ncid, nid, nvdm, Time, status)
        if (idbug.gt.0) write(66,*) ' Time=', Time
c
c inquire about the variable named 'MPP_IO_VERSION'
c
        if (idbug.gt.0) write(66,*) 'MPP_IO_VERSION'
        iret = NF_GET_ATT_TEXT(ncid,NF_GLOBAL,'MPP_IO_VERSION',version)
        if (iret.ne.NF_NOERR) then
          print*,nf_strerror(iret)
          stop
        end if
        lbeg = index(version, ',')
        last = lchar_occur(version,'$')
        ilen=last-lbeg-1
c        mpp_version(1:ilen)=version(lbeg+1:last-1)
        mpp_version(1:last-lbeg-1)=version(lbeg+1:last-1)
        if (idbug.gt.0) write(66,*)'mpp_version=',mpp_version
c
c inquire about the variable named 'temp'
c
        if (idbug.gt.0) write(66,*) 'TEMP'
        nid = NCVID(ncid,'temp',status)
        call NCVINQ(ncid, nid, vname, vtype, nvdm, vdm, nvatts, status)
        if (idbug.gt.0) write(6,*) '  name=',vname,'  n.dims=',nvdm
        do n = 1,nvdm
         if (idbug.gt.0) write(66,*)'   n=',n,'   dim.no.=',vdm(n),
     *   '   siz=',dsiz(vdm(n))
        enddo
c
c get one 'temp' value
c
c        write(6,*) 'TEMP at the point (i,j,k,t) = (150,90,2,1)'
c        indx(1) = 150
c        indx(2) = 90
c        indx(3) = 2
c        indx(4) = 1
c        nid = NCVID(ncid,'temp',status)
c        call NCVGT1(ncid, nid, indx, tval, status)
c        write(6,*) ' t(150,90,2,1)=', tval
c
c get one 'salinity' value
c
c        write(6,*) 'SAL at the point (i,j,k,t) = (150,90,2,1)'
c        indx(1) = 150
c        indx(2) = 90
c        indx(3) = 2
c        indx(4) = 1
c        nid = NCVID(ncid,'salinity',status)
c        call NCVGT1(ncid, nid, indx, sval, status)
c        write(6,*) ' s(150,90,2,1)=', sval
c
c get whole 'temp' array
c
        if (idbug.gt.0) write(66,*) 'TEMP'
        nid = NCVID(ncid,'temp',status)
        call NCVINQ(ncid, nid, vname, vtype, nvdm, vdm, nvatts, status)
        do n = 1,nvdm
          start(n) = 1
          count(n) = dsiz(vdm(n))
          if (idbug.gt.0) write(66,*) start(n), count(n)
        enddo
        call NCVGT(ncid, nid, start, count, temp, status)
c
c inquire about the variable named 'salinity'
c
        if (idbug.gt.0) write(66,*) 'SALINITY'
        nid = NCVID(ncid,'salinity',status)
        call NCVINQ(ncid, nid, vname, vtype, nvdm, vdm, nvatts, status)
        if (idbug.gt.0) write(66,*) '  name=',vname,'  n.dims=',nvdm
        do n = 1,nvdm
         if (idbug.gt.0) write(66,*)'   n=',n,'   dim.no.=',vdm(n),
     *'   siz=',dsiz(vdm(n))
        enddo
c
c get whole 'salinity' array
c
        if (idbug.gt.0) write(66,*) 'SALINITY'
        nid = NCVID(ncid,'salinity',status)
        call NCVINQ(ncid, nid, vname, vtype, nvdm, vdm, nvatts, status)
        do n = 1,nvdm
          start(n) = 1
          count(n) = dsiz(vdm(n))
          if (idbug.gt.0) write(66,*) start(n), count(n)
        enddo
        call NCVGT(ncid, nid, start, count, salinity, status)
c
c inquire about the variable named 'xt_i'
c
        if (idbug.gt.0) write(66,*) 'LONGITUDE'
        nid = NCVID(ncid,'xt_i',status)
        call NCVINQ(ncid, nid, vname, vtype, nvdm, vdm, nvatts, status)
        if (idbug.gt.0) write(66,*) '  name=',vname,'  n.dims=',nvdm
        do n = 1,nvdm
         if (idbug.gt.0) write(66,*)'   n=',n,'   dim.no.=',vdm(n),
     *'   siz=',dsiz(vdm(n))
        enddo
c
c get whole 'xt_i' array
c
        if (idbug.gt.0) write(66,*) 'xt_i'
        nid = NCVID(ncid,'xt_i',status)
        call NCVINQ(ncid, nid, vname, vtype, nvdm, vdm, nvatts, status)
        do n = 1,nvdm
          start(n) = 1
          count(n) = dsiz(vdm(n))
          if (idbug.gt.0) write(66,*) start(n), count(n)
        enddo
        call NCVGT(ncid, nid, start, count, xt_i, status)
 100  format(10f8.4)
c
      do kk=1,k
        do jj=1,j
          do ii=1,i
            anlz_tem(ii,jj,kk)=temp(ii,jj,kk,1)
            anlz_sal(ii,jj,kk)=(salinity(ii,jj,kk,1)+0.035)*1000.
          end do
        end do
      end do

      call NCCLOS(ncid,status)           ! close netCDF dataset

      if (idbug.gt.0) write(66,*) xt_i
      return
      end








