/*****************************************************************************
 Revision Date: 02-Oct-03 (YHD - pathname[129] to pathname[128] & print depth
                18-Sep-01 (RS - modify to get path/filename form global var 
                                TOPO)

 THIS CODE READ THE TERRAINBASE DATA  (written by J. Trinanes)
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define LATN	89.9583333
#define LONW	-179.958333
#define XSIZE	4320
#define YSIZE	2160

void swap(char *x, char size);

int rdtbase_(float *lat,float *lon)
{
FILE *in,*out;
float depthf;
double consta,consta2;
short depth;
int i,j, len;

int dummy;
char *bathy_file, pathname[129];

// Get pathname for the topography file
// ------------------------------------
if ( (bathy_file = getenv("TOPO")) == NULL)
{
  printf("ERROR: TOPO <-- no such environment variable\n");
  dummy = 99999;
  return(dummy);
}

consta=1.0/12.0;
consta2=consta/2.0;

strcpy(pathname, bathy_file);
len = 0;
while ( pathname[len] != ' ' )
{
   len++;
}
pathname[len] = NULL;

in=fopen(pathname, "r");

i=(int)((LATN+consta2-(*lat))/consta);
j=(int)(((*lon)-(LONW-consta2))/consta);

fseek(in,(i*XSIZE+j)*2,SEEK_SET);
fread(&depth,sizeof(short),1,in);

swap((char *)&depth,2);

fprintf(stdout,"-> rdtbase: lat=%f lon=%f depth=%d\n",*lat,*lon,depth);
fclose(in);
return(depth);
}

void swap(char *x, char size)
{
  unsigned char c;
  unsigned short s;
  unsigned long l;

  switch (size)
  {
    case 2: /* swap two bytes */
      c = *x;
      *x = *(x+1);
      *(x+1) = c;
      break;
    case 4: /* swap two shorts (2-byte words) */
      s = *(unsigned short *)x;
      *(unsigned short *)x = *((unsigned short *)x + 1);
      *((unsigned short *)x + 1) = s;
      swap ((char *)x, 2);
      swap ((char *)((unsigned short *)x+1), 2);
      break;
    case 8: /* swap two longs (4-bytes words) */
      l = *(unsigned long *)x;
      *(unsigned long *)x = *((unsigned long *)x + 1);
      *((unsigned long *)x + 1) = l;
      swap ((char *)x, 4);
      swap ((char *)((unsigned long *)x+1), 4);
      break;
  }
}
