c    
c  Revision Date: 19-Jan-05 (YHD - APEX_TSO3 case: p,t,s ok & o bad
c                                  Increased dimension of iend_pck & imany_pck
c                 02-Oct-03 (YHD - All dimensions check)
c                 10-Feb-03 (YHD - fill value is in data line case)
c                 07-Jun-02 (YHD - At least 3 points needed to test 
c                 27-Jun-01 (YHD - checksum flag zero case; t,s,p need to 
c                                  be check)
c                 27-Apr-01 (YHD - checksum flag zero case added)
c     spike_check.f
c     ============
c     This program is copied from an internet.  yhd, 04-05-2001
c     This test checks a median value of temp/salinity of the window of
c     3 data points and to see if the absolute value of the median 
c     value-actual value is within a given tolerance range.  Otherwise,
c     it is a possibly bad data point.  
c     inputs:
c       val   - temp.or salinity array
c       val1  - salinity or temp array
c       pres  - pressure array
c       nlev  - number of pres/temp/salinity pairs
c      output:
c       iflag  - 1     good data point
c                4     bad data point
c
      subroutine spike_check (val,val1,pres,nlev,cksm_flag,iflag)

      implicit none
      integer i,j,k,nlev,iflag(*),mwin,mcnt,idbug,status,
     *        nw,cksm_flag(*),ibeg,iend,imany,iend_pck(50),
     *        imany_pck(50),icnt
      integer, parameter :: lmax = 2200
      real    val(*),val1(*),pres(*),val_new(lmax),xmed,xmed_save(lmax),
     *        tol,x(5),fv
      character prg_sub*11
      data    tol /0.4/
      data    prg_sub /'Spike_check'/
      data    idbug /0/                ! make it 1 to debug
      data    nw /3/                   ! nw points per window
      data    fv /-999./
c
c*    Use a window of nw data points and find a median.
c
      if (idbug.gt.0) write(66,*)'<<<<< DEBUG from SPIKE_CHECK >>>>>'
      if (idbug.gt.0) write(66,*)'spike_check:nlev =',nlev,
     *' Number of pts per window=',nw
      if (nlev.lt.3) then
        do i=1,nlev
          iflag(i)=0
        end do
        return
      end if
c
c* In case checksum flag, val, val1, and pres are zero, find out indices 
c  for beginning and ending.

      icnt=0                           ! number of zero gaps
      iend=0
      imany=0
      do i=1,nlev
        if ((cksm_flag(i).eq.0.and.val(i).eq.0.0.and.val1(i).eq.0.0
     *  .and.pres(i).eq.0.0).or.val(i).eq.fv.or.val1(i).eq.fv.or.
     *  pres(i).eq.fv) then
          iend=i
          imany=imany+1
        else
          if (iend.ne.0) then
            icnt=icnt+1
            iend_pck(icnt)=iend
            imany_pck(icnt)=imany
            iend=0
            imany=0
          end if
        end if
      end do
      if (icnt.ne.0.and.idbug.gt.0) then
        write(66,*)'The number of zero gaps is ',icnt
        write(6,*)'The number of zero gaps is ',icnt
        do k=1,icnt
          write(66,*) 'gap :',iend_pck(k),imany_pck(k)
          write(6,*) 'gap :',iend_pck(k),imany_pck(k)
        end do
      end if
     
      if (icnt.ne.0) then
        do k=1,icnt
          ibeg=iend_pck(k)-imany_pck(k)+1
          if (idbug.gt.0) then
            write(66,*)'Part of checksum flags are 0''s or fillvalues.'
            write(66,*)'How many ckecksum flags are zeros? ',
     *      imany_pck(k)
            write(66,*)'ibeg,iend=',ibeg,iend_pck(k)
            write(6,*)'Part of checksum flags are 0''s or fillvalues.'
            write(6,*)'How many ckecksum flags are zeros? ',
     *      imany_pck(k)
            write(6,*)'ibeg,iend=',ibeg,iend_pck(k)
          end if
        end do                         ! do i=1,icnt
        do i=1,nlev
          if ((val(i).eq.0.0.and.val1(i).eq.0.0.and.pres(i).eq.0.0.and.
     *        cksm_flag(i).eq.0).or.val(i).eq.fv.or.val1(i).eq.fv.or.
     *        pres(i).eq.fv) then
          else
            j=j+1
            val_new(j)=val(i)
          end if
        end do
      else
        do i = 1, nlev
          val_new(i)=val(i)
        end do
      end if                           ! if (icnt.ne.0) then

      mcnt=0
 10   continue
      if (mcnt.ge.nlev) go to 100
      if (nlev-mcnt.ge.nw) then      ! Enough data points?
        mwin=nw
      else
        go to 100
      end if
      do i=1,mwin
        x(i)=val_new(mcnt+i)
      end do
      if (mwin.ne.nw) then
        status=9
        write(6,*) prg_sub,' mwin is not 3. Check mwin value.'
        write(6,*) prg_sub, ': STOP -> STATUS = ', status
        call exit (status)
        stop '9'
      end if
      call median(x,mwin,xmed)
      mcnt = mcnt + 1
      xmed_save(mcnt+(nw/2))=xmed
c      if (idbug.gt.0) write(66,*)prg_sub,' data,xmed:',val(mcnt+(nw/2)),
c     *xmed_save(mcnt+(nw/2)),mcnt+(nw/2)
      go to 10
 100  continue
c
c*   Compare median value against the actual value.
c
      do i=1,(nw/2)
        iflag(i)=1                   ! (nw/2) data points make it good
      end do

      if (icnt.gt.0) then         ! Part of checksum flags are zero case
c
c*    Beginning to the first gap.
c
        iend=iend_pck(1)-imany_pck(1)
        j=(nw/2)
        do i = nw-(nw/2), iend
          j=j+1
          if (idbug.gt.0) write(66,110) prg_sub,j,val_new(j),
     *    xmed_save(j),abs(val_new(j)-xmed_save(j))
          if (abs(val_new(j)-xmed_save(j)).gt.tol) then
            iflag(i)=4
          else
            iflag(i)=1
          end if
        end do
c 
c* Between the zero gaps.
c
        do k=1,icnt
          ibeg=iend_pck(k)-imany_pck(k)+1
          iend=iend_pck(k)
          do i=ibeg,iend
            iflag(i)=0
          end do
        end do

        do k=1,icnt-1
          ibeg=iend_pck(k)+1
          iend=iend_pck(k+1)-imany_pck(k+1)
          do i =ibeg ,iend
            j=j+1
            if (idbug.gt.0) write(66,110) prg_sub,j,val_new(j),
     *      xmed_save(j),abs(val_new(j)-xmed_save(j))
            if (abs(val_new(j)-xmed_save(j)).gt.tol) then
              iflag(i)=4
            else
              iflag(i)=1
            end if
          end do
        end do                  ! do k=1,icnt-1
c
c*      Last gap to the end of data
c
        iend=iend_pck(icnt)
        do i=iend+1,nlev-(nw/2)
          j=j+1
          if (idbug.gt.0) write(66,110) prg_sub,j,val_new(j),
     *    xmed_save(j),abs(val_new(j)-xmed_save(j))
          if (abs(val_new(j)-xmed_save(j)).gt.tol) then
            iflag(i)=4
          else
            iflag(i)=1
          end if
        end do
      else                          ! checksum flags are all 1 case.
        do i = nw-(nw/2), nlev-(nw/2)
          if (idbug.gt.0) write(66,110) prg_sub,i,val(i),xmed_save(i),
     *    abs(val(i)-xmed_save(i))
          if (abs(xmed_save(i)-val(i)).gt.tol) then
             iflag(i)=4
          else
            iflag(i)=1
          end if
        end do      
      end if
      do i = nlev-(nw/2)+1,nlev
        iflag(i)=1              ! Make last (nw/2) point good
      end do
 110  format(1x,a11,i3,1x,f6.3,1x,f6.3,1x,f6.3)
      return
      end

      SUBROUTINE median(x, n, xmed)

! Find the median of X(1), ... , X(N), using as much of the quicksort
! algorithm as is needed to isolate it.
! N.B. On exit, the array X is partially ordered.
!     Latest revision - 26 November 1996

      IMPLICIT NONE

      INTEGER n
      REAL    x(*),xmed

! Local variables

      REAL     temp, xhi, xlo, xmax, xmin
      LOGICAL  odd
      INTEGER  hi, lo, nby2, nby2p1, mid, i, j, k,idbug
      character prg_sub*6
      DATA     idbug /0/                 ! make it 1 to get printout
      data     prg_sub /'median'/

      nby2 = n / 2
      nby2p1 = nby2 + 1
      odd = .true.

!     HI & LO are position limits encompassing the median.

      IF (n .eq.(2* nby2)) odd = .false.
      lo = 1
      hi = n
      IF (n .lt. 3) THEN
        IF (n .lt. 1) THEN
          xmed = 0.0
          RETURN
        END IF
        xmed = x(1)
        IF (n .eq. 1) RETURN
        xmed = 0.5*(xmed + x(2))
        RETURN
      END IF

!     Find median of 1st, middle & last values.

 10   mid = (lo + hi)/2
      xmed = x(mid)
      xlo = x(lo)
      xhi = x(hi)
      if (idbug.gt.0) write(66,*)prg_sub,' xlo,xmed,xhi:',xlo,xmed,xhi
      IF (xhi .lt. xlo) THEN          ! Swap xhi & xlo
       temp = xhi
       xhi = xlo
       xlo = temp
      END IF
      IF (xmed .gt. xhi) THEN
       xmed = xhi
      ELSE IF (xmed .lt. xlo) THEN
       xmed = xlo
      END IF

! The basic quicksort algorithm to move all values <= the sort key (XMED)
! to the left-hand end, and all higher values to the other end.

      i = lo
      j = hi

 50   continue

      IF (x(i) .ge. xmed) go to 60
      i = i + 1
      go to 50
 60   continue

      IF (x(j) .le. xmed) go to 70
      j = j - 1
      go to 60
 70   continue
      IF (i .lt. j) THEN
       temp = x(i)
       x(i) = x(j)
       x(j) = temp
       if (idbug.gt.0) then
         write(66,*) prg_sub,' load:x(',i,')=',x(i),' x(',j,')=',x(j)
       end if
       i = i + 1
       j = j - 1
!     Decide which half the median is in.
       IF (i .le. j) GO TO 50
      END IF

      IF (.NOT. odd) THEN
        IF (j .eq. nby2 .AND. i .eq. nby2p1) GO TO 130
        IF (j .lt. nby2) lo = i
        IF (i .gt. nby2p1) hi = j
        IF (i .ne. j) GO TO 100
        IF (i .eq. nby2) lo = nby2
        IF (j .eq. nby2p1) hi = nby2p1
      ELSE
        IF (j .lt. nby2p1) lo = i
        IF (i .gt. nby2p1) hi = j
        IF (i .ne. j) GO TO 100

! Test whether median has been isolated.

        IF (i .eq. nby2p1) RETURN
      END IF
 100  continue
      IF (lo .lt. hi - 1) GO TO 10

      IF (.NOT. odd) THEN
        xmed = 0.5*(x(nby2) + x(nby2p1))
        RETURN
      END IF
      temp = x(lo)
      IF (temp .gt. x(hi)) THEN
        x(lo) = x(hi)
        x(hi) = temp
      END IF
      xmed = x(nby2p1)
      RETURN

! Special case, N even, J = N/2 & I = J + 1, so the median is
! between the two halves of the series.   Find max. of the first
! half & min. of the second half, then average.

 130  continue
      xmax = x(1)
      DO k = lo, j
        xmax = MAX(xmax, x(k))
      END DO
      xmin = x(n)
      DO k = i, hi
        xmin = MIN(xmin, x(k))
      END DO
      xmed = 0.5*(xmin + xmax)
       
      RETURN
      END 






