#!/bin/sh
# ==============================================================================================
# Revision Date: 22-May-2014 (CS,EF - changed
#                 4) any_qcsensor_failed=`expr $any_qcsensor_failed + 1`  
#                    complete=w
#                TO
#                 4) any_qcsensor_failed=`expr $any_qcsensor_failed + 1`  
#                    complete=y
#                07-Apr-07 (RS - code to check if the following directories exists was moved 
#                                after a few lines lines down from "while read phy_file ana_file"
#                                loop line 
#                                      DONE_PHYFILES_DIR/aomlid 
#                                      DONEOLD_PHYFILES_DIR/aomlid
#                                If the 'aomlid' does not exist, it is created)
#                13-Mar-14 (CS - program did not create subdirectories with $aomlid and mv did
#                                not have the "/" at the end -> some phy files were lost)
#                18-Feb-14 (RS,CS - moving phy files from "done" to "done_old" used to be done
#                                   cnt2phy.sh. Because of that old phy files from Iridium
#                                   floats were not moved (i.e. they were lost). Now, an old
#                                   'phy' file is moved to "done_old" in this script.)
#                05-Jun-13 (RS - introduced a new status flag (12)in the report logfile.
#                                The flag is set to '12' when the instrument type is not
#                                recognized in the case statement "case $instr_type in".
#                                If the profile flag is set to '12' then the intrument type 
#                                must be coded in the 'case \$instr_type in') 
#                04-Jun-13 (RS - variables 'prgno, prgno_status,  type_status,
#                                instr_type and performqc' are now printed.
#                                Line: "'NAVISIR'*) to_adjust_pres=0" was added to case
#                                statement " case $instr_type in".
#                                It prints "<<< Skip PSalAdjustment >>>" when appropiate)
#                05-Apr-13 (RS - define 'QCFILES_AOMLID_DIR' which is used in qc_t.f &
#                                qc_s.f)
#                31-Oct-12( RS - code changes related to the creation of the 'aomlid' 
#                                directory for each float under:  ARGO/data/qc) 
#                26-Sep-12 (RS - pressure adjustment logic modified to correct ambiguity) 
#                18-Apr-12 (RS - change pathname to pres_adj.x)
#                07-Mar-12 (RS - removed reference to TO_DATABASE_DIR. 
#                                Since database server (IDA) is no longer 
#                                supported, there is no need to create softlinks
#                                to *.qc files)
#                13-Apr-11 (RS - add comment 'prospect2gts=y' in PerformQC function)
#                04-Aug-10 (ER - APEX_T3 and PROVOR_T4 floats not to be pressure-adjusted
#                                for the time being.
#                19-Jul-10 (ER - If it is APEX_ then do pressure adjustement, but if
#                                it is APEXIR_ do not.
#                01-Jun-10 (ER - Keep phy files before pressure is adjusted in new
#                                directory $PHY/before_pressure_adjustment)
#                09-Mar-10 (ER - When processing return from adjsal2phy.x, in the case of
#                                status_adj=2:
#                                * do nothing
#                                * return 1 (OK) 
#                03-Mar-10 (ER - add calling to pressure adjust program (pres_adj.x)
#                19-Oct-09 (RS - when qc_exit=2 set complete variable to 'w'
#                                instead 'n' and set it also to 'w' when qc_exit=4)
#                28-Sep-08 (RS - Create function PerformQC from existing code)
#                25-Sep-09 (RS - 1. for clarity the variable name 'send2gts' was changed
#                                to 'prospect2gts; 2. create the function 'PSalAdjustment'
#                                from the code in 'Main'.  It was modified to eliminate 
#                                the 'stderror' reported when 'adjsal2phy.x' returned 
#                                with status=0 but didn't create an adjusted 'phy' file
#                                becasue the sal offset & std =0.  Previously, a move to
#                                override the existing 'phy' file was being executed with
#                                a none-existing file that produced the 'stderror'.)
#                22-Sep-09 (RS - removed deprecated code, 07Mar06, related to profile
#                                links and modified echo statement related to 'tmp_table')
#                23-Jul-09 (RS - PHY_DATE & PHY_TIME: modified algorithm & moved to 
#                                section where the entry to PHY2GTSFMT_TABLE is written)
#                31-Mar-09 (RS - enable process for a bounce float to continue)
#                Jun-08 (RS - add F90QC Exec failure to email subject.
#                                Add bounced and corrupted profiles to table and email)
#                26-Feb-08 (RS - ensure that the metafile for the 'phy' file exists)
#                25-Feb-08 (RS - QC chedk for corrupted profiles, exit 11)
#                06-Sep-07 (RS - take care of case when no PSAL adjustment is needed) 
#                05-Sep-07 (RS - take care of a new incoming ANALYSIS_FILE 
#                                while processing the auto-qc of a 'PHY' file) 
#                11-Apr-07 (CS - added exit status 2 to PSAL ADJUST part)
#                29-Mar-07 (RS - report WARNING and/or ERRORS in the email subject)
#                28-Mar-07 (RS - add profile name to adjsal printout)
#                28-Feb-07 (RS - run program to adjust salinity when 'PSAL ADJUST'
#                                line is in the float metafile - a new phy file
#                                is created)
#                13-Sep-06 (RS - documentation & allow profiles with QC-Status=4
#                                to be transmitted to GTS)
#                22-May-06 (RS - allow status=2 profiles (passed incomplete) to 
#                                create link for NETCDF)  
#                08-Mar-06 (RS - streamline email text. Skip profile tests
#                                in email when a problem)
#                                was not reported)                
#                07-Mar-06 (RS - links in TO_NETWORK_DIR, no longer used)
#                17-Jun-05 (RS - add logic for 'bounced profile' file & for sending
#                                only 'complete' profiles to GDACs)         
#                10-May-05 (RS - replace status=5 for profile with 'zero data line'
#                                with profile with 'no position and no data') 
#                05-May-05 (RS - allow profile '0' to go to GTS and create link to
#                                create a NetCDF file when a profile reports an
#                                illegal position)
#                09-Jul-04 (RS - create link in NETCDF_QCLINKS_DIR for profiles 
#                                with no data)
#                24-Feb-04 (RS - bypass if "no data line" (status=3) when returned
#                                from the QC execution)
#                01-Dec-03 (RS - introduce a test based on the value (n/y) taken  
#                                from the 'send to GTS' line in meta files)
#                07-Oct-03 (RS - skip QC for S if status  for T >= 9)
#                11-Sep-03 (RS - new exit status (3, no data lines) from 
#                                the QC Fortran program)
#                15-Aug-03 (RS - remove PACKQC2FTP_TABLE no longer needed and
#                                save a list of filenames of 'qc' profiles that ran
#                                successfully as follows:
#                                ARGOLIST_DIR/lists/QC2MATLAB_TABLE.timestamp  
#                                ARGO_MANUALPROCESS_LIST_DIR/qc_manual.timestamp_list  
#                                where timestamp=TODAY)
#                06-Aug-03 (RS - change for checking manual when mode is qc)
#                15-Jul-03 (RS - set global variables & streamline code)
#                27-May-03 (XX - set prgno = 00000, for ORBCOMM floats)
#                15-May-03 (RS - add parameter in call to qc_sensor.sh)
#                30-Apr-03 (RS - 4 digits for profile number &
#                                10 char for transmission ID)
#                13-Jan-03 (RS - bypass NetCDF links when WMO=0)
#                31-Oct-02 (RS - create QC links in to_network (qc/links)
#                31-Oct-02 (RS - exclude profile with illegal position
#                                and/or date from link creation to NetCDF) 
#                15-Oct-02 (RS - create links to_database)
#                15-Oct-02 (RS - introduce profile zero with data)
#                30-Sep-02 (RS - change name of QC links dir for conversion
#                                to NetCDF)
#                04-Sep-02 (RS - add illegal position and/or date status)
#                17-Aug-02 (RS - add no position to PACKQC2FTP_TABLE)
#                17-Jul-02 (RS - QC profiles with no position and on land
#                                and create links to them if Operational Site
#                                is the NetCDF Distribution Site)
#                10-Mar-01 (RS - documentation)
#                17-Jan-02 (RS - correction to if (one_dataline_only)
#                26-Nov-01 (RS - add constant value test)
#                20-Sep-01 (RS - add code for 'position on land')
#                22-Aug-01 (RS - don't move 'phy' file to 'failure' dir
#                                when there is a QC execution failure )
#                09-Aug-01 (RS - correction to PHY2GTS_TABLE, when a 
#                                profile changes from incomplete -> complete)
#                19-Jul-01 (RS - back to 5 digits)
#                10-Jul-01 (RS - argos id expansion)
#                02-Jul-01 (RS - skip sal exec if status=8 or 9)
#                01-Mar-01 (RS - add code for status not defined) 
#                01-Feb-01 (RS - implement status 8 return from QC)
#                01-Feb-01 (RS - implement status 0 return from QC)
#                31-Jan-01 (RS - add complete field to PHY2GTSFMT_TABLE)
#                23-Jan-01 (RS - location to position)
#                08-Jan-01 (RS - implement Exit Code Table)
#                19-Dec-00 (RS - merge qc_t.sh & qc_s.sh into qc_sensor.sh
#                15-Dec-00 (RS - use PHY_DATE & PHY_TIME in tables)
#                12-Dec-00 (RS - change table name)
#                01-Dec-00 (RS - set sensor label to 'L' for profile '000'
#                30-Nov-00 (RS - bypass profile '000' entry to phy2gts) 
#                28-Nov-00 (RS - report qc script (t/s) not found)
#                24-Nov-00 (RS - implement phyfile_list_notfound)
#                20-Sep-00 (RS - new meta data)
#                05-Sep-00 (RS - change qc2gts phy2gts)
#                28-Aug-00 (RS - implement PACKQC2FTP_TABLE)
#                27-Aug-00 (RS - update doc & save all qc profiles)
#                18-Aug-00 (RS - set exit status value)
#                15-Aug-00 (RS - remove sensors from Table)
#                04-AUg-00 (RS - updates for F77 interface)
#                20-Jun-00 (RS - global env in ./ARGO/init_scripts) 
#                06-Jun-00 (RS)
#
# qc_process.sh
# =============
# (1) Executes script 'qc_t.sh' to do the following profile quality
# control temperature tests:
#
#      gross 
#      checksum
#      speed
#      vertical gradiant
#      climatology  
#      analysis 
#
# (2) Executes script 'qc_s.sh' to do the following profile quality
# control salinity tests when applicable:
#
#      gross
#      checksum
#      speed
#      vertical gradiant
#      climatology
#      analysis
#
# (3) Creates or                     maintain the following tables:
#
#     Table Name        Columns 
#     ----------        -------
#     PHY2GTSFMT_TABLE  profile_id.phy, PHY_DATE, PHY_TIME and GTSFMT_FLAG 
#     QC2MATLAB_TABLE   profile_id.qc
#
#     where:
#       profile_id  - PHY/QC profile identification (0014_12275_085.phy/qc) 
#       PHY_DATE    - PHY profile date (yyyy/mm/dd) of the first position record
#       PHY_TIME    - PHY profile time (hh:mm) of the first position record 
#       COMPLETE    - y (profile is complete) or n (profile not complete)
#       GTSFMT_FLAG - y (gts formatted) or n ( not formatted)

#
# (4) Generates a summary report of floats processed.
#
# (5) Creates links in NETCDF_QCLINKS_DIR pointing to newly created QC profile
#     files in QCFILES_DIR 
#     where:
#            NETCDF_QCLINKS_DIR=$ARGO_DIR/netcdf/data/qc_links
#            QCFILES_DIR=$ARGO_DIR/data/qc
#
#     Linked files will be used by 'qc2netcdf.sh' to created NetCDF files from
#     QC profiles. 
#
# Exit status values
# ------------------
# 0, success
# 1, no PHY file to process
# 2, no QC profile created by C-program (qc_?.x); ? -> sensor type
# ==============================================================================================
# --------------------------------------------------------------------
#  Revision Date: 29-Nov-00 (RS)
#
#  ExitCodeTable
#  =============
#  Creates a table with exit code, reason and action for each process
#
#  Usage: ExitCodeTable
# --------------------------------------------------------------------
ExitCodeTable()
{
  processexit_table=$ARGOSTMP_DIR/processexit.$TODAY"_"table
  cat > $processexit_table << EOF
Code              Reason                          Action
 0  +Process finished successfully          +Continue with ARGO
 1  +No PHY file to process                 +Exit ARGO, see log-files
 2  +No QC profile created by Fortran-program(s): +Exit ARGO, see log-files
EOF
 return
}
# --------------------------------------------------------------------
#  Revision Date: 29-Nov-00 (RS)
#
#  DelExitCodeTable
#  =================
#  Deletes 'Exit Code Table'
#
#  Usage: DelExitCodeTable
# --------------------------------------------------------------------
DelExitCodeTable()
{
   rm -f $processexit_table
   return
}
# --------------------------------------------------------------------
#  Revision Date: 29-Nov-00 (RS)
#
#  MatchExitCode
#  =============
#  Looks up the exit code. If code is matched, it prints the reason
#  and action else prints a no match message.
#
#  Usage: MatchExitCode code
# --------------------------------------------------------------------
MatchExitCode()
{
  code=$1
  grep "$code " $processexit_table > /dev/null     # 0, match; !- 0 otherwise
  if [ "$?" = "0" ]
  then
    reason=`grep "$code " $processexit_table | cut -d"+"  -f2`
    action=`grep "$code " $processexit_table | cut -d"+"  -f3`
    echo "\tExitCode: $code => $reason"
    echo "\tAction: $action"
  else
   echo "Exit Code not found in: $processexit_table"
  fi
  return
}
# --------------------------------------------------------------------
#  Revision Date: 16-Aug-13 (RS)
#
#  QCStatusReportHeadings
#  ======================
#  Write heading of the "Quality Control Process Status Report"
#  to SUMMARY_QC file.
# --------------------------------------------------------------------
QCStatusReportHeadings()
{
  equal="==================================================================================================="
  title="\t\t\t  Quality Control Process Status Report"
  location="Location: $PHYFILES_DIR"
  head_zone=`date +'%Z`
  head_datetime="\t\t\t\t  $TODAY_DATE $TODAY_TIME $head_zone"
  head="\n$equal\n$title\n$head_datetime"
  echo "$head\n"                                                                                       > $SUMMARY_QC
  echo "\t0, partially QCed (only 1 data line)"                                                       >> $SUMMARY_QC
  echo "\t1, passed complete"                                                                         >> $SUMMARY_QC
  echo "\t2, passed incomplete"                                                                       >> $SUMMARY_QC
  echo "\t3, no data lines"                                                                           >> $SUMMARY_QC
  echo "\t40, complete/incomplete/semi-passed (Analysis and/or Climatology failed all others passed)" >> $SUMMARY_QC
  echo "\t41, complete/incomplete/failed (Deep pressure test failed)"                                 >> $SUMMARY_QC
  echo "\t42, passed/incomplete/semi-passed (Primary profile passed & secondary failed)"              >> $SUMMARY_QC
  echo "\t43, passed/incomplete/failed (Primary profile failed)"                                      >> $SUMMARY_QC
  echo "\t5, no position and no data"                                                                 >> $SUMMARY_QC
  echo "\t6, illegal position and/or date"                                                            >> $SUMMARY_QC
  echo "\t7, position on land with data or speed check failed"                                        >> $SUMMARY_QC
  echo "\t8, no position with data"                                                                   >> $SUMMARY_QC
  echo "\t9, execution failed"                                                                        >> $SUMMARY_QC
  echo "\t10, bounced profile(s)"                                                                     >> $SUMMARY_QC
  echo "\t12, must add intrument type to the 'case \$instr_type in'"                                  >> $SUMMARY_QC
  echo "\n\tT: temperature  S: salinity  N: profile with no data lines"                               >> $SUMMARY_QC
  echo $equal                                                                                         >> $SUMMARY_QC

  echo "Location: $PHYFILES_DIR"                                                                      >> $SUMMARY_QC
  printf "\n\tProfile                 Sensor    Status   Float Type\n"                                >> $SUMMARY_QC

  return
}
# --------------------------------------------------------------------
# GetSensors: given a PHY/QC/ or a meta float file. it returns sensor(s)
# present in float. 
#
# Usage: sensors=GetSensors phy_file
#
#  phy_file=PHY/QC Palace float profile
#
# Return Value: string containing the sensor(s) in float
#
# --------------------------------------------------------------------
GetSensors()
{
   meta_header=$1

   cat $meta_header | grep -i temperature > /dev/null
   t_status="$?"
   if [ $t_status = "0" ]
   then
     sensors=t
   fi

   cat $meta_header | grep -i salinity   > /dev/null
   s_status="$?"
   if [ $s_status = "0" ]
   then
     sensors=$sensors"s"
   fi

   echo $sensors
}
# --------------------------------------------------------------------
# CheckSensor: given float identication, it check is float has the
#              given sensor type.
#
# Return Value:
#   0, float does not have given sensor type
#   1, float has given sensor type
#
# --------------------------------------------------------------------
CheckSensor()
{
  float_type=$1
  sensor_type=$2

  echo $float_type | grep -i $sensor_type > $QCTMP_DIR/greptype
  if [ "$?" = "0" ]
  then
    echo "1"
  else
    echo "0"
  fi
  rm -f $QCTMP_DIR/greptype
}
# --------------------------------------------------------------------------------
# Revision Date: 24-Sep-09 (RS)
#
# PSalAdjustment
# --------------
# Run 'adjsal2phy.x' to create a new 'phy' file if necessary.
# If the adjustment is needed, it creates a new 'phy' file  that will contain the
# following line:
#   PSAL ADJUST [dd mm yyyy N S_off stddev] dd mm yyy profnum offset std 
# and add a column with the new calibrated salinity value based on the offset and std
# to each data line
#  
#   |-----------------------------------------------------------------------------|
#   |                          Exit Status Values                                 |
#   |------------------------------------------------------------------------------
#   |Status |Condition      |Description                                      |QC?|
#   |-----------------------------------------------------------------------------|
#   |       |               |The most recent delayed-mode file processed to   |   |
#   |       |               |determine the salinity adjusment has a salinity  |   |
#   |       | sal_offset=0  |correction that does not exceed 0.005 psu, so    |   |
#   |       | sal_std=0     |the salinity offset and the corresponding        | Y |
#   |   0   |               |standard deviation are set to zefo; therefore    |   |
#   |       |               |nothing needs to be done.                        |   |
#   |       |-----------------------------------------------------------------|---|
#   |       |The column was |A new phy file with an added adjusted salinity   |   |
#   |       |to the phy file|is created. (Calls add_adjsal2phy)               |   |
#   |-------------------------------------------------------------------------|---|
#   |       |The profile # |                                                  |   |
#   |       |is less than  |This profile has a smaller profile number than    |   |
#   |   1   |the profile # |most recent delayed-mode file that was processed  | Y |
#   |       |in the PSAL   |to determine the salinity adjustment; therefore   |   |
#   |       |ADJUST line   |nothing is done (D nc file exists)                |   |
#   |       |in meta file  |                                                  |   |
#   |-------------------------------------------------------------------------|---|
#   |       |PSAL ADJUST   |Indicates that the adjusted salinity column was   |   |
#   |   2   |line exists in|created in a previous run; therefore nothing is   | Y |
#   |       |the phy file  |done.                                             |   |
#   |-------------------------------------------------------------------------|---|
#   |       |              |Error trying to open, or write to any of the      |   |
#   |   9   |I/O error     |following files:  old phy file, debug file, log   | N |
#   |       |              |file, meta file, new phy file.                    |   |
#   |-------------------------------------------------------------------------|---|
#
# Return Status
# -------------
# retval=0, do not perform QC 
# retval=1, perform QC 
# --------------------------------------------------------------------------------
PSalAdjustment()
{
  echo "=> Enter PSalAdjustment"
  cp -p $infile_pathname $QCTMP_DIR
  tmp_adjphy=$QCTMP_DIR/$phy_file"_adjusted" 
  printf "Run $QCPRG_DIR/adjsal2phy.x $phy_file (status_adj="
  $QCPRG_DIR/adjsal2phy.x  $infile_pathname  $meta_file $tmp_adjphy >> $logadjsal
  status_adj=$?
  printf "$status_adj) -> "
  case $status_adj in
    0) echo "OK"  # if sal offset & sal_std are equal to zero then 'tmp_adjphy' is not created
       if [ -f $tmp_adjphy ]
       then
         echo "OK"
         printf "Move: PSalAdjusted phy_file -> $PHYFILES_DIR/$phy_file - "
         mv $tmp_adjphy $PHYFILES_DIR/$phy_file   # overwrites the orig phy file
         echo "OK"
       else
         echo "No new (tmp_adjphy) created because the sal offset & std are equal zero"
       fi
       retval=1;;
    1) echo "OK - no adjustment needed (less/equal to start profile)" # D nc file exists -> no QC or R nc file needed 
       retval=1;;
    2) echo "OK - no adjustment needed (has already been done)" # phy with saladj
       retval=1;;
    *)
       echo "ERROR (status=$status_adj)"
       echo "$infile_pathname" >> $error_adjsal2phy_list
       printf "Move: $phy_file -> $FAILED_PHYFILES_DIR - "
       mv $infile_pathname  $FAILED_PHYFILES_DIR/
       echo "OK"
       retval=0;;
  esac
  echo "=> Exit PSalAdjustment (status=$retval)"
  return $retval
}
# --------------------------------------------------------------------------------
# Revision Date: 03-Mar-10 (ER)
#
# PresAdjustment
# --------------
# Run 'pres_adj.x' to create a new 'phy' file if necessary.
# If the adjustment is needed, it creates a new 'phy' file adding a column with the
# new adjusted pressure value
#  
#   |-----------------------------------------------------------------------------|
#   |                          Exit Status Values                                 |
#   |-----------------------------------------------------------------------------|
#   |Status |Description                                                      |QC?|
#   |-----------------------------------------------------------------------------|
#   |   0   | pres_adj had previously been executed for that profile before.  | Y |
#   |-------|-----------------------------------------------------------------|---|
#   |       | While the pressure values in this profile did not need to be    |   |
#   |   1   | adjusted, the following line was added to the new phy file      | Y |
#   |       | MOST RECENT VALID SURFACE PRES (DBAR)                           |   |
#   |-------------------------------------------------------------------------|---|
#   |   2   | Pressure values adjusted in new phy file.                       | Y |
#   |-------------------------------------------------------------------------|---|
#   |   >2  | Some error occurred during the pres_adj.x execution             | N |
#   |-------------------------------------------------------------------------|---|
#
# Return Status
# -------------
# retval=0, do not perform QC 
# retval=1, perform QC 
# --------------------------------------------------------------------------------
PresAdjustment()
{

  now=`date +'%h %d, %Y %T %p'`
  echo "$now: Begin pressure adjustment on $phy_file "
  $QCPRG_DIR/c_programs/pres_adj.x $PHYFILES_DIR/$phy_file \
                                   $PHYFILES_DIR/done/$aomlid \
                                   $QCTMP_DIR \
                                   0 \
                                   $trace_outfile \
                                   $error_outfile 
             
  status_adj=$?
  now=`date +'%h %d, %Y %T %p'`
  echo "$now: End 'pres_adj.x' of $phy_file (status= $status_adj)"
   
  case $status_adj in
    0) echo "OK: No new phy created because pressure had already been adjusted"
       retval=1;;
    1) echo "OK: Pressure Adjustment not needed but line added to phy_file"
       if [ -f $QCTMP_DIR/$phy_file ]
       then
         printf "Move: Original $phy_file -> $PHYFILES_DIR/before_pressure_adjustment - "
         mv $PHYFILES_DIR/$phy_file $PHYFILES_DIR/before_pressure_adjustment/  
         echo "OK"
         printf "Move: PresAdjusted phy_file -> $PHYFILES_DIR - "
         mv $QCTMP_DIR/$phy_file $PHYFILES_DIR/$phy_file  
         echo "OK"
       fi
       retval=1;;
    2) echo "OK: Pressure Adjustement Applied"
       if [ -f $QCTMP_DIR/$phy_file ]
       then
         printf "Move: Original file -> $PHYFILES_DIR/before_pressure_adjustment - "
         mv $PHYFILES_DIR/$phy_file $PHYFILES_DIR/before_pressure_adjustment/
         echo "OK"
         printf "Move: Adjusted phy_file -> $PHYFILES_DIR - "
         mv $QCTMP_DIR/$phy_file $PHYFILES_DIR/
         echo "OK"
       fi
       retval=1;;
    *)
       echo "ERROR (status=$status_adj)"
       echo "$infile_pathname" >> $error_adjpres2phy_list
       printf "Move: $phy_file -> $FAILED_PHYFILES_DIR - "
       mv $infile_pathname  $FAILED_PHYFILES_DIR/
       echo "OK"
       retval=0;;
  esac
  return $retval
}
# --------------------------------------------------------------------------------
# Revision 28-Sep-09 (RS)
#
# PerformQC
# ---------
# Performs QC. If applicable, it creates links for: 1) the distribution of 'nc' 
# files to GDACs, and/or 2) the creation of files to load the database.
# --------------------------------------------------------------------------------
PerformQC()
{
    float_type=`echo $up_float_type | \
                tr "[:upper:]" "[:lower:]"`

    any_qcsensor_failed=0                             # Set qc profile failure  
    any_qcsensor_exec_failed=0                        # Set qc profile exec failure  
    profile_with_data=1                               # Set to profile with data lines 
    complete=y                                        # Set profile completion to 'y' 
    one_dataline_only=n                               # Set only 1 data line to 'n'
    position_on_land=n                                # Set to position on water
    no_position=n                                     # Set no position to 'n'
    nopos_nodata=n                                    # Set no position & no data to 'n' 
    illegal_posdate=n                                 # Set illegal position and/or date to 'n'
    bounced_profiles=n                                # Set 'bounced profiles' to 'n' - process 
    corruptedprof=n                                   # Set 'corruptedprof' to 'n' - profile is ok 
 
    for sensor in `echo $SENSOR_TYPES`                # Loop: sensor
    do
      match=`CheckSensor $float_type $sensor`
      line=`echo "float_type= $float_type \
                  sensor_type: $sensor match: $match"`
      if [ $match -eq 0 ]                             # NO MATCH -> skip sensor
      then 
        continue
      fi

      low_sensor=`echo $sensor | tr "[:upper:]" "[:lower:]"`
      qc_script=qc_sensor.sh 

      if [ ! -f $QCSCRIPT_DIR/$qc_script ]     # Does QC Script (t/s) exists?
      then                                     #   No, branch to loop-end
        text="SCRIPT NOT FOUND: $QCSCRIPT_DIR/$qc_script -> Branch to Loop-End"
        echo $text
        continue
      fi

      outfile_pathname=$QCTMP_DIR/$profile_id.qc_$low_sensor  # output file holder
      filename=`basename $infile_pathname`
      meta_pathname=$METAFILES_DIR/`echo $filename | awk -F"_" '{print $1 "_" $2}'`.meta
      echo "QC_PROCESS BEFORE $qc_script :"
      echo "   infile:  $infile_pathname" 
      echo "   meta_pathname: $meta_pathname"
      echo "   outfile: $outfile_pathname" 
      echo "   sensor:  $low_sensor"

      $QCSCRIPT_DIR/$qc_script $infile_pathname $meta_pathname \
                               $outfile_pathname $profile_id $low_sensor
      status="$?"
      infile_pathname=$outfile_pathname         # rename infile 
      line="$line | $qc_script status: $status"
      echo $line

# -----------------------------------------------------------------------------
# Status Description                    QC File  NetCDF   To GTS
# ====== ===========                    =======  ======   =====
#   0    partially QCed (1 data line)    yes      yes     no 
#   1    passed complete                 yes      yes     yes, no delay
#   2    passed incomplete               yes      yes     yes, wait a chosen number of days
#   3    no data lines                   yes      yes     no 
#   4    complete/incomplete failed      yes      yes     yes (no - 13sep06) VQC/'grey list' to decide
#   5    no position & no data           yes      yes     no   
#   6    illegal position and/or date    yes      yes     no     
#   7    position on land with data      yes      yes     no
#   8    no position with data           yes      yes     no
#   9    f90 exec failure                no       no      no
#  10    'bounced profiles' file         yes      no      no
#  11    corrupted 'phy' file            no       no      no
#
#                           !!! WARNING !!!!
# (1) QC return status: 9 take precedence over 5
# (2) For status=3, only speed check test is done when there is a position
# (3) An 'N' implies a profile with no data lines
# (4) For status=10, soft links to QC file for NetCDF and Database are
#     not created. The bounced profile(s) does(do) not contain salinity.   
#     Move 'PHY' file to PHYFILES_DONE_DIR.
# -----------------------------------------------------------------------------
      case $status in
        0) one_dataline_only=y;; 
        1) success_qc=`expr $success_qc + 1`                   
           complete=y;;
        2) success_qc=`expr $success_qc + 1`                   
           complete=w;;
        3) profile_with_data=0                  # QC - only speed check 
           success_qc=`expr $success_qc + 1`;;
        4) any_qcsensor_failed=`expr $any_qcsensor_failed + 1`  
           complete=y
           failure_qc=`expr $failure_qc + 1`;;
        5) nopos_nodata=y;;
        6) illegal_posdate=y;;
        7) position_on_land=y;;                                       
        8) no_position=y;;                                       
        9) any_qcsensor_exec_failed=`expr $any_qcsensor_exec_failed + 1`
           execf90_failures=`expr $execf90_failures + 1`;;
       10) bounced_profiles=y
           sensor_label=T
           echo "BREAK from SENSOR LOOP - BOUNCED PROFILE(S)"
           printf "\t%-20s      %s         %-3s       %s\n" \
                  $profile_id $sensor_label $status $float_type >> $SUMMARY_QC
           printf "\t%-20s      %s         %-3s       %s\n" \
                  $profile_id $sensor_label $status $float_type >> $EMAIL_MESSAGE
           break;; 
       11) corruptedprof=y
           echo "BREAK from SENSOR LOOP - CORRUPTED PROFILE(phy)"
           printf "\t%-20s      %s         %-3s       %s\n" \
                  $profile_id $sensor_label $status $float_type >> $SUMMARY_QC
           printf "\t%-20s      %s         %-3s       %s\n" \
                  $profile_id $sensor_label $status $float_type >> $EMAIL_MESSAGE
           break;; 
        *) any_qcsensor_exec_failed=`expr $any_qcsensor_exec_failed + 1`;; 
      esac
        
      if [ $status -eq 3 ]                      # Profile with no data?
      then                                      #   Yes, label=N =>  exit loop 
        sensor_label=N
        printf "\t%-20s      %s         %-3s       %s\n" \
               $profile_id $sensor_label $status $float_type >> $SUMMARY_QC
        printf "\t%-20s      %s         %-3s       %s\n" \
               $profile_id $sensor_label $status $float_type >> $EMAIL_MESSAGE
      else                                      #  No, label=T or S)
        profile_with_data=1                 
        sensor_label=$sensor
        printf "\t%-20s      %s         %-3s       %s\n" \
               $profile_id $sensor_label $status $float_type >> $SUMMARY_QC
        
        if [ $status -ne 1 ]                    #  To Email (status != 1) ?
        then                                    #   Yes
        printf "\t%-20s      %s         %-3s       %s\n" \
               $profile_id $sensor_label $status $float_type >> $EMAIL_MESSAGE
        fi

        if [ $no_position = "y" ]               # Skip next sensor exec?
        then                                    #   Yes, exit loop
          echo "SENSOR LOOP - NO_POSITION"
        fi

        if [ $position_on_land = "y" ]  # Skip next sensor exec?
        then                            #   Yes, exit loop
          echo "SENSOR LOOP - POSITION ON LAND"
        fi

        if [ $illegal_posdate = "y" ]   # Ilegal position and/or date?
        then                            #   Yes, exit loop
          echo "SENSOR LOOP - ILLEGAL POSITION AND/OR DATE"
        fi

        if [ $status -ge 9 ]            # Skip next sensor exec?
        then                            #   Yes, exit loop
          echo "BREAK from SENSOR LOOP - EXECUTION ERROR"
          break
        fi
      fi # endif - profile with no data lines?
    done # end - sensor loop

    echo "End-Sensor Loop - profile number: $profile_no"
    echo "    $root_script_name: prostect2gts= $prospect2gts"
    echo "    $root_script_name: any_qcsensor_failed = $any_qcsensor_failed"
    echo "    $root_script_name: any_qcsensor_exec_failed = $any_qcsensor_exec_failed"
    echo "    $root_script_name: bounced_profiles = $bounced_profiles"
    echo "    $root_script_name: corruptedprof= $corruptedprof"
    echo "    $root_script_name: complete= $complete"
    echo "    $root_script_name: illegal_posdate= $illegal_posdate"
    echo "    $root_script_name: one_dataline_only= $one_dataline_only"
    echo "    $root_script_name: no_position= $no_position"
    echo "    $root_script_name: nopos_nodata= $nopos_nodata"
    echo "    $root_script_name: position_on_land= $position_on_land"
    echo "    $root_script_name: profile_with_data = $profile_with_data"
  
# -----------------------------------------------------------------------------
#                        CORRUPTED 'phy' PROFILE
#          (1) Move 'PHY' profile to FAILED_PHYFILES_DIR 
#          (2) Continue with next 'PHY' profile
# -----------------------------------------------------------------------------
    if [ $corruptedprof = "y" ]
    then
      echo "   <- CORRUPTED 'PHY' PROFILE ->"
      printf "   Move: $PHYFILES_DIR/$profile_id.phy -> $FAILED_PHYFILES_DIR - "
      mv $PHYFILES_DIR/$profile_id.phy $FAILED_PHYFILES_DIR/
      echo "OK"
      now=`date +'%h %d, %Y %T %p'`
      echo "<------------------- End   $profile_id $now --------------------->"
      continue
    fi

# -----------------------------------------------------------------------------
#                           BOUNCED PROFILES
#          (1) Move working 'QC' profile file to QCFILES_DIR
#          (2) Move 'PHY' profile to DONE_PHYFILES_DIR
#          (3) Continue with next 'PHY' profile
# -----------------------------------------------------------------------------
    if [ $bounced_profiles = "y" ]
    then
      echo "   <- BOUNCED PROFILE(S) ->"
#     mv $outfile_pathname $QCFILES_DIR/$profile_id.qc
#     echo "   Moved: $outfile_pathname"
#     echo "   To:    $QCFILES_DIR/$profile_id.qc"
#     mv $PHYFILES_DIR/$profile_id.phy $DONE_PHYFILES_DIR # Move to done dir
#     echo "   Moved: $PHYFILES_DIR/$profile_id.phy"
#     echo "   To:    $DONE_PHYFILES_DIR/$profile_id.phy"
#     now=`date +'%h %d, %Y %T %p'`
#     echo "<------------------- End   $profile_id $now --------------------->"
#     continue
    fi

    fmt="    prospect2gts: %c complete: %c no_position: %c one_dataline_only: %c position_on_land: %c illegal_posdate: %c\n"
    printf "$fmt" $prospect2gts $complete $no_position $one_dataline_only $position_on_land $illegal_posdate

# -----------------------------------------------------------------------------
#             Is there any sensor execution failure? 
#          No  - write 'qc' filename to QC2MATLAB_TABLE
#          Yes - do not write to QC2MATLAB_TABLE  
#
# Table pathname depends on the operational mode (production or manual)
#   production: ARGO_DIR/lists/QC2MATLAB_TABLE.$TODAY       
#   manual pathname: MANUALPROCESS_DIR/lists/QC2MATLAB_TABLE.$TODAY
# -----------------------------------------------------------------------------
    if [ $any_qcsensor_exec_failed -eq 0 ]
    then
       echo $profile_id.qc >> $QC2MATLAB_TABLE
    fi
# -----------------------------------------------------------------------------
#  Check if none of the following  QC sensor execution failures is reported
#         QC Exit Status    Reason
#         --------------    ------
#               3           no data lines found
#               5           no position and no data 
#               6           illegal position and/or date
#               7           position on land with data
#               8           no position with data 
#               9           f90 exec failure
# -----------------------------------------------------------------------------
#  Yes  -  if profile meets criteria, insert into PHY2GTSFMT_TABLE
#       -  always insert it in PACKQC2FTP_TABLE
#       -  add profile to execution success list
#       -  move it to the DONE directory   
#  No   -  do not insert profile in tables (PHY2GTSFMT_TABLE, PACKQC2FTP_TABLE)
#       -  add it to execution failure list 
#       -  if status=9 
#             move profile to FAILED_PHYFILES_DIR directory
#          else
#            move profile to DONE_DIR directory
#            if OPERATIONAL_SITE=NETCDF_DISTRIBUTION_SITE 
#            and profile_with_data=1 and illegal_posdate="n"
#            and wmo!=0 
#              create link in NETCDF_QCLINKS_DIR 
# -----------------------------------------------------------------------------
# Are sensor f90 executions OK, contains data lines, position(s) available,
# not on land and position and/or date are valid? 
#
# Exit Status:  3, no data lines found 
#               5, no position and no data 
#               6, illegal position and/or date
#               7, position on land with data
#               8, no position with data
#               9, f90 execution error
    if [ $any_qcsensor_exec_failed -eq 0 \
        -a $profile_with_data -eq 1 \
        -a $no_position = "n" \
        -a $nopos_nodata = "n" \
        -a $position_on_land = "n" \
        -a $illegal_posdate = "n" \
        -a $prospect2gts = "y" ]
    then                                                     #  Yes,  Add to success list 
      success_phy=`expr $success_phy + 1`                    
      echo $profile_id.phy >> $success_phy_list
                                                             # Move 'qc' to  QCFILES_DIR/$aomlid
      printf "Move: $outfile_pathname -> $QCFILES_DIR/$aomlid/$profile_id.qc - " 
      mv $outfile_pathname $QCFILES_DIR/$aomlid/$profile_id.qc  
      echo "OK"
                                                             # Move 'phy' profile to 'done_old' if it exists in 'done'
      phy_filename="$profile_id.phy"                         # Note: Use 'stat' command to find out when file was moved  
      if [ -f $DONE_PHYFILES_DIR/$aomlid/$phy_filename ]
      then
        printf "Move: $DONE_PHYFILES_DIR/$aomlid/$phy_filename -> $DONEOLD_PHYFILES_DIR/$aomlid - "
        mv $DONE_PHYFILES_DIR/$aomlid/$phy_filename $DONEOLD_PHYFILES_DIR/$aomlid/
        echo "OK"
      fi
                                                             # Move 'phy' file to 'done' 
     printf "Move: $PHYFILES_DIR/$profile_id.phy -> $DONE_PHYFILES_DIR/$aomlid - "
     mv $PHYFILES_DIR/$profile_id.phy $DONE_PHYFILES_DIR/$aomlid/
     echo "OK"

# -----------------------------------------------------------------------    
#    !!! ONLY if Operational Site is the NetCDF Distribution Site !!!
#  Create links in NETCDF_QCLINKS_DIR pointing to QC profile files
#  in QCFILES_DIR.  Linked files will be used by 'qc2netcdf.sh' 
#  to create NetCDF files.
# -----------------------------------------------------------------------    
# -a $complete = "y"   - removed 22-May-06
      if [ $OPERATIONAL_SITE = $NETCDF_DISTRIBUTION_SITE -a $wmo -ne 0 ]
      then
        thisdir=`pwd`
        cd $NETCDF_QCLINKS_DIR
        if [ -f $profile_id.qc ]
        then
          rm $profile_id.qc
        fi
        printf "Link -> $QCFILES_DIR/$aomlid/$profile_id.qc in $NETCDF_QCLINKS_DIR - "
        ln -s $QCFILES_DIR/$aomlid/$profile_id.qc .
        echo "OK"
        cd $thisdir
        echo "Link -> $QCFILES_DIR/$aomlid/$profile_id.qc CREATED in $NETCDF_QCLINKS_DIR"
      fi
# -----------------------------------------------------------------------    
#  PHY2GTSFMT_TABLE - profile_id, PHY_DATE, PPHY_TIME & GTSFMT_FLAG 
#
#   Were all sensors QC OK and profile number is not zero (000)?
#     Yes, continue
#          Does profile already exist in table?
#            yes, do not insert
#            no,  insert
#     No,  skip if-block
# -----------------------------------------------------------------------    
#  Sensors QC OK, profile with more than 1 data line  
#  -a $profile_no -ne 0 ] - removed 05-May-05 
#  if [ $any_qcsensor_failed -eq 0  -a $one_dataline_only = "n" ] 13sep06 status=4 -> GTS 
      if [ $one_dataline_only = "n" ] 
      then                                                   #   Yes 
        lposhead=`grep -n "LATITUDE" $tmp_pathname_phy_file | awk -F':' ' {print $1}'`
        lpos1=`expr $lposhead + 1`
        posline=`sed  -n "$lpos1,$lpos1"p $tmp_pathname_phy_file`
        PHY_DATE=`echo $posline | awk '{print $3}'` 
        PHY_TIME=`echo $posline | awk '{print $4}' | awk -F':' '{print $1 ":" $2}'` 

        match=`grep -n $profile_id $PHY2GTSFMT_TABLE`
        if [ "$?" = "0" ]                                    #   Does profile exists?
        then                                                 #     Yes, check if completion
                                                             #          flag changed  
          echo "$script_name: $profile_id already exists in PHY2GTSFMT_TABLE"
          text=`echo $match | awk -F":" '{print $3}'`
          old_complete=`echo $text |  awk '{print $2}'`
          old_transmitted=`echo $text |  awk '{print $3}'`
          if [ "$old_complete" != "$complete" \
               -a "$old_transmitted" = "n" ]                 #     Is new completion different than old and has not been transmitted
          then                                               #     Yes, delete old line & insert new one
            line_no=`echo $match | awk -F":" '{print $1}'`   #     get number of line to be deleted 
            echo "Profile exists in PHY2GTSFMT_TABLE - record #$line_no"  
            tmp_table="$QCTMP_DIR/tmp_phy2gtsfmt.$TODAY"
            sed "$line_no"d  $PHY2GTSFMT_TABLE > $tmp_table  #     delete line, output to temp file
            printf  "Move: $tmp_table -> $PHY2GTSFMT_TABLE -  "
            mv $tmp_table $PHY2GTSFMT_TABLE                   
            echo "OK"
            
            printf '%s: Table - PHY2GTSFMT_TABLE %-23s %s %5s      %s          n (UPDATED)\n' \
                    $script_name  $profile_id.phy $PHY_DATE $PHY_TIME $complete
            printf '%-23s %s %5s      %s          n\n' \
                    $profile_id.phy $PHY_DATE $PHY_TIME $complete >> $PHY2GTSFMT_TABLE
          fi
        else                                                 #     No, insert in table 
          printf '%s: Table - PHY2GTSFMT_TABLE %-23s %s %5s      %s          n\n' \
                  $script_name  $profile_id.phy $PHY_DATE $PHY_TIME $complete
          printf '%-23s %s %5s      %s          n\n' \
                  $profile_id.phy $PHY_DATE $PHY_TIME $complete >> $PHY2GTSFMT_TABLE
        fi # endif: does profile exist?
      fi # endif: sensors QC OK, more than 1 data line & profile_no not equal 0?

# -----------------------------------------------------------------------
#       Come here only for QC Exit Status: 3, 6, 7, 8, 9 or unknown  
#       when one of the following conditions is satisfied
#                 profile_with_data=0
#                 no_position=y
#                 position_on_land=y 
#                 illegal_posdate=y
#                 any_qcsensor_exec_failed != 0
#                 prospect2gts = y
# -----------------------------------------------------------------------
    else                                           #   No, cases: 3, 5, 6, 7, 8, 9 or unknown 
      if [ $any_qcsensor_exec_failed -ne 0 ]       #   Is 9 or unknown (exec failure)?
      then                                         #     Yes, move to failure dir 
        failure_phy=`expr $failure_phy + 1`          
        echo $profile_id.phy >> $failure_phy_list
        printf "Move: $PHYFILES_DIR/$profile_id.phy ->  $FAILED_PHYFILES_DIR - "
        mv $PHYFILES_DIR/$profile_id.phy  $FAILED_PHYFILES_DIR/
        echo "OK"
        trace_file=`basename $trace_outfile`
        error_file=`basename $error_outfile`
        echo "$trace_file  $error_file" >> $floatfail_trace_error_list
      else                                         #  No, 3 (no data lines),
                                                   #      5 (no position & no data lines) 
                                                   #      6 (illegal position and/or date), 
                                                   #      7 (on land) or 8 (no position) 
        success_phy=`expr $success_phy + 1`        
        echo $profile_id.phy >> $success_phy_list
                                                               # Move 'qc' to  QCFILES_DIR/$aomlid
        printf "Move: $outfile_pathname -> $QCFILES_DIR/$aomlid/$profile_id.qc - "
        mv $outfile_pathname $QCFILES_DIR/$aomlid/$profile_id.qc
        echo "OK"
                                                               # Move 'phy' profile to 'done_old' if it exists in 'done'
        phy_filename="$profile_id.phy"                         # Note: Use 'stat' command to find out when file was moved
        if [ -f $DONE_PHYFILES_DIR/$aomlid/$phy_filename ]
        then
          printf "Move: $DONE_PHYFILES_DIR/$aomlid/$phy_filename -> $DONEOLD_PHYFILES_DIR/$aomlid - "
          mv $DONE_PHYFILES_DIR/$aomlid/$phy_filename $DONEOLD_PHYFILES_DIR/$aomlid/
          echo "OK"
        fi
                                                               # Move 'phy' file to 'done_old' 
        printf "Move: $PHYFILES_DIR/$profile_id.phy -> $DONE_PHYFILES_DIR/$aomlid - "
        mv $PHYFILES_DIR/$profile_id.phy $DONE_PHYFILES_DIR/$aomlid/
        echo "OK"
# -----------------------------------------------------------------------
#    !!! ONLY if Operational Site is the NetCDF Distribution Site !!!
#  Create links in NETCDF_QCLINKS_DIR pointing to QC profile files
#  in QCFILES_DIR.  Linked files will be used by 'qc2netcdf.sh'
#  to create NetCDF files.
#        !!! Always create link for status=3 (no data lines) !!!
# -----------------------------------------------------------------------
# -a $illegal_posdate = "n" - removed 05-May-05
# -a $complete = "y"        - removed 22-May-06
        if [ $OPERATIONAL_SITE  = $NETCDF_DISTRIBUTION_SITE -a $wmo -ne 0 ]
        then
          thisdir=`pwd`
          cd $NETCDF_QCLINKS_DIR
          if [ -f $profile_id.qc ]
          then
            rm $profile_id.qc
          fi
          printf "Link -> $QCFILES_DIR/$aomlid/$profile_id.qc in $NETCDF_QCLINKS_DIR - "
          ln -s $QCFILES_DIR/$aomlid/$profile_id.qc .
          echo "OK"
          cd $thisdir
        fi #endif: operational site is NETCDF distribution site
      fi #endif: any_qcsensor_exec_failed
    fi  # endif: did any qcsensor execution fail (status:3,6,7,8 and 9 reported)?  

    return
}
# ---------------------------- Main (qc_process) -----------------------------
FAILURE_METADATA_DIR=$QCTMP_DIR

script_name=`basename $0`
root_script_name=`echo $script_name | awk -F"." '{print $1}`
up_script_name=`echo $root_script_name | tr "[:lower:]" "[:upper:]"`

SUMMARY_QC=$QCLOG_DIR/qc.$TODAY"_"summary
SUMMARY_REPORT=$QCLOG_DIR/$root_script_name.$TODAY"_"report     # process: summary report
EMAIL_MESSAGE=$EMAILFILES_DIR/$root_script_name.$TODAY"_"email  # process: argos_process 
export EMAIL_MESSAGE SUMMARY_REPORT

# Success and Failure Lists
# -------------------------
phy_notfound_list=$QCLIST_DIR/phy_notfound.$TODAY"_"list  # in cnt2phy_list but not found
success_phy_list=$QCLIST_SUCCESS_DIR/qc.$TODAY"_"success  # only for qc
failure_phy_list=$QCLIST_FAILURE_DIR/qc.$TODAY"_"failure  # only for qc
qcpassed_list=$ARGOLIST_DIR/qcpassed.$TODAY"_"list        # profiles that passed qc  

floatfail_trace_error_list=$QCLOG_DIR/float_failure.$TODAY"_"trace"_"error.list
qc_process_stderror=$QCLOG_DIR/$root_script_name.$TODAY.stderror    # Error Logfile
missing_metafile_list=$QCLIST_FAILURE_DIR/qc.$TODAY"_"nometafile  # only for qc
noinfo_in_metadata_list=$FAILURE_METADATA_DIR/noinfo_in_metadata.$TODAY"_"list
logadjsal=$QCLOG_DIR/adjsal2phy.$TODAY"_logadjsal"
logadjpres=$QCLOG_DIR/adjpres2phy.$TODAY"_logadjpres"
error_adjsal2phy_list=$QCLOG_DIR/adjsal2phy.$TODAY"_"error.list
error_adjpres2phy_list=$QCLOG_DIR/adjpres2phy.$TODAY"_"error.list

export qcpassed_list
export qc_process_stderror
export missing_metafile_list
export noinfo_in_metadata_list
export logadjsal error_adjsal2phy_list
#----------------------------- end local init ------------------------------

# Define stderror file 
# -------------------- 
if [ -f $qc_process_stderror ]
then
  rm -f $qc_process_stderror
fi
exec 2>>$qc_process_stderror
  
now=`date +'%h %d, %Y %T %p'`
echo "<++++++++++++++++++++ Start  $script_name: $now +++++++++++++++++++>"

ExitCodeTable                  # load Exit Code Table

echo "QCFILES_DIR: $QCFILES_DIR"
echo "NETCDF_QCLINKS_DIR: $NETCDF_QCLINKS_DIR"
echo "OPERATIONAL_SITE: $OPERATIONAL_SITE"
echo "NETCDF_DISTRIBUTION_SITE: $NETCDF_DISTRIBUTION_SITE"
echo "\nSensor Types Allowed: $SENSOR_TYPES"

# -------------------------------------------------------------------
#                Does the cnt2phy.* list file exists?
#                  yes, continue execution
#                  no,  send email and  exit
# -------------------------------------------------------------------
phy_input_file_names=$QCTMP_DIR/phy_input_file_names
echo "phy_input_file_names: $phy_input_file_names"

# Manual or Real-time Processing 
# ------------------------------
if [ "${MANUALPROCESS_PHY_ANAL_LIST=}" != "" ]
then
  manual=1
  cat $MANUALPROCESS_PHY_ANAL_LIST | awk '{print $1}' > $phy_input_file_names
  QC2MATLAB_TABLE=$ARGO_MANUALPROCESS_LIST_DIR/QC2MATLAB_TABLE.$TODAY
else
  manual=0
  cat $ARGOLIST_DIR/cnt2phy.*_list > $phy_input_file_names
  QC2MATLAB_TABLE=$ARGOLIST_DIR/QC2MATLAB_TABLE.$TODAY
fi

echo "=> QC2MATLAB_TABLE: $QC2MATLAB_TABLE"
 
sort -u  $phy_input_file_names -o $phy_input_file_names  # Merge only - no sort 

if [ ! -s "$phy_input_file_names"  ]
then
  ret_val=1
  subj="QC_PROCESS - No PHY File to Process"
  msg=">>> $script_name: NO PHY File to Process <<<" 
  echo $msg > $EMAIL_MESSAGE

  echo "\nSending Email ...."
  echo "To: $EMAIL_OPERATOR"
  echo "Subject: $subj"
  echo "Text:"
  cat $EMAIL_MESSAGE

  mailx -s "$subj" $EMAIL_OPERATOR < $EMAIL_MESSAGE
  echo "\n..... Email Sent"

  rm -f $phy_input_file_names
  MatchExitCode $ret_val
  DelExitCodeTable
  echo "<+++++++++++++++++++ Terminated $script_name: $now +++++++++++++++++>" 
  exit $ret_val   # no PHY file to process
fi

echo "\nPHY file(s) to be processed are located in $PHYFILES_DIR are: "
cat $phy_input_file_names

# -------------------------------------------------------------------------------
#  PHY2GTSFMT_TABLE with the following column heading:
#    profile_id  - profile identification (0014_12275_085.phy)
#    PHY_DATE    - PHY profile date (yyyy/mm/dd) of the first position record
#    PHY_TIME    - PHY profile time (hh:mm) of the first position record
#    COMPLETE    - y (profile is complete) or n (profile not complete)
#    GTSFMT_FLAG - y (gts formatted) or n ( not formatted)
#
# Check if PHY2GTSFMT_TABLE exists, if not create it
# -------------------------------------------------------------------------------
if [ -f $PHY2GTSFMT_TABLE ]
then
  echo "$script_name:  PHY2GTSFMT_TABLE Exists"
  echo "----- $PHY2GTSFMT_TABLE -----"
  cat $PHY2GTSFMT_TABLE
else
  echo "$script_name:  PHY2GTSFMT_TABLE Created"
  touch $PHY2GTSFMT_TABLE
fi
 
# Write heading for the "Quality Control Process Status Report" to SUMMARY_QC
# ----------------------------------------------------------------------------
QCStatusReportHeadings

cp $SUMMARY_QC $EMAIL_MESSAGE
 
# Define QC test results output file 
# ----------------------------------
results_outfile=$QCLOG_DIR/QCTEST_RESULTS.$TODAY"_"table # QC test result table 
export results_outfile 

# -------------------------------------------------------------------
#           Loop over PHY File(s) to Execute Shell Scripts:
#                           qc_?.sh 
# where ? is the sensor type, e.g. 't' or 's'
# -------------------------------------------------------------------
failure_qc=0
success_qc=0
failure_phy=0
success_phy=0
nphy=0                                         

if [ $manual -ne 0 ]                      # Manual? 
then                                      #   Yes, read phy & weekly analysis pair from file
  file2read=$MANUALPROCESS_PHY_ANAL_LIST  
else                                      #   No, phy from input list 
  file2read=$phy_input_file_names       
fi

execf90_failures=0                        # counter for qc_exit=9, used for email subject
export execf90_failures

exec < $file2read                         # Read PHY file list (manual=0, only filename)
while read phy_file ana_file              #   manual=0, PHY profile filename only         
do                                        #   manual=1, PHY profile filename and NCEP weekly &
  now=`date +'%h %d, %Y %T %p'`           #             its weekly NCEP analysis filename 
  nphy=`expr $nphy + 1`
  profile_id=`echo $phy_file | awk -F"." '{print $1}'` 
  float_id=`echo $profile_id | awk -F"_" '{print $1 "_" $2}'` 
  profile_no=`echo $profile_id | awk -F"_" '{print $3}'`
  aomlid=`echo $float_id | awk -F"_" '{print $1}'`

  echo "<------------------- Begin $profile_id aomlid:$aomlid $now --------------------->"
  printf "Does $DONE_PHYFILES_DIR/$aomlid  exist? "
  if [ -d $DONE_PHYFILES_DIR/$aomlid ]
  then
    echo "Yes" 
  else
    printf "No -> mkdir - "
    mkdir $DONE_PHYFILES_DIR/$aomlid
    echo "OK"
  fi

  printf "Does $DONEOLD_PHYFILES_DIR/$aomlid  exist? "
  if [ -d $DONEOLD_PHYFILES_DIR/$aomlid ]
  then
    echo "Yes" 
  else
    printf "NO -> mkdir - "
    mkdir $DONEOLD_PHYFILES_DIR/$aomlid
    echo "OK"
  fi

  printf "Does $QCFILES_DIR/$aomlid exist? "
  if [  -d $QCFILES_DIR/$aomlid ]
  then
    echo "Yes"
  else
    printf "No -> mkdir - "
    mkdir $QCFILES_DIR/$aomlid
    echo "OK"
  fi

#added 2003/04/05
  QCFILES_AOMLID_DIR=$QCFILES_DIR/$aomlid
  export QCFILES_AOMLID_DIR

  if [ "$ana_file" = "" ]
  then
    printf "Auto Run -> " 
    check_file=`ls $QCINDATA_DIR/$ANALYSIS_FILE_PREFIX.*`
    if [ "$ANALYSIS_FILE" != "$check_file" ]
    then
      printf "New - "
      ANALYSIS_FILE=$check_file
      export ANALYSIS_FILE
    fi
  else
    printf "Manual Run -> " 
    ANALYSIS_FILE=$MANUALPROCESS_TMP_ANAL_DIR/$ana_file
    export ANALYSIS_FILE
  fi
  echo $ANALYSIS_FILE 

  trace_outfile=$QCLOG_DIR/$profile_id.$TODAY"_"trace   # one per profile 
  error_outfile=$QCLOG_DIR/$profile_id.$TODAY"_"error   # one per profile 
  debug_outfile=$QCLOG_DIR/$profile_id.$TODAY"_"debug   # one per profile 
  summary_outfile=$QCLOG_DIR/$profile_id.$TODAY"_"error # one per profile 
  
  export trace_outfile
  export error_outfile
  export debug_outfile

  meta_file=$METAFILES_DIR/$float_id.meta
 
  if [ ! -f $meta_file ]
  then
    echo "NO METAFILE found"
    echo $phy_file >> $missing_metafile_list
    echo "<------------------- End   $profile_id aomlid:$aomlid $now --------------------->"
    continue
  fi
 
  prospect2gts=`grep -i "send to GTS" $meta_file | awk '{print $4}'`
  if [ "$prospect2gts" = "" ]    # set to 'y' when line is not in meta files
  then
    prospect2gts=y               
  fi
 
  wmo=`grep -i "WMO ID number" $meta_file | awk '{print $4}'`
  echo "WMO: $wmo"

  prgno=`grep -i "ARGOS program number" $meta_file | awk '{print $4}' `

# Add check for prgno, if it is empty, set it to 00000, for orbcomm,this is the case
# ----------------------------------------------------------------------------------
  if [ -z "$prgno" ]
  then
    prgno="00000"
  fi
  
  prgno_status="$?"     
  printf "prgno=$prgno prgno_status: $prgno_status "

  up_float_type=`grep -i "instrument type   " $meta_file | \
                 awk '{print $3}' | awk -F"_" '{print $2}' `
  type_status="$?"     
  echo  "up_float_type: $up_float_type type_status: $type_status"

  if [ "$type_status" = "0" -a $prgno_status = "0" ]  # Is type & prog no. in meta data? 
  then                                                #   Yes, QC float 
    infile_pathname=$PHYFILES_DIR/$phy_file           # input file holder
    if [ ! -f $infile_pathname ]                      # Does file exist?
    then                                              #   No, add to list & skip loop
      echo $phy_file >> $phy_notfound_list
      cat $phy_notfound_list
      continue
    fi

    cp -p $infile_pathname $ARGOSTMP_DIR
    tmp_pathname_phy_file=$ARGOSTMP_DIR/$phy_file

# --------------------------------------------------------------------------------
#  Check if salinity adjustment is necessary
# --------------------------------------------------------------------------------
    if [ "`grep 'PSAL ADJUST' $meta_file  2> /dev/null`" != "" ] # Adjust salinity?
    then                
      PSalAdjustment
      performqc=$?
    else
      echo "<<< Skip PSalAdjustment >>>"
      performqc=1
    fi

# --------------------------------------------------------------------------------
#  If there was no error in salinity adjustment, check if pressure adjustment
#  is necessary
# --------------------------------------------------------------------------------
    echo "Before Case to set 'to_adjust_pres' - performqc: $performqc"
    if [ $performqc -ne 0 ]  # Perform QC (so far)?
    then                     #  Yes QC (so far)
      #
      # Check whether pressure adjustment is necessary
      # 
      instr_type=`grep -i "^instrument type" $meta_file | awk '{print $3}'`
      echo "instr_type: $instr_type"
# to_adjust_pres=0  0: do not adjust pressure, 1: adjust pressure
      case $instr_type in
        'APEX'*) if [ $instr_type = "APEX_T3" ]
                 then
                   to_adjust_pres=0
                   echo "APEX- NO, to_adjust_pres: $to_adjust_pres"
                 else
                   to_adjust_pres=1
                   echo "APEX- YES, to_adjust_pres: $to_adjust_pres"
                 fi;;
        'PROVOR'*) if [ $instr_type = "PROVOR_T4" ]
                   then
                     to_adjust_pres=0
                     echo "PROVOR - NO, to_adjust_pres: $to_adjust_pres"
                   else
                     echo "PROVOR - YES, to_adjust_pres: $to_adjust_pres"
                     to_adjust_pres=1
                   fi;; 
        'NAVISIR'*) to_adjust_pres=1;;
        'SOLO'*) to_adjust_pres=0;;
        *) echo "<<< No match found for $instr_type in case statement >>>"
           status=12
           float_type=`echo $up_float_type | tr "[:upper:]" "[:lower:]"`
           sensor="?"
           printf "\t%-20s      %s         %-3s       %s\n" \
                   $profile_id $sensor $status $float_type >> $SUMMARY_QC
           printf "\t%-20s      %s         %-3s       %s\n" \
           continue;;
      esac

      if [ $to_adjust_pres -eq 1 ]
      then
        echo "<<< Float Type=$instr_type -> PresAdjustment >>>"
        PresAdjustment
        performqc=$?
      else
        echo "<<< Float Type=$instr_type -> Skip PresAdjustment >>>"
        performqc=1
      fi
    fi
    echo "After Case to set 'to_adjust_pres' - performqc: $performqc"

# --------------------------------------------------------------------------------
#  Check if QC is to be performed
# --------------------------------------------------------------------------------
    if [ $performqc -ne 0 ]  # Perform QC (0, no; 1, yes)?
    then                     #  Yes QC
      PerformQC
    else                     #  No QC, go to end of profile 'do loop'
      continue
    fi

  else                           # No, float type or/and prg no found in meta data 
# --------------------------------------------------------------------------------
# Come here only when there is no float type and/or program no is not in meta file
# --------------------------------------------------------------------------------
    failure_phy=`expr $failure_phy + 1`         
    failure_qc=`expr $failure_qc + 1`
    echo $profile_id.phy >> $failure_phy_list

    printf "Move: $PHYFILES_DIR/$profile_id.phy -> $FAILED_PHYFILES_DIR - "
    mv $PHYFILES_DIR/$profile_id.phy  $FAILED_PHYFILES_DIR/
    echo "OK"

    sensor="?"
    status="?"
    float_type="?"
    printf "\t%-20s      %s         %-3s       %s\n" \
           $profile_id.phy $sensor $status $float_type >> $SUMMARY_QC
    echo $float_id.meta >> $noinfo_in_metadata_list
  fi # endif: float_type and/or program number (found/not found)  

  if [ -f $error_outfile -a ! -s $error_outfile ]     # delete if exists & empty
  then
    rm $error_outfile
  fi

  if [ -f $debug_outfile -a ! -s $debug_outfile ]     # delete if exists & empty
  then
    rm $debug_outfile
  fi

  now=`date +'%h %d, %Y %T %p'`
  echo "<------------------- End   $profile_id aomlid:$aomlid $now --------------------->"

done # end - profile loop

echo "\nNumber of PHY Files Processed Successfully: $success_phy"
echo  "Number of PHY Files Processed UnSuccessfully: $failure_phy"

echo "\nNumber of PHY Files Processed Successfully: $success_phy" \
      >> $SUMMARY_QC
echo  "Number of PHY Files Processed UnSuccessfully: $failure_phy" \
      >> $SUMMARY_QC

echo $equal >> $SUMMARY_QC

if [ -f $error_outfile -a ! -s $error_outfile ]   # delete if exists & empty
then
  rm $error_outfile
fi

if [ -f $debug_outfile -a ! -s $debug_outfile ]   # delete if exists & empty
then
  rm $debug_outfile
fi

# --------------------------------------------------------------------------
#                 Any PHY file QC successfully?
#                   yes, continue execution
#                   no,  send email with summary report and exit
# --------------------------------------------------------------------------
if [ $success_phy -eq 0 ]     # Any PHY file QC successfully? 
then                          #  no , all failures 
  ret_val=2
  subj="QC_PROCESS - QC Output List Empty"
  msg=">>> $script_name: QC Output List is Empty - all QC processed failed <<<" 
  msg=$msg"\n\nFor more details look at the following files:"
  msg=$msg"\n\t$log_file"
  msg=$msg"\n\t$SUMMARY_QC"
  echo "$msg"                        >  $EMAIL_MESSAGE

  if [ -f $floatfail_trace_error_list ]
  then 
    if  [ -s $floatfail_trace_error_list ]
      then
      msg="\nAnd float PHY trace & error log_files in $QCLOG_DIR:"
      echo $msg                       >> $EMAIL_MESSAGE
      cat $floatfail_trace_error_list >> $EMAIL_MESSAGE
    fi
  else
    rm -f $floatfail_trace_error_list
  fi

  echo "\nSending Email ...."
  echo "To: $EMAIL_OPERATOR"
  echo "Subject: $subj"
  echo "Text:"
  cat $EMAIL_MESSAGE

  mailx -s "$subj" $EMAIL_OPERATOR < $EMAIL_MESSAGE
  echo "\n..... Email Sent"

  rm -f $phy_input_file_names
  MatchExitCode $ret_val
  DelExitCodeTable
  echo "<+++++++++++++++++++ Terminated $script_name: $now +++++++++++++++++>" 
  exit $ret_val   # no QC profile created by C-program (qc_?.x); ? -> sensor type
fi

# Move PHY success list to list directory under ARGO 
# -------------------------------------------------
if [ -f $success_phy_list ]
then
  echo "\nPHY Files which Executed Successfully: $qcprocess_outfile"
  cat $success_phy_list
fi

# Remove  ARGOLIST_DIR/cnt2phy.*_list
# -------------------------------------
rm -f $ARGOLIST_DIR/cnt2phy.*_list
# -------------------------------------------------------------------------
#                      Report for QC Processing 
# -------------------------------------------------------------------------
#                   
#   SUMMARY_QC           (????) 
#   RESULT_TABLE         (QC test result table)
#   failure_phy_list     (phy files unsuccessfully processed) 
#   qc_process_stderror  (stderror output produced by script)
# -------------------------------------------------------------------------
mv $SUMMARY_QC  $SUMMARY_REPORT

if [ -f $failure_phy_list ]
then
  echo "\nArgo PHY Files for which Fortran Program QC Execution Terminated:" \
       >> $SUMMARY_REPORT
  cat $failure_phy_list >> $SUMMARY_REPORT
fi

# -----------------------------------------------------------------
# Report the QC results from profile QC Tests
# -----------------------------------------------------------------
$QCSCRIPT_DIR/report_qctest_results.sh

# ---------------------------------------------------------------------
# List PHY profiles in the cnt2phy list that were not found.
# ---------------------------------------------------------------------
if [ -f $phy_notfound_list ]
then
  if [ -s $phy_notfound_list ]
  then
    count=`wc -l $phy_notfound_list | awk '{print $1}'`
    if [ $count = "1" ]
    then
      msg="File for the following profile in the 'cnt2phy_list' was not"
      msg=$msg"found.\nFor details see the 'argos_process' log-file and "
      msg=$msg"its trace and error log-files in $ARGOSLOG_DIR"
    else
      msg="Files for the following profiles in the 'cnt2phy_list' were not"
      msg=$msg"found.\nFor details see the 'argos_process' log-file and "
      msg=$msg" their trace and error log-files in \n\t$ARGOSLOG_DIR"
    fi
    echo $msg
    cat  $phy_notfound_list
    echo $msg >> $SUMMARY_REPORT
    cat  $phy_notfound_list >> $SUMMARY_REPORT
  else
    rm -f $phy_notfound_list
  fi
fi

# ---------------------------------------------------------------------
# List float trace & error logfiles created when a failure was
# detected while executing qc_process.sh 
# ---------------------------------------------------------------------
if [ -f $floatfail_trace_error_list ]
then
  if [ -s $floatfail_trace_error_list ]
  then
    msg="\nFor details on profile QC FORTRAN-Programs execution failures"
    msg=$msg"\nlook at the following trace and error log files in $QCLOG_DIR:\n"
    note="Note - trace/error might be empty depending where execution "
    note=$note"termination occured." 

    echo $msg
    cat  $floatfail_trace_error_list
    echo $note

    echo $msg >> $SUMMARY_REPORT
    cat  $floatfail_trace_error_list >> $SUMMARY_REPORT
    echo $note >> $SUMMARY_REPORT
  else
    rm -f $floatfail_trace_error_list
  fi
fi

# ---------------------------------------------------------------------
# Report possible metadata errors (missing file and/or float type)
# and stderrror produce by this script.  
#
# Note - file 'add2subj_file' is used to return addition to email
# subject if WARNING and/ERROR are reported . A variable set/redefined
# in child script is not known to parent script.
# ---------------------------------------------------------------------
add2subj_file=$QCTMP_DIR/addsubj_file.$TODAY
touch $add2subj_file
$QCSCRIPT_DIR/report_metadata_adjsal_stderror.sh $script_name $add2subj_file

# ----------------------------------------------------------------------
#                      Send Email to OPERATOR
# ----------------------------------------------------------------------
add2subj=`head -1 $add2subj_file`
$QCSCRIPT_DIR/send_email.sh $up_script_name "$add2subj"

echo "\n -------  ONLY FOR DEBUGGING BEFORE EXIT ------"
echo "PHYFILES_DIR: $PHYFILES_DIR"
ls -l $PHYFILES_DIR

echo "FAILED_PHYFILES_DIR: $FAILED_PHYFILES_DIR"
ls -l $FAILED_PHYFILES_DIR

echo "\n -------  $PHY2GTSFMT_TABLE ------"
cat $PHY2GTSFMT_TABLE

echo "\n -------  $QC2MATLAB_TABLE ------"
cat $QC2MATLAB_TABLE

echo "\n -------   $SUMMARY_REPORT ------"
cat $SUMMARY_REPORT

ret_val=0
MatchExitCode $ret_val
DelExitCodeTable

echo "<++++++++++++++++++++ Finish $script_name: $now +++++++++++++++++++>" 

exit $ret_val 
