#!/bin/sh
#########################################################################
# Revision Date: 08-Mar-06 (RS - streamline email text. Skip profile tests
#                                in email when a problem)
#                11-Mar-05 (RS - redesigned qc table output file)
#                30-Apr-03 (RS - 4 digits for profile number &
#                                10 char for transmission ID)
#                26-Nov-01 (RS - add constant value test)
#                10-Aug-01 (RS - add header line)
#                19-Jul-01 (RS - back to 5 digits)
#                10-Jul-01 (RS - argos id expasion)
#                01-May-01 (RS - change table heading)
#                29-Nov-00 (RS - correction to QC Result Table heading)
#                15-Aug-00 (RS - add header & footer)
#                13-Jun-00 (RS)
#
# report_qctest_results.sh 
# ========================
# Writes header, appends the profile(s) QC test results and
# writes footer to a temporary file and then append to the
# SUMMARY_REPORT
#########################################################################

script_name=`basename $0`
now=`date +'%h %d, %Y %T %p'`

echo "<============== Start  $script_name: $now ==============>"
echo "Entering Script: $0"

equal="========================================================================"
dash="------------------------------------------------------------------------"
tmp_qctest_report=$QCTMP_DIR/tmp_qctest_report.$TODAY

if [ -f $results_outfile -a -s $results_outfile ]
then
  echo "\n$equal" > $tmp_qctest_report
  echo "\t\t   Results from Quality Control Tests" >> $tmp_qctest_report
  echo "" >> $tmp_qctest_report
  echo "  T: sensor type        c: constant value test d: deepest pressure" >> $tmp_qctest_report
  echo "  g: gross              j: sensor jump         p: pressure increasing" >> $tmp_qctest_report
  echo "  s: spike              v: vertical gradient   r: regional" >> $tmp_qctest_report
  echo "  D: density gradient   spd: speed check       f: frozen" >> $tmp_qctest_report
  echo "  A: analysis           C: climatology         O: overall flag" >> $tmp_qctest_report
  echo "\t       P: passed   F: failed   N: not applicable" >> $tmp_qctest_report
  echo $equal >> $tmp_qctest_report
  echo "    Profile     T   c d g j p s v r D      spd    f     A C     O" >> $tmp_qctest_report
  echo "$dash" >> $tmp_qctest_report
 
  cat  $results_outfile >> $tmp_qctest_report
  echo "$equal"  >> $tmp_qctest_report
  mv $tmp_qctest_report $results_outfile
  cat $results_outfile >> $SUMMARY_REPORT
  cat $results_outfile >> $EMAIL_MESSAGE
fi

echo "<============== Finish $script_name: $now ==============>"

exit 
