#!/bin/sh
####################################################################################
# Revision Date: 29-Mar-07 (RS - add WARNING and/or ERROR if add2subj is not empty)
#                08-Mar-06 (RS - streamline email text. Skip profile tests
#                                in email when a problem)
#                20-Jun-00 (RS)
#
# send_email.sh
# ================
# Send SUMMARY_REPORT to OPERATOR list. 
####################################################################################
# ----------------------------------------------------------------------
#                         FUTURE EMAIL WORK
# Only one EMAIL_MESSAGE for all hex files process by "argos_process.sh"
# ----------------------------------------------------------------------
up_script_name=$1
add2subj=$2

this_script=`basename $0`

now=`date +'%h %d, %Y %T %p'`
echo "<-------------------- Start $this_script: $now -------------------->"
echo "Entering Script: $this_script"
echo "Calling Script:  $up_script_name"
echo "Email Location: $EMAIL_MESSAGE"
echo "Email Recepient(s): $EMAIL_OPERATOR"

if [ -f $EMAIL_MESSAGE ]
then
  if [ -s $EMAIL_MESSAGE ]
  then                                                  # Email file exists
    echo "[Email Begin]"
    echo "  To: $EMAIL_OPERATOR"
    if [ "$add2subj" = "" ]
    then
      subj="$up_script_name - Process Finished"
    else
      subj="$up_script_name - Process finished with WARNINGS and/or ERRORS ($add2subj)" 
    fi
    echo "  Subj: $subj"
    printf "  Sending ... " 
    mailx -s "$subj" $EMAIL_OPERATOR < $EMAIL_MESSAGE
    status=$?
    if [ $status -eq 0 ]
    then                                     # EMAIL sent
      echo "OK"
      rm -f $EMAIL_MESSAGE
    else
      echo "FAILURE"
    fi
    echo "[Email End]"
  else                                                  # Email file empty
     echo ">>> $this_script:  Email File is Empty <<<"
  fi
else                                                    # No Email file
  echo ">>> $this_script:  No Email File <<<"
fi

now=`date +'%h %d, %Y %T %p'`
echo "<-------------------- Finish $this_script: $now ------------------->"

exit 0
